;..................................................
;EXTENDED TIMER MODUL
;..................................................
    ;entry - check for new minute
_EXT000tim:
    sbrs    tiFLAG,m1m
    rjmp    _EXT000timEX    ; no new minute
_EXT001tim:
    ;new minute detected
    ;A) Load timerX control
    lds     zl,DYNtim
    clr     zh
    subi    zl,low(-enTIMcontrol)
    sbci    zh,high(-enTIMcontrol)
    ;B) Check for enabled timers 0...9
    ld      r16,z
    sbrc    r16,4       ;timer enable =1 ?
    rjmp    _EXT004tim  ;yes
    ;no!
_EXT002tim:
    lds     zl,DYNtim
    cpi     zl,9
    brsh    _EXT003tim
    inc     zl
    sts     DYNtim,zl
    rjmp    _EXT001tim
    
    ;...................................................
    ;limit reached - prepare new start after new minute
    ;...................................................
_EXT003tim:
    clr zl
    sts     DYNtim,zl
    cbr tiFLAG,1<<m1m
    rjmp  _EXT000timEX  


    ;...................................................
    ;enabled timer found - check for equal
    ;enTIMmin            =   0xec3       + koMAP ;start adress minute
    ;enTIMhour           =   0xecd       + koMAP ;start adress hour
    ;enTIMday            =   0xed7       + koMAP ;start adress weekday
    ;enTIMcontrol        =   0xee1       + koMAP ;timer control 
    ;
    ;minutS			=	0x63	+ koMAP		;*1min      	"     "      63hex
    ;stundS			=	0x64	+ koMAP		;*1h		"     "      64hex
    ;wocheS			=	0x66	+ koMAP		;*1Wochentag 0=Monday...6=Sunday
    ;...................................................
_EXT004tim:
    ;A) check minute
    lds     zl,DYNtim
    clr     zh
    subi    zl,low(-enTIMmin)
    sbci    zh,high(-enTIMmin)
    ld      r16,z
    lds     r17,minutS
    cp      r16,r17
    breq    _EXT005tim          ;minute equal !
    rjmp    _EXT002tim          ;not equal - check next timer!
    
    ;B) check hour
_EXT005tim:
    adiw    zh:zl,10
    ld     r16,z
    lds     r17,stundS
    cp      r16,r17
    breq    _EXT006tim          ;stunde equal !
    rjmp    _EXT002tim          ;not equal - check next timer!
    
   ;B) check weekday
_EXT006tim:
    adiw    zh:zl,10
    ld     r16,z
    tst     r16
    breq    _EXT008tim          ;0=not interested in days !
    ;make weekday bit
    lds     r17,wocheS
_EXT006timLOOP:
    tst r17
    breq _EXT007tim
    dec r17
    lsr r16         
    rjmp  _EXT006timLOOP  
_EXT007tim:
    sbrs    r16,0          
    rjmp    _EXT002tim          ;not equal - check next timer!
    rjmp    _EXT008tim          ;day equal !


    ;.............................................
    ;timer event !
    ;.............................................
_EXT008tim:
	    ;..........................................
		;events neu
        ;190...199
		ldi	r23,190
        lds r16,DYNtim
        add r23,r16
		sts	eventTE,r23			;timer3 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................

    ;execute scene by timer event?
_EXT009tim:
    lds     zl,DYNtim
    clr     zh
    subi    zl,low(-enTIMcontrol)
    sbci    zh,high(-enTIMcontrol)
    ;B) Check for enabled timers 0...9
    ld      r16,z
    sbrs    r16,5               ;scene enable =1 ?
    rjmp    _EXT010tim          ;not enabled - back & check next timer / next slot!
    ;scene enable
    andi    r16,0xf
    sts     prog_platzA,r16
    ;ex macro
    ldi     r16,1
    sts     matrix_flag,r16
    ;select next timer
_EXT010tim:
    lds     zl,DYNtim
    cpi     zl,9
    brsh    _EXT003tim
    inc     zl
    sts     DYNtim,zl
;..................................................
;return
_EXT000timEX:
    ret
