;******************************************************************************************
;**************************MACRO-MATRIX****************************************************
;******************************************************************************************
;lediglich programmparameter 0-9 & runMTX(flag) ODER makeMTX aus matrix_flag, als eingabeparameter erforderlich !
;
;##_coMATRIX  - kombi-mode-matrix
;zuordnung der sollwerte entsprechend des programmplatzes
;prog_platzA f. programmplatz
;matrix_flag f. matrix - flags
;takti_adrB f. temp aktivbytespeicher
;takti_cntB f. temp aktivbytezhler
;
;
;-> sollwerte aus speicherplatz von e2prom nach sram sollwerten
_coMATRIX:
	lds	r20,matrix_flag		;matrix-flag's
	sbrc	r20,makeMTX
	rjmp	_coMATRIXb		;make=1
	sbrs	r20,runMTX		;flag ==1 <=> aktuelle programmanforderung luft
	rjmp	_coMATpreBKc	;zurck mit default werten
	nop
_coMATRIXb:
	lds	yl,takti_adrBL		;aktuelles sram category-adresse holen
	lds	yh,takti_adrBH
	;schreiben WAIT
	sbrs	r20,wrMTX		;flag ==1 <=> schreiben luft
	rjmp	_MATCKa			;nein....
	;restore data
	lds	r17,sollwertMa
	lds	r21,sollwertMb
	jmp		_WRe2matrix





_MATCKa:
	;cat0-sram range prfen...
	cpi	yl,low(phase1 +8)
	ldi	r22,high(phase1 +8)
	cpc	yh,r22
	breq	_MATCKbX	;nchste category bearbeiten...
	brsh	_MATCKb		;nchste category prfen...
	jmp		_MATCKiX	;cat weiter bearbeiten...




_MATCKbX:
	ldi	yl,low(CpareA)
	ldi	yh,high(CpareA)
	;
	;
_MATCKb:
	;cat2-sram range prfen...
	cpi	yl,low(CpareA +8)
	ldi	r22,high(CpareA +8)
	cpc	yh,r22
	breq	_MATCKcX	;nchste category bearbeiten...
	brsh	_MATCKc		;nchste category prfen...
	jmp		_MATCKiX	;cat weiter bearbeiten...




_MATCKcX:
	ldi	yl,low(Akdi0)
	ldi	yh,high(Akdi0)
	;
	;
_MATCKc:
	;cat3-sram range prfen...
	cpi	yl,low(Akdi0 +8)
	ldi	r22,high(Akdi0 +8)
	cpc	yh,r22
	breq	_MATCKdX	;nchste category bearbeiten...
	brsh	_MATCKd		;nchste category prfen...
	jmp		_MATCKiX	;cat weiter bearbeiten...





_MATCKdX:
	ldi	yl,low(dy0temp)
	ldi	yh,high(dy0temp)
	;
	;
_MATCKd:
	;cat1-sram range prfen...
	cpi	yl,low(dy0temp +8)
	ldi	r22,high(dy0temp +8)
	cpc	yh,r22
	brsh	_coMATpreBKX	;ready
	jmp		_MATCKiX		;cat weiter bearbeiten...


	;fertig & events generieren
_coMATpreBKX:
	jmp	_coMATpreBK


	;----------------------------------------------------------------------------------------
_MATCKiX:
	;
	;nun kalkuliere programmplatz: (prog_platzA == speicherplatz)*(8 == SWmultiplikation)+
	;                              (startadresse proE2ADRe)= programmplatz
	lds	r21,prog_platzA	;0-9	
	ldi	r22,32			;8devices*4 kategorien == 32bytes/segment
	mul	r21,r22
	mov	r21,r0
	mov	r17,r1
	;
	;
	;addiere devicebyte# + (programmplatz*32)
	lds	r18,takti_cntB	;temp.devicebytecounter (L)
	ldi	r20,0			;(H)
	add	r21,r18			;Add low bytes
	adc	r17,r20			;Add high bytes with carry
	;
	;addiere aktivbyte# + (programmplatz*8) +	proE2ADR
	subi	r21, low(-proE2ADR)	;Add low byte ( x -(-y)) = x + y
	sbci	r17, high(-proE2ADR)	;Add high byte with carry
	;
	;make / do?
	lds		r20,matrix_flag
	sbrc	r20,makeMTX
	rjmp	_WRe2matrix		;schreibe in e2prom

	;----------------------------------------------
	;adressierung fertig / nun ins sram speichern !
	;----------------------------------------------
_RDe2matrix:
	sbic	eecr,eewe		; EEWE nicht gelscht ?
	rjmp	_RDe2matrix			; warte...
	out	eearh,r17
	out	eearl,r21		; adressierung e2prom
	sbi	eecr,eere		; bereite bertragung aus e2prom vor 
	in	r19,eedr		; kopiere daten aus e2prom nach r19
	;es ist vollbracht genauer sollwert aus p-platz im e2prom
	;
;	lds	zl,sollwertMa		;sollwertadresse...16bit
;	lds	zh,sollwertMb
	st	y,r19			;sollwert aus programmplatz nach sollwert
	jmp	matriLOOP

	;----------------------------------------------
	;adressierung fertig / nun ins sram speichern !
	;----------------------------------------------
_WRe2matrix:
	sbic	eecr,eewe		; EEWE nicht gelscht ?
	rjmp	_WRe2matrixWT			; warte...
;	lds	zl,sollwertMa		;sollwertadresse...16bit
;	lds	zh,sollwertMb
	ld	r19,y				;sollwert
	out	eearh,r17
	out	eearl,r21		; adressierung e2prom
	out	eedr,r19
	sbi	eecr,eemwe		; bereite bertragung aus e2prom vor 
	sbi	eecr,eewe
	;
	lds	r20,matrix_flag
	cbr	r20,1<<wrMTX
	sts	matrix_flag,r20
	;es ist vollbracht genauer sollwert nach e2prom
	jmp	matriLOOP

	;kann nicht schreiben 
	;sichern und zurck
_WRe2matrixWT:
	lds	r20,matrix_flag
	sbr	r20,1<<wrMTX
	sts	matrix_flag,r20
	;matrix adresse sichern
	sts	sollwertMa,r17
	sts	sollwertMb,r21
	;sollwert adresse sichern
	sts	takti_adrBL,yl	;sichere aktuelle adresse 
	sts	takti_adrBH,yh	;sichere aktuelle adresse 
	;zurck
	jmp	_coMATbk






	;------------------------------------------------
	;loop
	;------------------------------------------------
matriLOOP:
	;behandle aktivbytezhler !
	adiw	yh:yl,1
	sts	takti_adrBL,yl	;sichere aktuelle adresse 
	sts	takti_adrBH,yh	;sichere aktuelle adresse 
	;behandle aktivbyte-adressevariable!
	lds	r19,takti_cntB
	inc	r19
	sts	takti_cntB,r19
	jmp	_coMATbk





	;------------------------------------------------
	;ready...
	;------------------------------------------------
_coMATpreBK:
    ;now store prog_platzA
	lds	r21,prog_platzA	;0-9	
    ldi zl,low(prog_platzAadr)
    ldi zh,high(prog_platzAadr)
_coMATpreBKaWR:
	sbic	eecr,eewe		; EEPE nicht gelscht ?
	rjmp	_coMATpreBKaWR			; warte...
	out	eearh,zh
	out	eearl,zl		; adressierung e2prom
	out	eedr,r21          ; kopiere ins'e2prom-datenregister
	sbi	eecr,eemwe	
	sbi	eecr,eewe		;set EEPROM Write strobe
					; nach 4 maschinenzyklen ist der schreibprozess abgeschlossen 		


	lds		r20,matrix_flag
	sbrc	r20,makeMTX
	rjmp	_coMATpreBKb
	;-------------------------------------------
	;-> setzte macro-ex-event == 38
	ldi	r20,38
	sts	eventTE,r20			;macro 38 event setzen
	call	_MAKEeventSUB	;submodul !
	;-------------------------------------------
	rjmp	_coMATpreBKc
	;
_coMATpreBKb:
	;-------------------------------------------
	;-> setzte macro-make-event == 37
	ldi	r20,37
	sts	eventTE,r20			;macro 37 event setzen
	call	_MAKEeventSUB	;submodul !
	;-------------------------------------------
	;ready...
_coMATpreBKc:
	lds	r20,matrix_flag
	cbr	r20,1<<runMTX		;lsche matrix-ex-flag...
	cbr	r20,1<<makeMTX		;lsche matrix-make-flag
	cbr	r20,1<<wrMTX		;lsche write wait
	sts	matrix_flag,r20		;
	;
	clr	r20
	sts	takti_cntB,r20		;lsche e2prom-bytezhler 
	;
	ldi	r20,high(phase1)
	sts	takti_adrBH,r20	;lade mit sram category startadresse 
	ldi	r20,low(phase1)
	sts	takti_adrBL,r20	
	;ret
_coMATbk:
	ret


	













