;--------------------------------------------------------------------------------------------
;----------- dynamic process_engine ---------------------------------------------------------
;--------------------------------------------------------------------------------------------
;Allgemeines:
;process-psc wird hier zur generierung der HIF-daten beeinflusst
;wiederum beeinflussen die empfangenen HIF-Daten, entsprechend 
;der auswahl (index) den process psc
;
_proZS:	
	lds	r21,prozPSC		;(p)rocess (s)tatus (c)ounter nach r21

	;prfe ob als remote master
	;ttig?
	lds	r17,remFLAG
	sbrc	r17,RTmaster		;master remote
	rjmp	_NcorrZW			;...dann kein prozess-mode mglich !
	;noch alte sendeaufforderung aktiv ???
	;prfe ob spi aktiv
	lds	r17,comFLAGspi
	sbrs	r17,repSPItrPZ
	rjmp	_psc000PROZ
	jmp		_NcorrYY	;vielleicht jetzt senden

_NcorrZW:
	jmp		_NcorrZ
;-----------------------------------------------------------------------------------------------------------
;##_psc000PROZ - startup 
;-----------------------------------------------------------------------------------------------------------
_psc000PROZ:
	lds	r21,prozPSC		;(p)rocess (s)tatus (c)ounter nach r21
	tst	r21				
	brne	_psc000PROZb	;prozPSC>0
	lds		r17,progPSC
	tst	r17
	brne	_psc000PROZbk	;progPSC>0
	;dynamische rtc einblendung
	jmp		_psc000RTC			;prozPSC & progPSC=0
_psc000PROZbk:
	jmp		_NcorrZ	;

;-----------------------------------------------------------------------------------------------------------
;---------------- ab hier eingabeabhngig ------------------------------------------------------------------
;-----------------------------------------------------------------------------------------------------------
;+++++++++++++++++++++++++++++++++++++
;INFO:
;ausfhrung knftig nur mglich wenn
;-keine spi-aktivitt herrscht
;-eine execute-anforderung vorliegt
;+++++++++++++++++++++++++++++++++++++
_psc000PROZb:
	lds	r17,comFLAGspi
	sbrc	r17,exeSPIdata
	rjmp	_psc001PROZ
	;------------------------------------------------------
	;hier eingabeunabhngige jumps einfgen
	;
	;A) search hot-shot...
	cpi	r21,62
	brne	_psc000PROZckA
	jmp	_psc062PROZ
	;B) para display loop
_psc000PROZckA:
	cpi	r21,77
	brne	_psc000PROZckB	
	jmp	_psc077PROZ


	;
	;...to be continued !
	;
_psc000PROZckB:
	jmp		_NcorrZ






;-----------------------------------------------------------------------------------------------------------
;##_psc001PROZ - auswahl der grundfunktionen
;-----------------------------------------------------------------------------------------------------------
_psc001PROZ:	
	cpi	r21,1			;psc=1   <=> auswahl der grundfunktion	
	brne	_psc002PROZ
	;auf psc1 erfolgt keine process-reaktion
	;jedoch anzeige des grundmens
	;pzHIF=1
	ldi	r18,1
	jmp		_NcorrY












;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++ SYSTEM POWER CONTROL +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-------------------------------------------------------------------------------------------------------------------------
;##_psc002PROZ - powerrail an/aus ///steuerung (pwm0) current sense , soft an/aus , delayed off im program-modul definiert
;-------------------------------------------------------------------------------------------------------------------------
;* PWRflag -Tabelle :
; _______________________________________________
;|     |     |     |     |     |     |     |     |
;|bit7 |bit6 |bit5 |bit4 |bit3 |bit2 |bit1 |bit0 |
;|_____|_____|_____|_____|_____|_____|_____|_____|
;|rail |     |rail |rail |rail |rail |cur. |cur. |
;|s-cut|     |d-off|down |up   |on   |up   |on   |
;|_____|_____|_____|_____|_____|_____|_____|_____|
;
;equ	SHcut	=	7	;kurzschlu flag
;equ	portON	=	6	;portON-flag	
;equ	delOFF	=	5	;delayed-off-flag
;equ	softDW	=	4	;soft-down-flag
;equ	softUP	=	3	;soft-up-flag
;equ	railON	=	2	;power-rail-on-flag
;equ	senseON	=	1	;current-sense-on-flag
;equ	curON	=	0	;kurzschluberwachung an/aus-flag
_psc002PROZ:	
	cpi	r21,2			;psc=2   <=> power on/off
	brne	_psc005PROZ
	;rail an/aus
	lds	r19,PWRflag		;hole mal die powerflag's
	sbrs	r19,railON	;	
	rjmp	_psc002PROZoff
	;rail ist an -> kann nur deaktiviert werden
	ldi	r21,3			;psc=3
	;pzHIF=2
	ldi	r18,2
	jmp	_NcorrY
	;rail ist aus -> kann nur aktiviert werden
_psc002PROZoff:
	ldi	r21,4			;psc=4
	;pzHIF=3
	ldi	r18,3
	jmp	_NcorrY
	;rail aus...
_psc005PROZ:
	cpi	r21,5			;psc=5
	brne	_psc006PROZ
	lds	r19,PWRflag		;hole mal die powerflag's
	cbr	r19,1<<railON	;railpower deaktivierung einleiten &
	sbr	r19,1<<delOFF	;delayed off 
	sts	PWRflag,r19		;sichere powerflag's
		;..........................................
		;<systempower down-event>
		ldi	yl,12
		sts	eventTE,yl			;power up event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	ldi	r21,2			;psc=2
	jmp	_psc002PROZ
	;rail an...
_psc006PROZ:
	cpi	r21,6
	brne	_psc007PROZ
	lds	r19,PWRflag		;hole mal die powerflag's
	sbr	r19,1<<railON	;railpower aktivieren &
	sbr	r19,1<<softUP	;softstart &
	cbr	r19,1<<senseON	;delayed current sense
	cbr	r19,1<<SHcut	;kurzschluflag lschen
	cbr	r19,1<<curON 
	sts	PWRflag,r19		;sichere powerflag's
		;..........................................
		;<systempower up-event>
		ldi	yl,11
		sts	eventTE,yl			;power up event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	ldi	r21,2			;psc=2
	jmp	_psc002PROZ











;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++ SYSTEM INFO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-----------------------------------------------------------------------------------------------------------
;##_psc007PROZ     allgemeine infos - keine weitere ausfhrung 
;-----------------------------------------------------------------------------------------------------------
_psc007PROZ:
	cpi	r21,7			;prfe psc...
	brne	_psc008PROZ
	;auf psc7 erfolgt keine process-reaktion
	;jedoch anzeige des grundmens
	;pzHIF=4
	ldi	r18,4
	jmp	_NcorrY
	
	












;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++ PROCESS MODE SELECT ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~		
;-----------------------------------------------------------------------------------------------------------
;##_psc008PROZ     auswahl der prozess funktionen
;-----------------------------------------------------------------------------------------------------------
_psc008PROZ:
	cpi	r21,8			;prfe psc...
	brne	_psc009PROZ
	;auf psc8 erfolgt keine process-reaktion
	;jedoch anzeige des prozessmens
	;pzHIF=5
	ldi	r18,5
	jmp	_NcorrY













;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++ MACRO CALL +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-----------------------------------------------------------------------------------------------------------
;##_psc009PROZ     manueller macroaufruf 
;-----------------------------------------------------------------------------------------------------------
_psc009PROZ:
	cpi	r21,9			;prfe psc...
	brne	_psc010PROZ	
	;beim ersten mal hif=17
	;weiter mit hif=55
	lds	r18,pzHIF
	cpi	r18,6
	breq	_psc009PROZb
	cpi	r18,56
	breq	_psc009PROZb
	;wert im HIF darstellen
	;pzHIF pointer=17
	ldi	r18,6
	lds	r20,prog_platzA	 		;macroplatz holen
	sts	paraA,r20
	rjmp	_psc009PROZd
	;ist schon 17, nun 55
_psc009PROZb:
	ldi	r18,56
	lds	r17,paraA
	sts	prog_platzA	,r17	;empfangenen parameter speichern

_psc009PROZd:
	jmp	_NcorrY



;-----------------------------------------------------------------------------------------------------------
;##_psc010PROZ     macro-edit loop 
;-----------------------------------------------------------------------------------------------------------
_psc010PROZ:
	cpi	r21,10			;prfe psc...
	brne	_psc011PROZ		;nchsten wert eingeben...
	;
_psc010PROZready:
	;startschuss f. programmausfhrung !
	lds	r20,matrix_flag	;matrix flag setzen (wg.programmaufruf erforderlich)
	sbr	r20,1<<runMTX	;wird nach erledigung von matrix gelscht !
	sts	matrix_flag,r20	
	;fertig & zur basis
	;zurck
	ldi	r21,8
	jmp	_psc008PROZ













;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++ TIMER ACCESS +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;--------------------------------------------------------------------------------------------------------------------
;##_psc011PROZ - global timer status/auswahlmen
;--------------------------------------------------------------------------------------------------------------------

;GLOBtim 	=      	;global timer (de-)aktivierungsvariable
;GLtim0		=	0	;global timer flag 0
;GLtim1		=	1	;   "          "   1
;GLtim2		=	2	;   "          "   2
;GLtim3		=	3	;   "          "   3	


_psc011PROZ:
	cpi	r21,11			;prfe psc...
	brne    _psc012PROZ
	;auf psc11 erfolgt die statusabfrage der timer
	;und anzeige des timermens inkl.status
	lds	r20,GLOBtim
	;timer0 ?
	sbrs	r20,GLtim0	;0=timer0 inaktiv
	rjmp	_psc011PROZa
	ldi		r18,0x2b	;ascii code fr + (aktiv)
	sts		paraA,r18
	sts		paraI,r18
	jmp		_psc011PROZax
_psc011PROZa:
	ldi		r18,0x2d	;ascii code fr - (deaktiv)
	sts		paraA,r18
	sts		paraI,r18
	;timer1 ?
_psc011PROZax:
	sbrs	r20,GLtim1	;0=timer1 inaktiv
	rjmp	_psc011PROZb
	ldi		r18,0x2b	;ascii code fr + (aktiv)
	sts		paraB,r18
	sts		paraJ,r18
	jmp		_psc011PROZbx
_psc011PROZb:
	ldi		r18,0x2d	;ascii code fr - (deaktiv)
	sts		paraB,r18
	sts		paraJ,r18
	;timer2 ?
_psc011PROZbx:
	sbrs	r20,GLtim2	;0=timer1 inaktiv
	rjmp	_psc011PROZc
	ldi		r18,0x2b	;ascii code fr + (aktiv)
	sts		paraC,r18
	sts		paraK,r18
	jmp		_psc011PROZcx
_psc011PROZc:
	ldi		r18,0x2d	;ascii code fr - (deaktiv)
	sts		paraC,r18
	sts		paraK,r18
	;timer3 ?
_psc011PROZcx:
	sbrs	r20,GLtim3	;0=timer1 inaktiv
	rjmp	_psc011PROZd
	ldi		r18,0x2b	;ascii code fr + (aktiv)
	sts		paraD,r18
	sts		paraL,r18
	jmp		_psc011PROZdx
_psc011PROZd:
	ldi		r18,0x2d	;ascii code fr - (deaktiv)
	sts		paraD,r18
	sts		paraL,r18
_psc011PROZdx:
	;pzHIF=7
	ldi	r18,7
	jmp		_NcorrY

;--------------------------------------------------------------------------------------------------------------------
;##_psc012-15PROZ - global timerX auswahl...
;--------------------------------------------------------------------------------------------------------------------
;timer0 gewhlt
_psc012PROZ:
	cpi	r21,12
	brne	_psc013PROZ
	ldi	r19,0x30		;ascii0
	sts	paraA,r19		;timer 0
	sts	paraO,r19
	;
	lds	r19,minut1		;minuten laden
	call	_PROZmkDIG	;nach ascii-digits teilen
	sts	paraG,yl
	sts	paraH,r19
	;
	lds	r19,stund1		;stunden laden
	call	_PROZmkDIG	;nach ascii-digits teilen
	sts	paraE,yl
	sts	paraF,r19
	;
	lds	r19,tage1		;tag laden
	call	_PROZmkday	;nach ascii-digits teilen
	sts	paraC,yl
	sts	paraD,r19
	;
	lds	r19,paraI		;status
	sts	paraB,r19
	;pzHIF=8
	ldi	r18,8
	jmp	_NcorrY


;timer1 gewhlt
_psc013PROZ:
	cpi	r21,13
	brne	_psc014PROZ
	ldi	r19,0x31		;ascii1
	sts	paraA,r19		;timer 1
	sts	paraO,r19
	;
	lds	r19,minut2		;minuten laden
	call	_PROZmkDIG	;nach ascii-digits teilen
	sts	paraG,yl
	sts	paraH,r19
	;
	lds	r19,stund2		;stunden laden
	call	_PROZmkDIG	;nach ascii-digits teilen
	sts	paraE,yl
	sts	paraF,r19
	;
	lds	r19,tage2		;tag laden
	call	_PROZmkday	;nach ascii-digits teilen
	sts	paraC,yl
	sts	paraD,r19
	;
	lds	r19,paraJ		;status
	sts	paraB,r19
	;pzHIF=8
	ldi	r18,8
	jmp	_NcorrY


;timer2 gewhlt
_psc014PROZ:
	cpi	r21,14
	brne	_psc015PROZ
	ldi	r19,0x32		;ascii2
	sts	paraA,r19		;timer 2
	sts	paraO,r19
	;
	lds	r19,minut3		;minuten laden
	call	_PROZmkDIG	;nach ascii-digits teilen
	sts	paraG,yl
	sts	paraH,r19
	;
	lds	r19,stund3		;stunden laden
	call	_PROZmkDIG	;nach ascii-digits teilen
	sts	paraE,yl
	sts	paraF,r19
	;
	lds	r19,tage3		;tag laden
	call	_PROZmkday	;nach ascii-digits teilen
	sts	paraC,yl
	sts	paraD,r19
	;
	lds	r19,paraK		;status
	sts	paraB,r19
	;pzHIF=8
	ldi	r18,8
	jmp	_NcorrY

_psc016PROZx:
	jmp	_psc016PROZ
;timer3 gewhlt
_psc015PROZ:
	cpi	r21,15
	brne	_psc016PROZx
	ldi	r19,0x33		;ascii3
	sts	paraA,r19		;timer 3
	sts	paraO,r19
	;
	lds	r19,minut4		;minuten laden
	call	_PROZmkDIG	;nach ascii-digits teilen
	sts	paraG,yl
	sts	paraH,r19
	;
	lds	r19,stund4		;stunden laden
	call	_PROZmkDIG	;nach ascii-digits teilen
	sts	paraE,yl
	sts	paraF,r19
	;
	lds	r19,tage4		;tag laden
	call	_PROZmkday	;nach ascii-digits teilen
	sts	paraC,yl
	sts	paraD,r19
	;
	lds	r19,paraL		;status
	sts	paraB,r19
	;pzHIF=8
	ldi	r18,8
	jmp	_NcorrY


;-----------------------------
;sub make digit f. para
;-----------------------------

_PROZmkDIG:
	;nun wert in digits zerlegen...
	;
	clr	yl	;zehner
	clr	yh	;hunderter
	;
	;>100?
_PROZmkDIGhun:
	cpi	r19,100
	brsh	_PROZmkDIGhunINC
_PROZmkDIGten:
	cpi	r19,10
	brlo	_PROZmkDIGone	
	;-10
	subi	r19,10
	inc		yl	
	jmp	_PROZmkDIGten

_PROZmkDIGone:
	ldi	r18,0x30	;ascii korrektur
	;einer== r19
	;zehner==yl
	;hunderter==,yh
	add	yh,r18
	add	yl,r18
	add	r19,r18
	ret
	;
	;-100
_PROZmkDIGhunINC:
	subi	r19,100
	inc		yh
	jmp	_PROZmkDIGhun


;-----------------------------
;sub make day f. para
;-----------------------------
_PROZmkday:
	tst	r19
	brne	_PROZmkdayB
	;=0 kein tag
	ldi	yl,0x2d
	ldi	r19,0x2d
	jmp	_PROZmkdayBK
	;
_PROZmkdayB:
	cpi	r19,1
	brne	_PROZmkdayC
	;=1 Montag
	ldi	yl,0x4d
	ldi	r19,0x6f
	jmp	_PROZmkdayBK
	;
_PROZmkdayC:
	cpi	r19,2
	brne	_PROZmkdayD
	;=2 Dienstag
	ldi	yl,0x54
	ldi	r19,0x75
	jmp	_PROZmkdayBK
	;
_PROZmkdayD:
	cpi	r19,3
	brne	_PROZmkdayE
	;=3 Mittwoch
	ldi	yl,0x57
	ldi	r19,0x65
	jmp	_PROZmkdayBK
	;
_PROZmkdayE:
	cpi	r19,4
	brne	_PROZmkdayF
	;=4 Donnerstag
	ldi	yl,0x54
	ldi	r19,0x68
	jmp	_PROZmkdayBK
	;
_PROZmkdayF:
	cpi	r19,5
	brne	_PROZmkdayG
	;=5 Freitag
	ldi	yl,0x46
	ldi	r19,0x72
	jmp	_PROZmkdayBK
	;
_PROZmkdayG:
	cpi	r19,6
	brne	_PROZmkdayH
	;=6 Samstag
	ldi	yl,0x53
	ldi	r19,0x61
	jmp	_PROZmkdayBK
	;
_PROZmkdayH:
	cpi	r19,7
	brne	_PROZmkdayFAIL
	;=7 Sonntag
	ldi	yl,0x53
	ldi	r19,0x75
	jmp	_PROZmkdayBK
	;
_PROZmkdayFAIL:
	;>7 failed
	ldi	yl,0x4f
	ldi	r19,0x56
_PROZmkdayBK:
	ret











;--------------------------------------------------------------------------------------------------------------------
;##_psc016/17PROZ - global timerX (de-)aktivierung
;--------------------------------------------------------------------------------------------------------------------
_psc017PROZx:
	jmp	_psc017PROZ
;timerX aktivieren
_psc016PROZ:
	cpi	r21,16
	brne	_psc017PROZx
	;global timer-flags holen
	lds	r20,GLOBtim	
	;welcher timer ist gewhlt?
	lds	r18,paraO
	subi	r18,0x30	;ascii korrektur
	tst	r18
	brne	_psc016PROZb
	ldi	r21,12	;nchster psc=12
	;=0
	;aktiv?
	sbrs	r20,GLtim0
	rjmp	_psc016TIM0
	cbr	r20,1<<GLtim0
	ldi	r18,0x2d	;-
	sts	paraI,r18
	rjmp	_psc016ready
	;nein...
_psc016TIM0:
	sbr	r20,1<<GLtim0
	ldi	r18,0x2b
	sts	paraI,r18
	rjmp	_psc016ready
	;
	;--------------------------------------
	;
_psc016PROZb:
	cpi	r18,1
	brne	_psc016PROZc
	;welcher timer ist gewhlt?
	lds	r18,paraO
	subi	r18,0x30	;ascii korrektur
	cpi	r18,1
	brne	_psc016PROZc
	ldi	r21,13	;nchster psc=12
	;=0
	;aktiv?
	sbrs	r20,GLtim1
	rjmp	_psc016TIM1
	cbr	r20,1<<GLtim1
	ldi	r18,0x2d	;-
	sts	paraJ,r18
	rjmp	_psc016ready
	;nein...
_psc016TIM1:
	sbr	r20,1<<GLtim1
	ldi	r18,0x2b
	sts	paraJ,r18
	rjmp	_psc016ready
	;
	;--------------------------------------
	;
_psc016PROZc:
	cpi	r18,2
	brne	_psc016PROZd
	;welcher timer ist gewhlt?
	lds	r18,paraO
	subi	r18,0x30	;ascii korrektur
	cpi	r18,2
	brne	_psc016PROZd
	ldi	r21,14	;nchster psc=14
	;=0
	;aktiv?
	sbrs	r20,GLtim2
	rjmp	_psc016TIM2
	cbr	r20,1<<GLtim2
	ldi	r18,0x2d	;-
	sts	paraK,r18
	rjmp	_psc016ready
	;nein...
_psc016TIM2:
	sbr	r20,1<<GLtim2
	ldi	r18,0x2b
	sts	paraK,r18
	rjmp	_psc016ready
	;
	;---------------------------------------
	;
_psc016PROZd:
	cpi	r18,3
	brne	_psc016ready
	;welcher timer ist gewhlt?
	lds	r18,paraO
	subi	r18,0x30	;ascii korrektur
	cpi	r18,3
	brne	_psc016PROZd
	ldi	r21,15	;nchster psc=15
	;=0
	;aktiv?
	sbrs	r20,GLtim3
	rjmp	_psc016TIM3
	cbr	r20,1<<GLtim3
	ldi	r18,0x2d	;-
	sts	paraL,r18
	rjmp	_psc016ready
	;nein...
_psc016TIM3:
	sbr	r20,1<<GLtim3
	ldi	r18,0x2b
	sts	paraL,r18
	rjmp	_psc016ready
	;
	;zurck...
_psc016ready:
	sts	GLOBtim,r20
	jmp	_psc012PROZ


;-------------------------
;##psc17PROZ  frei
;-------------------------
_psc017PROZ:
	jmp	_psc018PROZ



;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++ DYNAMIC PROCESSES ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-----------------------------------------------------------------------------------------------------------
;ab...##_psc018PROZ     manuelle parametermanipulation (aktivatorbyte bezogen) 
;-----------------------------------------------------------------------------------------------------------
;1) auswahl des gewnschten ausganges/pin's
;2) automatische vorlage der mglichen bedienungsmglichkeit 
;   -> triggered mode:  <+>,<->,<alle devices +>,<alle devices ->
;   -> delayed mode:    <start>,<alle devices start>
;   -> compared mode:   <+>,<->,<alle devices[+]>,<alle devices[-]>
;   -> direkt mode:     <deaktiv>,<aktiv>,<alle devices deaktiv>,<alle devices aktiv>	
;akTE	=				;temporre aktivator-var.7bhex	;f.prozess-engine
;sollTE =      			;temp. sollwertvariable

;;-------------------------------------------------------------------------------------------------------------
;definition
.equ	PROZ0ziel	=	phase1	;trigger/pwm
.equ	PROZ1ziel	=	dy0temp	;delays
.equ	PROZ2ziel	=	CpareA	;compare soll
.equ	PROZ3ziel	=	Akdi0	;direct a 


;hif=10 full pwm auswahl
;hif=11 red. pwm auswahl
;hif=12 full edit 
;hif=13 red. edit


;---------------------------------------------------------------
;##psc018PROZ m-access hauptauswahl....
;---------------------------------------------------------------
_psc018PROZ:
	cpi	r21,18		
	brne	_psc019PROZ
	;hif pointer =9
	ldi	r18,9		
	jmp	_NcorrY		;befehlssequenz z.HIF




;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++ TRIGGERED PWM MODE +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;----------------------------------------------------------------
;##psc019PROZ   triggered pwm 
;----------------------------------------------------------------
_psc020PROZx:
	jmp		_psc020PROZ
	;
_psc019PROZ:
	cpi	r21,19
	brne	_psc020PROZx
	;prfe ob's noch der alte HIF ist !	
	lds	r18,pzHIF
	cpi	r18,12
	brsh	_psc019PROZb	;ja,wiederholter aufruf !
	cpi	r18,9
	breq	_psc019PROZb	;ja,erstmaliger aufruf !
	rjmp	_psc019PROZc	;nein,bereits aufgerufen

;----------------------------------------------------------------
;erstmaliger aufruf !
_psc019PROZb:
	;alle phase/pwm-werte in
	;die para's
	;1)phase-paras
	ldi	zh,high(PROZ0ziel)	
	ldi	zl,low(PROZ0ziel)	
	;2)hif paras
	ldi	yh,high(paraB)	
	ldi	yl,low(paraB)
	;para loop
_psc019PROZbLOOP:
	ld	r20,z+
	st	y+,r20	
	cpi	zl,low(PROZ0ziel +8)	;Compare low byte
	ldi	r17,high(PROZ0ziel +8)	;
	cpc	zh,r17	;Compare high byte
	brsh	_psc019PROZbGO	;fertig!
	jmp	_psc019PROZbLOOP	;loop !
	;goon
_psc019PROZbGO:
	clr	r20
	sts	glob0ENA,r20
	ldi	r20,127
	sts	paraA,r20
	sts	paraJ,r20	;bk of paraA
	;neuer pzHIF (full)
	ldi	r18,10		
	jmp	_NcorrY

;------------------------------------------------------
;check index=0 (back...)
_psc019PROZc:
	lds	r20,CURindex
	tst	r20
	brne	_psc019PROZd
	lds		r20,paraFUNC
	sbrs	r20,ediG
	rjmp	_psc019PROZcc
	;restore 1stelle
	lds	r20,paraJ
	sts	paraA,r20
	jmp	_psc019PROZback
_psc019PROZcc:
	jmp	_psc019PROZback

	
;------------------------------------------------------
;check index=1 (edit all pwm's)
_psc019PROZeX:
	jmp	_psc019PROZe
_psc019PROZd:
	cpi		r20,1
	brne	_psc019PROZeX
	lds		r20,paraFUNC
	sbrs	r20,ediG
	rjmp	_psc019PROZnoaction
	;now edit (loop)!
	;u/d oder ruhezustand?
	lds		r20,paraA
	cpi		r20,127
	brlo	_psc019PROZdown		;down instruction
	breq	_psc019PROZnoaction ;up instruction
	jmp		_psc019PROZdCKUP
				

	;------------------------------			
	;zurck ohne weitere aktion !		
	_psc019PROZnoaction:
	jmp	_psc019PROZback
	;------------------------------


	

;--------------------------------------------------
;dw !
;1.0) ud flags ==0 (ursprungszustand)
;--------------------------------------------------
_psc019PROZdown:
	;----------------------------------------
	;<all-lights-down-state> - event setzen
	ldi		yl,47
	sts		eventTE,yl			;
	call	_MAKEeventSUB		;submodul !
	;----------------------------------------
lds		r20,PZphFLAG
tst		r20
breq	_psc019PROZdaDW	;default!
;1.1) dw flag gesetzt
sbrs	r20,allPHdw	
rjmp	_psc019PROZdaUPDWRUN
jmp	_psc019PROZdaDWRUN



;----------------------------------------------
;DW aus DEFAULT-Status
;----------------------------------------------
_psc019PROZdaDW:
clr		r17				;phase status flags
sts		glob0ENA,r17
sts		Ak1bck,r17
sts		Ak2bck,r17
sts		Ak3bck,r17
sts		Ak4bck,r17
sts		Ak5bck,r17
sts		Ak6bck,r17
sts		Ak7bck,r17
sts		Ak8bck,r17
sbr		r20,1<<allPHdw	;alle dw flag =1
cbr		r20,1<<allPHup	;alle up flag =0
jmp	_psc019PROZdaDWRUN  ;run...
;-------------------------------------------






;-------------------------------------------
;DW aus UP-Status !
;-------------------------------------------
;c) dw-range-flag gesetzt
;phase-werte erhhen bis alle
;AkXbk's ==0 dann _psc019PROZdaUP !
_psc019PROZdaUPDWRUN:
lds		r17,glob0ENA
ldi		zh,high(Ak1bck)
ldi		zl,low(Ak1bck)
ldi		yh,high(phase1)
ldi		yl,low(phase1)
;
;phase1 prfen
ldi		r22,0b11111110
call	_psc019PROZdaUPDWSUB
sts		paraB,r18
;phase2 prfen
ldi		r22,0b11111101
call	_psc019PROZdaUPDWSUB
sts		paraC,r18
;phase3 prfen
ldi		r22,0b11111011
call	_psc019PROZdaUPDWSUB
sts		paraD,r18
;phase4 prfen
ldi		r22,0b11110111
call	_psc019PROZdaUPDWSUB
sts		paraE,r18
;phase5 prfen
ldi		r22,0b11101111
call	_psc019PROZdaUPDWSUB
sts		paraF,r18
;phase6 prfen
ldi		r22,0b11011111
call	_psc019PROZdaUPDWSUB
sts		paraG,r18
;phase7 prfen
ldi		r22,0b10111111
call	_psc019PROZdaUPDWSUB
sts		paraH,r18
;phase8 prfen
ldi		r22,0b01111111
call	_psc019PROZdaUPDWSUB
sts		paraI,r18
tst		r17
brne	_psc019PROZdBACKxxlx
jmp	_psc019PROZdaDW	;set default...& run
;back loop
_psc019PROZdBACKxxlx:
jmp		_psc019PROZdBACK
;
;
;sub
_psc019PROZdaUPDWSUB:
ld		r19,z ;AktXbck laden
tst		r19
brne	_psc019PROZddwRUNaX
and		r17,r22
jmp		_psc019PROZddwRUNa
;bck-1/phase-1
_psc019PROZddwRUNaX:
dec		r19
st		z,r19
_psc019PROZddwRUNa:
ld		r18,y
dec		r18
st		y+,r18
adiw	zh:zl,1
ret
;-----------------------------------------------








;-----------------------------------------------
;DW aus DW-Status
;-----------------------------------------------
_psc019PROZdaDWRUN:
lds		r17,glob0ENA
ldi		zh,high(Ak1bck)
ldi		zl,low(Ak1bck)
ldi		yh,high(phase1)
ldi		yl,low(phase1)
;phase1 prfen
ldi		r22,0b00000001
call	_psc019PROZdaDWRUNSUB
sts		paraB,r18
;phase2 prfen
ldi		r22,0b00000010
call	_psc019PROZdaDWRUNSUB
sts		paraC,r18
;phase3 prfen
ldi		r22,0b00000100
call	_psc019PROZdaDWRUNSUB
sts		paraD,r18
;phase4 prfen
ldi		r22,0b00001000
call	_psc019PROZdaDWRUNSUB
sts		paraE,r18
;phase5 prfen
ldi		r22,0b00010000
call	_psc019PROZdaDWRUNSUB
sts		paraF,r18
;phase6 prfen
ldi		r22,0b00100000
call	_psc019PROZdaDWRUNSUB
sts		paraG,r18
;phase7 prfen
ldi		r22,0b01000000
call	_psc019PROZdaDWRUNSUB
sts		paraH,r18
;phase8 prfen
ldi		r22,0b10000000
call	_psc019PROZdaDWRUNSUB
sts		paraI,r18
jmp		_psc019PROZdBACK
;
;SUB
;phase prfen
_psc019PROZdaDWRUNSUB:
cpi		r17,0xff
breq	_psc019PROZdbDWRETx
ld		r18,y
tst		r18
breq	_psc019PROZdaDWx ;phase1 =0 !
dec		r18	;phase1-1
st		y,r18
rjmp	_psc019PROZdbDW
;hier entscheiden ob backup-counter+1?
;phase=255 
_psc019PROZdaDWx:
or		r17,r22		;phase1 maximal erreicht
ld		r19,z		
inc		r19
st		z,r19
_psc019PROZdbDW:
adiw	zh:zl,1
adiw	yh:yl,1
_psc019PROZdbDWRET:
ret
;back without action
_psc019PROZdbDWRETx:
	clr	r18
	ret

					
					;---------------------------------------------
					;up !	
					;2.0) ud flags==0 (ursprungszustand!)
					;---------------------------------------------
					_psc019PROZdCKUP:
	;----------------------------------------
	;<all-lights-up-state> - event setzen
	ldi		yl,48
	sts		eventTE,yl			;
	call	_MAKEeventSUB		;submodul !
	;----------------------------------------
					lds		r20,PZphFLAG
					tst		r20
					breq	_psc019PROZdaUP	;default!
					;2.1) up flag gesetzt
					sbrs	r20,allPHup	
					rjmp	_psc019PROZdaDWUPRUN
					jmp	_psc019PROZdaUPRUN
					;----------------------------------------------
					


					;----------------------------------------------
					;UP aus DEFAULT-Status
					;----------------------------------------------
					_psc019PROZdaUP:
					clr		r17				;phase status flags
					sts		glob0ENA,r17
					sts		Ak1bck,r17
					sts		Ak2bck,r17
					sts		Ak3bck,r17
					sts		Ak4bck,r17
					sts		Ak5bck,r17
					sts		Ak6bck,r17
					sts		Ak7bck,r17
					sts		Ak8bck,r17
					cbr		r20,1<<allPHdw	;alle dw flag =0
					sbr		r20,1<<allPHup	;alle up flag =1
					jmp	_psc019PROZdaUPRUN  ;run...
					;-------------------------------------------




					;-------------------------------------------
					;UP aus DW-Status !
					;-------------------------------------------
					;c) dw-range-flag gesetzt
					;phase-werte erhhen bis alle
					;AkXbk's ==0 dann _psc019PROZdaUP !
					_psc019PROZdaDWUPRUN:
					lds		r17,glob0ENA
					ldi		zh,high(Ak1bck)
					ldi		zl,low(Ak1bck)
					ldi		yh,high(phase1)
					ldi		yl,low(phase1)
					;
					;phase1 prfen
					ldi		r22,0b11111110
					call	_psc019PROZdaDWUPSUB
					sts		paraB,r18
					;phase2 prfen
					ldi		r22,0b11111101
					call	_psc019PROZdaDWUPSUB
					sts		paraC,r18
					;phase3 prfen
					ldi		r22,0b11111011
					call	_psc019PROZdaDWUPSUB
					sts		paraD,r18
					;phase4 prfen
					ldi		r22,0b11110111
					call	_psc019PROZdaDWUPSUB
					sts		paraE,r18
					;phase5 prfen
					ldi		r22,0b11101111
					call	_psc019PROZdaDWUPSUB
					sts		paraF,r18
					;phase6 prfen
					ldi		r22,0b11011111
					call	_psc019PROZdaDWUPSUB
					sts		paraG,r18
					;phase7 prfen
					ldi		r22,0b10111111
					call	_psc019PROZdaDWUPSUB
					sts		paraH,r18
					;phase8 prfen
					ldi		r22,0b01111111
					call	_psc019PROZdaDWUPSUB
					sts		paraI,r18
					tst		r17
					brne	_psc019PROZdBACKxxl
					jmp	_psc019PROZdaUP	;set default...& run
					;back loop
					_psc019PROZdBACKxxl:
					jmp		_psc019PROZdBACK
					;
					;
					;sub
					_psc019PROZdaDWUPSUB:
					ld		r19,z ;AktXbck laden
					tst		r19
					brne	_psc019PROZdupRUNaX
					and		r17,r22
					jmp		_psc019PROZdupRUNa
					;bck-1/phase+1
					_psc019PROZdupRUNaX:
					dec		r19
					st		z,r19
					_psc019PROZdupRUNa:
					ld		r18,y
					inc		r18
					st		y+,r18
					adiw	zh:zl,1
					ret
					;-----------------------------------------------

	


					;-----------------------------------------------
					;UP aus UP-Status
					;-----------------------------------------------
					_psc019PROZdaUPRUN:
					lds		r17,glob0ENA
					ldi		zh,high(Ak1bck)
					ldi		zl,low(Ak1bck)
					ldi		yh,high(phase1)
					ldi		yl,low(phase1)
				;phase1 prfen
					ldi		r22,0b00000001
					call	_psc019PROZdaUPRUNSUB
					sts		paraB,r18
					;phase2 prfen
					ldi		r22,0b00000010
					call	_psc019PROZdaUPRUNSUB
					sts		paraC,r18
					;phase3 prfen
					ldi		r22,0b00000100
					call	_psc019PROZdaUPRUNSUB
					sts		paraD,r18
					;phase4 prfen
					ldi		r22,0b00001000
					call	_psc019PROZdaUPRUNSUB
					sts		paraE,r18
					;phase5 prfen
					ldi		r22,0b00010000
					call	_psc019PROZdaUPRUNSUB
					sts		paraF,r18
					;phase6 prfen
					ldi		r22,0b00100000
					call	_psc019PROZdaUPRUNSUB
					sts		paraG,r18
					;phase7 prfen
					ldi		r22,0b01000000
					call	_psc019PROZdaUPRUNSUB
					sts		paraH,r18
					;phase8 prfen
					ldi		r22,0b10000000
					call	_psc019PROZdaUPRUNSUB
					sts		paraI,r18
					jmp		_psc019PROZdBACK
					;
					;SUB
					;phase prfen
					_psc019PROZdaUPRUNSUB:
					cpi		r17,0xff
					breq	_psc019PROZdbUPRET
					ld		r18,y
					cpi		r18,0xff
					breq	_psc019PROZdaUPx ;phase1 maximal !
					inc		r18	;phase1+1
					st		y,r18
					rjmp	_psc019PROZdbUP
					;hier entscheiden ob backup-counter+1?
					;phase=255 
					_psc019PROZdaUPx:
					or		r17,r22		;phase1 maximal erreicht
					ld		r19,z		
					inc		r19
					st		z,r19
					_psc019PROZdbUP:
					adiw	zh:zl,1
					adiw	yh:yl,1
					_psc019PROZdbUPRET:
					ret
					

_psc019PROZdBACK:
	;back...
	sts	glob0ENA,r17
	sts	PZphFLAG,r20
	ldi	r20,127
	sts	paraA,r20
	jmp	_psc019PROZback






;--------------------------------------------------------------------------
;check index=2...9 (edit pwm 1...8)
_psc019PROZe:
	cpi		r20,10
	brsh	_psc019PROZback
	;push index
	mov		zl,r20
	subi	zl,2
	sts		paraK,zl	;store device
	;==device X
	lds		r17,paraFUNC
	sbrs	r17,ediG
	rjmp	_psc019PROZback
	;edit device
	;a)psc edit
	ldi		r21,20
	;b)prepare edit hif mask
	ldi		r18,10
	;c)load soll device 0+index-2
	clr		zh
	subi	zl,low(-phase1)	
	sbci	zh,high(-phase1)	
	sts		paraPOINTl,zl
	sts		paraPOINTh,zh
	;d)to edit...
	jmp		_psc020PROZ		;edit deviceX


;-------------------------------------------------------------
_psc019PROZback:
	;ediG prfen
	;=0 max. maske
	;=1 red. maske
	lds		r20,paraFUNC
	sbrc	r20,ediG
	rjmp	_psc019PROZred
	;pzHIF=10 (full pwm maske)
	ldi	r18,10 
	jmp	_NcorrY
_psc019PROZred:	
	;pzHIF=11 (reduzierte pwm maske)
	ldi	r18,11
	jmp	_NcorrY

;-------------------------------------------------------------




;----------------------------------------------------------------
;##psc020PROZ   triggered pwm parameter verndern & darstellen
;----------------------------------------------------------------
;beim ersten mal parameter aus parapoint laden und zum hif senden
;spter gelieferten parameter speichern...
_psc020PROZ:
	cpi	r21,20
	brne	_psc021PROZ
	;edit loop aktiv ?
	lds		r17,paraFUNC
	sbrs	r17,ediG
	rjmp	_psc020PROZback ;nein!
	;ja !
	;beim ersten mal hif=10
	;weiter mit hif=12
	cpi	r18,10
	breq	_psc020PROZb
	;
	;edit luft...	
	;a)sollwertadresse holen...
	lds	zl,paraPOINTl
	lds	zh,paraPOINTh
	;alten sollwert holen..
	ld	yl,z
	;neuen sollwert holen
	lds	r17,paraA
	;parameter sichern....
	st	z,r17
	;vergleiche...
	cp	r17,yl	;neu > alt == up
				;neu=alt   == 
				;neu < alt == down
	brlo	_psc020PROZdw
	breq	_psc020PROZgo
			;>
			;----------------------------------------
			;<lightX-up-state> - event setzen
			ldi		yl,57
			lds		zl,paraK
			add		yl,zl
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	rjmp	_psc020PROZgo


_psc020PROZdw:
			;<
			;----------------------------------------
			;<lightX-down-state> - event setzen
			ldi		yl,49
			lds		zl,paraK
			add		yl,zl
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	;==
_psc020PROZgo:
	;red mask hif=13
	ldi		r18,13
	jmp		_NcorrY
	;

	;erstmaliger aufruf !
_psc020PROZb:
	;neuer hif=12
	ldi	r18,12
	;sollwertparameter holen...
	lds	zl,paraPOINTl
	lds	zh,paraPOINTh
	ld	r17,z
	sts	paraA,r17
	jmp	_NcorrY

	;ende....(entry-conditions f. pwm)
_psc020PROZback:
	;hif=9
	ldi	r18,9
	jmp	_NcorrY










;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++ DELAY MODE +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;------------------------------------------------------------------------------------------------------------------------------------
;##_psc021PROZ - delayed mode:    alle definierten devices anzeigen
;------------------------------------------------------------------------------------------------------------------------------------
;hif18=full delay mask
;hif19=red delay mask

_psc025PROZx:
	jmp		_psc025PROZ
	;
_psc021PROZ:
	cpi	r21,21
	brne	_psc025PROZx
	;prfe ob's noch der alte HIF ist !	
	lds	r18,pzHIF
	cpi	r18,9
	breq	_psc021PROZb	;ja,erstmaliger aufruf !
	rjmp	_psc021PROZc	;nein,bereits aufgerufen

;----------------------------------------------------------------
;erstmaliger aufruf !
_psc021PROZb:
	;alle delay soll-werte in
	;die para's
	;1)phase-paras
	ldi	zh,high(delay0)	;sollwerte laden
	ldi	zl,low(delay0)	
	;2)hif paras
	ldi	yh,high(paraA)	
	ldi	yl,low(paraA)
	;para loop
_psc021PROZbLOOP:
	ld	r20,z+
	st	y+,r20	
	cpi	zl,low(delay0 +8)	;Compare low byte
	ldi	r17,high(delay0 +8)	;
	cpc	zh,r17	;Compare high byte
	brsh	_psc021PROZbGO	;fertig!
	jmp	_psc021PROZbLOOP	;loop !
	;goon
_psc021PROZbGO:
	lds	r20,paraA
	sts	paraJ,r20	;bk of paraA
	;neuer pzHIF (full)
	ldi	r18,18		
	jmp	_NcorrY



;------------------------------------------------------
;check index=0 (back...)
_psc021PROZc:
	lds	r20,CURindex
	tst	r20
	brne	_psc021PROZd
	;restore 1stelle
	lds	r20,paraJ
	sts	paraA,r20
	jmp	_psc021PROZback

	
;------------------------------------------------------
;check index=1 (start all delays)
_psc021PROZeX:
	jmp	_psc021PROZe
_psc021PROZd:
	cpi		r20,1
	brne	_psc021PROZeX
	;now start!
	clr	r20
	ldi	zh,high(PROZ1ziel)	;startwerte 
	ldi	zl,low(PROZ1ziel)	
	;para loop
_psc021PROZdLOOP:
	st	z+,r20	
	cpi	zl,low(PROZ1ziel +8)	;Compare low byte
	ldi	r17,high(PROZ1ziel +8)	;
	cpc	zh,r17	;Compare high byte
	brsh	_psc021PROZdGO	;fertig!
	jmp	_psc021PROZdLOOP	;loop !
	;goon
_psc021PROZdGO:
			;----------------------------------------
			;<start-all-delays-state> - event setzen
			ldi		yl,71
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	lds	r20,paraJ
	sts	paraA,r20	;bk of paraA
	jmp	_psc021PROZback




;------------------------------------------------------
;check index=2..9 (start one selected delays)
_psc021PROZbackX:
	jmp	_psc021PROZback
_psc021PROZe:
	cpi		r20,10
	brsh	_psc021PROZbackX
	;now start!
	mov		zl,r20
	subi	zl,2
	clr		zh
	subi	zl,low(-PROZ1ziel)	;startwerte 
	sbci	zh,high(-PROZ1ziel)
	clr		r20
	st		z,r20	
	lds	r20,paraJ
	sts	paraA,r20	;bk of paraA
			;----------------------------------------
			;<start-delayX-state> - event setzen
			ldi		yl,72
			add		yl,r20	;event + deviceX
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	jmp	_psc021PROZback


;----------------------------------------------------
_psc021PROZback:
	;pzHIF=19 (reduzierte delay maske)
	ldi	r18,19
	jmp	_NcorrY




;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++ COUNTER COMPARE MODE +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;------------------------------------------------------------------------------------------------------------------------------------
;##_psc025PROZ - counter compare mode:    auswahl all/single
;------------------------------------------------------------------------------------------------------------------------------------
;hif33=compare auswahl
;hif34=red auswahl mask
_psc026PROZx:
	jmp		_psc026PROZ
	;
_psc025PROZ:
	cpi	r21,25
	brne	_psc026PROZx
	;prfe ob's noch der alte HIF ist !	
	lds	r18,pzHIF
	cpi	r18,9
	breq	_psc025PROZb	;ja,erstmaliger aufruf !
	cpi	r18,35
	brsh	_psc025PROZb	;ja,,wiederholter startaufruf!
	rjmp	_psc025PROZc	;nein,bereits aufgerufen

;----------------------------------------------------------------
;erstmaliger aufruf !
_psc025PROZb:
	;default device 0
	clr	r20
	sts	paraA,r20
	sts	paraJ,r20	;bk of paraA
	;neuer pzHIF (full)
	ldi	r18,33		
	jmp	_NcorrY

;------------------------------------------------------
;check index=0 (back...)
_psc025PROZc:
	lds	r20,CURindex
	tst	r20
	brne	_psc025PROZd
	lds		r20,paraFUNC
	sbrs	r20,ediG
	rjmp	_psc025PROZback
	;restore 1stelle
	lds	r20,paraJ
	sts	paraA,r20
	jmp	_psc025PROZback

;------------------------------------------------------
;check index=1 (select all compare)
_psc025PROZeX:
	jmp	_psc025PROZe
_psc025PROZd:
	cpi		r20,1
	brne	_psc025PROZeX
	lds		r20,paraFUNC
	sbrs	r20,ediG
	rjmp	_psc025PROZdJMP
	lds	r20,paraJ
	sts	paraA,r20	;bk of paraA
	jmp	_psc025PROZback
	;jmp to select all compare
_psc025PROZdJMP:
	ldi	r21,26
	jmp	_psc026PROZ


;------------------------------------------------------
;check index=2 (one selected compare)
_psc025PROZbackX:
	jmp	_psc025PROZback
_psc025PROZe:
	cpi		r20,2
	brne	_psc025PROZback
	lds		r20,paraFUNC
	sbrs	r20,ediG
	rjmp	_psc025PROZeJMP
	;selected device....
	lds	r20,paraA
	sts	paraJ,r20	;bk of paraA
	jmp	_psc025PROZback
	;jmp to select all compare
_psc025PROZeJMP:
	ldi	r21,28
	jmp	_psc028PROZ


;-------------------------------------------------------------
_psc025PROZback:
	;ediG prfen
	;=0 max. maske
	;=1 red. maske
	lds		r20,paraFUNC
	sbrc	r20,ediG
	rjmp	_psc025PROZred
	;pzHIF=33 (full compare maske)
	ldi	r18,33 
	jmp	_NcorrY
_psc025PROZred:	
	;pzHIF=34 (reduzierte compare maske)
	ldi	r18,34
	jmp	_NcorrY





;------------------------------------------------------------------
;_psc026PROZ   all compare devices
;------------------------------------------------------------------

;hif35=all compare auswahl
;hif36=red all auswahl mask
_psc028PROZx:
	jmp		_psc028PROZ
	;
_psc026PROZ:
	cpi	r21,26
	brne	_psc028PROZx
	;prfe ob's noch der alte HIF ist !	
	lds	r18,pzHIF
	cpi	r18,35
	brlo	_psc026PROZb	;ja,erstmaliger aufruf !
	rjmp	_psc026PROZc	;nein,bereits aufgerufen

;----------------------------------------------------------------
;erstmaliger aufruf !
_psc026PROZb:
	;neuer pzHIF (full)
	ldi	r18,35		
	jmp	_NcorrY

;------------------------------------------------------
;check index=0 (back...)
_psc026PROZc:
	lds	r20,CURindex
	tst	r20
	brne	_psc026PROZd
	jmp	_psc026PROZback

	
;------------------------------------------------------
;check index=1 (stop all compare)
_psc026PROZeX:
	jmp	_psc026PROZe
_psc026PROZd:
	cpi		r20,1
	brne	_psc026PROZeX
	;stop= alle istwerte nach soll kopieren
	ldi	zh,high(CpareA)	;soll start
	ldi	zl,low(CpareA)	
	ldi	yh,high(CpareI1);ist start
	ldi	yl,low(CpareI1)	
	;copy-loop
_psc026PROZdLOOP:
	ld	r20,y+
	st	z+,r20	
	cpi	yl,low(CpareI1 +8)	;Compare low byte
	ldi	r17,high(CpareI1 +8)	;
	cpc	yh,r17	;Compare high byte
	brsh	_psc026PROZdGO	;fertig!
	jmp	_psc026PROZdLOOP	;loop !
	;goon
_psc026PROZdGO:
			;----------------------------------------
			;<all-blend-stop-state> - event setzen
			ldi		yl,81
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	jmp	_psc026PROZback




;------------------------------------------------------
;check index=2 (all compare down)
_psc026PROZe:
	cpi		r20,2
	brne	_psc026PROZf
	;down= alle maxwerte nach soll kopieren
	ldi	zh,high(CpareA)	;soll 
	ldi	zl,low(CpareA)	
	ldi	yh,high(CmaxA)	;max
	ldi	yl,low(CmaxA)	
	;copy-loop
_psc026PROZeLOOP:
	ld	r20,y+
	st	z+,r20	
	cpi	yl,low(CmaxA +8)	;Compare low byte
	ldi	r17,high(CmaxA +8)	;
	cpc	yh,r17	;Compare high byte
	brsh	_psc026PROZeGO	;fertig!
	jmp	_psc026PROZeLOOP	;loop !
	;goon
_psc026PROZeGO:
			;----------------------------------------
			;<all-blend-down-state> - event setzen
			ldi		yl,82
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	jmp	_psc026PROZback

;------------------------------------------------------
;check index=3 (all compare up)
_psc026PROZbackX:
	jmp	_psc026PROZback
_psc026PROZf:
	cpi		r20,3
	brne	_psc026PROZback
	;up= alle sollwerte =0
	ldi	zh,high(CpareA)	;soll 
	ldi	zl,low(CpareA)	
	clr	r20
	;copy-loop
_psc026PROZfLOOP:
	st	z+,r20	
	cpi	zl,low(CpareA +8)	;Compare low byte
	ldi	r17,high(CpareA +8)	;
	cpc	zh,r17	;Compare high byte
	brsh	_psc026PROZfGO	;fertig!
	jmp	_psc026PROZfLOOP	;loop !
	;goon
_psc026PROZfGO:
			;----------------------------------------
			;<all-blend-up-state> - event setzen
			ldi		yl,83
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	jmp	_psc026PROZback


;-------------------------------------------------------------
_psc026PROZback:
	;pzHIF=36 (reduzierte all compare maske)
	ldi	r18,36
	jmp	_NcorrY






;-------------------------------------------------------------
;_psc028PROZ	one selected device
;-------------------------------------------------------------

;hif37=one compare auswahl
;hif38=red one auswahl mask
_psc030PROZx:
	jmp		_psc030PROZ
	;
_psc028PROZ:
	cpi	r21,28
	brne	_psc030PROZx
	;prfe ob's noch der alte HIF ist !	
	lds	r18,pzHIF
	cpi	r18,37
	brlo	_psc028PROZb	;ja,erstmaliger aufruf !
	rjmp	_psc028PROZc	;nein,bereits aufgerufen

;----------------------------------------------------------------
;erstmaliger aufruf !
_psc028PROZb:
	lds	r18,paraJ
	sts	paraA,r18
	sts	paraB,r18
	sts	paraC,r18
	;neuer pzHIF (full)
	ldi	r18,37		
	jmp	_NcorrY

;------------------------------------------------------
;check index=0 (back...)
_psc028PROZc:
	lds	r20,CURindex
	tst	r20
	brne	_psc028PROZd
	jmp	_psc028PROZback

	
;------------------------------------------------------
;check index=1 (stop selected compare)
_psc028PROZeX:
	jmp	_psc028PROZe
_psc028PROZd:
	cpi		r20,1
	brne	_psc028PROZeX
	;stop= istwerte nach soll kopieren
	lds	zl,paraJ
	sts	paraA,zl
			;----------------------------------------
			;<stop-blendX-state> - event setzen
			ldi		yl,84
			add		yl,zl	;event + deviceX
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	clr	zh
	subi	zl,low(-CpareA)	;soll 
	sbci	zh,high(-CpareA)	
	lds	yl,paraJ
	clr	yh
	subi	yl,low(-CpareI1) ;ist
	sbci	yh,high(-CpareI1)	
	ld	r20,y
	st	z,r20
	jmp	_psc028PROZback







;------------------------------------------------------
;check index=2 (sel. compare down)
_psc028PROZe:
	cpi		r20,2
	brne	_psc028PROZf
	;down= sel. maxwert nach soll kopieren
	lds	zl,paraJ
	sts	paraA,zl
			;----------------------------------------
			;<down-blendX-state> - event setzen
			ldi		yl,92
			add		yl,zl	;event + deviceX
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	clr	zh
	subi	zl,low(-CpareA)	;soll 
	sbci	zh,high(-CpareA)	
	lds	yl,paraJ
	clr	yh
	subi	yl,low(-CmaxA) ;max
	sbci	yh,high(-CmaxA)	
	ld	r20,y
	st	z,r20
	jmp	_psc028PROZback



;------------------------------------------------------
;check index=3 (sel. compare up)
_psc028PROZbackX:
	jmp	_psc028PROZback
_psc028PROZf:
	cpi		r20,3
	brne	_psc028PROZback
	;up= alle sollwerte =0
	lds	zl,paraJ
	sts	paraA,zl
			;----------------------------------------
			;<up-blendX-state> - event setzen
			ldi		yl,100
			add		yl,zl	;event + deviceX
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	clr	zh
	subi	zl,low(-CpareA)	;soll 
	sbci	zh,high(-CpareA)	
	clr	r20
	st	z,r20
	jmp	_psc028PROZback


;-------------------------------------------------------------
_psc028PROZback:
	;pzHIF=38 (reduzierte sel.compare maske)
	ldi	r18,38
	jmp	_NcorrY












;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++ DIREKT MODE ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	
;----------------------------------------------------------------------------------------------
;##psc030PROZ - direkt mode A:     <deaktiv>,<aktiv>,<alle devices deaktiv>,<alle devices aktiv>
;----------------------------------------------------------------------------------------------
;hif=41 full mask
;hif=42 red.mask
_psc031PROZx:
	jmp	_psc031PROZ
_psc030PROZ:
	cpi	r21,30
	brne	_psc031PROZx
	;prfe ob's noch der alte HIF ist !	
	lds	r18,pzHIF
	cpi	r18,9
	breq	_psc030PROZb	;ja,erstmaliger aufruf !
	rjmp	_psc030PROZc	;nein,bereits aufgerufen

;----------------------------------------------------------------
;erstmaliger aufruf !
_psc030PROZb:
	lds	r20,OUTaktFL	;akt status holen
	sts	glob3ENA,r20	;&temp sichern
	;status anzeigen....
	call	_psc030PROZSHOW
	;bkup
	lds	r18,paraA
	sts	paraJ,r18
	;neuer pzHIF (full)
	ldi	r18,41		
	jmp	_NcorrY

;------------------------------------------------------
;check index=0 (back...)
_psc030PROZc:
	lds	r20,CURindex
	tst	r20
	brne	_psc030PROZd
	jmp	_psc030PROZback

;------------------------------------------------------
;check index=1 (all on/off)
_psc030PROZd:
	lds	r20,CURindex
	cpi	r20,1
	brne	_psc030PROZe
	;status prfen
	;a)>0..<255 == dann alle aus (0)
	;b) 0		== dann alle an  (255)
	;c)255		== dann alle aus (0)
	lds	r20,OUTaktFL	;	glob3ENA	;status holen....
	tst	r20
	breq	_psc030PROZdb
	cpi	r20,0xff
	breq	_psc030PROZdc
	;a&c)
_psc030PROZdc:
				;----------------------------------------
				;<ALLoff-akt-state> - event setzen
				ldi		yl,116
				sts		eventTE,yl			;
				call	_MAKEeventSUB		;submodul !
				;----------------------------------------
	clr	r20
	sts	glob3ENA,r20
	jmp	_psc030PROZdLOOP
	;b)
_psc030PROZdb:
				;----------------------------------------
				;<ALLon-akt-state> - event setzen
				ldi		yl,117
				sts		eventTE,yl			;
				call	_MAKEeventSUB		;submodul !
				;----------------------------------------
	ldi	r20,0xff
	sts	glob3ENA,r20
	jmp	_psc030PROZdLOOP
	;
	;store to aktX
_psc030PROZdLOOP:
	ldi	zl,low(Akdi0)
	ldi	zh,high(Akdi0)
	;copy-loop
_psc030PROZdLOOPx:
	st	z+,r20	
	cpi	zl,low(Akdi0 +8)	;Compare low byte
	ldi	r17,high(Akdi0 +8)	;
	cpc	zh,r17	;Compare high byte
	brsh	_psc030PROZdGO	;fertig!
	jmp	_psc030PROZdLOOPx	;loop !
	;goon
_psc030PROZdGO:
	call	_psc030PROZSHOW
	jmp	_psc030PROZback




;------------------------------------------------------
;check index=2...9 ( on/off)
_psc030PROZe:
	lds		r20,CURindex
	cpi		r20,10
	brsh	_psc030PROZback
	subi	r20,2	;==device
	mov		zl,r20	;bk
	;mask reg. default
	clr		r17
	sec
_psc030PROZsft:
	rol		r17
	tst		r20
	breq	_psc030PROZeGO
	dec		r20
	rjmp	_psc030PROZsft
	;
_psc030PROZeGO:
	lds		r18,glob3ENA
	and		r18,r17		;maske drber...
	;status prfen
	;a)>0..<=255 == dann aus (0)
	;b) 0		== dann an  (255)	
	tst		r18
	breq	_psc030PROZea
	;>0
	lds		r18,glob3ENA
	com		r17
	and		r18,r17		;maske drber...
	sts		glob3ENA,r18
	mov		r20,r18
	clr		r18
			;----------------------------------------
			;<off-aktX-state> - event setzen
			ldi		yl,126
			add		yl,zl	;event + deviceX
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	rjmp		_psc030PROZeSTORE
	;0
_psc030PROZea:
	lds		r18,glob3ENA
	or		r18,r17		;maske drber...
	sts		glob3ENA,r18
	mov		r20,r18
	ldi		r18,0xff
			;----------------------------------------
			;<on-aktX-state> - event setzen
			ldi		yl,118
			add		yl,zl	;event + deviceX
			sts		eventTE,yl			;
			call	_MAKEeventSUB		;submodul !
			;----------------------------------------
	rjmp		_psc030PROZeSTORE
	;
_psc030PROZeSTORE:
	clr		zh	
	subi	zl,low(-Akdi0)
	sbci	zh,high(-Akdi0)
	st		z,r18
	call	_psc030PROZSHOW
	jmp		_psc030PROZback


;back
;-----------------------------
_psc030PROZback:
	;pzHIF=42 (reduzierte akt maske)
	ldi	r18,42
	jmp	_NcorrY





;----------------------------
;sub show input=r20
;----------------------------
_psc030PROZSHOW:
	;status anzeigen....
	ldi	zl,low(paraA)
	ldi	zh,high(paraA)
_psc030PROZLOOP:
	lsr	r20
	brcc	_psc030PROZLOOPb	;bit0==off
	clc
	ldi	r18,0x2b	;+
	jmp	_psc030PROZLOOPc
	;=0
_psc030PROZLOOPb:
	ldi	r18,0x2d	;-
_psc030PROZLOOPc:
	st	z+,r18
	cpi	zl,low(paraA +8)	;Compare low byte
	ldi	r17,high(paraA +8)	;
	cpc	zh,r17	;Compare high byte
	brsh	_psc030PROZloopGO	;fertig!
	jmp	_psc030PROZLOOP	;loop !
_psc030PROZloopGO:
	ret



;----------------------------------------------------------------
;##psc031PROZ  write new paras to macro
;----------------------------------------------------------------
_psc031PROZ:
	cpi	r21,31
	brne	_psc055PROZ
	lds	r17,matrix_flag		;matrix-flag's
	sbrs	r17,runMTX		;
	sbr	r17,1<<makeMTX
	sts	matrix_flag,r17
	;psc=18
	ldi	r21,18
	jmp	_psc018PROZ




;----------------------------------------------------------------
;##psc055PROZ   Program Setup
;----------------------------------------------------------------
_psc055PROZ:
	cpi	r21,55
	brne	_psc056PROZ
	;hif
	ldi	r18,57	;prog. setup auswahl
	jmp	_NcorrY

;----------------------------------------------------------------
;##psc56PROZ   Display Setup
;----------------------------------------------------------------
_psc056PROZ:
	cpi	r21,56
	brne	_psc057PROZ
	;hif
	ldi	r18,58	;display setup auswahl
	jmp	_NcorrY

;----------------------------------------------------------------
;##psc57PROZ   Display EDIT brightness
;----------------------------------------------------------------
_psc057PROZ:
	cpi	r21,57
	brne	_psc058PROZ
	;beim ersten mal hif=59
	;weiter mit hif=60
	lds	r18,pzHIF
	cpi	r18,59
	breq	_psc057PROZb
	cpi	r18,60
	breq	_psc057PROZb
	;wert im HIF darstellen
	;pzHIF pointer=59
	ldi	r18,59
	lds	r17,teDISbr
	sts	paraA,r17
	rjmp	_psc057PROZd
	;ist schon 59, nun 60
_psc057PROZb:
	ldi	r18,60
	lds	r17,paraA
	sts	teDISbr,r17	;empfangenen parameter speichern

_psc057PROZd:
	jmp	_NcorrY



;----------------------------------------------------------------
;##psc58PROZ   Display EDIT contrast
;----------------------------------------------------------------
_psc058PROZ:
	cpi	r21,58
	brne	_psc059PROZ
	;beim ersten mal hif=59
	;weiter mit hif=60
	lds	r18,pzHIF
	cpi	r18,61
	breq	_psc058PROZb
	cpi	r18,62
	breq	_psc058PROZb
	;wert im HIF darstellen
	;pzHIF pointer=61
	ldi	r18,61
	lds	r17,teDISco
	sts	paraA,r17
	rjmp	_psc058PROZd
	;ist schon 61, nun 62
_psc058PROZb:
	ldi	r18,62
	lds	r17,paraA
	sts	teDISco,r17	;empfangenen parameter speichern

_psc058PROZd:
	jmp	_NcorrY

;----------------------------------------------------------------
;##psc59PROZ   Secure Area Entry
;---------------------------------------------------------------
_psc059PROZ:
	cpi	r21,59
	brne	_psc060PROZ
	;PZhif=63
	ldi	r18,63
	jmp	_NcorrY

_psc060PROZ:
	cpi	r21,60
	brne	_psc061PROZ
	;hier programm-modul aktivieren
	;& prozess-modul deaktivieren
	;prozPSC=0
	clr	r21
	sts	prozPSC,r21		;psc sichern (process-modul)	
	;progPSC=1
	ldi	r16,1
	sts	progPSC,r16
	;HIF's=0
	clr	r17
	sts	prHIF,r17
	sts	pzHIF,r17
;test
;direkter sprung zum prog-modul
	jmp	_psc1CK






;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
;##psc061PROZ	HOT SHOTS -------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
;features:
;- zugriff auf definierte hosts (freigabe im progOB16..)
;- kommunikation im dma-mode 
;
;entry:
;cursor position 4 im <dynamic-processes>-screen (psc8/hif5)
;...................................................................................................
;
;A)start execute hot-shot...
;- hot shot 0..4 auswhlen
;- definierte host-target adressen suchen und sequenziell abarbeiten
;
;WICHTIG!
;- entspricht die host-adresse der aktuellen system-hostadresse dann intern abarbeiten
;- Analog Full-Remote: bertragung von eventgesteuerten Object-& DMA-Frames bei aktiviertem Group-Access gesperrt !
; 
	;hot shot events
	;181= hot shot 0 -event + 
	;182= hot shot 1 -event +
	;183= hot shot 2 -event +
	;184= hot shot 3 -event +
	;185= hot shot 4 -event +
;.................................................................................................. 
;
;...................................................................................................
_psc062PROZx:
	jmp	_psc062PROZ

_psc061PROZ:
	cpi	r21,61
	brne	_psc062PROZx
	;erster aufruf der funktion
	lds	r18,pzHIF
	cpi	r18,66
	brlo	_psc061PROZa	;<  66 first call
	jmp		_psc061PROZb	;>= 66 loop	


;............................................................
;.......... first call ......................................
;............................................................

_psc061PROZa:
	;load HOTnumb & display in ASCII
	lds	r17,HOTnumb
	ldi	r20,0x30
	add	r17,r20
	sts	paraA,r17
	;bk
	sts	paraI,r17
	;---------------
	;load HS-Name & display (paraB...paraG)
	;-> calc adress
	call	_HScalcADR		
	;bytes to read from e2p...
	ldi	r19,6
	sts	HOTe2doSIZ,r19
	;store bytes to sram...
	ldi	zl,low(paraB)
	ldi	zh,high(paraB)
	sts	HOTparadrL,zl
	sts	HOTparadrH,zh
	;save actually status counter
	sts	paraO,r21
	;new psc
	ldi	r21,62
	;full hif
	ldi	r18,66
	sts	paraN,r18
	;next...
	jmp	_NcorrZ	

;............................................................
;.......... loop call ......................................
;............................................................	
;index=0  back...
_psc061PROZb:
	lds	r20,CURindex
	tst	r20
	brne	_psc061PROZc
	lds		r20,paraFUNC
	sbrs	r20,ediG
	rjmp	_psc061PROZbb
	lds	r17,paraI
	sts	paraA,r17	
	jmp	_psc061PROZback
_psc061PROZbb:
	;back to main menu...
	ldi	r21,8
	jmp	_psc008PROZ	





;............................................................
;.......... loop call ......................................
;............................................................	
;index=1  select hot-shot...
_psc061PROZc:
	cpi	r20,1
	brne	_psc061PROZd
	lds		r20,paraFUNC
	sbrs	r20,ediG
	rjmp	_psc061PROZcc
	;A) select hs on edit ON
	;   => show HSnumb <paraA>
	;   => show HSname <paraB...paraG>
	;HOTnumb
	lds	r17,paraA
	sts	paraI,r17	;bk
	subi r17,0x30   ;-0x30
	sts	HOTnumb,r17	;store to HSnumb
	;HOTname
	;load HS-Name & display (paraB...paraG)
	;-> calc adress
	call	_HScalcADR		
	;bytes to read from e2p...
	ldi	r19,6
	sts	HOTe2doSIZ,r19
	;store bytes to sram...
	ldi	zl,low(paraB)
	ldi	zh,high(paraB)
	sts	HOTparadrL,zl
	sts	HOTparadrH,zh
	;save actually status counter
	sts	paraO,r21
	;new psc
	ldi	r21,62
	;reduced hif
	ldi	r18,67
	sts	paraN,r18
	;next...
	jmp	_NcorrZ	




_psc061PROZbacko:
    ldi r18,50
;    sts phase6,r18             ;THIS IS A MAILFUNCTION TEST - DELETE AFTER ANALYSIS
    rjmp    _psc061PROZback
_psc061PROZbackp:
    ldi r18,100
;    sts phase7,r18             ;THIS IS A MAILFUNCTION TEST - DELETE AFTER ANALYSIS
    rjmp    _psc061PROZback


_psc061PROZcc:
	;B) execute hs on HIFedit OFF & HSedit ON & HSexe=0
	lds	r19,HOTstate
	sbrs	r19,HSon
	rjmp	_psc061PROZbacko	;no further action !
	sbrc	r19,HSexe
	rjmp	_psc061PROZbackp	;no further action !
	;   => prepare to execute (adressing/pointers...)
	;	- group segment counter <HSseg> = 0  
	;A) set execution flag
	sbr	r19,1<<HSexe
	sts	HOTstate,r19
	;B) set segment =0
	clr	r19
	sts	HSseg,r19
	;C) clear exe counter
	sts	HOTpsc,r19
	;back to main menu...
	ldi	r21,8
	jmp	_psc008PROZ	



;............................................................
;.......... loop call ......................................
;............................................................	
;index=2 ...
_psc061PROZd:
	cpi	r20,2
	brne	_psc061PROZback	
	lds	r17,paraI
	sts	paraA,r17	
	jmp	_psc061PROZback



;----------------------------------------------------------------
;back......
_psc061PROZback:
	;ediG check
	;=0 max. mask
	;=1 red. mask
	lds		r22,paraFUNC
	sbrc	r22,ediG
	rjmp	_psc061PROZred
	ldi	r18,66
	jmp	_NcorrY

_psc061PROZred:	
	;pzHIF=67 (reduced hs mask)
	ldi	r18,67
	jmp	_NcorrY


;----------------------------------------------------------------


;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++ INDEPENDENT E2P READ LOOP & ASCII RANGE CHECK ! +++++++++
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
_psc063PROZx:
	jmp	_psc063PROZ
_psc062PROZ:
	cpi	r21,62
	brne	_psc063PROZx
	sbic	eecr,eewe		; EEPE nicht gelscht ?
	rjmp	_psc062PROZback	; warte...
	;ready...
	;A)load quantity
	lds	r19,HOTe2doSIZ
	tst	r19
	breq	_psc062PROZdone
	dec	r19
	sts	HOTe2doSIZ,r19
	;B)load e2p adress
	lds	zl,HOTe2adrL
	lds	zh,HOTe2adrH
	;C)load sram adress
	lds	yl,HOTparadrL
	lds	yh,HOTparadrH
	;D)e2p access
	out	eearh,zh
	out	eearl,zl		; adressierung e2prom
	sbi	eecr,eere		; bereite bertragung aus e2prom vor 
	in	r19,eedr		; kopiere daten aus e2prom nach r18
	;--------------------------
	;check ascii valid range
	;0x21...0x7e
	cpi	r19,0x21
	brsh	_psc062PROZasciiA
	ldi	r19,0x2a	;* default
_psc062PROZasciiA:
	cpi	r19,0x7f
	brlo	_psc062PROZasciiB	
	ldi	r19,0x2a	;* default
	;--------------------------
_psc062PROZasciiB:
	st	y+,r19
	;E)save new sram adress
	sts	HOTparadrL,yl
	sts	HOTparadrH,yh
	;F)new e2p adress +1
	adiw	zh:zl,1
	;G)store new e2p adress
	sts	HOTe2adrL,zl
	sts	HOTe2adrH,zh
	rjmp	_psc062PROZback	;loop...
	;prepare loop exit
_psc062PROZdone:
	;load old psc
	lds	r21,paraO
	;load hif
	lds	r18,paraN
	jmp	_NcorrY
	;back without store
_psc062PROZback:
	jmp	_NcorrZ


;-----------------------------------------------------------------------------------------
;----------------------- SUB CALCULATE STARTADRESS IN HOT-SHOT-SEGMENT 0..4 --------------
;-----------------------------------------------------------------------------------------
			;Startadressing (<HOTnumb>*<hshot_seg_fact>)+ <hot_shot_tbl> +1
			_HScalcADR:
				lds	yl,HOTnumb
				ldi	yh,hshot_seg_fact
				mul	yl,yh
				movw	yh:yl,r1:r0
				subi yl,low(-hot_shot_tbl)
				sbci yh,high(-hot_shot_tbl)
				adiw	yh:yl,1
				sts	HOTe2adrL,yl
				sts	HOTe2adrH,yh
				ret	












;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
;##psc063PROZ	DYNAMIC SENSORIC PARAMETER DISPLAY ------------------------------------------------
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
;select para category menu (hif=68)
;select a para within the category (hif=69...80) FULL // (hif=81...92) REDUCED


_psc063PROZ:
	cpi	r21,63
	brne	_psc064PROZ
	;pzHIF=68 (para menu)
	ldi	r18,68
	jmp	_NcorrY





;............................................................
;.......... define for selected category ....................
;............................................................

;select a-temp paras
_psc064PROZ:
	cpi	r21,64
	brne	_psc065PROZ
	;full hif
	ldi	yl,69
	sts	paraL,yl
	;red hif
	ldi	yl,81
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,0
	sts	paraJ,yl
	;store max. paras
	ldi	zl,5
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ



;---------------------------------------------------------------
;select	i-temp paras
_psc065PROZ:
	cpi	r21,65
	brne	_psc066PROZ
	;full hif
	ldi	yl,70
	sts	paraL,yl
	;red hif
	ldi	yl,82
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,10
	sts	paraJ,yl
	;store max. paras
	ldi	zl,5
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ
	


;---------------------------------------------------------------
;select	humidity paras
_psc066PROZ:
	cpi	r21,66
	brne	_psc067PROZ
	;full hif
	ldi	yl,71
	sts	paraL,yl
	;red hif
	ldi	yl,83
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,20
	sts	paraJ,yl
	;store max. paras
	ldi	zl,5
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ





;---------------------------------------------------------------
;select	pressure paras
_psc067PROZ:
	cpi	r21,67
	brne	_psc068PROZ
	;full hif
	ldi	yl,72
	sts	paraL,yl
	;red hif
	ldi	yl,84
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,30
	sts	paraJ,yl
	;store max. paras
	ldi	zl,5
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ



;---------------------------------------------------------------
;select	rotation paras
_psc068PROZ:
	cpi	r21,68
	brne	_psc069PROZ
	;full hif
	ldi	yl,73
	sts	paraL,yl
	;red hif
	ldi	yl,85
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,40
	sts	paraJ,yl
	;store max. paras
	ldi	zl,5
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ


;---------------------------------------------------------------
;select	current paras
_psc069PROZ:
	cpi	r21,69
	brne	_psc070PROZ
	;full hif
	ldi	yl,74
	sts	paraL,yl
	;red hif
	ldi	yl,86
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,50
	sts	paraJ,yl
	;store max. paras
	ldi	zl,10
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ


;---------------------------------------------------------------
;select	voltage paras
_psc070PROZ:
	cpi	r21,70
	brne	_psc071PROZ
	;full hif
	ldi	yl,75
	sts	paraL,yl
	;red hif
	ldi	yl,87
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,70
	sts	paraJ,yl
	;store max. paras
	ldi	zl,10
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ


;---------------------------------------------------------------
;select	speed paras
_psc071PROZ:
	cpi	r21,71
	brne	_psc072PROZ
	;full hif
	ldi	yl,76
	sts	paraL,yl
	;red hif
	ldi	yl,88
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,90
	sts	paraJ,yl
	;store max. paras
	ldi	zl,5
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ



;---------------------------------------------------------------
;select	brightness paras
_psc072PROZ:
	cpi	r21,72
	brne	_psc073PROZ
	;full hif
	ldi	yl,77
	sts	paraL,yl
	;red hif
	ldi	yl,89
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,100
	sts	paraJ,yl
	;store max. paras
	ldi	zl,5
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ


;---------------------------------------------------------------
;select	noise & audio paras
_psc073PROZ:
	cpi	r21,73
	brne	_psc074PROZ
	;full hif
	ldi	yl,78
	sts	paraL,yl
	;red hif
	ldi	yl,90
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,110
	sts	paraJ,yl
	;store max. paras
	ldi	zl,5
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ



;---------------------------------------------------------------
;select	timing paras
_psc074PROZ:
	cpi	r21,74
	brne	_psc075PROZ
	;full hif
	ldi	yl,79
	sts	paraL,yl
	;red hif
	ldi	yl,91
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,120
	sts	paraJ,yl
	;store max. paras
	ldi	zl,5
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ


;---------------------------------------------------------------
;select	position paras
_psc075PROZ:
	cpi	r21,75
	brne	_psc076PROZ
	;full hif
	ldi	yl,80
	sts	paraL,yl
	;red hif
	ldi	yl,92
	sts	paraI,yl
	;set add factor for para(SRAM) & hys(E2P)
	ldi	yl,130
	sts	paraJ,yl
	;store max. paras
	ldi	zl,5
	sts	paraK,zl
	;goon...
	ldi	r21,76	;!!!!
	jmp	_psc076PROZ
















;............................................................
;.......... select para within th category ......................................
;............................................................

_psc077PROZx:
	jmp	_psc077PROZ
_psc076PROZ:
	cpi	r21,76
	brne	_psc077PROZx
	;erster aufruf der funktion
	lds	r18,pzHIF
	cpi	r18,69
	brlo	_psc076PROZa	;<  69 first call
	jmp		_psc076PROZb	;>= 69 loop	

;............................................................
;.......... first call ......................................
;............................................................
_psc076PROZa:
	;show parameter numb (start =0) ascii 0x30
	ldi	yl,0x30
	sts	paraA,yl
	sts	paraO,yl	;bk
	;clear paraB
	ldi	yl,0x20
	sts	paraB,yl
	;
	;calculate parameter-adress
	clr	yh
	lds	yl,paraJ	;add factor
	subi	yl,low(-Atemp1H)
	sbci	yh,high(-Atemp1H)
	sts	paraM,yl
	sts	paraN,yh
	;
	ld	zh,y+	;msb para-data
	ld	zl,y
	;
	;
	;+++++++++++++++++++++++++++
	;make digits
	call	_CALC16PRODIG
	;+++++++++++++++++++++++++++
	;
	;
	;
	;back with full hif
	lds	r18,paraL
	jmp	_NcorrY





;.......... loop ............................................
;index=0 back to para category menu
_psc076PROZb:
	lds	r19,curINDEX
	tst	r19
	brne	_psc076PROZc	
	;edit?
	lds		r20,paraFUNC
	sbrc	r20,ediG
	rjmp	_psc076PROZbEDI
	;back jump...
	ldi	r21,63
	jmp	_psc063PROZ
	;
	;
_psc076PROZbEDI:
	lds	r19,paraO
	sts	paraA,r19
	;red.hif
	lds	r18,paraI	
	jmp	_NcorrY




;.......... loop ............................................
;index=1 select para 0...paraMAX  within para category 
_psc076PROZdX:
	jmp	_psc076PROZd
_psc076PROZc:
	cpi	r19,1
	brne	_psc076PROZdX	
	;edit?
	lds		r20,paraFUNC
	sbrs	r20,ediG
	rjmp	_psc076PROZcNOEDI
	;edit & display once !
	lds	zl,paraA	;ascii
	sts	paraO,zl	;bk		
	subi	zl,0x30 ;=bin
	lds	zh,paraK	;max para/category
	cp	zl,zh
	brlo	_psc076PROZcOK
	;to high
	subi	zh,1
	;ascii korr
	ldi	r22,0x30
	add	r22,zh
	;
	sts	paraA,r22
	sts	paraO,r22	;bk	
	mov	zl,zh
_psc076PROZcOK:
	;calculate parameter-adress
	;add para-numb *2
	ldi	zh,2
	mul	zl,zh
	movw	zh:zl,r1:r0
	clr	yh
	lds	yl,paraJ	;add factor
	;add factor + numb*2
	add	yl,zl
	adc	yh,zh
	;add startadress
	subi	yl,low(-Atemp1H)
	sbci	yh,high(-Atemp1H)
	sts	paraM,yl
	sts	paraN,yh
	;
	ld	zh,y+	;msb para-data
	ld	zl,y
	;
	;.............................
	;make digits
	call	_CALC16PRODIG
	;............................
	;
	;back with red hif
	lds	r18,paraI
	jmp	_NcorrY



	;goto dynamic display loop.....
_psc076PROZcNOEDI:
	;set cursor to back
	clr	zl
	sts	curINDEX,zl
	;repeat counter
	ldi	zl,0xff
	sts	paraP,zl

	ldi	zl,0
	sts	WTremPROC,zl
	;remote ?
	lds	zl,remFLAG
	sbrs	zl,RTactivS
	rjmp	_psc076PROZcNOEDIxx
	;bei remote verzgern
	ldi	zl,3
	sts	WTremPROC,zl
_psc076PROZcNOEDIxx:
	;
	ldi	r21,77
	jmp	_NcorrX	;_psc077PROZ



;.......... loop ............................................
;index>1 do nothing
_psc076PROZd:
	lds	r19,paraO
	sts	paraA,r19
	;red.hif
	lds	r18,paraI	
	jmp	_NcorrY







;............................................................
;.......... display parameter dynamic .......................
;............................................................

_psc250PROZx:
	jmp	_psc250PROZ
_psc077PROZ:
	cpi	r21,77
	brne	_psc250PROZx
	;edit?
	lds		r20,paraFUNC
	sbrs	r20,ediG
	rjmp	_psc077PROZNOEDI
	;clear edit
	cbr	r20,1<<ediG
	sts	paraFUNC,r20
	;set cursor to select
	ldi	zl,1
	sts	curINDEX,zl
	;start hif
	ldi	r18,68
	sts	pzHIF,r18
	;jump back to last menu...
	ldi	r21,76
	jmp	_psc076PROZ
	;
	;

_psc077PROZNOEDI:
	;check repeat counter
	lds	zl,paraP
	tst	zl 
	breq	_psc077PROZgoA	
	dec	zl
	sts	paraP,zl
	jmp	_NcorrZ
	;check repeat delay (remote)
_psc077PROZgoA:
	lds	zl,WTremPROC
	tst	zl
	breq	_psc077PROZgo
	dec	zl
	sts	WTremPROC,zl
	ldi	zl,0xff
	sts	paraP,zl
	jmp	_NcorrZ




	;
_psc077PROZgo:
	ldi	zl,0xff
	sts	paraP,zl
	
	ldi	zl,0
	sts	WTremPROC,zl
	;remote ?
	lds	zl,remFLAG
	sbrs	zl,RTactivS
	rjmp	_psc077PROZgoB
	ldi	zl,3
	sts	WTremPROC,zl
_psc077PROZgoB:
	;	
	lds	yl,paraM
	lds	yh,paraN
	;
	ld	zh,y+	;msb para-data
	ld	zl,y
	;...........................
	;make digits
	call	_CALC16PRODIG
	;............................
	;restore paraA
	lds	r19,paraO
	sts	paraA,r19
	;back with red hif
	lds	r18,paraI
	jmp	_NcorrY






;----------------------------------------------------------------
_psc250PROZ:
	jmp	_NcorrX





;............................................................................................
;*** SUB16bit - lse 16bit parameter (zh/zl) nach digits auf / hilfsregister=r22/yl/yh
;............................................................................................

_CALC16PRODIG:
	;check neg./pos range
	lds	r22,paraJ	;add factor
	cpi	r22,11
	brsh	_CALC16PRODIGconvert	;>=11
	;temp categories use negativ & positiv range
	;Vin(max) =5V
	;Vref(Vcc)=5,12V 
	;calculate: (((Vin*1024)/Vref)*5) = MAX.VALUE 5000
	;zero val.=2500
	ldi	yl,low(2500)
	ldi	yh,high(2500)
	cp	zl,yl
	cpc	zh,yh
	brlo	_CALC16PRODIGnegate	;<2500
	breq	_CALC16PRODIGzero	;=2500
	;....................................
	;>2500	  
	sub	zl,yl
	sbc	zh,yh
	;+
	ldi	r22,0x2b
	sts	paraB,r22
	rjmp	_CALC16PRODIGconvert	
	;...................................
	;=0
_CALC16PRODIGzero:
	sub	zl,yl
	sbc	zh,yh
	;space
	ldi	r22,0x20
	sts	paraB,r22
	rjmp	_CALC16PRODIGconvert	
	;...................................
	;<2500
_CALC16PRODIGnegate:
	sub	yl,zl
	sbc	yh,zh
	movw	zh:zl,yh:yl
	;-
	ldi	r22,0x2d
	sts	paraB,r22

_CALC16PRODIGconvert:
	;prepare
	clr	r22
	sts	digitA,r22
	sts	digitB,r22
	sts	digitC,r22
	sts	digitD,r22
	sts	digitE,r22
	;A) zh/zl >50000?
	cpi	zl,low(kon50tsd)	
	ldi	r22,high(kon50tsd)	;
	cpc	zh,r22	
	brlo	_CALC16PRODIGB		;<50000
	;>=50000
	ldi	r22,5
	sts	digitA,r22
	;zh/zl-50000
	subi	zl,low(kon50tsd)
	sbci	zh,high(kon50tsd)
	;........................
	;B)zh/zl >10000
_CALC16PRODIGB:
	cpi	zl,low(kon10tsd)	
	ldi	r22,high(kon10tsd)	;
	cpc	zh,r22	
	brlo	_CALC16PRODIGC		;<10000
	;>=10000
	lds	r22,digitA
	inc	r22
	sts	digitA,r22
	;zh/zl-10000
	subi	zl,low(kon10tsd)
	sbci	zh,high(kon10tsd)
	jmp	_CALC16PRODIGB
	;........................
	;C)>5000
_CALC16PRODIGC:
	cpi	zl,low(kon5tsd)	
	ldi	r22,high(kon5tsd)	;
	cpc	zh,r22	
	brlo	_CALC16PRODIGD		;<5000
	;>=5000
	ldi	r22,5
	sts	digitB,r22
	;zh/zl-5000
	subi	zl,low(kon5tsd)
	sbci	zh,high(kon5tsd)
	;........................
	;D)>=1000
_CALC16PRODIGD:
	cpi	zl,low(kon1tsd)	
	ldi	r22,high(kon1tsd)	;
	cpc	zh,r22	
	brlo	_CALC16PRODIGE		;<1000
	;>=1000
	lds	r22,digitB
	inc	r22
	sts	digitB,r22
	;zh/zl-1000
	subi	zl,low(kon1tsd)
	sbci	zh,high(kon1tsd)
	jmp	_CALC16PRODIGD
	;........................
	;E)>500
_CALC16PRODIGE:
	cpi	zl,low(kon5hun)	
	ldi	r22,high(kon5hun)	;
	cpc	zh,r22	
	brlo	_CALC16PRODIGF		;<500
	;>=500
	ldi	r22,5
	sts	digitC,r22
	;zh/zl-500
	subi	zl,low(kon5hun)
	sbci	zh,high(kon5hun)
	;........................
	;F)zh/zl >100
_CALC16PRODIGF:
	cpi	zl,low(kon1hun)	
	ldi	r22,high(kon1hun)	;
	cpc	zh,r22	
	brlo	_CALC16PRODIGG		;<100
	;>=100
	lds	r22,digitC
	inc	r22
	sts	digitC,r22
	;zh/zl-100
	subi	zl,low(kon1hun)
	sbci	zh,high(kon1hun)
	jmp	_CALC16PRODIGF
	;........................
	;G)>50
_CALC16PRODIGG:
	cpi	zl,low(kon5zig)	
	ldi	r22,high(kon5zig)	;
	cpc	zh,r22	
	brlo	_CALC16PRODIGH		;<50
	;>=50
	ldi	r22,5
	sts	digitD,r22
	;zh/zl-50
	subi	zl,low(kon5zig)
	sbci	zh,high(kon5zig)
	;........................
	;H)zh/zl >10
_CALC16PRODIGH:
	cpi	zl,low(kon1zehn)	
	ldi	r22,high(kon1zehn)	;
	cpc	zh,r22	
	brlo	_CALC16PRODIGI		;<10
	;>=10
	lds	r22,digitD
	inc	r22
	sts	digitD,r22
	;zh/zl-10
	subi	zl,low(kon1zehn)
	sbci	zh,high(kon1zehn)
	jmp	_CALC16PRODIGH
	;........................
	;<10
_CALC16PRODIGI:
	sts	digitE,zl

;.....................................
;..... convert to ascii ..............
;..  *  clear digit A/B/C if zero ....
;..  *  diaplay zero measure range ...
;.....................................

	;make ascii dig's
	ldi	zl,0x20	;space
	ldi	zh,0x30	;ascii add
	;...........................
	;test digitA
	lds	r22,digitA
	tst	r22
	brne	_CALC16PROaADDa	
	;0= space
	mov	r22,zl
	sts	paraC,r22
	rjmp	_CALC16PROaADDb	
	;not zero
_CALC16PROaADDa:
	add	r22,zh
	sts	paraC,r22
	;
	lds	r22,digitB
	add	r22,zh
	sts	paraD,r22
	;
	lds	r22,digitC
	add	r22,zh
	sts	paraE,r22
	;
	jmp	_CALC16PROaADDf

	;..........................
_CALC16PROaADDb:
	;test digitB
	lds	r22,digitB
	tst	r22
	brne	_CALC16PROaADDc	
	;0= space
	mov	r22,zl
	sts	paraD,r22
	rjmp	_CALC16PROaADDd	
	;not zero
_CALC16PROaADDc:
	add	r22,zh
	sts	paraD,r22
	;
	lds	r22,digitC
	add	r22,zh
	sts	paraE,r22
	;
	jmp	_CALC16PROaADDf
	;..........................
_CALC16PROaADDd:
	;test digitC
	lds	r22,digitC
	tst	r22
	brne	_CALC16PROaADDe	
	;0= space
	mov	r22,zl
	sts	paraE,r22
	rjmp	_CALC16PROaADDf	
_CALC16PROaADDe:
	add	r22,zh
	sts	paraE,r22
	;..........................
_CALC16PROaADDf:
	lds	r22,digitD
	add	r22,zh
	sts	paraF,r22
	;
	lds	r22,digitE
	add	r22,zh
	sts	paraH,r22
	;............................
	;TEST
	;set comma
	ldi	r22,0x2c
	sts	paraG,r22
	;TEST END
	;............................
	ret

;..........................................................



;************************************************************
;sub
;************************************************************
_decKdev:
	;nun prfen ob & welche devices zum port gefhrt werden
	;
	;* ,aktivierung-byte'-Info-Tabelle :
	; _______________________________________
	;|    |    |    |    |    |    |    |    |
	;|bit7|bit6|bit5|bit4|bit3|bit2|bit1|bit0|
	;|____|____|____|____|____|____|____|____|
	;|execute bit's |Dev-bit's|category bit's|
	;|-> portx.0-7  |         |-> 0-5        |
	;|______________|_________|______________|
	;selektionsstart
	ldi	zh,high(akt1)
	ldi	zl,low(akt1)
	lds	r19,katVAR		;soll kategorie holen
	lds	r16,devFLAG		;device flags
	;parameter pointer auf paraA
	ldi	yh,high(paraA)
	sts	paraPOINTh,yh
	ldi	yl,low(paraA)
	sts	paraPOINTl,yl
	;zuerst alle para's
	;0x20 setzen
	ldi	r17,0x20
	ldi	r20,8
_decKdevLOOPa:
	tst	r20
	breq	_decKdevA
	dec	r20
	st	y+,r17	
	rjmp	_decKdevLOOPa
	;
_decKdevA:
	;aktX holen
	lds	yl,paraPOINTl
	lds	yh,paraPOINTh
	ld	r17,z
	mov	r20,r17
	andi	r17,0b00000011	;nur kategorie freigeben
	cp		r17,r19 	;kategorie OK? 
	brne	_decKdevCK
	;kategorie enthalten !
	;welches device?
	mov		r17,r20
	lsr		r17
	lsr		r17
	andi	r17,0b00000111
	;deviceX+parapoint
	clr	r20
	add	yl,r17
	adc	yh,r20
	ldi	r17,0x2b		;,+'
	st	y,r17		;zu hif parameter
	;
	;prfe ob alle akt-variablen geprft?
_decKdevCK:
	cpi	zl,low(akt8)	;Compare low byte
	ldi	r17,high(akt8)	;
	cpc	zh,r17	;Compare high byte
	brsh	_decKdevHOME	;fertig!
	;pointer +1
	adiw	zh:zl,1
	jmp	_decKdevA
_decKdevHOME:
	ret



;

;-------------------------------------------------------------------------------------------------------------------	
;##_Ncorr  rcksprung & sicherung 
;-------------------------------------------------------------------------------------------------------------------

;spi-decoder flags lschen
;hif transfer freigeben
_NcorrY:
	;pzHIF als backup speichern
	sts	PUpzHIF,r18
	sts	prozPSC,r21		;psc sichern (process-modul)	
_NcorrYY:
	;prfe ob spi aktiv
	lds	r17,comFLAGspi
	sbrc	r17,spiBUSY
	rjmp	_NcorrW
  	;jetzt spi frei - aber etwas
	;zeit lassen um kollisionen
	;zu vermeiden...
	sbrs	r17,repSPItrPZ
	rjmp	_NcorrYgo
	;nun timeoutcounter prfen
	lds	r18,HIFtiLOOP
	tst	r18
	breq	_NcorrYgo	;0= ok
	dec	r18
	sts	HIFtiLOOP,r18
	jmp	_NcorrW
	;
_NcorrYgo:
	;default timeloop
	ldi	r18,5   ;5
	sts		HIFtiLOOP,r18
	;
	lds	r18,PUpzHIF	
	sts	pzHIF,r18
	lds	r17,comFLAGspi
	sbr	r17,1<<newSPIsnd	;neuen transfer zum HIF freigeben
	cbr	r17,1<<exeSPIdata	;ausfhrung beenden
	sbr	r17,1<<spiMready
	sbr	r17,1<<spiBUSY		;nun spi fr weitere module sperren
	cbr	r17,1<<repSPItrPZ	;wiederholflag lschen
	sts	comFLAGspi,r17
	ret

;spi noch aktiv ODER timeoutcounter aktiv. also senden wenn frei...
_NcorrW:
	sbr	r17,1<<repSPItrPZ	;wiederholflag setzen
	sts	comFLAGspi,r17
	ret



;spi-decoder flags lschen
;hif transfer sperren
_NcorrX:	
	lds	r17,comFLAGspi
	cbr	r17,1<<newSPIsnd	;neuen transfer zum HIF sperren
	cbr	r17,1<<exeSPIdata	;ausfhrung beenden
	sts	comFLAGspi,r17
_NcorrZ:
	sts	prozPSC,r21		;psc sichern (process-modul)	
_NcorrZZ:
	ret



;******************************************************************************************
;******************************************************************************************








;---------------------------------------------------
;##psc000RTC  dynamische rtc einblendung
;---------------------------------------------------
_psc000RTC:
	;
	;--------------------------------
	;HIF check
	;--------------------------------
	lds	r18,pzHIF
	cpi	r18,64	;schon zeitanzeige?
	brne 	_TIMEdHIFckB
	;nur rtc zeile
	;pzHIF=65
	ldi	r18,65
	clr	r21
	jmp	_TIMEdHIFckD
	;
_TIMEdHIFckB:
	cpi	r18,65
	brne	_TIMEdHIFckC		
	clr	r21
	jmp	_TIMEdHIFckD
	;
_TIMEdHIFckC:
	;rtc-zeile mit header-text
	ldi	r18,64
	clr	r21
	jmp	_TIMEdisplayGO
	;
_TIMEdHIFckD:
	;hier sekunde 0 prfen
	lds	r22,rtcFLAG
	lds	yl,sekunS		;sekunden holen
	tst	yl			;sekunde 0 ?
	brne	_NcorrZZZ
	sbrs	r22,showTD
	rjmp	_NcorrZZ
	jmp	_TIMEdisplayGO
_NcorrZZZ:
	sbr	r22,1<<showTD
	sts	rtcFLAG,r22
	jmp	_NcorrZZ



;---------------------------------------------------------------------------------------
;zeitanzeige im hif-moodul
;-------------------------------------------------------------------------------------		:
;---------------------------------------------------------------
;stunden/minuten aktualisiert anzeigen
;---------------------------------------------------------------
;speicherorte
;.equ	wdayASCIIa		
;.equ	wdayASCIIb	
;.equ	dayNUM			
;.equ	monthASCIIa	
;.equ	monthASCIIb		
;.equ	monthASCIIc	
;.equ	yearNUM		
;.equ	hourNUM		
;.equ	minNUM	
;.equ	dcfASCII	
;.equ	rtcFLAG		

_TIMEdisplayGO:
	;anzeigen wenn fertig berechnet
	lds	r22,rtcFLAG
	sbrs r22,calREADY
	rjmp	_NcorrZZ
	cbr	r22,1<<showTD
	sts	rtcFLAG,r22

	;nun tag xx
	lds	r19,wdayASCIIa
	sts	paraA,r19
	lds	r19,wdayASCIIb
	sts	paraB,r19
	;
	;nun datum xx
	lds	r22,tageS
	call	makDIGB
	sts	paraC,yl	;10er
	sts	paraD,r22	;1er


	;nun monat xxx
	lds	r19,monthASCIIa
	sts	paraE,r19
	lds	r19,monthASCIIb
	sts	paraF,r19
	lds	r19,monthASCIIc
	sts	paraG,r19
	;
	;nun jahr xx
	lds	r22,jahrS	
	call	makDIGB
	sts	paraH,yl	;10er
	sts	paraI,r22	;1er
	;
	;nun stunde xx
	lds	r22,stundS
	call	makDIGB
	sts	paraJ,yl	;10er
	sts	paraK,r22	;1er
	;
	;nun minute xx
	lds	r22,minutS	
	call	makDIGB
	sts	paraL,yl	;10er
	sts	paraM,r22	;1er
	;
	;dcf status -/+
	lds	r19,dcfASCII
	sts	paraN,r19
	;
	jmp	_NcorrY


	;--------------------------------
	;digit(ascii) aus 8bit parameter
	;--------------------------------
makDIGB:
	;nun wert in digits zerlegen...
	;
	clr	yl	;zehner
	clr	yh	;hunderter
	;
	;>100?
_makDIGhunB:
	cpi	r22,100
	brsh	_makDIGhunINCB
_makDIGtenB:
	cpi	r22,10
	brlo	_makDIGoneB	
	;-10
	subi	r22,10
	inc		yl	
	jmp	_makDIGtenB

_makDIGoneB:
	;nach ascii...
	ldi	zl,0x30
	add	r22,zl
	add	yl,zl
	add	yh,zl
	;einer== r22
	;zehner==yl
	;hunderter==,yh
	ret
	;
	;-100
_makDIGhunINCB:
	subi	r22,100
	inc		yh
	jmp	_makDIGhunB













