;--------------------------------------------------------------------------------------------------
;wochentag/datum-anzeige
;--------------------------------------------------------------------------------------------------

;basis:	- schaltjahr ? (2004/2008/2012/2016/2020/2024/2028/2032/2036/2040...)
;		- 1.montag des jahres (+0 ...+7)
;		- monat (1...12)
;		- tag (1...31)
;		- jahr (01...40)
;--------------------------------------------------------------------------------------------------
;input-variablen:			- tageS 	= tag
;							- 			= monat
;							- jahrS		= jahr
;
;--------------------------------------------------------------------------------------------------
;temporre variablen:	- JAtagL	=	gesamt tage low (16bit)
;						- JAtagH	=	"       "   high (16bit)
;--------------------------------------------------------------------------------------------------
;konstanten:	- jan =	31
;				- feb = 28 (schaltjahr +1)
;				- mrz =	31
;				- apr = 30
;				- mai = 31
;				- jun = 30
;				- jul = 31
;				- aug = 31
;				- sep = 30
;				- okt = 31
;				- nov = 30
;				- dez = 31
;
;schaltjahrtabelle: _RCmonat   31,28,31,30,31,30,31,31,30,31,30,31,99,99
;					_RTCfirstMO	04,04,01,   05,02,00,   06,01,00,  07,00,00.....
;-------------------------------------------------------------------------------------------------

_date003suX:
	rjmp	_date003su	
_suHOMEa:
	rjmp	_suHOME		
_date001su:
	lds	r22,dateLOOP
	cpi	r22,0
	brne	_date003suX
	;
_date001suFREE:
	lds	r20,dateVAR
	sbrs	r20,kalender
	rjmp	_suHOME
	sbrs	r20,kalLOOP
	rjmp	_date002suSTART	
	rjmp	_date002suREPEAT	

_date002suSTART:
	;
	lds	r21,kalcount
	dec	r21
	sts	kalcount,r21
	tst	r21
	brne	_suHOMEa
	ldi	r21,50
	sts	kalcount,r21
	;
	lds	r18,jahrS	;jahr
_date002su:
    ldi	zh,high(_RTCfirstMO *2)
	ldi	zl,low(_RTCfirstMO *2)
 
 
	rjmp	_date002suLOOP

_date002suREPEAT:
	lds	r18,jahrS	;jahr
	lds	zh,storeKAh
	lds	zl,storeKAl
_date002suLOOP:
	nop
	nop
	lpm
	nop
	nop
	mov	r19,r0
	cpi	r19,99
	breq	_SUyearOUTrange	;kein passendes jahr !!!
	cp	r18,r19
	breq	_SUyearEQU		;das jahr passt !
	adiw 	zl,3
	;
	sts	storeKAl,zl
	sts	storeKAh,zh
	sbr	r20,1<<kalLOOP
	sts	dateVAR,r20
	rjmp	_suHOME

_SUyearEQU:
	adiw	zl,1
	lpm				
	mov		r19,r0			;hier der korrekturfaktor ,1.montag des jahres'
	adiw	zl,1
	lpm		
	tst	r0
	brne	_SUyearSCHALT
	cbr		r20,1<<schaltFL
	rjmp	_SUyearSTORE
_SUyearSCHALT:
	sbr		r20,1<<schaltFL
_SUyearSTORE:
	;
	sts		yearKORR,r19	;korrekturfaktor wg. wochentag berechnung
	ldi	r22,1
	cbr	r20,1<<kalLOOP
	sts		dateVAR,r20		;flag variable f. schaltjahr etc. sichern
	rjmp	_suHOME

_SUyearOUTrange:
	cbr	r20,1<<kalLOOP
	sts		dateVAR,r20		;flag variable f. schaltjahr etc. sichern
	ldi		r20,80
	sts		jahrS,r20	;jahr
	rjmp	_suHOME






;---------------------------------------------------------------------------------------

_suHOMEb:
	rjmp	_suHOME	
	;	
_date003su:
	cpi	r22,1
	brne	_date004su
	;
	lds	r20,kalcount
	dec	r20
	sts	kalcount,r20
	tst	r20
	brne	_suHOMEb
	ldi	r20,50
	sts	kalcount,r20
	;
	lds	r17,monatS	;monat

	;TEST wg. overrun
	tst	r17
	breq	_date003suKORR
	cpi	r17,13
	brlo	_date003suGOON
	;out of range
_date003suKORR:	
	ldi	r17,1	
	sts	monatS,r17
	;TEST end

_date003suGOON:
	clr	r10	;tage L
	clr	r11	;tage H
	ldi	r20,0
	subi	r17,1
	ldi	zl,low(_RTCmonat*2)
	ldi	zh,high(_RTCmonat*2)
_date003suLOOP:
	cp	r20,r17
	breq	_date003suFINISH	
	lpm
	clr	r12
	add	r10,r0		;tage des monats
	adc	r11,r12
	inc		r20
	adiw	zl,1
	rjmp	_date003suLOOP
	;
	;
_date003suFINISH:
	sts	JAtagL,r10	;summe der tage der vergangenen monate des jahres 
	sts	JAtagH,r11	; "                    "                  "
	;berechne text-tabellenstart
	ldi	zh,high(_RTCjan*2)
	ldi	zl,low(_RTCjan*2)
	inc	r20
	clr	r17		;h
	ldi	r16,4
	mul	r20,r16
	mov	r16,r0	;l
	subi r16,4
	;
	add		zl,r16	
	adc		zh,r17
	;display MONAT
	lpm	r19,z+
	sts	monthASCIIa,r19 ;daten nach sram & pointer+1
	lpm	r19,z+
	sts	monthASCIIb,r19 ;daten nach sram & pointer+1
	lpm	r19,z
	sts	monthASCIIc,r19 ;daten nach sram 
	;zurck.........
	ldi	r22,2	
	rjmp	_suHOME





;----------------------------------------------------------
;----------------------------------------------------------

_suHOMEc:
	rjmp _suHOME
	;
_date004su:
	cpi	r22,2
	brne	_date005su
	;
	;
	lds	r20,kalcount
	dec	r20
	sts	kalcount,r20
	tst	r20
	brne	_suHOMEc
	ldi	r20,50
	sts	kalcount,r20
	ldi	r22,3
	rjmp	_suHOME


;----------------------------------------------------------
;----------------------------------------------------------


_suHOMEd:
	rjmp	_suHOME	
_date006suX:
	rjmp	_date006su	
_date005su:
	cpi	r22,3
	brne	_date006suX
	;
	;
	lds	r20,kalcount
	dec	r20
	sts	kalcount,r20
	tst	r20
	brne	_suHOMEd
	ldi	r20,50
	sts	kalcount,r20
	;
	lds	r16,tageS	;tag


	;TEST wg. overrun
	tst	r16
	breq	_date005suNEW
	cpi	r16,32
	brlo	_date005suGO
	;out of range
_date005suNEW:	
	ldi	r16,1	
	sts	tageS,r16
	;TEST end


_date005suGO:
	lds	r19,yearKORR	;korrekturfaktor
	;korrekturfehler beheben
	inc	r19
	;
	lds	r21,dateVAR		;flags

;berechne hier nun den wochentag und stelle ihn auf dem lcd dar !
;{JAtag(L/H)} - korrekturfaktor {yearKORR} / 7 = ganze wochen ...rest = wochentag 
;
;schaltjahr: {JAtag(L/H)} > 60 dann bei schaltjahr +1 !
	clr	r20
	lds	r17,JAtagL
	lds	r18,JAtagH
	add	r17,r16	;tage des laufenden monats dazu
	adc	r18,r20
	;
	lds	r20,monatS	;monat 
	cpi	r20,3		;ab mrz prfen ob schaltjahr - dann jahr 1 tag lnger!
	brsh	_date005suSCHALT
	rjmp	_date005suKORR
_date005suSCHALT:
	sbrs	r21,schaltFL
	rjmp	_date005suKORR
	;+1
	subi	r17, low(-ser1K)	;Add low byte ( x -(-y)) = x + y
	sbci	r18, high(-ser1K)	;Add high byte with carry

_date005suKORR:
	;- korrekturfaktor !!!
	mov	yl,r17
	mov	yh,r18
_date005suKORRloop:
	clr	r20
	sub	r17,r19	;- yearKORR
	sbc	r18,r20
	;
	;<0 ??
	brmi	_date005suADDseven
	rjmp	_date005suLOOP	

_date005suADDseven:
	mov	r17,yl
	mov	r18,yh
		;+7
	subi	r17, low(-Wday)	;Add low byte ( x -(-y)) = x + y
	sbci	r18, high(-Wday);Add high byte with carry	
	rjmp	_date005suKORRloop




	;-7 loop
_date005suLOOP:	
	;<=7
	cpi	r17,low(Wday)	;Compare low byte
	ldi	r20,high(Wday)	;
	cpc	r18,r20		;Compare high byte
	brlo	_date005suDIS	;rest == wochentag !!

	;-7	
	subi	r17,low(Wday)	;Subtract low bytes
	sbci	r18,high(Wday)	;Subtract high byte with carry
	rjmp	_date005suLOOP
	;wochentag anzeigen
_date005suDIS:
	;zuerst speichern
	sts	wocheS,r17		;....wochentag f. rtc & timers
	;
	ldi	zl,4
	mul	r17,zl
	mov	r17,r0
	clr	r18
	;
	ldi	zl,low(_RTCmo*2)
	ldi	zh,high(_RTCmo*2)
	add	zl,r17
	adc	zh,r18
	;WOCHENTAG nach ascii-varibale
	lpm	r19,z+
	sts	wdayASCIIa,r19 ;daten nach sram & pointer+1
	lpm	r19,z
	sts	wdayASCIIb,r19 ;daten nach sram
	;
	ldi	r22,4
	rjmp	_date006su	




;------------------------------------------------------------

_date006su	:
	cpi	r22,4
	brne	_suHOME
	;
	lds	r20,kalcount
	dec	r20
	sts	kalcount,r20
	tst	r20
	brne	_suHOME
	ldi	r20,50
	sts	kalcount,r20
	;
	lds	r20,dateVAR
	cbr	r20,1<<kalender
	sts	dateVAR,r20
	;datum komplett
	lds	r22,rtcFLAG
	sbr	r22,1<<calREADY
	sts	rtcFLAG,r22
	;
	clr	r22
	rjmp	_suHOME


;----------------------------------------------------------
;zurck..............
;----------------------------------------------------------
		
_suHOME:
	sts	dateLOOP,r22
	ret



