;--------------------------------------------------------------------------------------------
;------------------------------- zeituhr subroutine -----------------------------------------
;--------------------------------------------------------------------------------------------

_zeitSUB:

	;prfe 10ms-sekunden-flag
	sbrs	tiFLAG,s10msB	;10ms indikator f. zeitanzeige im lc-display
	rjmp	_dirBK		;direkt zurck...		;
	
	;lokale registerdefinition

	lds	r16,sekunS		;sekunde 
	lds	r17,minutS		;minute 
	lds	r18,stundS		;stunde 
	lds	r19,tageS		;tag
	lds	r20,wocheS		;woche
	lds	r21,monatS		;monat
	lds	r22,jahrS		;jahr
	;
	;hier dcf77 aktivitt prfen
	lds	r23,dcf77_status
	sbrs	r23,dcf77sync
	rjmp	_sekCO	;dcf-modul kein signal == interne rtc aktiv...
	;hier sekunden rtc-flag prfen
	lds	r23,time1msFL
	sbrs	r23,dcf1_s
	rjmp	_zeitBK	;& back...
	cbr	r23,1<<dcf1_s
	sts	time1msFL,r23
	rjmp	_zeitBK	;& back...
	;
	;---------------------------------------

_sekCO:		
	cpi	r16,60
	brsh	_minUP		;minuten aktualisieren	;
	rjmp	_zeitBK		;<60sek = zurck (auch dann keine aktualisierung von timer funktionen !)

_minUP:
	;
	subi	r16,60		;>=60....neuer wert = alter wert -60 !
	inc	r17		;+1 minute
	;
	;starte kalender
	lds	zl,dateVAR
	sbr	zl,1<<kalender
	sts	dateVAR,zl

    ;set minute flag
    sbr tiFLAG,1<<m1m


		;..........................................
		;events neu
		ldi	r23,4
		sts	eventTE,r23			;minuten event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................




	;
	cpi	r17,60
	brsh	_stuUP		;stunden aktualisieren
	rjmp	_TIMloopx	;timer aktualisieren

_stuUP:
	clr	r17		;minuten 00
	inc	r18		;+1 stunde
	;
		;..........................................
		;events neu
		ldi	r23,5
		sts	eventTE,r23			;stunden event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	;

	cpi	r18,24		
	brsh	_tagUP		;da ist es 00:00h
	rjmp	_TIMloopx
	
	;nun tag +1
_tagUP:
	clr	r18		
	inc	r19		;+1 tag
	;
	;
		;..........................................
		;events neu
		ldi	r23,6
		sts	eventTE,r23			;tag event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	;
        ;------------------------------------------
        ;start decoding dcf 77 once a day at 00:00
        ;------------------------------------------
	    lds	r23,dcf77_status
        cbr r23,1<<dcf77ena 
        sts dcf77_status,r23
        ;------------------------------------------

	
		;decodermatrix!!!
		;parameter:
		;- schaltjahr ? (wegen februar !)
		;- tage pro monat
		cpi	r21,13
		brlo	_rtcKORREKTmo
		ldi	r21,12
_rtcKORREKTmo:
		subi	r21,1	;monat -1
		ldi	zl,low(_RTCmonat*2)
		ldi	zh,high(_RTCmonat*2)
		add	zl,r21
		adc	zh,r18
		lpm
		mov	zh,r0
		inc	r21	;monatszhler wieder herstellen
		inc	zh	;monatstage aus tabelle+1
;schaltjahr +februar ? dann r18+1
		cpi	r21,2
		brne	_tagNOfebr	
		lds	zl,dateVAR
		sbrs	zl,schaltFL ;1== schaltjahr
		rjmp	_tagNOfebr
		;schaltjahr !!
		inc	zh	;februar +1tag
		rjmp	_tagNOfebr	
;---------------------	
_tagNOfebr:	
	cp	r19,zh			;vergleiche isttage+1 <=> tabellenmaxwert+1
	brsh	_monUP		;da ist es der erste tag des neuen monats 00:00:01h !	
	rjmp	_TIMloopx

;---------------------







	;hier monat +1
_monUP:	
	ldi	r19,1	;1 ter des monats
	inc	r21		;+1 monat
	;
		;..........................................
		;events neu
		ldi	r23,7
		sts	eventTE,r23			;monat event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	;
	cpi	r21,13
	brsh	_zeitOPT	;da ist es der 1.1 eines neuen jahres um 00:01h !
	rjmp	_TIMloopx





	;jahr
_zeitOPT:
		inc	r22	;jahr +1
	;
		;..........................................
		;events neu
		ldi	r23,8
		sts	eventTE,r23			;jahr event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	;
		ldi	r21,1		;der 1 monat
		rjmp	_TIMloopx
	
	
;----------------------------------------------------------------------------------------
;---- timer / schaltuhr - loop  (basis zeituhr 0x60-0x68) ---------------------------------
;----------------------------------------------------------------------------------------

;<timer>0
;minut1	=		;1min	   "     "      6ahex(sram) - 0x64 = 0x6 (e2prom)
;stund1	=	0x6b	;1h	   "     "      6bhex(sram) - 0x64 = 0x7 (e2prom)
;tage1	=	0x6c	;1Tag	   "     "      6chex(sram) - 0x64 = 0x8 (e2prom

;<timer>1
;minut2	=	0x6e	;1min	   "     "      6ehex(sram) - 0x64 = 0xa (e2prom)
;stund2	=	0x6f	;1h	   "     "      6fhex(sram) - 0x64 = 0xb (e2prom)
;tage2	=	0x70	;1Tag	   "     "      70hex(sram) - 0x64 = 0xc (e2prom)

;<timer>2
;minut3	=	0x72	;1min	   "     "      72hex(sram) - 0x64 = 0xe (e2prom)
;stund3	=	0x73	;1h	   "     "      73hex(sram) - 0x64 = 0xf (e2prom)
;tage3	=	0x74	;1Tag	   "     "      74hex(sram) - 0x64 = 0x10(e2prom)

;<timer>3
;minut4	=	0x76	;1min	   "     "      76hex(sram) - 0x64 = 0x12(e2prom)
;stund4	=	0x77	;1h	   "     "      77hex(sram) - 0x64 = 0x13(e2prom)
;tage4	=	0x78	;1Tag	   "     "      78hex(sram) - 0x64 = 0x14(e2prom)
		
;matrix_FL=	0x146	;matrix flag variable    
;runMTX	=	0	;matrix-programmaufruf variable
;
;GLOBtim =      0x71	;global timer (de-)aktivierungsvariable
;GLtim0	=	0	;global timer flag 0
;GLtim1	=	1	;   "          "   1
;GLtim2	=	2	;   "          "   2
;GLtim3	=	3	;   "          "   3	
;
;0x145	=	programmvariable (matrix)

;same0-3 flags wg. wiederholungssperre einbetten !

	

_TIMloopx:
	
	;lokales registerbackup
	sts	sekunS,r16		;sekunde 
	sts	minutS,r17		;minute 
	sts	stundS,r18		;stunde 
	sts	tageS,r19		;tag
	sts	wocheS,r20		;woche
	sts	monatS,r21		;monat
	sts	jahrS,r22		;jahr
	;einige oben verwendeter register wieder frei !

_TIMloopDCFaktiv:
	mov	r6,r17		;minutS
	mov	r7,r18		;stundS
	mov	r8,r19		;tageS

	lds	r20,GLOBtim		;global timer (de-)aktivierungsflagvariable
	lds	r19,matrix_flag	;matrix-flag nach r19
	;---------------------------------------------------------------------
_TIM0:
	sbrc	r20,GLtim0	;timerbetrieb ok?
	rjmp	_TIM0ok
	rjmp	_TIM1
_TIM0ok:		
	;schaltuhr1-sollwerte laden !	
	lds	r10,minut1		;minut1
	lds	r11,stund1		;stund1
	lds	r12,tage1		;tage1
	rcall	_COchk		;
	sbrs	r19,same
	rjmp	_TIM0x
	;vorbereitung programmaufruf
	sbrc	r19,same0
	rjmp	_TIM1
	sbr	r19,1<<same0
	sbr	r19,1<<runMTX
	lds	r22,tim0PRO			;vordefinierten programmplatz holen
	sts	prog_platzA	,r22	;kopiere nach programmplatz-variable (matrix)
		;..........................................
		;events neu
		ldi	r23,39
		sts	eventTE,r23			;timer0 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	jmp	_TIM1
_TIM0x:
	cbr	r19,1<<same0
	;	
	;----------------------------------------------------------------------
	;
	;
_TIM1:
	sbrc	r20,GLtim1	;timerbetrieb ok?
	rjmp	_TIM1ok
	rjmp	_TIM2
_TIM1ok:		
	;schaltuhr2-sollwerte laden !	
	lds	r10,minut2		;minut2
	lds	r11,stund2		;stund2
	lds	r12,tage2		;tage2
	rcall	_COchk		;
	sbrs	r19,same
	rjmp	_TIM1x
	;vorbereitung programmaufruf
	sbrc	r19,same1
	rjmp	_TIM2
	sbr	r19,1<<same1
	sbr	r19,1<<runMTX
	lds	r22,tim1PRO			;vordefinierten programmplatz holen
	sts	prog_platzA,r22		;kopiere nach programmplatz-variable (matrix)
		;..........................................
		;events neu
		ldi	r23,40
		sts	eventTE,r23			;timer1 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	jmp	_TIM2
_TIM1x:
	cbr	r19,1<<same1
	;
	;----------------------------------------------------------------------
	;
_TIM2:
	sbrc	r20,GLtim2	;timerbetrieb ok?
	rjmp	_TIM2ok
	rjmp	_TIM3
_TIM2ok:		
	;schaltuhr3-sollwerte laden !	
	lds	r10,minut3		;minut3
	lds	r11,stund3		;stund3
	lds	r12,tage3		;tage3
	rcall	_COchk		;
	sbrs	r19,same
	rjmp	_TIM2x
	;vorbereitung programmaufruf
	sbrc	r19,same2
	rjmp	_TIM3
	sbr	r19,1<<same2
	sbr	r19,1<<runMTX
	lds	r22,tim2PRO			;vordefinierten programmplatz holen
	sts	prog_platzA,r22		;kopiere nach programmplatz-variable (matrix)
		;..........................................
		;events neu
		ldi	r23,41
		sts	eventTE,r23			;timer2 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	jmp	_TIM3
_TIM2x:
	cbr	r19,1<<same2
	;
	;-----------------------------------------------------------------------
	;
_TIM3:	
	sbrc	r20,GLtim3	;timerbetrieb ok?
	rjmp	_TIM3ok
	rjmp	_tiHOME
_TIM3ok:		
	;schaltuhr4-sollwerte laden !	
	lds	r10,minut4		;minut4
	lds	r11,stund4		;stund4
	lds	r12,tage4		;tage4
	rcall	_COchk		;
	sbrs	r19,same
	rjmp	_TIM3x
	;vorbereitung programmaufruf
	sbrc	r19,same3
	rjmp	_zeitBK
	sbr	r19,1<<same3
	sbr	r19,1<<runMTX
	lds	r22,tim3PRO			;vordefinierten programmplatz holen
	sts	prog_platzA	,r22	;kopiere nach programmplatz-variable (matrix)
	sts	matrix_flag,r19		;timer_FL sichern !
		;..........................................
		;events neu
		ldi	r23,42
		sts	eventTE,r23			;timer3 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	rjmp	_zeitBK
_TIM3x:
	cbr	r19,1<<same3
	sts	matrix_flag,r19		;timer_FL sichern !
	jmp	_zeitBK




	;vergleiche soll/ist werte...
_COchk:
	cbr	r19,1<<same
	cp	r10,r6
	breq	_COsta	;minuten gleich ... nun die Stunden !
	rjmp	_tiHOME;zurck zur hauptschleife
_COsta:
	cp	r11,r7	
	breq	_COtga	;stunden gleich ... nun die tage!
	rjmp	_tiHOME;zurck zur hauptschleife 
_COtga:
	;achtung aufpassen!
	tst	r12	;tage = 0 -> bedeutet datum dann nicht relevant !!!
	breq	_COtgaY
	cp	r12,r8
	brne	_tiHOME
_COtgaY:	
	sbr	r19,1<<same ;alles gleich.....
_tiHOME:
	sts	matrix_flag,r19		;timer_FL sichern !
	ret
	
	
	
;---------------------------------------------------------------------------------------
;----- rcksprung aus subroutine -------------------------------------------------------
;---------------------------------------------------------------------------------------	

_zeitBK:
	rjmp	_dirBK
_dirBK:	
	cbr	tiFLAG,1<<s10msB	;flag lschen
	ret








