;--------------------------------------------------------------------------------------------
;DYNAMIC TIMESLOT MODUL ---------------------------------------------------------------------
;--------------------------------------------------------------------------------------------
;----------Zyklische Abarbeitung durch 55,5s interrupt Aufruf ------------------------------
;INFO: mit Mega128 & 18,32MHz ~ 1050 Instructions/cycle !
;--------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------
;------ folgende globalen variablen werden benutzt: slotCNT(r26),TIflag(r27)
;--------------------------------------------------------------------------------------------


_s111x:
	jmp	_s111
_tiSLOT:
    ;***************************	
    ;erlaubt weitere
    ;nested interrupts
    ;INFO: wenns funktioniert
    ;dann e2p-routinen schtzen
	ldi	r16,tiREL		;s reload 
	out	tcnt0,r16
	in	r16,timsk
	cbr	r16,1<<toie0	;enable overflow interrupt disabled
	out	timsk,r16
    sei
    ;***************************
 	;NEW**************************************************
	lds	r26,SLOTcnt	
	inc	r26		;erhhe globale zeitsegment-variable
	cpi	r26,17
	brlo	_tiSLOTgo	
	ldi	r26,1
	;NEW END**********************************************
_tiSLOTgo:
	sts		SLOTcnt,r26
	;
    ;..................................................
    ;test for stable dimmer unit
	call	_SPEEDloop		;high speed trigger routine
    ;..................................................


	;timing	+++++++++++
	;
	;lokale registerdefinition
	lds	r23,_55iS	;55,5s counter
	lds	r24,_10miS	;10ms takt
	lds	r25,sekunS	;1s counter
	lds	r17,ms10bkUP	;10ms cntHLP
	lds	r16,_100ms	;100ms counter
	lds	r19,ms1CNT	;1ms variable...
	;
	;
	inc	r23
	cpi	r23,18		;== 1ms
	breq	_count1ms	;
	rjmp	_check10ms
_count1ms:
	inc	r19		;1ms counter +1ms
	sbr	TIflag,1<<s1ms	;ms flag setzen (verarbeitung im ....)
	clr	r23		;55,3s counter lschen
	;im 1ms takt !
	;counter0 +1
	lds	zl,TEcounter0L
	lds	zh,TEcounter0H
	adiw	zh:zl,1
	sts	TEcounter0L,zl
	sts	TEcounter0H,zh
	;counter1 +1
	lds	zl,TEcounter1L
	lds	zh,TEcounter1H
	adiw	zh:zl,1
	sts	TEcounter1L,zl
	sts	TEcounter1H,zh
	;counter2 +1
	lds	zl,TEcounter2L
	lds	zh,TEcounter2H
	adiw	zh:zl,1
	sts	TEcounter2L,zl
	sts	TEcounter2H,zh
	;counter3 +1
	lds	zl,TEcounter3L
	lds	zh,TEcounter3H
	adiw	zh:zl,1
	sts	TEcounter3L,zl
	sts	TEcounter3H,zh
	;counter4 +1
	lds	zl,TEcounter4L
	lds	zh,TEcounter4H
	adiw	zh:zl,1
	sts	TEcounter4L,zl
	sts	TEcounter4H,zh
	;counter5 +1
	lds	zl,TEcounter5L
	lds	zh,TEcounter5H
	adiw	zh:zl,1
	sts	TEcounter5L,zl
	sts	TEcounter5H,zh
	;counter6 +1
	lds	zl,TEcounter6L
	lds	zh,TEcounter6H
	adiw	zh:zl,1
	sts	TEcounter6L,zl
	sts	TEcounter6H,zh
	;counter7 +1
	lds	zl,TEcounter7L
	lds	zh,TEcounter7H
	adiw	zh:zl,1
	sts	TEcounter7L,zl
	sts	TEcounter7H,zh
	;
	;
_check10ms:
 	;Aktualisierung counter-variablen
	;10*1ms=10ms
	cpi	r19,10		
	breq	_check10msX		
	jmp	_s111x
_check10msX:
;*************************************
;SYSeol fr objektverarbeitung
;counter +1/10 sekunde 
;*************************************
	lds	zl,SYSeolL
	lds	zh,SYSeolH
	adiw	zh:zl,1
	cpi	zl,0xff
	brne	_TIMStore
	cpi	zh,0xff
	brne	_TIMStore
	clr	zh
	clr	zl
_TIMStore:
	sts	SYSeolL,zl
	sts	SYSeolH,zh
	;
	clr	r19		;1ms counter ==0
	inc	r24		;+10ms
	inc	r17		;r17/ms10bkUP 10ms - counter (fortlaufend 0-100)
	sbr	tiFLAG,1<<s10msB	;10ms indikator
	;10*10ms= 100ms
	cpi	r24,10		;10*10ms = 100ms
	brne	_secCNT
	clr	r24
	inc	r16		;inc 100ms counter (fortlaufend 8-bit)

	;sekunden generieren 100*10ms
_secCNT:
	cpi	r17,100		;100*10ms=1 sekunde
	breq	_secCNTb		
	jmp	_s111
_secCNTb:
	clr	r17
	;nach jeder vollen sekunde wird das <sekunde>-flag getoggelt.... 
	sbrc	TIflag,sekunde
	rjmp	toggleSEKUNDE
	sbr	TIflag,1<<sekunde
	rjmp	countSEK
toggleSEKUNDE:
	cbr	TIflag,1<<sekunde	
countSEK:
	inc	r25			;lokale variable
;*************************************
;SYSeol fr objektverarbeitung
;counter +1/sekunde 
;*************************************
;	lds	zl,SYSeolL
;	lds	zh,SYSeolH
;	adiw	zh:zl,1
;	cpi	zl,0xff
;	brne	_TIMStore
;	cpi	zh,0xff
;	brne	_TIMStore
;	clr	zh
;	clr	zl
;_TIMStore:
;	sts	SYSeolL,zl
;	sts	SYSeolH,zh
	;			
	;

_TIMScont:
		;setze sekunden-event-flag
		;..........................................
		;events neu
		ldi	r18,3
		sts	eventTE,r18			;sekunde event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
		;
_TIMScontB:	
	;check eventtimer 1
		lds	r21,TI1evist		;eventtimer 1 ist
		lds	r20,TI1evsoll		;           1 soll
		cp	r20,r21
		breq	_tsEVtim2CK
		inc	r21			;ist +1
		sts	TI1evist,r21
		cp	r20,r21
		brne 	_tsEVtim2CK	
		;..........................................
		;events neu
		ldi	r18,1
		sts	eventTE,r18			;eventtimer 1 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................

_tsEVtim2CK:
		;check eventtimer 2
		lds	r21,TI2evist		;eventtimer 2 ist
		lds	r20,TI2evsoll		;           2 soll
		cp	r20,r21
		breq	_tstim5CK
		inc	r21			;ist +1
		sts	TI2evist,r21
		cp	r20,r21
		brne 	_tstim5CK
		;..........................................
		;events neu
		ldi	r18,2
		sts	eventTE,r18			;eventtimer 2 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................


_tstim5CK:
	;setze 5 sekunden event-flag
			lds	r21,ti5secCNT
			cpi	r21,4
			breq	_set5secFLAG	
			inc	r21
			jmp	_5secBK
_set5secFLAG:
		;..........................................
		;events neu
		ldi	r18,18
		sts	eventTE,r18			;5 sek. event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
		clr	r21
_5secBK:
		sts	ti5secCNT,r21






	;---------------------------------
	;lokales register-> sram backup
_s111:
	sts	_100ms,r16	;100ms 
	sts	_55iS,r23	;55,5s counter
	sts	_10miS,r24	;10ms counter
	;
	;achtung: sekunde nur bei 
	;         dcf77 deaktiv speichern !
	;
	;hier dcf77 aktivitt prfen
	lds	r22,dcf77_status
	sbrc	r22,dcf77SYNC
	rjmp	_s111DCF	
	sts	sekunS,r25   	;1s counter	
_s111DCF:
	sts	ms10bkUP,r17	;10ms hlpCNT
	sts	ms1CNT,r19




;.....................................................................................................................	
_slot1:
  	;slot 1 all 55,5sek
;	call	_SPEEDloop		;high speed trigger routine
	call	_uart_transfer_entry	;subroutine checkt spi
	;mal testen ob's luft
	call	_serial_COM_entry	;serielles kommunikationsmodul
	call	_HIFentry		;spi/hif sub

	;slot 1 <=> 55,5sek ---> 1.ter interrupt
_slot1A:
	cpi	r26,1	
	brne	_slot2	
	call	_progMO			;programmier-modus
	jmp	_TIback


	;slot 2 <=> 111sek   ---> 2.ter interrupt !
_slot2:
	cpi	r26,2	
	brne	_slot3
	call	_pinDRV			;alle  / subroutine steuert externen port - auch phasenschnitt !
	jmp	_TIback

	;slot 3 <=> 3.ter interrupt
_slot3:
	cpi	r26,3
	brne	_slot4		
	call	_adcLOOP		;subroutine bernimmt strommessung an portpin 
	call	_obj001			;subroutine fhrt objekte aus und bereinigt speicher
	jmp	_TIback


	;slot 4 <=> 222sek ---> 4.ter interrupt
_slot4:
	cpi	r26,4
	brne	_slot5
	call	_dcfENTRY			;dcf77 routine
	call	_pinDRV			;alle  / subroutine steuert externen port - auch phasenschnitt !
	jmp	_TIback
	
	;slot 5 <=>5.ter interrupt
_slot5:
	cpi	r26,5
	brne	_slot6
	call	_proZS			;subroutine bearbeitet aktuellen datenbestand und nimmt eventuelle nderungen vor
	call	_COMP000ex		;sub compex
	jmp	_TIback

	;slot 6 <=> 333s ---> 6.ter interrupt
_slot6:
	cpi	r26,6
	brne	_slot7	
	call	_pinDRV			;alle  / subroutine steuert externen port - auch phasenschnitt !
	call	_coMATRIX		;kombimode (timer/kategorie/device) verarbeitung
	jmp	_TIback
	

	;slot 7 <=> 7.ter interrupt
_slot7:
	cpi	r26,7
	brne	_slot8
	call	_date001su
	call	_ob000fr			;subroutine konstruiert objekt 
	jmp	_TIback


	;slot	8 <=> 444s ---> 8.ter interrupt
_slot8:
	cpi	r26,8
	brne	_slot9
	call	_dcfENTRY			;dcf77 routine
	call	_pinDRV			;alle  / subroutine steuert externen port - auch phasenschnitt !
	jmp	_TIback


	;slot   9 <=> 9.ter interrupt
_slot9:
	cpi	r26,9
	brne	_slot10
	call	_PWRrail		;powerrail routine
	call	_key000SEQ		;key-sequencer
	jmp	_TIback


	;slot  10 <=> 555s
_slot10:
	cpi	r26,10
	brne	_slot11
	call	_pinDRV			;alle  / subroutine steuert externen port - auch phasenschnitt !
	jmp	_TIback



	;slot  11 <=> 11.ter interrupt
_slot11:
	cpi	r26,11
	brne	_slot12
	call	_remoteENTRY	;remote ?
    call    _STOR000del     ;delete e2p ?
    call    _EXT000tim      ;timer
	jmp	_TIback



	;slot  12 <=> 12.ter interrupt 666s
_slot12:
	cpi	r26,12
	brne	_slot13
	call	_dcfENTRY			;dcf77 routine
	call	_pinDRV			;alle  / subroutine steuert externen port - auch phasenschnitt !
	jmp	_TIback


	;slot  13 <=> 13.ter interrupt
_slot13:
	cpi	r26,13
	brne	_slot14
	call	_zeitSUB		;subroutine aktuallisiert Zeitregister
	call	_HSexe000PROZ	;hot shot execution
	jmp	_TIback


	;slot  14 <=> 14.ter  777s
_slot14:
	cpi	r26,14
	brne	_slot15
	call	_pinDRV			;alle  / subroutine steuert externen port - auch phasenschnitt !
	jmp	_TIback


			
	;slot  15 <=> 15.ter interrupt
_slot15:
	cpi	r26,15
	brne	_slot16
	call	_adcLOOP		;subroutine bernimmt strommessung an portpin 
	call	_virt000PO		;softport...
	jmp	_TIback



	;slot  16 <=> 16.ter 
_slot16:
	cpi	r26,16
	brne	_TIback	;X
	call	_dcfENTRY			;dcf77 routine
	call	_pinDRV			;alle  / subroutine steuert externen port - auch phasenschnitt !


	
_TIback:
   ;...........................................
    ;NEW - spi demolition counter
    ;CONDITION: must be reset in every:
    ;- receive INT
    ;- data transmit
    ;...........................................
    lds r23,spiDEMcnt
    sbis	ddrb,_IFsel		;spi-if still blocked    
	rjmp	_tiBACKgob		
    ;busy & check counter
    inc r23
    cpi r23,0xff
    brne  _tiBACKgoc   
    ;start unlock bus & set spi-slave!
    call    _SPIslaveINIT   ;includes _ifsel = 1
_tiBACKgob:
    clr r23
_tiBACKgoc:
    sts spiDEMcnt,r23
    ;.............................................
	clr	zl
    clr zh
	sts	ALLtiming1L,zl
	sts	ALLtiming1H,zh
    ;enable timer interrupt
	in	r16,timsk
	sbr	r16,1<<toie0	;enable overflow interrupt
	out	timsk,r16
  	;watchdog reset
	wdr
	reti		
