;---------------------------------------------------------------------------
;spi-data
;---------------------------------------------------------------------------
;modified mega128!
;remote flags integrated
;18-04-06
;...........................................................................
;.equ	SPIstring		=		;-> master spi buffer 
;...........................................................................
;.equ	spiDATctSOLL	
;.equ	spiDATctIST		
;.equ	spiBUFadrH			;-> buffer high
;.equ	spiBUFadrL			;-> buffer low
;.equ	comFLAGspi  		;flagvariable
;
;.equ	CURindex		=		;cursor CURindex
;.equ	paraFUNC		=		;parameter function
;.equ	paraPOS			=		;parameter position
;.equ	paraX			=		;parameter wert
;.equ	paraMIN			=		;parameter minimalwert
;.equ	paraMAX			=		;parameter maximalwert
;
;parameter
;.equ	paraA	
;.equ	paraB	
;.equ	paraC
;.equ	paraD	
;.equ	paraE	
;.equ	paraF
;.equ	paraG	
;.equ	paraH	
;.equ	paraI	
;.equ	paraJ	
;...........................................................................
;para-Function flag
;.equ	parG		=	6		;-> flag...
;.equ	ediG		=	7		
;...........................................................................
;;comFLAGspi's
;.equ	newSPIdata	=	0		;neue daten empfangen
;.equ	spiBUSY		=	1		;transfer aktiv
;.equ	spiMready	=	2		;master ready
;.equ	newSPIsnd	=	3		;neue daten senden
;.equ	exeSPIdata	=	4		;neue daten ausfhren


;----------------------------------------------------------------------------------------------------
;HIFentry  - neue daten von HIF eingetroffen ODER neue daten zum HIF versenden
;----------------------------------------------------------------------------------------------------
;<newSPIdata> wird im interruptgeteuerten slavemodul erzeugt (neue daten im buffer !)
;<newSPIsnd>  wird im prozessmodul generiert (neue daten verschicken!)

_HIFentry:
	lds	r16,comFLAGspi		;flagvariable laden
	sbrc	r16,newSPIdata	
	rjmp	_CONVdata		;neues datenframe vom HIF empfangen
	sbrc	r16,newSPIsnd	
	rjmp	_SPImstrDAT	;daten zum hif versand aufbereiten & versenden
	jmp		_HIFhome

;info:
;a)datenstruktur: <para.function><basismenu X><auswahlmenu X>
;			<subauswahlmenu X><infotextbaustein X><graph.baustein X>
;			<PARAx><paraPOSx><paraMINx><paraMAXx>...
;
;b)parameter funktionen (tabelle):
;
;Bit                           |7  |6  |5  |4  |3  |2  |1  |0  |Hex  |
;______________________________|___|___|___|___|___|___|___|___|_____|
;                              |edi|par|num|bar|p3 |p2 |p1 |p0 |     |
;______________________________|___|___|___|___|___|___|___|___|_____|
;edit alphnum.parameter        | x | x |   |   |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;edit num. parameter           | x | x | x |   |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;edit num. bargraph-parameter  | x | x | x | x |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;display alphanum.parameter    |   | x |   |   |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;display num.parameter 		   |   | x | x |   |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;display num. bargraph-param.  |   | x | x | x |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;keine parameter-funktion      |*  |   |*  |*  |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;
;p0-p3=anzahl angefgter parameter (maximal 10 inkl.position & min/max)
;numG	=numerische darstellung
;parG =parameter
;barG =bargraph
;ediG =parameter editieren
;

;----------------------------------------------------------------------------
;hif-tabellenwerte & parameter verknpfen
;newSPIdata	=	0
;newSPIsnd	=	1
;----------------------------------------------------------------------------
;spiMready	=	0(daten senden)
;spiMready	=	1(datenversand vornereiten)
;----------------------------------------------------------------------------
_SPImstrDAT:
	;&jetzt busy setzen
	sbr	r16,1<<spiBUSY	;busy...
	;---------------------------------------
	;modul aktiv - wird fr remote bentigt
	sbr	r16,1<<spiWORKIN
	sts	comFLAGspi,r16
	;---------------------------------------


	;<spiMready> prfen...
	sbrc	r16,spiMready
	rjmp	_SPImstrDATgo	;spiMready=1
	jmp		_SPImastrSND	;spiMready=0
	;spi master bereit...	
_SPImstrDATgo:
	cbr	r16,1<<spiMready	;beim nchsten durchlauf wird gesendet !
	sts	comFLAGspi,r16		;clr spiMready=0
;prfe ob prozess ODER program tabellen verschickt werden sollen
		lds	r17,pzHIF
		tst	r17
		brne	_HIFdataPROZ
		lds	r17,prHIF	
		tst	r17
		breq	_HIFdataPROZ ;beide hif's=0
;pgHIF-tabellen adressieren und startadresse holen bis 126
		cpi	r17,127
		brsh	_HIFdataPROGII
		ldi	zh,high(_pgHIFtbl*2)
		ldi	zl,low(_pgHIFtbl*2)
		rjmp	_SPImstrDATrun


;pgHIF-tabellenII adressieren und startadresse holen ab 127
_HIFdataPROGII:
		subi	r17,127
		ldi	zh,high(_pgHIFtblII*2)
		ldi	zl,low(_pgHIFtblII*2)
		rjmp	_SPImstrDATrun


;pzHIF-tabellen adressieren und startadresse holen
_HIFdataPROZ:
		ldi	zh,high(_pzHIFtbl*2)
		ldi	zl,low(_pzHIFtbl*2)
		rjmp	_SPImstrDATrun
		;
		;
		;
		;
		;
_SPImstrDATrun:
	;flash-table
	ldi	r18,2
	mul	r17,r18	;hif-pointer*2 (16-bit crosstable)
	;startadress +pointer =LSB
	add	zl,r0
	adc	zh,r1
	lpm	r0,z+		;lower adress nibble in r0
	;startadresse+pointer+1=MSB
	lpm	r1,z		;higher adress nibble in r1
	;
	mov	zl,r0
	mov	zh,r1
	;sram-buffer
	ldi	yh,high(SPIstring)
	ldi	yl,low(SPIstring)
	;para-flags
	lpm	r16,z+
	st	y+,r16	;para function (in tabelle definiert...)
	mov	r17,r16	;para-function in r17...
	ldi	r18,5
	;nun standard variablen einlesen 	
_SPImstr01loop:
	tst	r18
	breq	_SPImstr02ck					;
	lpm	r16,z+	;base,auswahl,subauswahl,text,graphic		
	st	y+,r16
	dec	r18
	rjmp	_SPImstr01loop
	;
_SPImstr02ck:
	;nun prfen ob parameter angehngt werden...
	sbrc	r17,parG	
	rjmp	_SPImstr03ck		;parameter angehngt !
	jmp		_SPImstr20snd		;keine parameter angehngt == gleich senden !
	;parameter (pos,min,max) einfgen
_SPImstr03ck:
	andi	r17,0b00001111		;nur anzahl der parameter einblenden...
	ldi		r18,3				;sind pro parameter 4 bytes !
	ldi		r19,1
_SPIpar01ck:
	;nun parameter 1 holen
	cpi		r19,1
	brne	_SPIpar02ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraA
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar02ck
	jmp		_SPImstr20snd
	;
_SPIpar02ck:
	;nun parameter 2 holen
	cpi		r19,2
	brne	_SPIpar03ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraB
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar03ck
	jmp		_SPImstr20snd
	;
_SPIpar03ck:
	;nun parameter 3 holen
	cpi		r19,3
	brne	_SPIpar04ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraC
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar04ck
	jmp		_SPImstr20snd
	;
_SPIpar04ck:
	;nun parameter 4 holen
	cpi		r19,4
	brne	_SPIpar05ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraD
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar05ck
	jmp		_SPImstr20snd
	;
_SPIpar05ck:
	;nun parameter 5 holen
	cpi		r19,5
	brne	_SPIpar06ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraE
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar06ck
	jmp		_SPImstr20snd
	;
_SPIpar06ck:
	;nun parameter 6 holen
	cpi		r19,6
	brne	_SPIpar07ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraF
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar07ck
	jmp		_SPImstr20snd
	;
_SPIpar07ck:
	;nun parameter 7 holen
	cpi		r19,7
	brne	_SPIpar08ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraG
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar08ck
	jmp		_SPImstr20snd
	;
_SPIpar08ck:
	;nun parameter 8 holen
	cpi		r19,8
	brne	_SPIpar09ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraH
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar09ck
	jmp		_SPImstr20snd
	;
_SPIpar09ck:
	;nun parameter 9 holen
	cpi		r19,9
	brne	_SPIpar10ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraI
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar10ck
	jmp		_SPImstr20snd
	;
_SPIpar10ck:
	;nun parameter 10 holen
	cpi		r19,10
	brne	_SPIpar11ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraJ
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar11ck
	jmp		_SPImstr20snd

_SPIpar11ck:
	;nun parameter 11 holen
	cpi		r19,11
	brne	_SPIpar12ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraK
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar12ck
	jmp		_SPImstr20snd

_SPIpar12ck:
	;nun parameter 12 holen
	cpi		r19,12
	brne	_SPIpar13ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraL
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar13ck
	jmp		_SPImstr20snd

_SPIpar13ck:
	;nun parameter 13 holen
	cpi		r19,13
	brne	_SPIpar14ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraM
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar14ck
	jmp		_SPImstr20snd

_SPIpar14ck:
	;nun parameter 14 holen
	cpi		r19,14
	brne	_SPIpar15ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraN
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar15ck
	jmp		_SPImstr20snd

_SPIpar15ck:
	;nun parameter 15 holen
	cpi		r19,15
	brne	_SPIpar16ck
	;byte berspringen
	adiw	zh:zl,1
	lds		r16,paraO
	st		y+,r16
	call	_SPImstr05loop
	tst		r17
	brne	_SPIpar16ck
	jmp		_SPImstr20snd

	;passt nicht ....
_SPIpar16ck:
	jmp		_SPImstr20bk	;ohne senden zurck....

;...................................
;sub...
_SPImstr05loop:
	tst		r18
	breq	_SPImstr05ck
	lpm	r16,z+		
	st	y+,r16
	dec r18
	rjmp	_SPImstr05loop
_SPImstr05ck:
	ldi	r18,3
	dec	r17	;anzahl parameter -1
	inc	r19	
	ret
;...................................





_SPImstr20snd:
;spi als master konfigurieren

		;prfe ob ein RFM
		;oder ein NET-data
		;transfer luft !
		sbis	pinb,_ifSEL
		rjmp	_SPImstr20bk 
        cbi ddrb,_ifSEL
        cbi portb,_ifSEL
        nop
        sbi ddrb,_ifSEL
        cbi portb,_ifSEL 
     	call	_SPImasterINIT      
	    jmp		_HIFhome
	;
_SPImstr20bk:
	;keine sendefreigabe...
	lds		r16,comFLAGspi
	sbr		r16,1<<spiMready
	sts		comFLAGspi,r16		;set spiMready=1
	jmp		_HIFhome



;----------------------------------------------------------------------------
;sub send spi data
;----------------------------------------------------------------------------
	_SPImastrSND:
    ;.................
    ;reset counter
    clr r16
    sts spiDEMcnt,r16
    ;................
		;jetzt byte counter laden
		lds	r16,spiDATctIST	
		tst	r16	;erstes byte gesendet...
		brne	_SPImastrOK
        ;.....................
		ldi	zh,high(SPIstring)
		ldi	zl,low(SPIstring)
		sts	spiBUFadrH,zh
		sts	spiBUFadrL,zl
		ld	r16,z					;para function holen
		sbrc	r16,parG	
		rjmp	_SPImastrPARA		;keine parameter angehngt !
		ldi		r16,1	;new
	    sts	spiDATctIST,r16
		ldi	r17,6		;nein == 6 bytes
		sts	spiDATctSOLL,r17
		rjmp	_SPImastrFIRST	;weiter zur datenbergabe
		;
		;parameter angehngt...
	_SPImastrPARA:
		andi	r16,0b00001111	;nur anzahl der parameter 
		ldi	yl,4			;pro parameter 4 bytes
		ldi	yh,6			;6 bytes
		mul	yl,r16		;anzahl *4
		add	yh,r0			;6bytes+ xParameter(*4)
		mov	r17,yh		;xBytes gesamt
		sts	spiDATctSOLL,r17
		ldi	r16,1 ;neu
	    sts	spiDATctIST,r16

 	    ;......................
		;first byte...identifier
		;......................
	_SPImastrFIRST:
		ldi	zl,0x2d
		out	spdr,zl         	;zu bertragende daten
		jmp	_SPImstrRUN	;weiter...
	


		;--------------------------------
		;-aktuelle daten nach spdr laden
		;-aktuelle comBUF adresse holen
		; & daten senden
        ;--------------------------------
	_SPImastrOK:
		lds	zh,spiBUFadrH
		lds	zl,spiBUFadrL
		ld	r0,z+				;aktuelle daten aus buffer an spdr
    _SPImasterTylOOP:
		sbis	spsr,spif
		rjmp	_SPImasterTylOOP	;warte bis daten bertragen
        in	r1,spdr
		out	spdr,r0	;zu bertragende daten
		;comBUF sichern
		sts	spiBUFadrH,zh
		sts	spiBUFadrL,zl
		;range prfen
		lds	r17,spiDATctSOLL
		;range?
		cp	r16,r17		;ist<soll ?
		brlo	_SPImastrOKb
		;......................
		;last byte
		;......................	
		;clr flags
        lds zl,comFLAGspi
		cbr	zl,1<<spiBUSY
		cbr	zl,1<<newSPIsnd
		sbr	zl,1<<spiMready
		sts	comFLAGspi,zl
		;data counter = 0
		clr	r16
		sts	spiDATctIST,r16

 _SPImasterTylOOPF:
		sbis	spsr,spif
		rjmp	_SPImasterTylOOPF	;warte bis daten bertragen
   
    	;---------------------------------------------
	    ;set SPI to slave-mode 
	    ;---------------------------------------------
	    call	_SPIslaveINIT
	    ;---------------------------------------------
		jmp	_SPImastrREADY ;& fertig...



		;......................
		;dynamic run...
		;......................
	_SPImastrOKb:
		inc	r16
		sts	spiDATctIST,r16
		jmp	_SPImstrRUN	;weiter...
	


;*****************************************************************
	;erreicht = fertig
_SPImastrREADY:	
	;modul deaktiv - wird fr remote bentigt
	lds	r16,comFLAGspi
	cbr	r16,1<<spiWORKIN
	sts	comFLAGspi,r16
	;zurck
_SPImstrRUN:
		jmp	_HIFhome

;*****************************************************************






;----------------------------------------------------------------------------
;sub spi (HIF) data nach variablen == neue daten vom hif eingetroffen 
;newSPIdata = 	1
;newSPIsnd	=	0
;----------------------------------------------------------------------------
_CONVdata:
	;---------------------------------------
	;modul aktiv - wird fr remote bentigt
	lds	r16,comFLAGspi
	sbr	r16,1<<spiWORKIN
	sts	comFLAGspi,r16
	;---------------------------------------

		ldi	zh,high(SPIstring)
		ldi	zl,low(SPIstring)
		ld	r0,z+
		sts	CURindex,r0
		;
		ld	r0,z+
		sts	paraFUNC,r0
		;
		ld	r0,z+
		sts	paraPOS,r0
		;
		ld	r0,z+
		sts	paraX,r0
		;
		ld	r0,z+
		sts	paraMIN,r0
		;
		ld	r0,z
		sts	paraMAX,r0

		;------------------------------------------------------
		;hier in abhngigkeit von:
		;a) KEIN EDIT MODE 
		;   mit PZpsc die cross-tabelle adressieren
		;   und innerhalb der zieltabelle den zielwert 
		;   mit index 0-254 adressieren (index255 = wert0!)
		;	& exeSPIdata setzen
		;  
		;b) EDIT MODE
		;   keine tabellenadressierung
		;   & exeSPIdata setzen
		;------------------------------------------------------
		;programm oder prozess cross-table?
		lds	r17,prozPSC
		tst	r17
		brne	_CONVdataPROZ
		lds	r17,progPSC	
		tst	r17
		breq	_CONVdataPROZ ;beide psc's=0
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		;progPSC>0
		lds		r16,paraFUNC
		sbrc	r16,ediG	
		rjmp	_CONVdataEDx	;1= edit routine luft
		;kein edit
		;nun adressieren...
		ldi	zh,high(_progPSCtbl*2)
		ldi	zl,low(_progPSCtbl*2)
		;pointer *2
		ldi	r18,2
		mul	r17,r18
		;startadress +pointer =LSB
		add	zl,r0
		adc	zh,r1
		lpm	r0,z+		;lower adress nibble in r0
		;startadresse+pointer+1=MSB
		lpm	r1,z		;higher adress nibble in r1
		;
		mov	zl,r0
		mov	zh,r1
		;
		lds	r17,CURindex
		;index 255=0
		cpi	r17,0xff
		breq	_CONVdataPZb
		clr	r18
		;pointer+ index
		add	zl,r17
		adc	zh,r18
		;neuen psc aus tabelle holen!
_CONVdataPZb:
		lpm	r17,z
		sts	progPSC,r17
_CONVdataEDx:
		lds	r16,paraX
		sts	paraA,r16
		jmp	_CONVdataHOME

		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		;prozPSC>=0
_CONVdataPROZ:
		lds		r16,paraFUNC
		sbrc	r16,ediG	
		rjmp	_CONVdataED	;1= edit routine luft
		;kein edit
		;nun adressieren...
		ldi	zh,high(_prozPSCtbl*2)
		ldi	zl,low(_prozPSCtbl*2)
		;pointer *2
		ldi	r18,2
		mul	r17,r18
		;startadress +pointer =LSB
		add	zl,r0
		adc	zh,r1
		lpm	r0,z+		;lower adress nibble in r0
		;startadresse+pointer+1=MSB
		lpm	r1,z		;higher adress nibble in r1
		;
		mov	zl,r0
		mov	zh,r1
		;
		lds	r17,CURindex
		;index 255=0
		cpi	r17,0xff
		breq	_CONVdataPGb
		clr	r18
		;pointer+ index
		add	zl,r17
		adc	zh,r18
		;neuen psc aus tabelle holen!
_CONVdataPGb:
		lpm	r0,z
		sts	prozPSC,r0
		;
_CONVdataED:
		lds	r16,paraX
		sts	paraA,r16
		
_CONVdataHOME:
		lds	 r16,comFLAGspi
		cbr	 r16,1<<newSPIdata
		sbr	 r16,1<<exeSPIdata
		cbr	 r16,1<<spiBUSY
		cbr	 r16,1<<spiWORKIN
		sts	 comFLAGspi,r16
		jmp	 _HIFhome		;zurck

;---------------------------------------------
;HIF home
;---------------------------------------------
_HIFhome:
	ret














