;+++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++ COMPEX MODUL ++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++
;continous para / hysteresis compare
;modul disabled if programming modul is running

_COMP000ex:
	lds	r16,progPSC
	tst	r16
	breq	_COMP000exGO
	jmp	_COMPexKILL		;progPSC>0
	;enabled
_COMP000exGO:
	lds	r16,COMPEXcnt	;load para counter
	lds	r17,COMPEXstate	;load compex state
	;state =0
	tst	r17
	breq	_COMP001ex	;=0
	;state <6 then read loop from e2p
	cpi	r17,6
	brlo	_COMP002ex	;<6
	cpi	r17,6			
	brne	_COMP000exb	
	jmp		_COMP003ex	;=6
	;>6
_COMP000exb:	
	clr	r17
	jmp	_COMPexBACK



;++++++++++++++++++++++++++++++++++++++++++++++++++++++
;state=0
;calculate adresses
_COMP001ex:
	mov	yl,r16	
	ldi	yh,2	;counter *2
	mul	yh,yl
	movw	yh:yl,r1:r0
	;load startadress HIGHE ADRESS NIBBLE
	ldi	zl,low(Atemp1H)
	ldi	zh,high(Atemp1H)
	;points to MSB of para-adress (sram)
	add	zl,yl
	adc	zh,yh
	;check range...
	;load last para-sram var+1
	ldi	r18,low(OBJposition5L +1)
	ldi	r19,high(OBJposition5L +1)
	cp	zl,r18
	cpc	zh,r19
	brlo	_COMP001exOK	;in range	
	;out of range
	;=> COMPEXstate =0
	clr	r17
	;=> COMPEXcnt = 0
	clr	r16
	jmp	_COMPexBACK
	;
	;
	;
	;in range
_COMP001exOK:
	;sram MSB dynamic para-var
	sts	varAx,zl ;low nibble 
	sts	varBx,zh ;high nibble
	;----------------------------------------------
	;load e2p hys-startadress HIGHER ADRESS NIBBLE
	ldi	zl,low(para_hys_tbl)
	ldi	zh,high(para_hys_tbl)
	;points to MSB of first i-temp hys-adress
	add	zl,yl
	adc	zh,yh
	;e2prom MSB hysteresis var to para
	sts	E2delL,zl ;low nibble 
	sts	E2delH,zh ;high nibble 
	;----------------------------------------------
	;calculate first byte in e2prom execute section
	mov	yl,r16	
	ldi	yh,3	;counter *3
	mul	yh,yl
	movw	yh:yl,r1:r0
	;load e2p ex-startadress
	ldi	zl,low(hys_exe_tbl)
	ldi	zh,high(hys_exe_tbl)
	;points to the first control-variable	
	add	zl,yl
	adc	zh,yh
	;store start-adress for ex-section 
	sts	ADRtempL,zl
	sts	ADRtempH,zh
	;
	;next step
	;=> COMPEXstate =1
	ldi	r17,1
	;=> COMPEXcnt +1
	inc	r16
	jmp	_COMPexBACK


;OK...





;++++++++++++++++++++++++++++++++++++++++++++++++++++++
;state=1...5
;load data from e2prom
_COMP002exKILLx:
	jmp		_COMPexKILL
_COMP002ex:
	sbic	eecr,eewe		; EEPE nicht gelscht ?
	rjmp	_COMP002exKILLx	; warte...
	;-----------------------------------
	;=1 ? (MSB HYST.)
	cpi	r17,1
	brne	_COMP002exb
	;load msb hyst
	lds	zl,E2delL
	lds	zh,E2delH
	;e2p access
	out	eearh,zh
	out	eearl,zl	
	sbi	eecr,eere		
	in	r22,eedr
	;store msb hyst data
	sts	COMPEXtempHYSh,r22
	;pointer+1
	adiw	zh:zl,1
	sts	E2delL,zl
	sts	E2delH,zh
	;
	;new state
	ldi	r17,2
	jmp	_COMPexBACK
	;-------------------------------

	;-----------------------------------
_COMP002exb:	
	;=2 ? (LSB HYST.)
	cpi	r17,2
	brne	_COMP002exc
	;load lsb hyst
	lds	zl,E2delL
	lds	zh,E2delH
	;e2p access
	out	eearh,zh
	out	eearl,zl	
	sbi	eecr,eere		
	in	r22,eedr
	;store lsb hyst data
	sts	COMPEXtempHYSl,r22
	;
	;new state
	ldi	r17,3
	jmp	_COMPexBACK
	;-------------------------------

	;-----------------------------------
_COMP002exc:	
	;=3 ? (control var )
	cpi	r17,3
	brne	_COMP002exd
	;load msb hyst
	lds	zl,ADRtempL
	lds	zh,ADRtempH
	;e2p access
	out	eearh,zh
	out	eearl,zl	
	sbi	eecr,eere		
	in	r22,eedr
	;store control variable
	sts	COMPEXtempCON,r22
	;
	;pointer+1
	adiw	zh:zl,1
	sts	ADRtempL,zl
	sts	ADRtempH,zh
	;new state
	ldi	r17,4
	jmp	_COMPexBACK
	;-------------------------------

	;-----------------------------------
_COMP002exd:
	;=4 ? (ex var )
	cpi	r17,4
	brne	_COMP002exe
	;load ex var
	lds	zl,ADRtempL
	lds	zh,ADRtempH
	;e2p access
	out	eearh,zh
	out	eearl,zl	
	sbi	eecr,eere		
	in	r22,eedr
	;store execute variable
	sts	COMPEXtempEXE,r22
	;
	;pointer+1
	adiw	zh:zl,1
	sts	ADRtempL,zl
	sts	ADRtempH,zh
	;new state
	ldi	r17,5
	jmp	_COMPexBACK
	;-------------------------------

	;-----------------------------------
_COMP002exe:	
	;=5 ? (event var )
	cpi	r17,5
	brne	_COMP002exOFRANGE
	;load event var
	lds	zl,ADRtempL
	lds	zh,ADRtempH
	;e2p access
	out	eearh,zh
	out	eearl,zl	
	sbi	eecr,eere		
	in	r22,eedr
	;store execute variable
	sts	COMPEXtempEVE,r22
	;
_COMP002exOFRANGE:
	;new state
	ldi	r17,6
	jmp	_COMPexBACK
	;-------------------------------









;++++++++++++++++++++++++++++++++++++++++++++++++++++++
;state=6
;compare sram para with hysteresis
_COMP003ex:
	;test if enable bit is set!
	lds	r19,COMPEXtempCON
	sbrc	r19,0
	rjmp	_COMP003exA	;enabled...
	;disabled
	jmp	_COMP003exKILL
	;-------------------------------------------
	;enabled
_COMP003exA:
	;load hysteresis
	lds	zl,COMPEXtempHYSl
	lds	zh,COMPEXtempHYSh
	;manipulation with control conditions
	sbrs	r19,1	;= para equal hyst
	rjmp	_COMP003exB
	;=
	;load para-msb
	lds	yl,varAx
	lds	yh,varBx
	ld	r3,y+
	;load para-lsb
	ld	r2,y
	mov	yl,r2
	mov	yh,r3
	;compare para/hyst
	cp	yl,zl
	cpc	yh,zh
	brne	_COMP003exANOT	
	jmp		_COMP003exEQU	;equal - execute !		
	;not equal..
_COMP003exANOT:	
	jmp		_COMP003exNOT	;not equal !
	;
	;----------------------------------------------
	;
  	;
_COMP003exB:
	sbrs	r19,2	;para < hyst
	rjmp	_COMP003exC
	;<
	;load para-msb
	lds	yl,varAx
	lds	yh,varBx
	ld	r3,y+
	;load para-lsb
	ld	r2,y
	mov	yl,r2
	mov	yh,r3
	;compare para/hyst
	cp	yl,zl
	cpc	yh,zh
	brsh	_COMP003exBNOT	
	jmp		_COMP003exEQU	;equal - execute !		
	;not lower than hysteresis..
_COMP003exBNOT:	
	jmp		_COMP003exNOT	;not equal !
	;
	;----------------------------------------------
	;
  	;
_COMP003exC:
	sbrs	r19,3	;para >= hyst
	rjmp	_COMP003exD
	;<
	;load para-msb
	lds	yl,varAx
	lds	yh,varBx
	ld	r3,y+
	;load para-lsb
	ld	r2,y
	mov	yl,r2
	mov	yh,r3
	;compare para/hyst
	cp	yl,zl
	cpc	yh,zh
	brsh	_COMP003exCEQU			
	jmp		_COMP003exNOT	;not equal !
	;not higher OR equal than hysteresis..
_COMP003exCEQU:	
	jmp		_COMP003exEQU	;equal - execute !
	;
	;----------------------------------------------
	;
  	;
_COMP003exD:
	sbrs	r19,4	;para >= hyst+10
	rjmp	_COMP003exE
	;<
	;load para-msb
	lds	yl,varAx
	lds	yh,varBx
	ld	r3,y+
	;load para-lsb
	ld	r2,y
	mov	yl,r2
	mov	yh,r3
	;hyst +10
	subi	zl,low(-10)
	sbci	zh,high(-10)
	;compare para/hyst
	cp	yl,zl
	cpc	yh,zh
	brsh	_COMP003exDEQU			
	jmp		_COMP003exNOT	;not equal !
	;not higher OR equal than hysteresis+10..
_COMP003exDEQU:	
	jmp		_COMP003exEQU	;equal - execute !
	;
	;----------------------------------------------
	;
  	;
_COMP003exE:
	sbrs	r19,5	;para <= hyst-10
	rjmp	_COMP003exF
	;<
	;load para-msb
	lds	yl,varAx
	lds	yh,varBx
	ld	r3,y+
	;load para-lsb
	ld	r2,y
	mov	yl,r2
	mov	yh,r3
	;hyst -10
	subi	zl,low(10)
	sbci	zh,high(10)
	;compare para/hyst
	cp	yl,zl
	cpc	yh,zh
	breq	_COMP003exEEQU	
	brlo	_COMP003exEEQU			
	jmp		_COMP003exNOT	;not equal !
	;not equal OR less than hysteresis-10..
_COMP003exEEQU:	
	jmp		_COMP003exEQU	;equal - execute !
	;
	;----------------------------------------------
	;
  	;
_COMP003exF:
	sbrs	r19,6	;para >= hyst+20
	rjmp	_COMP003exG
	;<
	;load para-msb
	lds	yl,varAx
	lds	yh,varBx
	ld	r3,y+
	;load para-lsb
	ld	r2,y
	mov	yl,r2
	mov	yh,r3
	;hyst +20
	subi	zl,low(-20)
	sbci	zh,high(-20)
	;compare para/hyst
	cp	yl,zl
	cpc	yh,zh
	brsh	_COMP003exFEQU			
	jmp		_COMP003exNOT	;not equal !
	;not equal OR higher than hysteresis+20..
_COMP003exFEQU:	
	jmp		_COMP003exEQU	;equal - execute !
	;
	;----------------------------------------------
	;
  	;
_COMP003exG:
	sbrs	r19,7	;para <= hyst-20
	rjmp	_COMP003exKILL
	;<
	;load para-msb
	lds	yl,varAx
	lds	yh,varBx
	ld	r3,y+
	;load para-lsb
	ld	r2,y
	mov	yl,r2
	mov	yh,r3
	;hyst +20
	subi	zl,low(20)
	sbci	zh,high(20)
	;compare para/hyst
	cp	yl,zl
	cpc	yh,zh
	breq	_COMP003exGEQU	
	brlo	_COMP003exGEQU			
	jmp		_COMP003exNOT	;not equal !
	;not equal OR higher than hysteresis+20..
_COMP003exGEQU:	
	jmp		_COMP003exEQU	;equal - execute !


;---------------------------------------------------------------
;condition to compare OK
_COMP003exEQU:

	;-------------------
	;TEST
;	jmp	_COMP003exKILL
	;-------------------



	;load execution state...
	;A) calculate flag position
	ldi	yl,low(COMexFLAG)
	ldi	yh,high(COMexFLAG)
	;
	mov	zl,r16
	subi	zl,1	;old counter value...
	cpi	zl,8
	brsh	_COMP003exEQUb
	;load flag
	jmp	_COMP003exEQUload
	



_COMP003exEQUb:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,16
	brsh	_COMP003exEQUc
	subi	zl,8
	;load flag
	jmp	_COMP003exEQUload



				
_COMP003exEQUc:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,24
	brsh	_COMP003exEQUd
	subi	zl,16
	;load flag
	jmp	_COMP003exEQUload


_COMP003exEQUd:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,32
	brsh	_COMP003exEQUe
	subi	zl,24
	;load flag
	jmp	_COMP003exEQUload



_COMP003exEQUe:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,40
	brsh	_COMP003exEQUf
	subi	zl,32
	;load flag
	jmp	_COMP003exEQUload



_COMP003exEQUf:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,48
	brsh	_COMP003exEQUg
	subi	zl,40
	;load flag
	jmp	_COMP003exEQUload



_COMP003exEQUg:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,56
	brsh	_COMP003exEQUh
	subi	zl,48
	;load flag
	jmp	_COMP003exEQUload



_COMP003exEQUh:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,64
	brsh	_COMP003exEQUi
	subi	zl,56
	;load flag
	jmp	_COMP003exEQUload



_COMP003exEQUi:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,72
	brsh	_COMP003exEQUofrange
	subi	zl,64
	;load flag
	jmp	_COMP003exEQUload



	;.......................
	;load flag
_COMP003exEQUload:
	ldi	r18,0b10000000				;mask start position
_COMP003exEQUloop:
	tst	zl
	breq	_COMP003exEQUloopREADY	;ready shifted	
	lsr	r18							;shift right
	dec	zl
	rjmp	_COMP003exEQUloop	

	;compare flag...
_COMP003exEQUloopREADY:
	ld	zh,y
	;range
	cpi	zh,175
	brsh	_COMP003exEQUofrange
	;	
	mov	r19,zh	;bk variable
	and	zh,r18	;show only the actually flag
	;=0 flag not set
	tst	zh
	breq	_COMP003exEQUexecute	;now execute...
	;do nothing, because para is 
	;still in hysteresis range !
_COMP003exEQUofrange:
	jmp	_COMP003exKILL
	 
	;now execute...
_COMP003exEQUexecute:

	;r19 = flag-var
	;r18  = mask
	or	r19,r18
	st	y,r19
	;--------------------------
	;test execution conditions
	lds	r19,COMPEXtempEXE

	;plausibility?
	sbrc	r19,4
	rjmp	_COMP003exEQUexecuteC	;do nothing
	;A)event
	sbrs	r19,5
	rjmp	_COMP003exEQUexecuteA	;no event...
	;load event
		;..........................................
		;events neu
		lds	zl,COMPEXtempEVE
		sts	eventTE,zl			;event set
		call	_MAKEeventSUB	;submodul !
		;..........................................
	
	;B)hot shot
_COMP003exEQUexecuteA:
	sbrs	r19,6
	rjmp	_COMP003exEQUexecuteB	;no hot shot...
	;now check if macro flag also is set?
	sbrc	r19,7
	rjmp	_COMP003exEQUexecuteC	;both not accepted !
	;load hot shot
	andi	r19,0b00001111
	;now check range!
	cpi	r19,5
	brsh	_COMP003exEQUexecuteC	;>=10 not accepted !
	;store hs
	sts	HOTnumb,r19
	;exe-state=1
	lds	r19,HOTstate
	sbr	r19,1<<HSexe
	sts	HOTstate,r19
	jmp	_COMP003exKILL


	;C)macro
_COMP003exEQUexecuteB:
	sbrs	r19,7
	rjmp	_COMP003exEQUexecuteC	;no macro...
	;load hot macro
	andi	r19,0b00001111
	;now check range!
	cpi	r19,10
	brsh	_COMP003exEQUexecuteC	;>=10 not accepted !
	;store macro
	sts	prog_platzA	,r19
	;startschuss f. programmausfhrung !
	lds	r19,matrix_flag	;matrix flag setzen (wg.programmaufruf erforderlich)
	sbr	r19,1<<runMTX	;wird nach erledigung von matrix gelscht !
	sts	matrix_flag,r19
	;ready..
_COMP003exEQUexecuteC:
	jmp	_COMP003exKILL











;---------------------------------------------------------------
	;condition to compare NOT OK
_COMP003exNOT:

	;load execution state...
	;A) calculate flag position
	ldi	yl,low(COMexFLAG)
	ldi	yh,high(COMexFLAG)
	;
	mov	zl,r16
	subi	zl,1	;old counter value...
	cpi	zl,8
	brsh	_COMP003exNOTb
	;load flag
	jmp	_COMP003exNOTload
	



_COMP003exNOTb:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,16
	brsh	_COMP003exNOTc
	subi	zl,8
	;load flag
	jmp	_COMP003exNOTload



				
_COMP003exNOTc:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,24
	brsh	_COMP003exNOTd
	subi	zl,16
	;load flag
	jmp	_COMP003exNOTload


_COMP003exNOTd:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,32
	brsh	_COMP003exNOTe
	subi	zl,24
	;load flag
	jmp	_COMP003exNOTload



_COMP003exNOTe:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,40
	brsh	_COMP003exNOTf
	subi	zl,32
	;load flag
	jmp	_COMP003exNOTload



_COMP003exNOTf:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,48
	brsh	_COMP003exNOTg
	subi	zl,40
	;load flag
	jmp	_COMP003exNOTload



_COMP003exNOTg:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,56
	brsh	_COMP003exNOTh
	subi	zl,48
	;load flag
	jmp	_COMP003exNOTload



_COMP003exNOTh:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,64
	brsh	_COMP003exNOTi
	subi	zl,56
	;load flag
	jmp	_COMP003exNOTload



_COMP003exNOTi:
	adiw	yh:yl,1	;next flag var...
	cpi	zl,72
	brsh	_COMP003exNOTofrange
	subi	zl,64
	;load flag
	jmp	_COMP003exNOTload



	;.......................
	;load flag
_COMP003exNOTload:
	ldi	r18,0b10000000				;mask start position
_COMP003exNOTloop:
	tst	zl
	breq	_COMP003exNOTloopREADY	;ready shifted	
	lsr	r18							;shift right
	dec	zl
	rjmp	_COMP003exNOTloop	

	;compare flag...
_COMP003exNOTloopREADY:
	ld	zh,y
	;range
	cpi	zh,175
	brsh	_COMP003exNOTofrange
	;
	mov	r19,zh	;bk variable
	and	zh,r18	;show only the actually flag
	;=0 flag not set
	tst	zh
	brne	_COMP003exNOTexecute	;now clear flag...
	;do nothing, because para is 
	;still in hysteresis range !
_COMP003exNOTofrange:
	jmp	_COMP003exKILL
	 

	;clear flag
_COMP003exNOTexecute:
	;r19 = flag-var
	;r18  = mask
	com	r18
	and	r19,r18
	st	y,r19
	jmp	_COMP003exKILL






;------------------------------------------------------------
_COMP003exKILL:
	;start state
	clr	r17
	jmp	_COMPexBACK

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++
;back jumps
_COMPexBACK:
	sts	COMPEXstate,r17
	sts	COMPEXcnt,r16
;return without action
_COMPexKILL:
	ret
