;-----------------------------------------------------------
;virtuelles Softport-Modul
;-----------------------------------------------------------
;________________________________________________________
;istwert		| schaltpunkt           | steuerung
;_______________|_______________________|________________
;softPo0		|softPo0hys			+10 |softPo0do    +20
;softPo1		|softPo1hys			+10 |softPo1do	  +20
;	.			|	.                   |   .
;	.			|	.                   |   .
;	.			|	.                   |   .
;softPo9		|softPo9hys			+10 |softPo9do    +20
;_______________|________________________________________



;ERKLRUNG:
;virtuelle softport-daten knnen verschiedenen ursprunges
;sein:
;a) vom (L)ocal-(A)rea-(B)us
;b) vom (S)ub-(A)rea-(B)us
;c) vom Host
;
;die weiterverarbeitung muss nicht zwangslufig im host erfolgen,
;sondern auch auf anderen netzteilnehmern - siehe o.g. varianten !
;
;zustzlich besteht die mglichkeit, bei bereinstimmung von 
;istwert & schaltpunkt, entsprechende eventflags zu setzen.
;die auswertung erfolgt in _PROFframer.asm !
;
;softport-events
;.equ	softPOev0	=	20	
;.equ	softPOev1	=	21
;.equ	softPOev2	=	22	
;.equ	softPOev3	=	23	
;.equ	softPOev4	=	24	
;.equ	softPOev5	=	25	
;.equ	softPOev6	=	26	
;.equ	softPOev7	=	27	
;.equ	softPOev8	=	28	
;.equ	softPOev9	=	29	
;

;steuervariable
;softPo(x)do
;was passiert wenn softPOevent(x) mit softPO(x)hys verglichen wird:
; _______________________________________________________________
;|bit7   |bit6   |bit5	 |bit4   |bit3   |bit2	 |bit1   |bit0   |
;|_______|_______|_______|_______|_______|_______|_______|_______|
;|hys-20 |hys+20 |hys-10 |hys+10 |=>     |<	 	 |==	 |       |
;|_______|_______|_______|_______|_______|_______|_______|_______|
;
;

;--------------------------------------------------------------
;!!!!!!!!!!!
;--------------------------------------------------------------
;da die adressbereiche aller multijobOS4.10 teilnehmer identisch
;konfiguriert sind, ist auf sorgfltigen datenversand via LAB zu
;achten. falsch-adressierung kann die zerstrung von ursprungs-,
;und zielparametern zur folge haben !!!
;--------------------------------------------------------------
;.equ	softPOcnt	=	ablaufcounter
;--------------------------------------------------------------
;verhindert mehrmalige generierung eines events bei dauerhaftem
;eintreten des grenzwertes....
;temporre statuswerte
;SWstateTEa	;bit0...7 <=> port 0...7
;SWstateTEb	;bit0...1 <=> port 8...9
;--------------------------------------------------------------
;--------------------------------------------------------------
_virt100POx:
	jmp	_virt100PO
_virt000PO:
	;
	lds	r16,softPOcnt
	cpi	r16,10
	brsh	_virt100POx
	;lade	startadresse <softPo0> 
	mov	r15,r16 ;counter nach r15 sichern...
	ldi	r17,0
	ldi	yh,high(softPo0)
	ldi	yl,low(softPo0)
	add	yl,r16
	adc	yh,r17
	;lade ziel-adresse-pointer
	ld	r18,y
	;limit ?
	cpi	r18,100
	brlo	go_virt000PO
	jmp	_virt099PO	;pointer zu gro == geht sonst ber den tabellenbereich !
go_virt000PO:
	;konvertiere m. cross_table (16-bit adressen)
	ldi	zh,high(cross_table)
	ldi	zl,low(cross_table)
	add	zl,r18 ;+pointer
	adc	zh,r17 
	lsl	zh
	lsl	zl	;
	brcc	_virt000noCARRY
	sbr	zh,1<<0 ;bit0 msb high
_virt000noCARRY:
	lpm
	mov	r16,r0  ; lade parameter-adresse-low 8-bit nibble 
	sbr	zl,1<<0 ;
	lpm	
	mov	r17,r0  ; lade parameter-adresse-high 8-bit nibble
	mov	zh,r17
	mov	zl,r16
	ld	r18,z	  ; real-parameter aus adresse geladen....
	;
	;
	;adressiere <softPOxhys> (aktuelle softPOx adresse +10 !!)
	ldi	r16,10
	add	yl,r16
	adc	yh,r17
	;lade hysterese-parameter aus adresse...
	ld	r19,y
	;
	;adressiere <softPOxdo> (aktuelle softPOxhys adresse +10 !!)
	add	yl,r16
	adc	yh,r17
	;lade do-parameter aus adresse...
	ld	r20,y
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;nun ist/hysterese-parameter vergleichen
;und entsprechend do-anweisung handeln...
		;-------------------------------------------
		;lade temporre statuswerte
		lds	zl,SWstateTEa	;bit0...7 <=> port 0...7
		lds	zh,SWstateTEb	;bit0...1 <=> port 8...9
		;-------------------------------------------
		;
		mov	r16,r15	;orginalen counterwert holen
		cpi	r16,0
		brne	_virt001PO
		ldi	r17,0		;ergebnis reg'
		call	_virtDOsub
		cpi	r17,0xff
		brne	_virt000POback	;keine aktion !
		;-------------------------------------------
		;...aktion?
		sbrc	zl,0
		rjmp	_virt000POhome
		;...ja !
		sbr		zl,1<<0
		sts	SWstateTEa,zl	
		;..........................................
		;events neu
		ldi	r17,20
		sts	eventTE,r17			;switch port 0 event setzen
		call	_MAKEeventSUB	;submodul !
		;
		;..........................................
_virt000POhome:		
	jmp	_virt099PO		
_virt000POback:
	;fr's nchste event enabled
	cbr	zl,1<<0
	sts	SWstateTEa,zl
	jmp	_virt099PO
	
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
_virt001PO:
		cpi	r16,1
		brne	_virt002PO
		ldi	r17,0		;ergebnis reg'
		call	_virtDOsub
		cpi	r17,0xff
		brne	_virt0001POback	;keine aktion !
		;-------------------------------------------
		;...aktion?
		sbrc	zl,1
		rjmp	_virt001POhome
		;...ja !
		sbr		zl,1<<1
		sts	SWstateTEa,zl	
		;..........................................
		;events neu
		ldi	r17,21
		sts	eventTE,r17			;switch port 1 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
_virt001POhome:		
	jmp	_virt099PO
_virt0001POback:
	;fr's nchste event enabled
	cbr	zl,1<<1
	sts	SWstateTEa,zl
	jmp	_virt099PO
		;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

_virt002PO:
		cpi	r16,2
		brne	_virt003PO
		ldi	r17,0		;ergebnis reg'
		call	_virtDOsub
		cpi	r17,0xff
		brne	_virt002POback	;keine aktion !
		;-------------------------------------------
		;...aktion?
		sbrc	zl,2
		rjmp	_virt002POhome
		;...ja !
		sbr		zl,1<<2
		sts	SWstateTEa,zl	
		;..........................................
		;events neu
		ldi	r17,22
		sts	eventTE,r17			;switch port 2 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................	
_virt002POhome:
	jmp	_virt099PO
_virt002POback:		
	;fr's nchste event enabled
	cbr	zl,1<<2
	sts	SWstateTEa,zl
	jmp	_virt099PO
		
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;
_virt003PO:
		cpi	r16,3
		brne	_virt004PO
		ldi	r17,0		;ergebnis reg'
		call	_virtDOsub
		cpi	r17,0xff
		brne	_virt003POback	;keine aktion !
		;-------------------------------------------
		;...aktion?
		sbrc	zl,3
		rjmp	_virt003POhome
		;...ja !
		sbr		zl,1<<3
		sts	SWstateTEa,zl	
		;..........................................
		;events neu
		ldi	r17,23
		sts	eventTE,r17			;switch port 3 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
_virt003POhome:
	jmp	_virt099PO
_virt003POback:		
	;fr's nchste event enabled
	cbr	zl,1<<3
	sts	SWstateTEa,zl
	jmp	_virt099PO
		
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;
		;
_virt004PO:
		cpi	r16,4
		brne	_virt005PO
		ldi	r17,0		;ergebnis reg'
		call	_virtDOsub
		cpi	r17,0xff
		brne	_virt004POback	;keine aktion !
		;-------------------------------------------
		;...aktion?
		sbrc	zl,4
		rjmp	_virt004POhome
		;...ja !
		sbr		zl,1<<4
		sts	SWstateTEa,zl	
		;..........................................
		;events neu
		ldi	r17,24
		sts	eventTE,r17			;switch port 4 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
_virt004POhome:
	jmp	_virt099PO
_virt004POback:		
	;fr's nchste event enabled
	cbr	zl,1<<4
	sts	SWstateTEa,zl
	jmp	_virt099PO
		
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;
		;
_virt005PO:
		cpi	r16,5
		brne	_virt006PO
		ldi	r17,0		;ergebnis reg'
		call	_virtDOsub
		cpi	r17,0xff
		brne	_virt005POback	;keine aktion !
		;-------------------------------------------
		;...aktion?
		sbrc	zl,5
		rjmp	_virt005POhome
		;...ja !
		sbr		zl,1<<5
		sts	SWstateTEa,zl	
		;..........................................
		;events neu
		ldi	r17,25
		sts	eventTE,r17			;switch port 5 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
_virt005POhome:
	jmp	_virt099PO
_virt005POback:		
	;fr's nchste event enabled
	cbr	zl,1<<5
	sts	SWstateTEa,zl
	jmp	_virt099PO
		
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;
_virt006PO:
		cpi	r16,6
		brne	_virt007PO
		ldi	r17,0		;ergebnis reg'
		call	_virtDOsub
		cpi	r17,0xff
		brne	_virt006POback	;keine aktion !
		;-------------------------------------------
		;...aktion?
		sbrc	zl,6
		rjmp	_virt006POhome
		;...ja !
		sbr		zl,1<<6
		sts	SWstateTEa,zl	
		;..........................................
		;events neu
		ldi	r17,26
		sts	eventTE,r17			;switch port 6 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
_virt006POhome:
	jmp	_virt099PO
_virt006POback:		
	;fr's nchste event enabled
	cbr	zl,1<<6
	sts	SWstateTEa,zl
	jmp	_virt099PO
		
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;
		;
_virt007PO:
		cpi	r16,7
		brne	_virt008PO
		ldi	r17,0		;ergebnis reg'
		call	_virtDOsub
		cpi	r17,0xff
		brne	_virt007POback	;keine aktion !
		;-------------------------------------------
		;...aktion?
		sbrc	zl,7
		rjmp	_virt007POhome
		;...ja !
		sbr		zl,1<<7
		sts	SWstateTEa,zl	
		;..........................................
		;events neu
		ldi	r17,27
		sts	eventTE,r17			;switch port 7 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
_virt007POhome:
	jmp	_virt099PO
_virt007POback:		
	;fr's nchste event enabled
	cbr	zl,1<<7
	sts	SWstateTEa,zl
	jmp	_virt099PO
		
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;
		;
_virt008PO:
		cpi	r16,8
		brne	_virt009PO
		ldi	r17,0		;ergebnis reg'
		call	_virtDOsub
		cpi	r17,0xff
		brne	_virt008POback	;keine aktion !
		;-------------------------------------------
		;...aktion?
		sbrc	zh,0
		rjmp	_virt008POhome
		;...ja !
		sbr		zh,1<<0
		sts	SWstateTEb,zh	
		;..........................................
		;events neu
		ldi	r17,28
		sts	eventTE,r17			;switch port 8 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
_virt008POhome:
	jmp	_virt099PO
_virt008POback:		
	;fr's nchste event enabled
	cbr	zh,1<<0
	sts	SWstateTEb,zh
	jmp	_virt099PO
		
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;
		;
_virt009PO:
		cpi	r16,9
		brne	_virt100POy
		ldi	r17,0		;ergebnis reg'
		call	_virtDOsub
		cpi	r17,0xff
		brne	_virt009POback	;keine aktion !
		;-------------------------------------------
		;...aktion?
		sbrc	zh,1
		rjmp	_virt009POhome
		;...ja !
		sbr		zh,1<<1
		sts	SWstateTEb,zh	
		;..........................................
		;events neu
		ldi	r17,29
		sts	eventTE,r17			;switch port 9 event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................	
		;..........................................
_virt009POhome:
	jmp	_virt099PO
_virt009POback:		
	;fr's nchste event enabled
	cbr	zh,1<<1
	sts	SWstateTEb,zh
	jmp	_virt099PO





;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
_virt100POy:
	jmp	_virt100PO
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;sub'
		;prfe do-anweisung
;|bit7   |bit6   |bit5	 |bit4   |bit3   |bit2	 |bit1   |bit0   |
;|_______|_______|_______|_______|_______|_______|_______|_______|
;|hys-20 |hys+20 |hys-10 |hys+10 |=>     |<	 |==	   |       |
;|_______|_______|_______|_______|_______|_______|_______|_______|
;
_virt000m20xx:
	jmp	_virt000m20
_virtDOsub:
		tst	r20			;0  == keine aktivitt
		breq	_virt000no
		cpi	r20,0b00000010	;2  == ist = hys
		breq	_virt000equ
		cpi	r20,0b00000100	;4  == ist < hys
		breq	_virt000lit
		cpi	r20,0b00001000	;8  == ist => hys
		breq	_virt000gre
		cpi	r20,0b00010000	;16 == ist >=hys+10 (<=255)
		breq	_virt000p10
		cpi	r20,0b00100000	;32 == ist <=hys-10 (>=0)
		breq	_virt000m10
		cpi	r20,0b01000000	;64 == ist >=hys+20 (<=255)
		breq	_virt000p20
		cpi	r20,0b10000000	;128== ist <=hys-20 (>=0)
		breq	_virt000m20xx
_virt000no:
		ret
		;ist = hys ?
_virt000equ:
		cp	r18,r19	;r18 ist / r19 hys
		brne	_virt000no
		ldi	r17,0xff
		jmp	_virt000no
		;ist < hys ?
_virt000lit:
		cp	r18,r19
		brlo	_virt000litX
		jmp	_virt000no
	_virt000litX:
		ldi	r17,0xff
		jmp	_virt000no
		;ist >= hys
_virt000gre:
		cp	r18,r19
		brsh	_virt000greX
		jmp	_virt000no
	_virt000greX:
		ldi	r17,0xff
		jmp	_virt000no
		;ist >= hys+10
_virt000p10:
		ldi	r21,10
		add	r19,r21	;hysterese +10
		brcc	_virt000p10Y
		ldi	r19,0xff
	_virt000p10Y:
		cp	r18,r19
		brsh	_virt000p10X
		jmp	_virt000no
	
	_virt000p10X:
		ldi	r17,0xff
		jmp	_virt000no
		;ist >= hys+20
_virt000p20:
		ldi	r21,20
		add	r19,r21	;hysterese +20
		brcc	_virt000p20Y
		ldi	r19,0xff
	_virt000p20Y:
		cp	r18,r19
		brsh	_virt000p20X
		jmp	_virt000no
	
	_virt000p20X:
		ldi	r17,0xff
		jmp	_virt000no


		;ist <= hysterese-10	
_virt000m10:
		ldi	r21,10
		sub	r19,r21	;hysterese -10
		brmi	_virt000m10Y
		jmp	_virt000m10OK
	_virt000m10Y:
		ldi	r19,0
	_virt000m10OK:
		cp	r18,r19
		breq	_virt000m10X
		brlo	_virt000m10X
		jmp	_virt000no
	_virt000m10X:
		ldi	r17,0xff
		jmp	_virt000no

		;ist <= hysterese-20	
_virt000m20:
		ldi	r21,20
		sub	r19,r21	;hysterese -20
		brmi	_virt000m20Y
		jmp	_virt000m20OK
	_virt000m20Y:
		ldi	r19,0
	_virt000m20OK:
		cp	r18,r19
		breq	_virt000m20X
		brlo	_virt000m20X
		jmp	_virt000no
	_virt000m20X:
		ldi	r17,0xff
		jmp	_virt000no			

;-------------------------------------------------------------------------
;jump back...
;-------------------------------------------------------------------------		
					

_virt099PO:
	inc	r16
	sts	softPOcnt,r16
	ret
_virt100PO:
	ldi	r16,0
	sts	softPOcnt,r16
	ret


