;----------------------------------------------------------------------------------
;ENTRY-FILE SYSsoft
;----------------------------------------------------------------------------------
.include "_+_m128def.inc"			;sram=4k   e2prom=4k   flash=128k	 
.equ    BOOTstart   =   LARGEBOOTSTART
;build for mega128 Fsys=18,32MHz 
;only use with the new Interface (107)

;time default motorschutz
.equ	COpro			=	100

;pwm process
.equ	allPHdw			=	0	;alle dw flag
.equ	allPHup			=	1	;alle up flag 
			

;key-flags
.equ	TOG1seq			=	0
.equ	TOG2seq			=	1
.equ	TOG3seq			=	2

;pin-definition
.equ	K0edge			=	3	;pine3
.equ	K1edge			=	4	;pine4
.equ	K2edge			=	5	;pine5
.equ	K3edge			=	6	;pine6
.equ	K4edge			=	7	;pine7

;pin wait states <keyWTstate>
.equ	K0wait			=	3	;
.equ	K1wait			=	4	;
.equ	K2wait			=	5	;
.equ	K3wait			=	6	;
.equ	K4wait			=	7	;

;--------------------------------------------------------------------------------------
;----------remote----------------------------------------------------------------------
;--------------------------------------------------------------------------------------
;statusflags
.equ	RTactivMstart	=	0   ;start remote as a master   - only if <RTon>=1
.equ	RTactivS		=	1   ;a remote client            - only if <RTon>=1
.equ	RTmaster		=	2	;remote master activ        - only if <RTon>=1
.equ	RToff			=	3   ;shutdown remote            - only if <RTon>=1
.equ	RTon			=	4   ;remote activ               - enabled the remote function


;dcf konstanten
.equ	ko2000dcf		=	8960 ;222s	/	9000 bei 2000 * 221s 
.equ	ko300dcf		=	1344 ;222s /   1350 bei 300 * 222s
.equ	ko999dcf		=	4659 ;222S /   4680 bei 999  * 222s
.equ	ko80dcf		=	358	;222s /    360	 bei 80   * 222s
.equ	ko180dcf		=	806	;222s /    810	 bei 180  * 222s

;flags:
.equ	dcf77sync		=	0	;sync-flag - dieses flag sperrt die interne rtc !!!!!
.equ	dcf77level	    =	1	;signal-flag
.equ    dcf77ena        =   2   ;start dcf scanning !
.equ	dcf77high		=	3	;high-impuls
.equ	dcf77sumST	    =	5	;start-sommerzeit
.equ	dcf77mesz		=	6	;sommerzeit mez+1
.equ	dcf77schalt	    =	7	;schaltsekunde

.equ	dcf77_ms		=	0	;1ms flag (0x224) im timeslotmodul gesetzt
.equ	dcf1_s		=	1	;1s flag (0x224) im dcf77III modul gesetzt


;--------------------------------------------------------------------------------------
;--------- timer/counter konstanten & bit Definition ----------------------------------
;--------------------------------------------------------------------------------------

.equ	tiREL			= 	129	;257-((clock_f/8)/18018)	;155 <=>Fclk=14,7456Mhz ...146 <=> 16MHz)   
								;129 <=> Fclk 18,432000MHz (slottime = 55,5S / 1024 instr. je slot)
.equ	ser1K			=	1

.equ    waitSPIko       =   20
;--------------------------------------------------------------------------------------
;----------------------------- tiFLAG bit definition ----------------------------------
;--------------------------------------------------------------------------------------


.equ	sekunde			=	0	;bit 0 wird als sekunden-flag genutzt (r27 <=> tiFLAG) ..wird getoggelt !!!!
.equ	help			=	1	;bit 1      "   help  -flag genutzt   (r27 <=> tiFLAG)
.equ	s100b			=	2	;bit 2      "   500ms help flag gen.  (r27 <=> tiFLAG)
.equ	s1s     		=   3   ;bit 3      "   1 sekunden flag       (r27 <=> tiFLAG)
.equ	s1ms  			=   4   ;bit 4      "   1ms falg              (r27 <=> tiFLAG)
.equ	s10msB			=	5	;bit 5	    "   10ms help flag	      (r27 <=> tiFLAG)
.equ    m1m             =   6   ;bit 6      "   wird als new minute flag fr extended timer gesetzt


;--------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------
;------------------ powerrail flag definition ----------------------------------
;--------------------------------------------------------------------------------------


;0xcc

.equ	SHcut			=	7	;kurzschlu flag
.equ	portON			=	6	;port-on-flag
.equ	delOFF			=	5	;delayed-off-flag
.equ	softDW			=	4	;soft-down-flag
.equ	softUP			=	3	;soft-up-flag
.equ	railON			=	2	;power-rail-on-flag
.equ	senseON			=	1	;current-sense-on-flag
.equ	curON			=	0	;kurzschluberwachung an/aus-flag





;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;->SOFTWARE-FLAG-VARIABLEN
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;SEflagA <=> serial data communication flag variable
;********Flag's in SEflagA: 
.equ	SEbusy  	=	7	;<=> activ data communication
.equ	NETrun  	=	6	;<=> net data communication running 
;				             SILwait =((10 * x)* CONbaud)* 55,3s<cycle_timeslot> 			   
.equ	RXframe 	=	4	;<=> new received data frame in buffer
.equ	TXframe 	=	3	;<=> new data frame to transmit
.equ	SEdir   	=	2	;<=> rx/tx ?
.equ	SEerror 	=	1	;<=> frame error
;
.equ	SEenabled	=	0	;<=> serial IF (dis-)enabled


;SEflagB <=> serial data communication flag variable
;********Flag's in SEflagB: 
.equ	newTX		=	2	;<=> signaliere new-data-frame-TX 
.equ	reqTX		=	1	;<=> "       "  request-data-tx
.equ	BRcast		=	0	;<=> broadcast frame received

;SEflagC <=> serial data communication flag variable
;********Flag's in SEflagC:

;.equ	TXready			=	7	;<=> tx abgeschlossen (abhngig von TXC(ucsra)
.equ	FRbuild			=	6	;<=> framebuilder (DMA/OBJECT/HOT-SHOT) belegt gerade txbuffer
.equ	SERcomACT		=	5	;<=> allgemeine sercom aktivitt die den rxbuffer belegt...
.equ	SERwireless		=	4	;<=> wireless auswahlflag
.equ	SERwired		=	3	;<=> wired auswahlflag
.equ	FRAMEfreeze		=	2	;<=> DMA/object-framer blocked
.equ    FRAMEhot        =   1   ;<=> hot-shot framer generiert daten
.equ    FRAMEdma        =   0   ;<=> dma framer generiert daten

;flags <fifoVAR>
.equ	fifoERR			=	0	;fifo error flag
.equ	fifoNEW			=	1	;fifo new-data flag
;----------------------------------------------------------------------------------------------------
;->DEFINITIONS SERcom.asm
;----------------------------------------------------------------------------------------------------
			
;......TWI
.equ	bitrate			=	80		;	standard 80					
.equ	prescal			=	0		;					
.equ	i2cout			=	100		;time out konstante 180

;twi-flags									
.equ	control			=	0		;control-flag (twi-STATUS)	   
.equ	TWIrequest		=	1		;request-flag (twi-STATUS)	
.equ	TWIinstr		=	2		;instruktion-flag (twi-STATUS)
.equ	adrmod			=	3		;adressierungsart			
.equ	adress			=	4		;adress-flag (twi-status)	
.equ	LHAreq			=	5		;transfer to LHA (request)
.equ    doTWI      		=   6       ;twi-aktion aktion noch abarbeiten
.equ	repSTART		=	7		;repeated start im request mode !

;twi-control-matrix
.equ	TWIstart		=	0x8		;twsr startmatrix				
.equ	TWIrep			=	0x10	;repeated start
.equ	slaW			=	0x18	;	"					
.equ	slaR			=	0x40	;	"					
.equ	rxACK			=	0x28	;   "
.equ	rxNACK			=	0x30	;	"
.equ	ARBerr			=	0x38	;arbitration lost...
.equ	txNACK			=	0x20	;nack
.equ	RECack			=	0x50
.equ	RECnack			=	0x58


;----------------------------------------------------------------------------------
;mi-Flags:
.equ	b_cast			=	7
.equ	RFsetup			=	6
.equ	request			=	5
.equ	adr_mod			=	4
.equ	trans1			=	3
.equ	trans0			=	2
.equ	requ1			=	1
.equ	requ0			=	0

;----------------------------------------------------------------------------------------------------
;->DEFINITIONS SERif.asm 
;----------------------------------------------------------------------------------------------------
.equ	WToutVAR		    = 	25	;25	14,4k ;fifo timeout... ((1/baud)*9/slottime)*2,2
.equ	TIrxBYTE			=	1	;TEST1 ((TIrxBYTE * Framesize)+ net_sou_adress)* slottime = wartezeit auf acknowledge
.equ	wiWAIT				=	30	;{TEST30}   wiWAIT * slottime = rx/tx umschaltungs delay	
.equ	REPTXdef			=	2	;tx repeat // auch group access 
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;FLAGS
.equ	showTD				=	1
.equ	calREADY			=	4

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;HOT SHOT
.equ	HSon				=	7	;hot shot enabled
.equ	HSdevEDI			=	6	;1=edit devive table // only possible after clear target instr. !
.equ	HSexe				=	5	;1=execute hotshot 



;flags
.equ	schaltFL			=	0	;schaltjahrflag
.equ	kalender			=	1	;kalender start
.equ	kalLOOP				=	2	;loop flag
;konstante
.equ	Wday				=	7	;wochentage
.equ	sixty				=	61	
;
;GLOBtim =      0x71	        	;global timer (de-)aktivierungsvariable
.equ	GLtim0				=	0	;global timer flag 0
.equ	GLtim1				=	1	;   "          "   1
.equ	GLtim2				=	2	;   "          "   2
.equ	GLtim3				=	3	;   "          "   3	
;
;FLAGS
.equ	t1ms0FLAG			=	0
.equ	t1ms1FLAG			=	1
.equ	t1ms2FLAG			=	2
.equ	t1ms3FLAG			=	3

;FLAGS
.equ	comp0activ			=	0
.equ	comp1activ			=	1
.equ	comp2activ			=	2
.equ	comp3activ			=	3
.equ	comp4activ			=	4
.equ	comp5activ			=	5
.equ	comp6activ			=	6
.equ	comp7activ			=	7

;....................................................................
;I2C Devices
;....................................................................
;bausteinadressen /2 (range):							          |
;pcf8574:  	0x20-0x27 !!!	-> 0x20 - 0x23				          |
;pcd3311:	0x24-0x25 		-> 0x24 - 0x25				          |
;tda8444:	0x20-0x27 !!!	-> 0x26 - 0x27				          |
;max128:	0x28-0x2f		-> 0x28 - 0x2b				          |
;saa1064:	0x38-0x3b !!!	-> 0x38 - 0x3b				          |
;pcf8574A: 	0x38-0x3f		-> 0x3c - 0x3f				          |
;lm75:		0x48-0x4f !!!	-> 0x48 - 0x4b				          |						
;pcf8591:	0x48-0x4f !!!	-> 0x4c - 0x4f 				          |
;pcf8583:	0x50-0x51		-> 0x50 - 0x51                        |
;st24c08:   0x50-0x57       -> 0x52 - 0x57                        |
;led matrix 0x7c-0x7f       -> 0x7c - 0x7f                        |
;....................................................................
;NOTE: Adresses will be multiplied by 2 in __comLAYER !
.equ    _ADR_pcf8574    =   0x20
.equ    _ADR_pcd3311    =   0x24
.equ    _ADR_tda8444    =   0x26
.equ    _ADR_max128     =   0x28
.equ    _ADR_saa1064    =   0x38
.equ    _ADR_pcf8574A   =   0x3c
.equ    _ADR_lm75       =   0x48
.equ    _ADR_pcf8591    =   0x4c
.equ    _ADR_pcf8583    =   0x50
.equ    _ADR_st24c08    =   0x52
.equ    _ADR_ledMAT     =   0x7c

;

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;spi-glcd flags
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; SPI
.equ	_SS				=	0	;pb0
.equ	MOSI				=	2	;pb2
.equ	MISO				=	3	;pb3
.equ	SCK				=	1	;pb1

;portb
.equ	_ifSEL			=	4	;interface select pin
.equ	_nSEL			=	6	;rfm12 busy pin

;.............................................................................
;--------------------------------------------------------------------------------------
;HIF Flags
;--------------------------------------------------------------------------------------
;...........................................................................
;para-Function flag
.equ	ediG			=	7		;
.equ	parG			=	6		;-> flag...
;...........................................................................
;comFLAGspi's 0x23f
.equ	newSPIdata		=	0		;neue daten empfangen
.equ	spiBUSY			=	1		;transfer aktiv
.equ	spiMready			=	2		;master ready
.equ	newSPIsnd			=	3		;neue daten senden
.equ	exeSPIdata		=	4		;neue daten ausfhren
.equ	repSPItrPZ		=	5		;gesetzt bei spiBUSY & neue pz-daten zum versand...
.equ	repSPItrPR		=	6		;gesetzt bei spiBUSY & neue pr-daten zum versand...
.equ	spiWORKIN			=	7		;spi routine aktiv


;...........................................................................
;ifSELstate flags
.equ    SPIrecHIF       =     0      ;HIF receiving
.equ    SPIrecNET       =     1      ;NET receiving
.equ    SPIrecERR       =       2   ;error receiving

;...........................................................................
;comFLAGspiREM
.equ	newSPIdataR		=	0		;neue daten im rem-master hif generiert und im slave verarbeiten
.equ	newSPIsndR		=	1		;neue daten im rem-slave generiert und im master verarbeiten 


;******************************************************************************************
;OBJECT DEFINITIONS
;******************************************************************************************
;siehe memMAP...

.equ	SYSeolSUB		=	32768	;konstante
;........................................................................
;flags(
.equ	errOB		=	0
.equ	newOB		=	1

;*******************************************************************************************
;programmplatzspeicher 
;E2prom  0x150-0x1F0 (im laufenden betrieb erforderlich)

;FLAG'S:
.equ	runMTX		=	0		;run matrix 	== 	mu zusammen mit programmplatz
;(0x146) an matrix - routine bergeben werden
.equ	same0		=	1 		;(0x146)
.equ	same1		=   2
.equ	same2		=	3
.equ	same3		=	4
.equ	makeMTX		=	5		;bergebe aktive sollparameter an macro
.equ	wrMTX		=	6		;schreiben aktiv !
.equ	same		=	7		;vergleichsflag	==	interne verarbeitung (timer/programm) 	

;******************************************************************************************* 
;progOB konstanten
.equ	kon50tsd	=	50000
.equ	kon10tsd	=	10000
.equ	kon5tsd		=	5000
.equ	kon1tsd		=	1000
.equ	kon1hun		=	100
.equ	kon5hun		=	500
.equ	kon5zig		=	50
.equ	kon1zehn	=	10

;..........................................................................................
;delete flag <e2pDELvar>
.equ    e2pDEL      =   0       ;dis-,enables the e2p segment delete

;----------------------------------------------------------------
;----------- Register Definition --------------------------------
;----------------------------------------------------------------
;Reservierte Register:
.def	tiFLAG	=	r27	;globale Zeitmarkenregister



;----------------------------------------------------------------
;interrupt adressen
;----------------------------------------------------------------

.cseg
.org	0
	;------------------> jump table fuer atmega128!!!
	jmp	SYSinit			   ;RESaddr =0x000	;Reset vector Adress
;**** Interrupt Vectors ****
.org	   $002	; External Interrupt0 Vector Address
    reti
.org	   $004	; External Interrupt1 Vector Address
    reti
.org	   $006	; External Interrupt2 Vector Address
    reti
.org	   $008	; External Interrupt3 Vector Address
    reti
.org	   $00a	; External Interrupt4 Vector Address
    reti
.org	   $00c	; External Interrupt5 Vector Address
    reti
.org	   $00e	; External Interrupt6 Vector Address
    reti
.org	   $010	; External Interrupt7 Vector Address
    reti
.org       $012	; Output Compare2 Interrupt Vector Address
    reti
.org	   $014	; Overflow2 Interrupt Vector Address
    reti
.org	   $016	; Input Capture1 Interrupt Vector Address
    reti
.org	   $018	; Output Compare1A Interrupt Vector Address
    reti
.org	   $01a	; Output Compare1B Interrupt Vector Address
    reti
.org	   $01c	; Overflow1 Interrupt Vector Address
    reti
.org	   $01e	; Output Compare0 Interrupt Vector Address
    reti

;tov0-flag 
.org	0x20
	jmp	_tiSLOT	
;spi-flag
.org	0x22
	jmp	SPI_SLAVE
.org	   $024	; USART0 Receive Complete Interrupt Vector Address
    reti
.org	   $026	; USART0 Data Register Empty Interrupt Vector Address
    reti
.org	   $028	; USART0 Transmit Complete Interrupt Vector Address
    reti
.org       $02a	; ADC Conversion Complete Handle
    reti
.org	   $02c	; EEPROM Write Complete Handle
    reti
.org	   $02e	; Analog Comparator Interrupt Vector Address
    reti
.org	   $030	; Output Compare1C Interrupt Vector Address
    reti
.org	   $032	; Input Capture3 Interrupt Vector Address
    reti
.org	   $034	; Output Compare3A Interrupt Vector Address
    reti
.org	   $036	; Output Compare3B Interrupt Vector Address
    reti
.org	   $038	; Output Compare3C Interrupt Vector Address
    reti
.org	   $03A	; Overflow3 Interrupt Vector Address
    reti
.org	   $03C	; USART1 Receive Complete Interrupt Vector Address
    reti
.org	   $03E	; USART1 Data Register Empty Interrupt Vector Address
    reti
.org	   $040	; USART1 Transmit Complete Interrupt Vector Address
    reti
.org       $042	; TWI Interrupt Vector Address
    reti
.org	   $044	; Store Program Memory Ready Interrupt Vector Address
    reti


;----------------------------------------------------------------------
;init counters,stack,timer...
;----------------------------------------------------------------------
.org	0x4a
SYSinit:
	;stack
	ldi	r16,high(ramend)
	out	sph,r16
	ldi	r16,low(ramend)
	out	spl,r16
	
	;+++++++++++++++++++++++++++++++++++++++++++
	;disable jtag IF
;	in	r16,mcucsr
;	sbr	r16,1<<jtd
;	out	mcucsr,r16
;	nop
;	out	mcucsr,r16



;-------------------clear sram complete 0x100 headroom ! ----------------------------------------------------------------------------
	clr	r16
	ldi	zh,high(sram_start)
	ldi	zl,low(sram_start)	;sram startadresse(0x100)
_CLRsram:
	st	z+,r16	
	cpi	zl,low(ramend)		;Compare low byte
	ldi	r17,high(ramend)	;
	cpc	zh,r17				;Compare high byte
	breq	_SRAMready
	jmp	_CLRsram
	;
_SRAMready:
;-----------------------------------mirror e2prom -> sram ------------------------------------


;		  *	0x000  	 	    	= 	entry pin
;		  +	0x001				= 	lha
			.equ	net_se2p	=	0x1
;		  +	0x002	-	0x005	=	powerdelays
;		  +	0x006	- 	0x014	=	timer0-3
;		  +	0x015	-	0x01e	=	delay 0-9 / ev-delay 0&1
;		  + 0x01f 	- 	0x026  	= 	port-aktiv-bytes 	
;		  *	0x027         		= 	adc-max-current-var
			.equ	adcHYSe2p	=	0x27	
;		  +	0x028 	- 	0x02f  	= 	compare-max 0-7 
;		  +	0x030	-	0x037	=	compare-ist 0-7
;		  +	0x038 	- 	0x049  	= 	compare-timers & counters 
;		  +	0x04a	- 	0x067 	= 	switchport-variablen 
;		  * 0x068	-	0x1a7	=	macro-matrix
			.equ	proE2ADR	=	0x68 
;		  +	0x1a8 	- 	0x35f	= 	dma-profiles
;		  +	0x360 	- 	0x48b	= 	object-class-table out
;		  +	0x48c	- 	0x611	= 	object-classfilter-table in
;		  + 0x612	- 	0x76a	=   key-sequencer
;         + 0x76b   -   0x7f6   =   class parameter definition table
;         + 0x7f7   -   0x8c8   =   class parameter execution conditions
;		  - 0x8c9   -   0x8f0	=   FREE
;         + 0x8f1   -   0x8f7   =   lha id
;         - 0x8f8   -   0x91a   =   FREE
;         + 0x91b   -   0xca3   =   hot shots
;         + 0xca4   -   0xcab   =   adc to parameter table
;         * 0xcac   -   0xdb1   =   host table
;         + 0xdb2   -   0xdd9   =   enhanced timers

;- = nicht belegt
;+ = kopiere beim booten
;* = dynamisches laden
;------------------------------------------------------------------------------------------


;
;range...n-1 (anzahl bytes -1)
.equ	_mirA	=	0x10		;timer 0-3
.equ	_mirB	=	0x8			;delay 0-7
.equ	_mirC 	=   0x8			;compare max. 0-7 / ist 0-7
.equ	_mirD 	=   0x8			;port aktivbytes
.equ	_mirF	=	0x1e		;virt_port 0-29
.equ	_mirG	=	0x1			;lha
.equ	_mirH	=	0x1b8		;profilframer..
.equ	_mirI	=	0xa			;compare timer
.equ	_mirJ	=	0x2			;eventdelay
.equ	_mirK	=	0x4			;powerdelays
.equ	_mirL	=	0x6			;comparetimer 5..7
.equ    _mirM   =   0x2c        ;enhanced timer 0...9
;----------------------------------------------------------
	;+net_sou_adress
__mirrorAX:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(net_se2p)
	ldi	r24,low(net_se2p)		
	ldi	zh,high(net_sou_adress)
	ldi	zl,low(net_sou_adress) 	;
	ldi	r19,_mirG		;max range 1
	call	_MIrrore2
;-------------------------------------

	;+timer1-4
__mirrorA:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(timerE2adr)
	ldi	r24,low(timerE2adr)			;mirror - e2prom start
	ldi	zh,high(minut1)
	ldi	zl,low(minut1) 	;mirror - sram start	
	ldi	r19,_mirA		;max range
	call	_MIrrore2

	;
	;+delay0-7
__mirrorB:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(delE2adrA)
	ldi	r24,low(delE2adrA)		;mirror - e2prom start
	ldi	zh,high(delay0)
	ldi	zl,low(delay0) 	;mirror - sram start	
	ldi	r19,_mirB		;max range
	call	_MIrrore2
	;
	;+power delays 1-4
__mirrorBY:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(delE2adrB)
	ldi	r24,low(delE2adrB)		;mirror - e2prom start
	ldi	zh,high(Pdelay1)
	ldi	zl,low(Pdelay1) 	;mirror - sram start	
	ldi	r19,_mirK		;max range
	call	_MIrrore2
	;
	;+ev-delay 0&1
__mirrorBX:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(delE2adrC)
	ldi	r24,low(delE2adrC)		
	ldi	zh,high(TI1evsoll)
	ldi	zl,low(TI1evsoll) 
	ldi	r19,_mirJ		;max range
	call	_MIrrore2

;-----------------------------------------------

	;+CmaxA...D 
	;blends /counter compare
__mirrorC:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(CmaxE2p)
	ldi	r24,low(CmaxE2p)		;mirror - e2prom start
	ldi	zh,high(CmaxA)
	ldi	zl,low(CmaxA) 	;mirror - sram start	
	ldi	r19,_mirC		;max range
	call	_MIrrore2

	;+Cist1...8
	;blends /counter compare
__mirrorCY:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(CistE2p)
	ldi	r24,low(CistE2p)		;mirror - e2prom start
	ldi	zh,high(CpareI1)
	ldi	zl,low(CpareI1) 	;mirror - sram start	
	ldi	r19,_mirC		;max range
	call	_MIrrore2

	;+Csoll 1...8 == ist
	;blends /counter compare
__mirrorCYY:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(CistE2p)
	ldi	r24,low(CistE2p)		;mirror - e2prom start
	ldi	zh,high(CpareA)
	ldi	zl,low(CpareA) 	;mirror - sram start	
	ldi	r19,_mirC		;max range
	call	_MIrrore2

;--------------------------------------------------------------
	;
	;+aktiv-port
__mirrorD:
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(aktE2adr)
	ldi	r24,low(aktE2adr)		;mirror - e2prom start
	ldi	zh,high(akt1)
	ldi	zl,low(akt1)	;mirror - sram start	
	ldi	r19,_mirD		;max range
	call	_MIrrore2


;----------------------------------------------------------------
	;+switch-port
__mirrorG:	
	clr	yl
	clr	yh
	clr	r18
	ldi	r25,high(softPo0ep)
	ldi	r24,low(softPo0ep)	;mirror - e2prom start
	;
	ldi	zh,high(softPo0)
	ldi	zl,low(softPo0)		;mirror - sram start	
	;
	ldi	r19,_mirF			;max range
	call	_MIrrore2

;----------------------------------------------------------------
	;+dma-profiles
__mirrorH:	
	clr	yl
	clr	yh
	ldi	r25,high(profiSTe2p)
	ldi	r24,low(profiSTe2p)	;mirror - e2prom start
	;
	ldi	zh,high(profiSTram)
	ldi	zl,low(profiSTram)	;mirror - sram start	
	;
	ldi	r19,low(_mirH)		;max range
	ldi	r18,high(_mirH)
	call	_MIrrore2
;----------------------------------------------------------------
	;+compare timer 0-4 
__mirrorI:	
	clr	yl
	clr	yh
	ldi	r25,high(comTIMe2adr)
	ldi	r24,low(comTIMe2adr)	;mirror - e2prom start
	;
	ldi	zh,high(timeUP0low)
	ldi	zl,low(timeUP0low)	;mirror - sram start	
	;
	ldi	r19,low(_mirI)		;max range
	ldi	r18,high(_mirI)
	call	_MIrrore2

	;+compare timer 5-7 & dw-timer
__mirrorIX:	
	clr	yl
	clr	yh
	ldi	r25,high(comTIMe2adrB)
	ldi	r24,low(comTIMe2adrB)	;mirror - e2prom start
	;
	ldi	zh,high(timeUP5low)
	ldi	zl,low(timeUP5low)	;mirror - sram start	
	;
	ldi	r19,low(_mirL)		;max range
	ldi	r18,high(_mirL)
	call	_MIrrore2






;---------------------------------------------------------------
	;+class_define (out)
__mirrorJ:	
	clr	yl
	clr	yh
	ldi	r25,high(class_defineEEPROM)
	ldi	r24,low(class_defineEEPROM)	;mirror - e2prom start
	;
	ldi	zh,high(class_define)
	ldi	zl,low(class_define)		;mirror - sram start	
	;
	ldi	r19,low(class_def_SIZ)		;max range
	ldi	r18,high(class_def_SIZ)
	call	_MIrrore2
;---------------------------------------------------------------
	;+class_filter_def (in)
__mirrorK:	
	clr	yl
	clr	yh
	ldi	r25,high(class_filter_defEEPROM)
	ldi	r24,low(class_filter_defEEPROM)	;mirror - e2prom start
	;
	ldi	zh,high(class_filter_def)
	ldi	zl,low(class_filter_def)		;mirror - sram start	
	;
	ldi	r19,low(class_fil_SIZ)			;max range
	ldi	r18,high(class_fil_SIZ)
	call	_MIrrore2

;---------------------------------------------------------------
	;+key-sequencer
__mirrorL:	
	clr	yl
	clr	yh
	ldi	r25,high(keyTBLstart_e2p)
	ldi	r24,low(keyTBLstart_e2p)	;mirror - e2prom start
	;
	ldi	zh,high(keyTBLstart)
	ldi	zl,low(keyTBLstart)		;mirror - sram start	
	;
	ldi	r19,low(keyTBLsiz)			;max range
	ldi	r18,high(keyTBLsiz)
	call	_MIrrore2

;---------------------------------------------------------------
	;+lha_id
__mirrorLX:	
	clr	yl
	clr	yh
	ldi	r25,high(lha_id_tble2p)
	ldi	r24,low(lha_id_tble2p)	;mirror - e2prom start
	;
	ldi	zh,high(lha_id_tbl)
	ldi	zl,low(lha_id_tbl)		;mirror - sram start	
	;
	ldi	r19,low(lha_id_range)			;max range
	ldi	r18,high(lha_id_range)
	call	_MIrrore2

	;adc sensoric cross table
__mirrorR:
	clr	yl
	clr	yh
	ldi	r25,high(adcSENSE_paraTBL)
	ldi	r24,low(adcSENSE_paraTBL)	;mirror - e2prom start
	;
	ldi	zh,high(ADC16_SA1H)
	ldi	zl,low(ADC16_SA1H)		;mirror - sram start	
	;
	ldi	r19,low(_mirD)			;max range
	ldi	r18,high(_mirD)
	call	_MIrrore2




	;enhanced timers
__mirrorS:
	clr	yl
	clr	yh
	ldi	r25,high(Etim_tble2p)
	ldi	r24,low(Etim_tble2p)	;mirror - e2prom start
	;
	ldi	zh,high(enTIMmin)
	ldi	zl,low(enTIMmin)		;mirror - sram start	
	;
	ldi	r19,low(_mirM)			;max range
	ldi	r18,high(_mirM)
	call	_MIrrore2


    ;macro backup
__mirrorT:
	clr	yl
	clr	yh
	ldi	r25,high(prog_platzAadr)
	ldi	r24,low(prog_platzAadr)	;mirror - e2prom start
	;
	ldi	zh,high(prog_platzA)
	ldi	zl,low(prog_platzA)		;mirror - sram start	
	;
	ldi	r19,low(_mirG)			;max range =1
	ldi	r18,high(_mirG)
    call	_MIrrore2


   ;powerflag backup
__mirrorU:
	clr	yl
	clr	yh
	ldi	r25,high(PWRflagadr)
	ldi	r24,low(PWRflagadr)	;mirror - e2prom start
	;
	ldi	zh,high(PWRflag)
	ldi	zl,low(PWRflag)		;mirror - sram start	
	;
	ldi	r19,low(_mirG)			;max range =1
	ldi	r18,high(_mirG)
    call	_MIrrore2
	jmp	_MIRready




;--------------------------------------------------------------------------
_MIrrore2:
	sbic	eecr,eewe		; eepe nicht gelscht ?
	rjmp	_MIrrore2		; warte...
	out		eearh,r25 
	out		eearl,r24		; adressierung e2prom
	sbi		eecr,eere		; bereite bertragung aus e2prom vor 
	in		r2,eedr			; kopiere daten aus e2prom nach r2
	st		z+,r2			;sram adr+1
	adiw 	r25:r24,1		;e2promadresse +1
	;range-1
	subi	r19,low(ser1K)
	sbci	r18,high(ser1K)
	;0?
	cp		yl,r19
	cpc		yh,r18			;nur bis ..mirror range
	brne	_MIrrore2
	ret


;-----------------------------------------------------------------------------------
;new ATmega128
_MIRready:

	;portA  Sek. output 
	;a)state: all pins L
	clr	r16
	out	porta,r16
	;b)direction: all pins output
	ldi	r16,0xff
	out	ddra,r16	

	;pwm-pin low
	cbi	portb,pb5
	sbi	ddrb,ddb5
	;set _ifSELinput
	sbi	portb,_ifSEL
	cbi	ddrb,_ifSEL
	;set _nSELinput
	cbi	portb,_nSEL ;sbi TEST 26-12-07
	cbi	ddrb,_nSEL
	;set _SS input
;	sbi	portb,_SS
;	cbi	ddrb,_SS
	;set SCK input
	sbi	portb,SCK
	cbi	ddrb,SCK
	;set MISO input
	sbi	portb,MISO
	cbi	ddrb,MISO
	;set MISO input
	sbi	portb,MOSI
	cbi	ddrb,MOSI


	;-----------------------------------------
	;portC  Prim. output
	;a)state: all pins low
	clr	r16
	out	portc,r16
	;b)direction: all pins output
	ldi	r16,0xff
	out	ddrc,r16


	;-----------------------------------------
	;portD   TWI(PD0,1)/UART1(PD2..PD4)/TRIGGER(PD6)/DCF(PD7)
	clr	r16			;testen.. eventuell PD6/PD7 pullup!
	sbr	r16,1<<7
	out	portd,r16
	ldi	r16,0b00010000
	out	ddrd,r16


	;-----------------------------------------
	;portE   UART0(PE0..PE2)/KEYS(PE3...PE7)
	;+++TEST
	;clr	r16
	ldi	r16,0b00000100		
	out	porte,r16
	ldi	r16,0b00000000
	out	ddre,r16

	
	;-----------------------------------------
	;portF   ADC(PF0..PF3)/JTAG(PF4...PF7)
	ldi	r16,0xf0
	sts	portf,r16
	clr	r16
	sts	ddrf,r16


	;-----------------------------------------
	
	;timer0 overflow-interrupt alle 55,5s
	;Fck(18,432000Mhz)/8= 2304000Hz/128=18000Hz <=> 1/18000 = 55,5s
	;
	;tiREL=(256+1)-128=129
	clr	r16
	sbr	r16,1<<toie0	;enable overflow interrupt
	out	timsk,r16
	clr	r16
	sbr	r16,1<<cs01	
	out	tccr0,r16		;prescale /8
	
	ldi	r16,tiREL		;s reload 
	out	tcnt0,r16
	;


	;-------------------------------------------------------------------------------------------
	;		  				 _______________________________________________________________
	;timer1/counter control:|com1A1 |com1A0 |com1B1 |com1B0 |foc1A  |foc1B  |wgm11  |wgm10  |
	;tccr1A		 			|_______|_______|_______|_______|_______|_______|_______|_______|
	;		           
	;
	;		  		 		 _______________________________________________________________
	;timer1/counter control:|icnc1  |ices1  |-      |wgm13  |wgm12  |cs12   |cs11   |cs10   |
	;tccr1B		 			|_______|_______|_______|_______|_______|_______|_______|_______|
	;		           
	;
	;
	;timer1 pwm-mode auf pin ocr1a!
	ldi	r16,0b10000001		;init ocr1a (choose 8-Bit PWM etc...)
	out	tccr1a,r16

	ldi	r16,0b00000001		;init PWM...mode1 / phase correct / (choose fclk/0!)
	out	tccr1b,r16
		
	ldi	r16,0			;default wert 0	
	out	ocr1ah,r16			
	out	ocr1al,r16
	out	tcnt1l,r16
	out	tcnt1h,r16


	;------------------------------------------------------------------------------------
	;flag lschen
	clr	tiFLAG


_evINI:
	;trigger-device init
	ldi	r16,4
	sts	DEVICEcnt,r16	;
	ldi	r22,180		;default
	sts	PHASEbkup,r22
	;timebase compare 120*1ms
	ldi	zh,0
	sts	timeDWhigh,zh
	ldi	zl,120	;test
	sts	timeDWlow,zl

	;startwert f. prog-auswahltexte
	clr	r16
	sts	auswahlCNT,r16

		;..........................................
		;events neu
;		ldi	r23,11
;		sts	eventTE,r23			;power up event setzen
;		call	_MAKEeventSUB	;submodul !
		;..........................................
	;blend states
	clr	r20
	sts	DEVUDstate,r20
	sts	DEVONstate,r20
	;
	;
	;matrix dafault-werte 
	clr	r20
	sts	matrix_flag,r20		;
	ldi	r20,high(phase1)
	sts	takti_adrBH,r20	;lade mit aktivbyte startadresse 
	ldi	r20,low(phase1)
    sts	takti_adrBL,r20	;lade mit aktivbyte startadresse 	
	;startadresse pindriver	
	ldi	r20,high(akt1)
	sts	PINcntH,r20
	ldi	r20,low(akt1)
	sts	PINcntL,r20
	;slot 1 beginnen
	ldi	r26,1 
	sts	slotCNT,r26		;timeslot-counter initialisieren
	;


;---------------------------------------------------------------------------------------------	
;adc init
;;--------------------------------------------------------------------------------------------
;* ADC-Multiplexer (ADMUX) - Tabelle :
; _______________________________________________
;|     |     |     |     |     |     |     |     |
;|refs1|refs0|adlar|mux4 |mux3 |mux2 |mux1 |mux0 |
;|_____|_____|_____|_____|_____|_____|_____|_____|
;
;refs1= 0 + refs0= 0 	== AREF (int.Ref off)
;refs1= 1 + refs0= 1 	== int.REF 2,56V (ext.Cap an AREF-Pin)
;
;
;adlar= 0  			== adc result right adjust (... default)
;adlar= 1			==            left adjust
;
;
;mux4 wird nur in speziellen modes (differential, gain-adjust...) verwendet
;
;--------------------------------------------------------------------------------------------
;* ADC-Control-,und Status-RegisterA (adcsr) - Tabelle :
; _______________________________________________
;|     |     |     |     |     |     |     |     |
;|aden |adsc |adate|adif |adie |adps2|adps1|adps0|
;|_____|_____|_____|_____|_____|_____|_____|_____|
;
;aden= 0 			== adc disabled
;aden= 1		 	== "   enabled
;
;
;adsc= 0  			== no affect
;adsc= 1			== start coversation 
;
;
;adate=0			== auto trigger disabled (siehe SFIOR settings !!!)
;adate=1			== "       "    enabled
;
;
;adif=0/1			== adc interrupt flag (set/cleared by hardware..)-> write 1 to clear
;
;
;adie=0				== adc interrupt disabled
;adie=1				== "         "   enabled
;
;
;adps0..2			== trigger prescaler Fclk:2/4/8/16/32/64/128 
;
;--------------------------------------------------------------------------------------------
;* Special-Function-Register (SFIOR) - Tabelle :
; _______________________________________________
;|     |     |     |     |     |     |     |     |
;|adts2|adts1|adts0|adhsm|acme |pud  |psr2 |psr10|
;|_____|_____|_____|_____|_____|_____|_____|_____|
;
;adts2 	adts1  	adts0
;0		0		0	== free running mode
;0		0		1	== analog comparator
;0		1		0	== external interrupt request 0
;0		1		1	== timer0 compare match
;1		0		0	== timer0 overflow
;1		0		1	== timer compare match B
;1		1		0	== timer1 overflow
;1		1		1	== timer1 capture event
;
;--------------------------------------------------------------------------------------------
;folgende adc-kanle werden 
;adc3(pf3) == analogD 
;adc2(pf2) == analogC
;adc1(pf1) == analogB
;adc0(pf0) == analogA

	ldi	r16,0b10010111		;no free-running-converation...
	out	adcsr,r16	
	;
	ldi	r16,0b01000000      ;ext.Vref&cap, mux0
	out	admux,r16			;bei interner Vref == 0xc4 !!!
	;
	ldi	r16,0
	sts	cntLOOP,r16			;adc-mux start channel4
;---------------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
	
	;serielle kommunikation initialisieren
	;zuerst einen definierten zustand schaffen
	;
	;serIF aktivieren
	;if-software enabled
	clr	r19
	sbr	r19,1<<SEenabled
	cbr	r19,1<<SEbusy	;TEST cbr
	sts	SEflagVARa,r19
	;
	ldi	r16,WToutVAR
	sts	WToutRX,r16		;timeout preset !!!



	clr	r19
	sts	matrixCNT,r19
	sts	SEflagVARb,r19
	;default == wireless
	sbr	r19,1<<SERwireless	
	sts	SEflagVARc,r19

	;init fifo by entry module
	clr		r16
	sts		fifoIN,r16
	sts		fifoOUT,r16
	sts		fifoVAR,r16
	;
	clr	r16
	sts		WIREset,r16
	;
	;

	;
	;twi initialisieren
	;defaults: - bitrate 80
	;		   - prescale 0		
	;<=> 24,39Kbit/s max.   
	;
	ldi	r16,bitrate
	sts	twbr,r16
	lds	r16,twsr
	cbr	r16,1<<twps0
	cbr	r16,1<<twps1
	sts	twsr,r16
	;stop condition
	ldi	r21,(1<<twint)|(1<<twen)|(1<<twsto)
	sts	twcr,r21
	;
	;
	;repeatCNT definieren
	;19-12-03
	;-> TX wiederholungssequenz
	ldi	r20,4
	sts	repeatCNT,r20
	;
	;- kalender -
	;default datum
	ldi	r20,1
	sts	tageS,r20
	sts	monatS,r20
	ldi	r20,4
	sts	jahrS,r20
	clr	r20
	sbr	r20,1<<kalender
	sts	dateVAR,r20
	clr	r20
	sts	dateLOOP,r20
	ldi	r20,200
	sts	kalcount,r20
	;
	;datum noch nicht komplett
	clr	r22
	sts	rtcFLAG,r22

	;dcf77
    ;--------------------------------
    ;start decoding dcf 77 after por
    ;--------------------------------	
	clr	r20
	sts	dcf77_status,r20
	sts	time1msFL,r20
	sts	dcf77_psc,r20
	sts	dcf77_levCTlow,r20
	sts	dcf77_levCThigh,r20
	sts	dcf77_sekunde,r20
	;
	;display variablen-default
	ldi	r20,170
	sts	teDISbr,r20
	ldi	r20,19
	sts	teDISco,r20
	;startup text im hif
	;comFLAGspi's
	clr	r20
	sts	pzHIF,r20
	sts	prHIF,r20
	sts	prozPSC,r20
	sts	progPSC,r20
	sts	comFLAGspi,r20

	;key edge status default == high (pulled up)
	ldi	r20,0xff
	sts	keyEDGE,r20

	;-----------------------------------------
	
	;object state
	;status auf=0
	clr		r20
	sts		object_state,r20
	;event = 1
	ldi		r20,1
	sts		temp_event,r20
	;objekt-counter =0
	clr		r20
	sts		object_counter,r20

	;hot shot state = on
	clr		r20
	sbr	r20,1<<HSon
	sts	HOTstate,r20

    ;clear state
    clr r20
    sts ifSELstate,r20

    ;init spi counter
    ldi r16,waitSPIko 
    sts spiWT,r16

;-------------------------------------------
; startup delay
;-------------------------------------------
_STdel:
	ldi	r18,40
_STdLOOP:
	tst	r18
	breq	_STback
	dec	r18
	ldi	r16,0xff
	ldi	r17,0xff
	jmp	_STdelA

_STback:
	jmp	_evLOOPa
;
_STdelA:
	tst	r16
	breq	_STdelB
	dec		r16
	jmp	    _STdelA
_STdelB:
	tst	r17
	breq	_STdLOOP
	dec	r17
	ldi	r16,0xff
	jmp	_STdelA




_evLOOPa:
    ;initialisiere power-flag's 
	lds	r19,PWRflag
    cpi r19,0xff
    brne    _evLOOPY
    clr r19
	sts	PWRflag,r19		;sichere powerflag's
    rjmp    _evLOOPZ
_evLOOPY:
    ;execute last scene stored in e2prom
    ldi     r16,1
    sts     matrix_flag,r16
_evLOOPZ:
    ;.....................
    ;global interrupts on
	sei
	;watchdog enabled
	clr	r28
	sbr	r28,1<<wde
	out	wdtcr,r28


;-----------------------------------------------------------------------------------------
;------- main-schleife bis zum nchsten interrupt ----------------------------------------
;-----------------------------------------------------------------------------------------

_evLOOP:
	lds	zl,ALLtiming1L
	lds	zh,ALLtiming1H	
	adiw	zh:zl,1
	sts	ALLtiming1L,zl
	sts	ALLtiming1H,zh
	jmp	_evLOOP








;tables & definitions
.include "_+_memMAP.inc"			 	 ;memory-map 
.include "_+_memAtable.asm"
.include "_+_memBtable.asm"

;dynamic modules
.include "+DYNrtcTIME.asm"
.include "+DYNslot.asm"
.include "+DYNprocess.asm"
.include "+DYNsetupV2A.asm"
.include "+DYNsetupBX.asm"
.include "+DYNmacMATRIX.asm"
.include "+DYNrtcDATE.asm"	
.include "+DYNthres8COMP.asm"
.include "+DYNspi.asm"
.include "+DYNevent.asm"
.include "+DYNthres16COMP.asm"
.include "+DYNe2pdel.asm"
.include "+DYNexTIMER.asm"
;i/o drivers,converters & physical
;communication layers
.include "_DEVdriver.asm"
.include "_adcREADER.asm"
.include "_dimDRIVER.asm"
.include "_pwrRAIL.asm"	
.include "_physLAYER.asm"
.include "_dcfREADER.asm"
.include "_keySEQ.asm"
.include "_spiREADER.asm"
.include "_spiINIT.asm"

;higher communication layers
.include "__comLAYER.asm"
.include "__netFRAMER.asm"
.include "__objectFILTER.asm"
.include "__remoteFRAMER.asm"
.include "__hotSHOT.asm"
.include "__bootLAYER.asm"

.exit
