;-----------------------------------------------------------------------------------
;SYSTEM SRAM MEMORY-MAP
;-----------------------------------------------------------------------------------
;basis: standard avr-device (startadresse sram: 0x60)
;-----------------------------------------------------------------------------------
;ACHTUNG: DEVICES, WIE Z.B. MEGA128 NUTZEN FREIES SRAM AB 0x100
;         ... ALSO ENTSPRECHEND KORRIGIEREN !
;-----------------------------------------------------------------------------------
.equ	koMAP		=	SRAM_START - 0x60
;-----------------------------------------------------------------------------------

                            ;................................................................................
                            .equ    exSYSe2p    =   0xde2   ;extended system code (e2p)
                            ;................................................................................
;<system-timebase>
.equ	_55iS			=	0x60	+ koMAP		;55S auf Speicherplatz 60hex
.equ	_10miS			=	0x61	+ koMAP		;10mS      	"     "      61hex
;<rtc>
.equ	sekunS			=	0x62	+ koMAP		;*1S	   	"     "      62hex
.equ	minutS			=	0x63	+ koMAP		;*1min      	"     "      63hex
.equ	stundS			=	0x64	+ koMAP		;*1h		"     "      64hex
.equ	tageS			=	0x65	+ koMAP		;*1Tag	   	"     "      65hex
.equ	wocheS			=	0x66	+ koMAP		;*1Woche	   	"     "      66hex
.equ	monatS			=	0x67	+ koMAP 	;*1Monat	   	"     "      67hex
.equ	jahrS			=	0x68	+ koMAP		;*1Jahr	   	"     "      68hex
.equ	_100ms 			=   0x69	+ koMAP		;100ms     	"     "      69hex
;<timer>0
.equ	minut1			=	0x6a	+ koMAP		;*1min	   "     "      6ahex(sram) - 0x64 = 0x6 (e2prom)
.equ	stund1			=	0x6b	+ koMAP		;*1h        "     "      6bhex(sram) - 0x64 = 0x7 (e2prom)
.equ	tage1			=	0x6c	+ koMAP		;*1Tag	   "     "      6chex(sram) - 0x64 = 0x8 (e2prom)
;
							;........................................................................................................
							;e2prom startkonstante
							.equ 	timerE2adr		=	( minut1 - koMAP ) - 0x64	
							.equ 	timerE2adrX		=	 minut1 - timerE2adr
                            .equ    timerE2adrRANGE =   timerE2adr +    14
							;........................................................................................................
							;
;<f.pindriver>
.equ	PINcntL			=	0x6d	+ koMAP		;pindriver_loop_counter
;<timer>1
.equ	minut2			=	0x6e	+ koMAP		;*1min	   "     "      6ehex(sram) - 0x64 = 0xa (e2prom)
.equ	stund2			=	0x6f	+ koMAP		;*1h	       "     "      6fhex(sram) - 0x64 = 0xb (e2prom)
.equ	tage2			=	0x70	+ koMAP		;*1Tag	   "     "      70hex(sram) - 0x64 = 0xc (e2prom)
;<global timer>
.equ	GLOBtim 		=   0x71	+ koMAP	    ;global timer (de-)aktivierungsvariable
;<timer>2
.equ	minut3			=	0x72	+ koMAP		;*1min	   "     "      72hex(sram) - 0x64 = 0xe (e2prom)
.equ	stund3			=	0x73	+ koMAP		;*1h	       "     "      73hex(sram) - 0x64 = 0xf (e2prom)
.equ	tage3	    	=	0x74	+ koMAP		;*1Tag	   "     "      74hex(sram) - 0x64 = 0x10(e2prom)
;<spi-wait>
.equ	spiWT			=	0x75	+ koMAP		;spi wait-routine
;<timer>3
.equ	minut4			=	0x76	+ koMAP		;*1min	   "     "      76hex(sram) - 0x64 = 0x12(e2prom)
.equ	stund4			=	0x77	+ koMAP		;*1h		   "     "      77hex(sram) - 0x64 = 0x13(e2prom)
.equ	tage4			=	0x78	+ koMAP		;*1Tag	   "     "      78hex(sram) - 0x64 = 0x14(e2prom)
;<program>
.equ	pHIFte			=	0x79	+ koMAP		;temporrer hifwert...		
;<speed trigger>
.equ	_PHbase			=	0x7a	+ koMAP		;*phase istwert           
;<port-pindriver>
.equ	tePORTvar		=	0x7b	+ koMAP		;device backupwert
;<program>
.equ	ADRtempL		=	0x7c	+ koMAP		;adress backupwert LSB
.equ	AKTtemp			=	0x7d	+ koMAP		;aktiv	backupwert
;<hif-display set>
.equ	teDISbr			=	0x7e	+ koMAP		;*temporre display helligkeit
.equ	teDISco			=	0x7f	+ koMAP		;*                  contrast
;<program>
.equ	teMAXlowX		=	0x80	+ koMAP		;variablen backup
.equ	teMAXhighX		=	0x81	+ koMAP		;variablen backup
.equ	teMAXadrX		=	0x82	+ koMAP		;variablen backup
;<port-aktivator flag bytes>
.equ	akt1			=	0x83	+ koMAP		;Aktiv flag byte 0       83hex(sram) - 0x64 = 0x1f(e2prom)
.equ	akt2  	 		=	0x84	+ koMAP		;                1       84hex(sram) - 0x64 = 0x20(e2prom)
.equ	akt3	 		=	0x85	+ koMAP		;                2       85hex(sram) - 0x64 = 0x21(e2prom)
.equ	akt4     		=	0x86    + koMAP     ;			     3       86hex(sram) - 0x64 = 0x22(e2prom)
.equ	akt5     		=	0x87   	+ koMAP     ;		         4       87hex(sram) - 0x64 = 0x23(e2prom)
.equ	akt6	 		=	0x88	+ koMAP		;                5       88hex(sram) - 0x64 = 0x24(e2prom)
.equ	akt7	 		=	0x89	+ koMAP		;                6       89hex(sram) - 0x64 = 0x25(e2prom)
.equ	akt8	 		=	0x8a	+ koMAP     ;			     7       8ahex(sram) - 0x64 = 0x26(e2prom)
							;........................................................................................................
							;e2prom startkonstante
							.equ 	aktE2adr		=	( akt1 - koMAP ) - 0x64
                            .equ    aktE2adrII      =   koMAP + 0x64	
                            .equ    aktE2adrRANGE   =   aktE2adr + 7
							;........................................................................................................
							;
;<phasenschnitt (licht)sollwert>
;kat0 soll
.equ	phase1			=	0x8b	+ koMAP		;*phase sollwert  1       8bhex
.equ	phase2			=	0x8c	+ koMAP		;*phase sollwert  2       8chex
.equ	phase3			=	0x8d	+ koMAP		;*phase sollwert  3       8dhex
.equ	phase4			=	0x8e	+ koMAP		;*phase sollwert  4       8ehex
.equ	phase5			=	0x8f	+ koMAP		;*phase sollwert  5       8fhex
.equ	phase6			=	0x90	+ koMAP		;*phase sollwert  6       90hex
.equ	phase7 			=	0x91	+ koMAP		;*phase sollwert  7       91hex
.equ	phase8			=	0x92	+ koMAP		;*phase sollwert  8		  92hex
							;
							;


;<delays sollwert>
;kat1 soll
.equ	delay0			=	0x93	+ koMAP		;*category delay 	0 	(0x15 e2 prom)
.equ	delay1			=	0x94	+ koMAP		;*					1	(0x16..
.equ	delay2			=	0x95	+ koMAP		;*					2	(0x17...
.equ	delay3			=	0x96	+ koMAP		;*					3	(0x18..
.equ	delay4			=	0x97	+ koMAP		;*category delay 	4 	(0x19 e2 prom)
.equ	delay5			=	0x98	+ koMAP		;*					5	(0x1a..
.equ	delay6			=	0x99	+ koMAP		;*					6	(0x1b...
.equ	delay7			=	0x9a	+ koMAP		;*					7	(0x1c..
							;........................................................................................................
							;e2prom startkonstante
							.equ 	delE2adrA		=	( delay0 - koMAP ) - 0x7e	
                            .equ    delE2adrARANGE  =   delE2adrA + 7
							;........................................................................................................
							;-> v05 korrigieren !!!!

;<compare soll>
;kat3 soll
.equ	CpareA			=	0x9b	+ koMAP		;*compare soll variable 1 9bhex
.equ	CpareB			=	0x9c	+ koMAP		;* "                 "  2 9chex
.equ	CpareC			=	0x9d	+ koMAP		;* "                 "  3 9dhex
.equ	CpareD 			=	0x9e	+ koMAP		;* "                 "  4 9ehex
.equ	CpareE			=	0x9f	+ koMAP		;*compare soll variable 1 9fhex
.equ	CpareF			=	0xa0	+ koMAP		;* "                 "  2 a0hex
.equ	CpareG			=	0xa1	+ koMAP		;* "                 "  3 a1hex
.equ	CpareH 			=	0xa2	+ koMAP		;* "                 "  4 a2hex


;<compare max>
.equ	CmaxA			=	0xa3	+ koMAP		;compare maximal       1 a3hex
.equ	CmaxB			=	0xa4	+ koMAP		; "                 "  2 a4hex
.equ	CmaxC  			=   0xa5	+ koMAP		; "                 "  3 a5hex
.equ	CmaxD  			=   0xa6	+ koMAP		; "                 "  4 a6hex
.equ	CmaxE			=	0xa7	+ koMAP		;compare maximal       1 a3hex
.equ	CmaxF			=	0xa8	+ koMAP		; "                 "  2 a4hex
.equ	CmaxG  			=   0xa9	+ koMAP		; "                 "  3 a5hex
.equ	CmaxH  			=   0xaa	+ koMAP		; "                 "  4 a6hex

								;...................................................
								;e2prom startadresse cmax
								.equ	CmaxE2p		=	(CmaxA - koMAP) - 0x7b
								;...................................................
								;e2prom sub-factor
								.equ	CmaxE2sub	=	CmaxA - 0x28
								;-> v05 korigieren !!!!

;<compare ist>
.equ	CpareI1			=	0xab	+ koMAP		;*compare ist variable  1 
.equ	CpareI2			=   0xac	+ koMAP		;* "                 "  2 
.equ	CpareI3			=	0xad	+ koMAP		;* "                 "  3 
.equ	CpareI4			=	0xae    + koMAP		;* "                 "  4 
.equ	CpareI5			=	0xaf	+ koMAP		;*compare ist variable  5 
.equ	CpareI6			=   0xb0	+ koMAP		;* "                 "  6 
.equ	CpareI7			=	0xb1	+ koMAP		;* "                 "  7 
.equ	CpareI8			=	0xb2    + koMAP		;* "                 "  8 
								;...................................................
								;e2prom startadresse cist
								.equ	CistE2p		=	(CpareI1 - koMAP) - 0x7b
								;...................................................
								;-> v05 korrigieren !!!!



;<pindriver direkt>
;kat3 soll
.equ	Akdi0 			= 	0xb3	+ koMAP		;*direkt mode a variable0 	
.equ	Akdi1  			=   0xb4	+ koMAP		;* "                 "  1 
.equ	Akdi2  			=   0xb5	+ koMAP	    ;* "                 "  2 
.equ	Akdi3	 		=   0xb6    + koMAP		;* "                 "  3 
.equ	Akdi4  			=   0xb7    + koMAP		;* "                 "  4 
.equ	Akdi5  			=   0xb8    + koMAP		;* "                 "  5 
.equ	Akdi6  			=   0xb9    + koMAP		;* "                 "  6 
.equ	Akdi7  			=   0xba    + koMAP		;* "                 "  7 



;<delays/temp>
.equ	dy0temp			=	0xbb	+ koMAP		;*temp. delay var.   1 
.equ	dy1temp			=   0xbc	+ koMAP		;* "                 2 
.equ	dy2temp			=   0xbd	+ koMAP		;* "                 3 
.equ	dy3temp			=   0xbe	+ koMAP		;* "                 4 
.equ	dy4temp			=	0xbf	+ koMAP		;* "                 5 
.equ	dy5temp			=   0xc0	+ koMAP		;* "                 6 
.equ	dy6temp			=   0xc1	+ koMAP		;* "                 7 
.equ	dy7temp			=   0xc2	+ koMAP		;* "                 8 
		


;<compare init>
.equ	teMAXlow		=	0xc3	+ koMAP		;variablen backup
.equ	teMAXhigh		=	0xc4	+ koMAP		;variablen backup
.equ	teMAXadr		=	0xc5	+ koMAP		;variablen backup
.equ	CiniFLAG		=	0xc6	+ koMAP		;compare initialisierungsflags
;<sercom>
.equ	twiSTATUS		=	0xc7	+ koMAP		;"		twi-statusflag	
;<time slot>
.equ	SLOTcnt			=	0xc8	+ koMAP		;slot counter
;<sercom>
.equ	twiINS			=	0xc9	+ koMAP		;twi instruktionbyte   
;<matrix>
.equ	prog_platzA		=	0xca	+ koMAP		;*matrix steuervariable				
.equ	matrix_flag		=	0xcb	+ koMAP		;*matrix flagvariable
                ;....................................
                ;prog_platzA backup
                .equ    prog_platzAadr  =   0xde0
                ;....................................

                ;....................................
                ;scene macro e2p segment
                .equ    sceneE2P        =   0x68    ;startadress
                .equ    sceneE2PRANGE   =   sceneE2P + 0x13f
                ;....................................

;<rail>
.equ	PWRflag			=	0xcc	+ koMAP		;*power statusflags
                ;....................................
                ;PWRflag backup
                .equ    PWRflagadr  =   0xde1
                ;....................................
.equ	R1msBK			=	0xcd	+ koMAP		;temporre countervariable
;<program>
.equ	delLOW			=	0xce	+ koMAP		;temporre variable	
.equ	delHIGH			=	0xcf	+ koMAP		;temporre variable
;<rail>
.equ	stSOFT			=	0xd0	+ koMAP		;*countervariable	
.equ	stRAMP			=	0xd1	+ koMAP		;*countervariable
.equ	teCOUNT			=	0xd2	+ koMAP		;countervariable
;<serif/sercom>
.equ	SEflagVARa		=	0xd3	+ koMAP		;Flag Variable 
.equ	SEflagVARb		=	0xd4	+ koMAP		;   "     "      
.equ	CNTbyte			=	0xd5	+ koMAP		;counter variable sram
.equ	ifSELstate		=	0xd6	+ koMAP		;spi-ifSEL state
.equ	IFstate			=	0xd7	+ koMAP		;interface state matrix
.equ	matrixCNT		=	0xd8	+ koMAP		;matrix step counter
.equ	repeatCNT		=	0xd9	+ koMAP		;*tx-repeat counter
.equ	COPYtempSOURCEl	=	0xda	+ koMAP		;kopier-adressvariable low-byte
.equ	COPYtempSOURCEh	=	0xdb	+ koMAP		;kopier-adressvariable high-byte
.equ	bufCNT			=	0xdc	+ koMAP		;adress-counter (buffer)
.equ	sourceADRA		=	0xdd	+ koMAP		;temp.adress variable
;<SAVE AREA / sercom>-----------------------------------------------------------
.equ	savAREA			=	0xde	+ koMAP		;start-adresse der save area
.equ	savAREArange	=	10					;range...
;-------------------------------------------------------------------------------
;<rtc>
.equ	ms1CNT			=	0xea	+ koMAP		;global timervariable	no	rtc
;<serif>
.equ	SframeCT	    =	0xeb	+ koMAP		;timeloop f. serial framer
.equ	WToutRX		    =	0xec	+ koMAP		;*rx-timeout (no byte)
;<trigger>
.equ	DEVICEcnt		=	0xed	+ koMAP		;countervariable trigger
;<adc>
.equ	ADCpC			=	0xee	+ koMAP		;*ADC para C
;<dma framer>
.equ	PROFcntA		=	0xef	+ koMAP		;countervariable    framer
.equ	SEGstBKh		=	0xf0	+ koMAP		;adressvariable	    framer
.equ	SEGstBKl		=	0xf1	+ koMAP		;adressvariable	    framer
.equ	FRAMEsize		=	0xf2	+ koMAP		;steuerungsvariable	framer
;<program event timer>
.equ	TI1evsoll		=	0xf3 	+ koMAP		; eventtimer1 soll
.equ	TI2evsoll		=	0xf5 	+ koMAP		; eventtimer2 soll
.equ	TI1evist		=	0xf4	+ koMAP		;* "         1  ist
.equ	TI2evist		=	0xf6	+ koMAP		;* "         2  ist	
							;........................................................................................................
							;e2prom startkonstante
							.equ 	delE2adrC		=	( TI1evsoll - koMAP ) - 0xd6
                            .equ    delE2adrCRANGE  =   delE2adrC + 1	
							;........................................................................................................
							;->v05 korrigieren !!!

;<event>
.equ	eventTE			=	0xf7	+ koMAP		;event
.equ	eventADRL		=	0xf8	+ koMAP		;"sram-adresse L
.equ	eventADRH		=	0xf9	+ koMAP		;"             H
.equ	eventBT			=	0xfa	+ koMAP		;event-byte
;<pindriver>>
.equ	OUTpwmFL		=	0xfb	+ koMAP		;category-pwm output-flags

;<analog comparator>
.equ	cntLOOP			=	0xfc	+ koMAP		;8-bit Zhler 		 fchex
.equ	ADCpB			=	0xfd	+ koMAP		;*ADC para B
.equ	ADCpA			=	0xfe	+ koMAP		;*ADC para A
;<program>
.equ	E2delH			=	0xff	+ koMAP		;countervariable
.equ	ProfilbyteLadr	=	0x100	+ koMAP		;temp adressvariable	programm
.equ	ProfilbyteHadr	=	0x101	+ koMAP		;temp adressvariable	programm
;<program profiler>
.equ	Profilbyte		=	0x102	+ koMAP		;steuerungsvariable	programm
;<pindriver>
.equ	OUTdelFL		=	0x103	+ koMAP		;category-delay output-flags	
;<program profiler>
.equ	ProfilbyteCNT	=	0x104	+ koMAP		;countervariable programm	
;<pindriver>
.equ	PINcntH			=	0x105	+ koMAP		;pindriver_loop_counter
;<program>
.equ	ADRtempH		=	0x106	+ koMAP		;adress backupwert MSB
;<pindriver>
.equ	OUTcompaFL		=	0x107	+ koMAP		;category-compare u/d-flags
.equ	OUTcompbFL		=	0x108	+ koMAP		;category-compare on/off-flags	
;<program>
.equ	E2delL			=	0x109	+ koMAP		;countervariable
;<process>
.equ	savSTadr		=	0x10a	+ koMAP		;f.prozessroutine - timer (de-)aktivierungsdisplay
.equ	wstTIproz		=	0x10b	+ koMAP		; "              "               "  time-loop
.equ	savTIadr		=	0x10c	+ koMAP		; "              "               "
;<adc>
.equ	ADCloop			=	0x10d	+ koMAP		;countervariable adc
;<pindriver>
.equ	OUTaktFL		=	0x10e	+ koMAP		;category-aktuator-flags

;---------------------------------------------------------------------------------------
;GROUP ACCESS A
;<temp. lha ID>
.equ	temp_id_tbl			=	0x10f		+ koMAP		;temp. id segment 7bytes
							;...........................................................
							;.equ	group_id_tbl	=	(temp_id_tbl - koMAP)	+ 0x7e9	;e2prom table
;----------------------------------------------------------------------------------------
;<pindriver>
.equ	PdeviceCNT		=	0x116	+ koMAP		;pindriver devicecounter
;<dma framer>
.equ	FRAMEflag		=	0x117	+ koMAP		;flagvariable framer	
;<rtc>
.equ	ms10bkUP		=	0x118	+ koMAP		;backup variable rtc	
;<timerprogrammierung>
.equ	varAy			=	0x119	+ koMAP		; tagX adresse MSB
.equ	varBy  			=   0x11a   + koMAP		; stundX adresse MSB
.equ	varCy  			=   0x11b   + koMAP		; tagX adresse MSB
;<program>
.equ	COtempFLAG		=	0x11c	+ koMAP		;
;<pindriver>
.equ	PcatCNT			=	0x11d	+ koMAP		;pindriver category-counter
;<process>
.equ	PZphFLAG		=	0x11e	+ koMAP		;pwm steuerungs flags (u/d...) 
;<device-driver>
.equ	OUTdelFLold		=	0x11f	+ koMAP		;alter delay-out-status       
.equ	OUTaktFLold		=	0x120	+ koMAP		;alter direct-out-status 
.equ	OUTcompaFLold	=	0x121	+ koMAP		;alter compA-out-status  
.equ	OUTcompbFLold	=	0x122	+ koMAP		;alter compB-out-status
;<prozess>
.equ	prozPSC			=	0x123	+ koMAP		;process status counter	 9ehex(sram) 
;<program>
.equ	PINte			=	0x124	+ koMAP		;steuerungsvariable backip
.equ	teVAR1			=	0x125	+ koMAP		;temporre variable
.equ	teVAR2			=	0x126	+ koMAP		;temporre variable
;<trigger>
.equ	PHASEbkup		=	0x127	+ koMAP
;<sercom>
.equ	sourceADRB		=	0x128	+ koMAP		;temp. variable
;<dma framer>
.equ	FRAMtempZL		=	0x129	+ koMAP		;temporre pointervariable framer
.equ	FRAMtempZH		=	0x12a	+ koMAP		;temporre pointervariable framer
;<serif/sercom>
.equ	SEflagVARc		=	0x12b	+ koMAP		;flagvariable
.equ	I2Ctimeout		=	0x12c	+ koMAP		;i2c timeout
.equ	teMIstore		=	0x12d	+ koMAP		;temporre mi-backup
;<program>
.equ	varAx			=	0x12e	+ koMAP		; tagX adresse LSB
.equ	varBx  			=   0x12f   + koMAP		; stundX adresse LSB
.equ	varCx  			=   0x130   + koMAP		; tagX adresse LSB
.equ	varDx			=	0x131	+ koMAP		;temporre adressvariable
;<sercom>
.equ	reqTWIsiz		=	0x132	+ koMAP		;request twi-size
.equ	twiADR			=	0x133	+ koMAP		;variable	slaveadresse	
.equ	twiCON			=	0x134	+ koMAP		;"		control/adressbyte
.equ	twiSIZ			=	0x135	+ koMAP		;"		twi-datasize	
;<trigger>
.equ	devAKT0			=	0x136	+ koMAP		;device bez. aktiv variablen
.equ	devAKT1			=	0x137	+ koMAP		;device bez. aktiv variablen
.equ	devAKT2			=	0x138	+ koMAP		;device bez. aktiv variablen
.equ	devAKT3			=	0x139	+ koMAP		;device bez. aktiv variablen
;<compare>
.equ	C1bck			=	0x13a	+ koMAP		;sollwert backup    "  1 13ahex (sollwertadresse + 96hex (150dec.))
.equ	C2bck			=	0x13b	+ koMAP		; "                 "  2 13bhex "           "           "         "
.equ	C3bck			=	0x13c	+ koMAP		; "                 "  3 13chex "           "           "         "
.equ	C4bck			=	0x13d	+ koMAP		; "                 "  4 14chex "           "           "         "  
.equ	C5bck			=	0x13e	+ koMAP		;sollwert backup    "  1 13ahex (sollwertadresse + 96hex (150dec.))
.equ	C6bck			=	0x13f	+ koMAP		; "                 "  2 13bhex "           "           "         "
.equ	C7bck			=	0x140	+ koMAP		; "                 "  3 13chex "           "           "         "
.equ	C8bck			=	0x141	+ koMAP		; "                 "  4 14chex "           "           "         "  


;<process>
.equ	dy1bck			=	0x14a	+ koMAP		;sollwert backup       1 14ahex (sollwertadresse + 96hex(150 dec.))
.equ	dy2bck			=	0x14b	+ koMAP		; "                 "  2 14bhex "             "            "
.equ	dy3bck			=	0x14c	+ koMAP		; "                 "  3 14chex	"             "            "
.equ	dy4bck			=	0x14d	+ koMAP		; "                 "  4 14dhex "             "            "
.equ	dy5bck			=	0x14e	+ koMAP		; "                 "  5 14ehex (sollwertadresse + 96hex(150 dec.))
.equ	dy6bck			=	0x14f	+ koMAP		; "                 "  6 14fhex "             "            "
.equ	dy7bck			=	0x150	+ koMAP		; "                 "  7 150hex	"             "            "
.equ	dy8bck			=	0x151	+ koMAP		; "                 "  8 151hex "             "            "
;<process bk akt&phase>
.equ	Ak1bck			=	0x152	+ koMAP		;sollwert backup       1 152hex (sollwertadresse + 96hex (150dec.))
.equ	Ak2bck			=	0x153	+ koMAP		; "                 "  2 153hex "              "              "
.equ	Ak3bck			=	0x154	+ koMAP		; "                 "  3 154hex "              "              "
.equ	Ak4bck			=	0x155	+ koMAP		; "                 "  4 155hex "              "              "
.equ	Ak5bck			=	0x156	+ koMAP		;sollwert backup       1 156hex (sollwertadresse + 96hex (150dec.))
.equ	Ak6bck			=	0x157	+ koMAP		; "                 "  2 157hex "              "              "
.equ	Ak7bck			=	0x158	+ koMAP		; "                 "  3 158hex "              "              "
.equ	Ak8bck			=	0x159	+ koMAP		; "                 "  4 159hex "              "              "
;<delays>
.equ	Pdelay1			=	0x15a	+ koMAP		;softstart-delay		
.equ	Pdelay2			=	0x15b	+ koMAP		;soft-off-delay			
.equ	Pdelay3			=	0x15c	+ koMAP		;current-switch-delay	
.equ	Pdelay4			=	0x15d   + koMAP		;pwr-off-delay			
							;........................................................................................................
							;e2prom startkonstante
							.equ 	delE2adrB		=	( Pdelay1 - koMAP ) - 0x158	
                            .equ    delE2adrBRANGE  =   delE2adrB   + 3
							;........................................................................................................
							;-> v05 korrigieren
;<process>
.equ	tePARApointL	=	0x15e	+ koMAP		;temp. parameter pointer
;<matrix>
.equ	SollMaP2		=	0x15f	+ koMAP		;steuervariable	Matrix	Sollwertadresee f.parameter 2
;<process>
.equ	tim0PRO			=	0x160	+ koMAP		;timer	0 	programmvariable
.equ	tim1PRO			=	0x161	+ koMAP		;	"	1	"            	"
.equ	tim2PRO			=	0x162	+ koMAP		;	"	2	"		"
.equ	tim3PRO			=	0x163	+ koMAP		;	"	3	"		"
;<matrix>
.equ	SollMbP2		=	0x164	+ koMAP		;steuervariable	Matrix	Sollwertadresse f.parameter 2
;<program>
.equ	prog_platzB		=	0x165	+ koMAP		;temp. makro nummer
.equ	auswahlCNT		=	0x166	+ koMAP		;hilfsvariable program-routine
;<cat-triggerII>
.equ	devAKT4			=	0x167	+ koMAP		;device bez. aktiv variablen
.equ	devAKT5			=	0x168	+ koMAP		;device bez. aktiv variablen
.equ	devAKT6			=	0x169	+ koMAP		;device bez. aktiv variablen
.equ	devAKT7			=	0x16a	+ koMAP		;device bez. aktiv variablen
;<process>
.equ	tePARApointH	=	0x16b	+ koMAP		;temp. parameter pointer
;<matrix>
.equ	sollwertMb		=	0x16c	+ koMAP		;datenvariable
.equ	takti_adrBL		=	0x16d	+ koMAP		;temp.aktivbyte-adresse 	
.equ	takti_cntB		=	0x16e	+ koMAP		;	" "        -zhler
.equ	sollwertMa		=	0x16f	+ koMAP		;sollwert      -adresse
;<sercom>
.equ	tempTWIsiz		=	0x170	+ koMAP		;temporre steuervariable	
.equ	tempTWIbufL		=	0x171	+ koMAP		;L	temporre adressvariable
.equ	tempTWIbufH		=	0x172	+ koMAP		;H	temporre adressvariable	
.equ	tempRXbufL		=	0x173	+ koMAP		;	temporre variable	
.equ	tempRXbufH		=	0x174	+ koMAP		;	temporre variable	
.equ	tempSERl		=	0x175	+ koMAP		;zieladresse
.equ	tempSERh		=	0x176	+ koMAP		; "     "
;<pindriver intervall> entfllt !!!!
.equ	delay10			=	0x177	+ koMAP		;intervalltimer...	1 puls	
.equ	delay11			=	0x178	+ koMAP		;					2 puls
.equ	delay12			=	0x179	+ koMAP		;					3 puls
.equ	delay13			=	0x17a	+ koMAP		;					4 puls
.equ	delay14			=	0x17b	+ koMAP		;					1 pause
.equ	delay15			=	0x17c	+ koMAP		;					2 pause
.equ	delay16			=	0x17d	+ koMAP		;					3 pause
.equ	delay17			=	0x17e	+ koMAP		;.................	4 pause	
							;........................................................................................................
;							;e2prom startkonstante
							.equ 	Mdelay10		=	( delay10 - koMAP ) - 0x137	
							.equ 	Mdelay14		=	( delay14 - koMAP ) - 0x137	
							;........................................................................................................
							;
.equ	TIbase1			=	0x17f	+ koMAP		;timingvariable...Intervalltimer
.equ	TIbase2			=	0x180	+ koMAP		; "
.equ	TIbase3			=	0x181	+ koMAP		; "
.equ	TIbase4			=	0x182	+ koMAP		; "
.equ	delay10BK		=	0x183	+ koMAP		;intervalltimer 1 puls
.equ	delay11BK		=	0x184	+ koMAP		;				1 pause
.equ	delay12BK		=	0x185	+ koMAP		;				2 puls
.equ	delay13BK		=	0x186	+ koMAP		;				2 pause
.equ	delay14BK		=	0x187	+ koMAP		;				3 puls
.equ	delay15BK		=	0x188	+ koMAP		;				3 pause
.equ	delay16BK		=	0x189	+ koMAP		;				4 puls
.equ	delay17BK		=	0x18a	+ koMAP		;...............4 pause	
;<sercom>
.equ	TEmiVAR			=	0x18b	+ koMAP		;mi backup
;<trigger>
.equ	portCte			=	0x18c	+ koMAP     ;temp.portstatus
.equ	portDte			=	0x18d	+ koMAP		; "
;<rtc/date>
.equ	JAtagL			=	0x18e	+ koMAP		;tagescounter
.equ	JAtagH			=	0x18f	+ koMAP		;"
.equ	dateVAR			=	0x190	+ koMAP
.equ	dateLOOP		=	0x191	+ koMAP		;ablaufvariable
.equ	yearKORR		=	0x192	+ koMAP
.equ	kalcount		=	0x193	+ koMAP		;countdown
.equ	storeKAl		=	0x194	+ koMAP	
.equ	storeKAh		=	0x195	+ koMAP
;<DEVdriver>
.equ	DEVUDstate		=	0x196	+ koMAP		;compare device u/d status
.equ	DEVONstate		=	0x197 	+ koMAP		;compare device on/off status
;<fifo>
.equ	fifoIN			=	0x198	+ koMAP	
.equ	fifoOUT			=	0x199	+ koMAP
.equ	fifoVAR			=	0x19a	+ koMAP
;<serif>
.equ	WIREset			=	0x19b	+ koMAP		;wireless set counter
;<timeslot>
.equ	ti5secCNT		=	0x19c	+ koMAP		;5 sekunden counter
.equ	KORR55_3mis		=	0x19d	+ koMAP		;55,3s korrekturcounter
;<sercom>
.equ	COPYtempTARGETl	=	0x19e	+ koMAP		;kopier-adressvariable low-byte
.equ	COPYtempTARGETh	=	0x19f	+ koMAP		;kopier-adressvariable high-byte


;<SWITCHPORT VARIABLEN>-----------------------------------------------------------------
.equ	softPo0			=	0x200	+ koMAP		;datenvariable
;--------------------bis 0x209--------------------------------------------------------
;<SWITCHPORT HYSTERESE>-----------------------------------------------------------------
.equ	softPo0hys		=	0x20a	+ koMAP		;datenvariable		
;--------------------bis0x213---------------------------------------------------------
;<SWITCHPORT STEUERUNG>-----------------------------------------------------------------
.equ	softPo0do		=	0x214	+ koMAP		;datenvariable
;--------------------bis0x21d---------------------------------------------------------
							;............................................................
							;e2prom startadresse switch port
							;---------------------------------------------------------------------------------------
							.equ	softPo0ep		=	(softPo0 - koMAP) - 0x1b6	;start e2prom segment
                            .equ    softPo0epRANGE  =   softPo0ep   +   0x1d
							;---------------------------------------------------------------------------------------
							;-> v05 korrigieren !!!
							;............................................................
.equ	softPOcnt		=	0x21e	+ koMAP		;ablaufcounter
.equ	softPoadrL		=	0x21f	+ koMAP		;sram variablenadresse L
.equ	softPoadrH		=	0x220	+ koMAP		;sram variablenadresse H
.equ	softPoadrLe		=	0x221	+ koMAP		;e2prom " L
.equ	softPoadrHe		=	0x222	+ koMAP		;e2prom " H
.equ	softPovar		=	0x223	+ koMAP		;parameter
;<dcf>
.equ	time1msFL		=	0x224	+ koMAP		;timer-flags 
.equ	dcf77_psc		=	0x225	+ koMAP		;status-counter
.equ	dcf77_status	=	0x226	+ koMAP		;statusflags
.equ	dcf77_levCTlow	=	0x227	+ koMAP		;dcf77 level counter (16bit)100ms=low/200ms=high
.equ	dcf77_levCThigh	=	0x228	+ koMAP		;dcf77 level counter (16bit)100ms=low/200ms=high
.equ	dcf77_sekunde	=	0x229	+ koMAP		;dcf77 sekunde 0-59(60)
.equ	dcf77_minute	=	0x22a	+ koMAP		;dcf77 minute 0-59
.equ	dcf77_stunde	=	0x22b	+ koMAP		;dcf77 stunde 0-23
.equ	dcf77_tag		=	0x22c	+ koMAP		;dcf77 kalendertag 1-31
.equ	dcf77_Wtag		=	0x22d	+ koMAP		;dcf77 wochentag 1-7
.equ	dcf77_monat		=	0x22e	+ koMAP		;dcf77 monat
.equ	dcf77_jahr		=	0x22f	+ koMAP		;dcf77 jahr
;<sercom>
.equ	targetADRA		=	0x230	+ koMAP		;temp.adress variable
.equ	targetADRB		=	0x231	+ koMAP		; "           "      "
;<group access>
.equ	GhostQUANT		=	0x232	+ koMAP		;group access - def. hosts in tabelle
.equ	GhostFOUND		=	0x233	+ koMAP		;adresse gefundener host
.equ	GhostSEARCH		=	0x234	+ koMAP		;adresse gesuchter host
.equ	GhostQUAL		=	0x235	+ koMAP		;qualitt gefundener host (aus repeat cnt /serif )
.equ	GhostCNTl		=	0x236	+ koMAP		;timeout counter LOW
.equ	GhostCNTh		=	0x237	+ koMAP		;timeout counter HIGH
.equ	HfoundL			=	0x238	+ koMAP		;wait cnt L
.equ	HfoundH			=	0x239	+ koMAP		;wait cnt H
;<sercom>
.equ	TWIhead			=	0x23a	+ koMAP		;variable (z.twisize)   
;<spi>
.equ	spiDATctSOLL	=	0x23b	+ koMAP	
.equ	spiDATctIST		=	0x23c	+ koMAP
.equ	spiBUFadrH		=	0x23d	+ koMAP		;-> buffer high
.equ	spiBUFadrL		=	0x23e	+ koMAP		;-> buffer low
.equ	comFLAGspi		=	0x23f	+ koMAP		;flagvariable
.equ	DATApointL		=	0x240	+ koMAP
.equ	DATApointH		=	0x241	+ koMAP
.equ	CURindex		=	0x242	+ koMAP		;cursor CURindex
.equ	paraFUNC		=	0x243	+ koMAP		;parameter function
.equ	paraPOS			=	0x244	+ koMAP		;parameter position
.equ	paraX			=	0x245	+ koMAP		;parameter wert
.equ	paraMIN			=	0x246	+ koMAP		;parameter minimalwert
.equ	paraMAX			=	0x247	+ koMAP		;parameter maximalwert
;<hif>
.equ	paraA			=	0x248	+ koMAP
.equ	paraB			=	0x249	+ koMAP
.equ	paraC			=	0x24a	+ koMAP
.equ	paraD			=	0x24b	+ koMAP
.equ	paraE			=	0x24c	+ koMAP
.equ	paraF			=	0x24d	+ koMAP
.equ	paraG			=	0x24e	+ koMAP
.equ	paraH			=	0x24f	+ koMAP
.equ	paraI			=	0x250	+ koMAP
.equ	paraJ			=	0x251	+ koMAP
;<program>
.equ	progPSC		 	=	0x252	+ koMAP		;programm status counter	 0x249hex(sram) --------------------
.equ	devFLAG			=	0x253	+ koMAP		;aktiv device flags
.equ	katVAR			=	0x254	+ koMAP		;kategorie variable
.equ	paraPOINTl		=	0x255	+ koMAP		;parameter pointer L
.equ	paraPOINTh		=	0x256	+ koMAP		;parameter pointer H
.equ	pzHIF			=	0x257	+ koMAP		;prozess hif pointer
.equ	prHIF			=	0x258	+ koMAP		;programm hif pointer
;<process>
.equ	glob0ENA		=	0x259	+ koMAP		;enable flags f.  kategorie0
.equ	glob1ENA		=	0x25a	+ koMAP		;enable flags f.  kategorie1
.equ	glob2ENA		=	0x25b	+ koMAP		;enable flags f.  kategorie2
.equ	glob3ENA		=	0x25c	+ koMAP		;enable flags f.  kategorie3
.equ	glob4ENA		=	0x25d	+ koMAP		;enable flags f.  kategorie4
.equ	glob5ENA		=	0x25e	+ koMAP		;enable flags f.  kategorie5
;<RXBUFFER SERIF/SERCOM/FIFO>------------------------------------------------------------
.equ	TXbufferST	    =	0x25f 	+ koMAP		;serial buffer real start adresse 
;------------------------END 0x35e  + koMAP	---------------------------------------------
;<serif-man>
.equ	RECBte			=	0x35f	+ koMAP		;decodiertes byte backup 
;----------------------------------------------------------------------------------------
.equ	timeUP0low		=	0x360  	+ koMAP		;timervariable
.equ	timeUP0high		=	0x361	+ koMAP		;	"
.equ	timeUP1low		=	0x362	+ koMAP		;	"
.equ	timeUP1high		=	0x363	+ koMAP		;	"
.equ	timeUP2low		=	0x364	+ koMAP		;	"
.equ	timeUP2high		=	0x365	+ koMAP		;	"
.equ	timeUP3low		=	0x366	+ koMAP		;	"
.equ	timeUP3high		=	0x367	+ koMAP		;	"
.equ	timeUP4low		=	0x368	+ koMAP		;	"
.equ	timeUP4high		=	0x369	+ koMAP		;	"
						;
						;................................................................
						;e2prom startadresse
						.equ	comTIMe2adr		=	(timeUP0low - koMAP) - 0x328
						;................................................................
						;-> v05 korrigieren !!!
						;
.equ	TEtimeDWlow		=	0x36a	+ koMAP		;	"
.equ	TEtimeDWhigh	=	0x36b	+ koMAP		;	"
.equ	teTIMEupL		=	0x36c	+ koMAP		;	"
.equ	teTIMEupH		=	0x36d	+ koMAP		;	"
.equ	runDIFF			=	0x36e	+ koMAP		;init variable
.equ	TEmax			=	0x36f	+ koMAP		;	"
.equ	TEcounter0L		=	0x370	+ koMAP		;countervariable
.equ	TEcounter0H		=	0x371	+ koMAP		;	"
.equ	TEcounter1L		=	0x372	+ koMAP		;	"
.equ	TEcounter1H		=	0x373	+ koMAP		;	"
.equ	TEcounter2L		=	0x374	+ koMAP		;	"
.equ	TEcounter2H		=	0x375	+ koMAP		;	"
.equ	TEcounter3L		=	0x376	+ koMAP		;	"
.equ	TEcounter3H		=	0x377	+ koMAP		;	"
.equ	CtimeFLAGS		=	0x378	+ koMAP		;flag variable
;<matrix>
.equ	takti_adrBH		=	0x379	+ koMAP		;adressbuffer

;<TX BUFFER>-----------------------------------------------------------------------------
.equ	RXbufferST		=	0x37a	+ koMAP		;twi-buffer real start adresse	
;-----------------------------END0x479-------------------------------------------------

;<DEV DRIVER>
.equ	SblendL			=	0x47a	+ koMAP		;store loop sram adresse low
.equ	SblendH			=	0x47b	+ koMAP		;store loop sram adresse high
;<SERIF>
.equ	WTackCTl		=	0x47c	+ koMAP		;wait for serial ack L
;<ADC>
.equ	ADCpD			=	0x47d	+ koMAP		;adc D
;<DEVICE DRIVER>
.equ	OUTpwmL			=	0x47e	+ koMAP		;L alter kummulierter pwm-wert (summe 8 devices)
.equ	OUTpwmH			=	0x47f	+ koMAP		;H             "
;<FIFO BUFFER>----------------------------------------------------------------------------
.equ	fifoSEG			=	0x480	+ koMAP		;fifo start segment
;-----------------------END 0x57f   + koMAP ----------------------------------------------
;<DEV DRIVER>
.equ	E2rangeBLEND	=	0x580	+ koMAP		;counter
;<SPI BUFFER>-----------------------------------------------------------------------------
.equ	SPIstring		=	0x581	+ koMAP		;-> master spi buffer 
;ACHTUNG: bei remotezugriff <comFLAGspiREM> auswerten !
;.equ	comFLAGspiREM	=	0x5dc	+ koMAP	;spi flags f. remote
;-----------------------END 0x5dc   + koMAP	----------------------------------------------
;<program>
.equ	progSTATE		=	0x5dd	+ koMAP		;programm status flags
;<DEV DRIVER>
.equ	SstateBLEND		=	0x5de	+ koMAP		;Status
;<rtc>
.equ	wdayASCIIa		=	0x5df	+ koMAP		;decoder variable
.equ	wdayASCIIb		=	0x5e0	+ koMAP		;	"
.equ	dayNUM			=	0x5e1	+ koMAP		;	"
.equ	monthASCIIa		=	0x5e2	+ koMAP		;	"
.equ	monthASCIIb		=	0x5e3	+ koMAP		;	"
.equ	monthASCIIc		=	0x5e4	+ koMAP		;	"
.equ	yearNUM			=	0x5e5	+ koMAP		;	"
.equ	hourNUM			=	0x5e6	+ koMAP		;	"
.equ	minNUM			=	0x5e7	+ koMAP		;	"
.equ	dcfASCII		=	0x5e8	+ koMAP		;	"
.equ	rtcFLAG			=	0x5e9	+ koMAP		;	"
;<SWITCH PORT>
.equ	SWstateTEa		=	0x5ea	+ koMAP		;switch port ststus a
;<hif>
.equ	paraK			=	0x5eb	+ koMAP		;parameter
.equ	paraL			=	0x5ec	+ koMAP		;	"
.equ	paraM			=	0x5ed	+ koMAP		;	"
.equ	paraN			=	0x5ee	+ koMAP		;	"
.equ	paraO			=	0x5ef	+ koMAP		;	"
;<process>
.equ	PUpzHIF			=	0x5f0	+ koMAP		;backup prozess hif
.equ	PUprHIF			=	0x5f1	+ koMAP		;backup program hif
.equ	HIFtiLOOP		=	0x5f2	+ koMAP		;timeloop
;<SWITCH PORT>
.equ	SWstateTEb		=	0x5f3	+ koMAP		;switch port ststus b
;<program>
.equ	Profile2pLadr	=	0x5f4	+ koMAP		;temp. adresse
.equ	Profile2pHadr	=	0x5f5	+ koMAP		;temp. adresse
;<DMA-PROFILES>--------------------------------------------------------------------------------
.equ	profiSTram		=	0x5f6	+ koMAP		; "                "        (sram)
							;..................................................................
							;e2prom startadresse f. profilemirror
							.equ	profiSTe2p		=	(profiSTram - koMAP) - 0x44e
                            .equ    profiSTe2pRANGE =   profiSTe2p  +  0x1b7				
							;..................................................................
							;-> v05 modifizieren !!!!
							;
.equ	profiSEGsize	=	44					;segmentgre 44bytes
.equ	profiSTcnt		=	10					;10 profiles
.equ	profiSTlim		=	profiSTram + (profiSEGsize * profiSTcnt)	;profile limit
;-----------------------END 0x7ae	+ koMAP	-----------------------------------------------
;<SERif>
.equ	TEframeSIZ			=	0x7af	+ koMAP		;temporre frameSIZE
;<object>
.equ	objectCNT		=	0x7b0	+ koMAP		;objekt counter
.equ	SYSeolL			=	0x7b1	+ koMAP		;system eol timer L
.equ	SYSeolH			=	0x7b2	+ koMAP		;   "     "     " H
.equ	object_state	=	0x7b3	;ablaufvariable
.equ	object_counter			=	0x7b4	+ koMAP		;anzahl, zum event verknpfter objekte
.equ	temp_Ctable_adrL		=	0x7b5	+ koMAP		;temporre Class-Tabellenadresse lsb
.equ	temp_Ctable_adrH		=	0x7b6	+ koMAP		; "               		   "     msb
.equ	temp_event_adrL			=	0x7b7	+ koMAP		; "        eventvariablenadresse lsb
.equ	temp_event_adrH			=	0x7b8	+ koMAP		; "        eventvariablenadresse msb
.equ	temp_event				=	0x7b9   + koMAP		; "        eventX (0...255)
.equ	temp_event_var			=	0x7ba	+ koMAP		; "        event flagvariable (daten)
.equ	temp_bitmask			=	0x7bb   + koMAP		; "		   event bitmask
.equ	objectFLAG		=	0x7bc	+ koMAP		;object flags
.equ	recDCLASS		=	0x7bd	+ koMAP
.equ	recLABSOU		=	0x7be	+ koMAP
;<delay/BK>
.equ	te0sBKup		=	0x7bf	+ koMAP		;delay time base 1
.equ	te1sBKup		=	0x7c0	+ koMAP		;delay time base 2
.equ	te2sBKup		=	0x7c1	+ koMAP		;delay time base 3
.equ	te3sBKup		=	0x7c2	+ koMAP		;delay time base 4
.equ	te4sBKup		=	0x7c3	+ koMAP		;delay time base 5
.equ	te5sBKup		=	0x7c4	+ koMAP		;delay time base 6
.equ	te6sBKup		=	0x7c5	+ koMAP		;delay time base 7
.equ	te7sBKup		=	0x7c6	+ koMAP		;delay time base 8
;<SERIF>
.equ	WTackCTh		=	0x7c7	+ koMAP		;wait for serial ack H
;<compare>
.equ	timeUP5low		=	0x7c8  	+ koMAP		;timervariable
.equ	timeUP5high		=	0x7c9	+ koMAP		;	"
.equ	timeUP6low		=	0x7ca	+ koMAP		;	"
.equ	timeUP6high		=	0x7cb	+ koMAP		;	"
.equ	timeUP7low		=	0x7cc	+ koMAP		;	"
.equ	timeUP7high		=	0x7cd	+ koMAP		;	"
.equ	timeDWlow		=	0x7ce	+ koMAP		;	"
.equ	timeDWhigh		=	0x7cf	+ koMAP		;	"

						;
						;................................................................
						;e2prom startadresse
						.equ	comTIMe2adrB		=	(timeUP5low - koMAP) - 0x786
						;................................................................
						;-> v05 korrigieren !!!

;--------------------------------------------------------------------------------------------
;<TEMP OBJECT SEGMENT>-----------------------------------------------------------------------
.equ	dyn_object_TE			=	0x7d0   + koMAP		;- startadresse temp. object segment
;														;- ein empfangenes objekt zur weiteren
;														;  verarbeitung zwischenspeichern
.equ	dyn_object_segment		=	9					;- gre eines objekt-segmentes (10)
.equ	dyn_object_limitTE		=	dyn_object_TE + dyn_object_segment 
;														;- konstante definition des segments
;-----------------------END 0x7d9	+ koMAP	-------------------------------------------------
;--------------------------------------------------------------------------------------------
;<process>
.equ	WTremPROC				=	0x7da	+ koMAP		;verzgerung im remote mode
;--------------------------------------------------------------------------------------------
;<FREE OBJECT INDEX>-------------------------------------------------------------------------
.equ	free_obj_index			=	0x7db	+ koMAP		;- startadresse indextabelle
;														;- aktuelle speicherbelegung indiziert
.equ	obj_index_limit			=	free_obj_index + 40	;- gre des verfgbaren speicherbereiches
.equ	obj_table_limit			=	40					;- max.40 objekt segmente...
;-----------------------END 0x803	+ koMAP	-------------------------------------------------
;--------------------------------------------------------------------------------------------
;<free>
;.equ	free				=	0x804	+ koMAP		;
;--------------------------------------------------------------------------------------------
;<CLASS TABLE>-------------------------------------------------------------------------------
.equ	class_define    		=	0x805	+ koMAP		;- out object-table startadresse 
									;..................................................................................................
									;- out e2prom-table startadresse
									.equ	class_defineEEPROM		=	(class_define - koMAP) - 0x4a5	
                                    .equ    class_defineEEPROMRANGE =   class_defineEEPROM  +   0x12b		
									;..................................................................................................
									;-> v05 modifizieren !!!
									;
.equ	class_segment			=	15					;- gre eines out-objekt-segmentes
.equ	class_count				=	20					;- maximale anzahl der out-objekte
.equ	class_def_SIZ			=	(class_segment * class_count) 
.equ	class_def_end			=	class_define + class_def_SIZ
;														;- letzte adresse des bereiches
;--------------------------------------------------------------------------------------------
;-----------------------END	0x931	+ koMAP -------------------------------------------------
;<CLASS FILTER TABLE>------------------------------------------------------------------------
.equ	class_filter_def		=	0x932	+ koMAP		;- object-filter table startadresse														;table start
									;..................................................................................................
									;- out e2prom-table startadresse
									.equ	class_filter_defEEPROM		=	(class_filter_def - koMAP) - 0x4a6
                                    .equ    class_filter_defEEPROMRANGE =   class_filter_defEEPROM  +   0x185			
									;..................................................................................................
									;-> v05 modifizieren !!!
									;
.equ	class_filter_segment	=	13					;- gre eines filtersegmentes
.equ	class_filter_count		=	30					;- maximale filteranzahl

.equ	class_fil_SIZ			=	(class_filter_segment * class_filter_count) 
.equ	class_filter_limit		=	(class_filter_def + class_fil_SIZ) -1		
;														;- letzte adresse des bereiches
;--------------------------------------------------------------------------------------------
;-----------------------END 0xab8	+ koMAP	-------------------------------------------------
;<DYNAMIC OBJECT DEFINE>---------------------------------------------------------------------
.equ	dyn_object_define		=	0xab9	+ koMAP		;- in object-table startadresse
.equ	dyn_object_count		=	40					;- maximale anzahl von objekten
;--------------------------------------------------------------------------------------------
;-----------------------END	0xc49 	+ koMAP	-------------------------------------------------
.equ	net_sou_adress		=	0xc4a		+ koMAP		;host adress - lokales device
;<PWR rail>
.equ	teRAILcnt			=	0xc4b		+ koMAP		;rail counter
;<group>
.equ	GhostSEARCHte			=	0xc4c		+ koMAP		;group access - def. hosts
;<compare>
.equ	TEcounter4L		=	0xc4d	+ koMAP		;countervariable
.equ	TEcounter4H		=	0xc4e	+ koMAP		;	"
.equ	TEcounter5L		=	0xc4f	+ koMAP		;	"
.equ	TEcounter5H		=	0xc50	+ koMAP		;	"
.equ	TEcounter6L		=	0xc51	+ koMAP		;	"
.equ	TEcounter6H		=	0xc52	+ koMAP		;	"
.equ	TEcounter7L		=	0xc53	+ koMAP		;	"
.equ	TEcounter7H		=	0xc54	+ koMAP		;	"
;<SYSTEM EVENT TABLE>-------------------------------------------------------------------------
.equ	SYSeventST			=	0xc55		+ koMAP		;eventtable startadresse (32*8 -flags)
;---------------------------------------------------------------------------------------------
;-----------------------END 0xc74	+ koMAP --------------------------------------------------
;<SYSTEM LAST EVENT TABLE>--------------------------------------------------------------------
.equ	SYSlasteventST		=	0xc75		+ koMAP		;last-eventtable startadresse(32*8 -flags)
;---------------------------------------------------------------------------------------------
;-----------------------END 0xc94	+ koMAP --------------------------------------------------
;---------------------------------------------------------------------------------------------
;<EVENT BUFFER>-------------------------------------------------------------------------------
.equ	STARTeventBUF		=	0xc95		+ koMAP		;startadresse eventbuffer
.equ	ENDeventBUF			=	0xcf9		+ koMAP		;endadress eventbuffer
;-----------------------END 0xcf9	+ koMAP	--------------------------------------------------
.equ	SAVEbufADRl			=	0xcfa		+ koMAP		;event table adress LSB
.equ	SAVEbufADRh			=	0xcfb		+ koMAP		;event table adress MSB
.equ	eventPOINT			=	0xcfc		+ koMAP		;tablepointer
.equ	eventBACKte			=	0xcfd		+ koMAP		;temporrer table
.equ	digitA				=	0xcfe		+ koMAP		;digit berechnung
.equ	digitB				=	0xcff		+ koMAP		;digit berechnung
.equ	digitC				=	0xd00		+ koMAP		;digit berechnung
.equ	digitD				=	0xd01		+ koMAP		;digit berechnung
.equ	digitE				=	0xd02		+ koMAP		;digit berechnung
.equ	teCresL				=	0xd03		+ koMAP		;temporrer parameter
.equ	teCresH				=	0xd04		+ koMAP		;temporrer parameter
.equ	teCadrL				=	0xd05		+ koMAP		;  "           "
.equ	teCadrH				=	0xd06		+ koMAP		;  "           "

;---------------------------------------------------------------------------------------------
.equ	CprotectA			=	0xd07		+ koMAP		;relais (motor) protectdelays
.equ	CprotectB			=	0xd08		+ koMAP		;
.equ	CprotectC			=	0xd09		+ koMAP
.equ	CprotectD			=	0xd0a		+ koMAP	
.equ	CprotectE			=	0xd0b		+ koMAP
.equ	CprotectF			=	0xd0c		+ koMAP
.equ	CprotectG			=	0xd0d		+ koMAP
.equ	CprotectH			=	0xd0e		+ koMAP
;---------------------------------------------------------------------------------------------
;<key_seq>
.equ	keyPINcnt			=	0xd0f		+ koMAP		;ablaufcounter
.equ	keyEDGE				=	0xd10		+ koMAP		;l/h-flanken flag's fr alle eingnge				
;->
.equ	key0TOG 			=	0xd11		+ koMAP		;toggle-status-flags fr sequence 1..3 / eingang0 	
.equ	key1TOG 			=	0xd12		+ koMAP		;toggle-status-flags fr sequence 1..3 / eingang1 	
.equ	key2TOG 			=	0xd13		+ koMAP		;toggle-status-flags fr sequence 1..3 / eingang2 	
.equ	key3TOG 			=	0xd14		+ koMAP		;toggle-status-flags fr sequence 1..3 / eingang3 	
.equ	key4TOG 			=	0xd15		+ koMAP		;toggle-status-flags fr sequence 1..3 / eingang4 	
;->
.equ	key0CNT 			=	0xd16		+ koMAP		;wait-time counter fr eingang0 	
.equ	key1CNT 			=	0xd17		+ koMAP		;wait-time counter fr eingang1 	
.equ	key2CNT 			=	0xd18		+ koMAP		;wait-time counter fr eingang2 	
.equ	key3CNT 			=	0xd19		+ koMAP		;wait-time counter fr eingang3 	
.equ	key4CNT 			=	0xd1a		+ koMAP		;wait-time counter fr eingang4 	
;->
.equ	key0CNTte 			=	0xd1b		+ koMAP		;temp. ist-time counter fr eingang0 	
.equ	key1CNTte 			=	0xd1c		+ koMAP		;temp. ist-time counter fr eingang1 	
.equ	key2CNTte 			=	0xd1d		+ koMAP		;temp. ist-time counter fr eingang2 	
.equ	key3CNTte 			=	0xd1e		+ koMAP		;temp. ist-time counter fr eingang3 	
.equ	key4CNTte 			=	0xd1f		+ koMAP		;temp. ist-time counter fr eingang4 	

.equ	key0SEQ				=	0xd20		+ koMAP		;aktive sequenz(1..3) fr eingang0	
.equ	key1SEQ				=	0xd21		+ koMAP		;aktive sequenz(1..3) fr eingang1	
.equ	key2SEQ				=	0xd22		+ koMAP		;aktive sequenz(1..3) fr eingang2	
.equ	key3SEQ				=	0xd23		+ koMAP		;aktive sequenz(1..3) fr eingang3	
.equ	key4SEQ				=	0xd24		+ koMAP		;aktive sequenz(1..3) fr eingang4	
;->
;---------------------------------------------------------------------------------------------
;<key_sequence storage>
.equ	keyTBLstart			=	0xd25		+ koMAP		;key-table-startadresse 
									;..................................................................................................
									;- e2prom-table startadresse
									.equ	keyTBLstart_e2p		    =	(keyTBLstart - koMAP) - 0x713	
                                    .equ    keyTBLstart_e2pRANGE	=   keyTBLstart_e2p + 0x158
									;..................................................................................................
									;-> v05 modifizieren !!!
									;
;---------------------------------------------------------------------------------------------
.equ	keySEQ_size		=	22				;eine key-sequence umfasst 22bytes
.equ	keyTOG_size		=	keySEQ_size/2	;11
.equ	keySEQ_full		=	69				;gre eines kompletten key-segmentes
.equ	keyTBLsiz		=	5 * keySEQ_full	;tablegre
;---------------------------------------------------------------------------------------------
;--------------------------END 0xe7e	+ koMAP ----------------------------------------------
;<key sequencer setup /prog>
.equ	progKEY				=	0xe7f		+ koMAP		;temp. selected key (0...4)
.equ	progSEQ				=	0xe80		+ koMAP		;temp. selected sequences (1...3)
.equ	progSEQmax			=	0xe81		+ koMAP		;temp. max. sequences (1...3)
.equ	progINSbase			=	0xe82		+ koMAP		;temp. base instruction (1...3)
.equ	progINSbaseMAX		=	0xe83		+ koMAP		;temp. max. base instruction (1...3)
.equ	progINStog			=	0xe84		+ koMAP		;temp. toggle instruction (1...3)
.equ	progINStogMAX		=	0xe85		+ koMAP		;temp. max. toggle instruction (1...3)
.equ	progEVENTbase		=	0xe86		+ koMAP		;temp. base event
.equ	progEVENTtog		=	0xe87		+ koMAP		;temp. toggle event
.equ	progPARAbase		=	0xe88		+ koMAP		;temp. base parameter 
.equ	progPARAtog			=	0xe89		+ koMAP		;temp. toggle parameter
.equ	progTOG				=	0xe8a		+ koMAP		;temp. toggle flags
.equ	paraP				=	0xe8b		+ koMAP		;temp. parameter var
.equ	progADRbaseL		=	0xe8c		+ koMAP		;temp. base adress LSB
.equ	progADRbaseH		=	0xe8d		+ koMAP		;temp. base adress MSB
.equ	progADRtogL			=	0xe8e		+ koMAP		;temp. toggle adress LSB
.equ	progADRtogH			=	0xe8f		+ koMAP		;temp. toggle adress MSB
.equ	progADRe2L			=	0xe90		+ koMAP		;temp. e2prom adress LSB
.equ	progADRe2H			=	0xe91		+ koMAP		;temp. e2prom adress MSB
.equ	progADRloop			=	0xe92		+ koMAP		;temp. store loop variable
.equ	keyWTstate			=	0xe93		+ koMAP		;key wait state
;<SERIF>
.equ	CAcksumLdyn			=	0xe94		+ koMAP		;dyn CK-SummeL
.equ	CAcksumHdyn			=	0xe95		+ koMAP		;dyn CK-SummeH
.equ	CAcksumLte			=	0xe96		+ koMAP		;dyn CK-SummeL
.equ	CAcksumHte			=	0xe97		+ koMAP		;dyn CK-SummeH

;-------------------------------------------------------------------------------------
;<lha ID>
.equ	lha_id_tbl			=	0xe98		+ koMAP		;lha id segment 7bytes
									;..................................................................................................
									;- e2prom-table startadresse
									.equ	lha_id_tble2p		=	(lha_id_tbl - koMAP) - 0x5a7
									;.................................................................................................
.equ	lha_id_range		=	7
                                    ;................................................
                                    ;e2p host table
                                    .equ    hostTABLE           =   0xcac
                                    .equ    hostTABLErange      =   0xdac
                                    ;................................................
;--------------------------------------------------------------------------------------
;-----------------------------END 0xe9e------------------------------------------------


;<remote>
;.equ	remGLOBflag			=	0xe9f		+ koMAP	;globale remoteflags	1
.equ	remFLAG				=	0xea0		+ koMAP	;remoteflags		
.equ	remCNT				=	0xea1		+ koMAP	;remoteflags
.equ	remMASTER			=	0xea2		+ koMAP	;remote master adress
.equ	remSLAVE			=	0xea3		+ koMAP	;remote slave adress
.equ	remSLloop			=	0xea4		+ koMAP	;remote slave loop var
.equ    remTEfl             =   0xea5       + koMAP
.equ	remWTloop			=	0xea6		+ koMAP	;snd wt
;<spi-timeout>
.equ	spiDEMcnt			=	0xea7		+ koMAP	;fail counter 
;<eexTIMER>
.equ	DYNtim			    =	0xea8		+ koMAP	;





;<hot shots>
;.........................................................................................
;............. hot shot e2prom table startadress..........................................
			.equ	hot_shot_tbl	=	0x91b
            .equ    hot_shot_tblRANGE   =   hot_shot_tbl    +   0x388   ;complete hs range
            ;.............................................................................
			.equ	gadr_add_fact	=	0x7		;add factor // group-adressierung innerhalb der table
			.equ	hshot_seg_fact	=	0xb5	;add factor // segmentgre eines hot-shots 
			.equ	hshot_Gseg_fact	=	0x1d	;add factor // segmentgre eines funktionssegmentes im hot-shot
;..............e2prom end0xca3 ...........................................................

.equ	HOTstate			=	0xea9		+ koMAP	;hot shot states
.equ	HOTnumb				=	0xeaa		+ koMAP	;hot shot number
.equ	HOTe2adrL			=	0xeab		+ koMAP	;e2 adresse L (prog&proz)
.equ	HOTe2adrH			=	0xeac		+ koMAP	;e2 adresse H (prog&proz)
.equ	HOTe2point			=	0xead		+ koMAP	;e2 adress pointer  (prog&proz)
.equ	HOTe2doSIZ			=	0xeae		+ koMAP	;e2 read/write size (prog&proz)
.equ	HOTparadrL			=	0xeaf		+ koMAP	;sram adresse L (prog&proz)
.equ	HOTparadrH			=	0xeb0		+ koMAP	;sram adresse H (prog&proz)
.equ	HSseg				=	0xeb1		+ koMAP	;Xsegment in hot shot 
.equ	HGROUPadr			=	0xeb2		+ koMAP	;possible group-member adress (group table !)
.equ	HGROUPpoint			=	0xeb3		+ koMAP	;para pointer...
.equ	HGROUPGpoint		=	0xeb4		+ koMAP	;adress pointer...
.equ	HGROUPTpointMAX		=	0xeb5		+ koMAP	;target adresses max.
.equ	HGROUPTpointACT		=	0xeb6		+ koMAP	;target adresses actually
.equ	HOTparadrLte		=	0xeb7		+ koMAP	;sram adresse L (prog&proz)temp
.equ	HOTparadrHte		=	0xeb8		+ koMAP	;sram adresse H (prog&proz)temp
.equ	HOTpsc				=	0xeb9		+ koMAP	;ablaufcounter f. Hot shot execution modul

;--------------------------------------------------------------------------------------
;hot-shot temp. parameter 
.equ	temp_para_hstbl		=	0xeba		+ koMAP	;temp. parameter ablage
;------------------end 0xec1 ----------------------------------------------------------


;----------------------------START 0cec3 ------------------------------------------------
;enhanced timers (9x)
;----------------------------------------------------------------------------------------
.equ    enTIMmin            =   0xec3       + koMAP ;start adress minute
;.equ    enTIMhour          =   0xecd       + koMAP ;start adress hour
;.equ    enTIMday           =   0xed7       + koMAP ;start adress weekday
.equ    enTIMcontrol        =   0xee1       + koMAP ;timer control 


	                                ;..................................................................................................
									;- e2prom-table startadresse
									.equ	Etim_tble2p		=	(enTIMmin - koMAP) - 0x111
                                    .equ    EtimSEG_SIZ     =   40
                                    .equ    EtimSEG_RANGE   =   Etim_tble2p + 39
									;.................................................................................................


;--------------------------- END0xeee ---------------------------------------------------





;---------------------------------------------------------------------------------------
;EXTERN (TWI...) SENSORIC PARAs (para size 16bit)
;---------------------------------------------------------------------------------------

;A) 5xtemperature (outdoor/object)
.equ	Atemp1H				=	0xeef		+ koMAP		;a-temp1 high
.equ	Atemp1L				=	0xef0		+ koMAP		;a-temp1 low

.equ	Atemp2H				=	0xef1		+ koMAP		;a-temp2 high
.equ	Atemp2L				=	0xef2		+ koMAP		;a-temp2 low

.equ	Atemp3H				=	0xef3		+ koMAP		;a-temp3 high
.equ	Atemp3L				=	0xef4		+ koMAP		;a-temp3 low

.equ	Atemp4H				=	0xee5		+ koMAP		;a-temp4 high
.equ	Atemp4L				=	0xef6		+ koMAP		;a-temp4 low

.equ	Atemp5H				=	0xef7		+ koMAP		;a-temp5 high
.equ	Atemp5L				=	0xef8		+ koMAP		;a-temp5 low

;B) 5xtemperature (indoor/object)
.equ	Itemp1H				=	0xef9		+ koMAP		;i-temp1 high
.equ	Itemp1L				=	0xefa		+ koMAP		;i-temp1 low

.equ	Itemp2H				=	0xefb		+ koMAP		;i-temp2 high
.equ	Itemp2L				=	0xefc		+ koMAP		;i-temp2 low

.equ	Itemp3H				=	0xefd		+ koMAP		;i-temp3 high
.equ	Itemp3L				=	0xefe		+ koMAP		;i-temp3 low

.equ	Itemp4H				=	0xeff		+ koMAP		;i-temp4 high
.equ	Itemp4L				=	0xf00		+ koMAP		;i-temp4 low

.equ	Itemp5H				=	0xf01		+ koMAP		;i-temp5 high
.equ	Itemp5L				=	0xf02		+ koMAP		;i-temp5 low

;.....................................................................
;C) humidity (air)
.equ	AIRpress1H			=	0xf03		+ koMAP		;air-press1 high
.equ	AIRpress1L			=	0xf04		+ koMAP		;air-press1 low

.equ	AIRpress2H			=	0xf05		+ koMAP		;air-press2 high
.equ	AIRpress2L			=	0xf06		+ koMAP		;air-press2 low

.equ	AIRpress3H			=	0xf07		+ koMAP		;air-press3 high
.equ	AIRpress3L			=	0xf08		+ koMAP		;air-press3 low

.equ	AIRpress4H			=	0xf09		+ koMAP		;air-press4 high
.equ	AIRpress4L			=	0xf0a		+ koMAP		;air-press4 low

.equ	AIRpress5H			=	0xf0b		+ koMAP		;air-press5 high
.equ	AIRpress5L			=	0xf0c		+ koMAP		;air-press5 low



;D) 5xpressure (fluid)
.equ	FLUIDpress1H		=	0xf0d		+ koMAP		;fluid-press1 high
.equ	FLUIDpress1L		=	0xf0e		+ koMAP		;fluid-press1 low

.equ	FLUIDpress2H		=	0xf0f		+ koMAP		;fluid-press2 high
.equ	FLUIDpress2L		=	0xf10		+ koMAP		;fluid-press2 low

.equ	FLUIDpress3H		=	0xf11		+ koMAP		;fluid-press3 high
.equ	FLUIDpress3L		=	0xf12		+ koMAP		;fluid-press3 low

.equ	FLUIDpress4H		=	0xf13		+ koMAP		;fluid-press4 high
.equ	FLUIDpress4L		=	0xf14		+ koMAP		;fluid-press4 low

.equ	FLUIDpress5H		=	0xf15		+ koMAP		;fluid-press5 high
.equ	FLUIDpress5L		=	0xf16		+ koMAP		;fluid-press5 low



;....................................................................................

;E) 5xrotation (air/fluid/object)
.equ	ALLrotate1H			=	0xf17		+ koMAP		;ALLrotate1 high
.equ	ALLrotate1L			=	0xf18		+ koMAP		;ALLrotate1 low

.equ	ALLrotate2H			=	0xf19		+ koMAP		;ALLrotate2 high
.equ	ALLrotate2L			=	0xf1a		+ koMAP		;ALLrotate2 low

.equ	ALLrotate3H			=	0xf1b		+ koMAP		;ALLrotate3 high
.equ	ALLrotate3L			=	0xf1c		+ koMAP		;ALLrotate3 low

.equ	ALLrotate4H			=	0xf1d		+ koMAP		;ALLrotate4 high
.equ	ALLrotate4L			=	0xf1e		+ koMAP		;ALLrotate4 low

.equ	ALLrotate5H			=	0xf1f		+ koMAP		;ALLrotate5 high
.equ	ALLrotate5L			=	0xf20		+ koMAP		;ALLrotate5 low


;....................................................................................

;F) 10xcurrent (electricial)
.equ	Ecurrent1H			=	0xf21		+ koMAP		;Ecurrent1 high
.equ	Ecurrent1L			=	0xf22		+ koMAP		;Ecurrent1 low

.equ	Ecurrent2H			=	0xf23		+ koMAP		;Ecurrent2 high
.equ	Ecurrent2L			=	0xf24		+ koMAP		;Ecurrent2 low

.equ	Ecurrent3H			=	0xf25		+ koMAP		;Ecurrent3 high
.equ	Ecurrent3L			=	0xf26		+ koMAP		;Ecurrent3 low

.equ	Ecurrent4H			=	0xf27		+ koMAP		;Ecurrent4 high
.equ	Ecurrent4L			=	0xf28		+ koMAP		;Ecurrent4 low

.equ	Ecurrent5H			=	0xf29		+ koMAP		;Ecurrent5 high
.equ	Ecurrent5L			=	0xf2a		+ koMAP		;Ecurrent5 low

.equ	Ecurrent6H			=	0xf2b		+ koMAP		;Ecurrent1 high
.equ	Ecurrent6L			=	0xf2c		+ koMAP		;Ecurrent1 low

.equ	Ecurrent7H			=	0xf2d		+ koMAP		;Ecurrent2 high
.equ	Ecurrent7L			=	0xf2e		+ koMAP		;Ecurrent2 low

.equ	Ecurrent8H			=	0xf2f		+ koMAP		;Ecurrent3 high
.equ	Ecurrent8L			=	0xf30		+ koMAP		;Ecurrent3 low

.equ	Ecurrent9H			=	0xf31		+ koMAP		;Ecurrent4 high
.equ	Ecurrent9L			=	0xf32		+ koMAP		;Ecurrent4 low

.equ	Ecurrent10H			=	0xf33		+ koMAP		;Ecurrent5 high
.equ	Ecurrent10L			=	0xf34		+ koMAP		;Ecurrent5 low

;....................................................................................

;F) 10xvoltage (electricial)
.equ	Evoltage1H			=	0xf35		+ koMAP		;Evoltage1 high
.equ	Evoltage1L			=	0xf36		+ koMAP		;Evoltage1 low

.equ	Evoltage2H			=	0xf37		+ koMAP		;Evoltage2 high
.equ	Evoltage2L			=	0xf38		+ koMAP		;Evoltage2 low

.equ	Evoltage3H			=	0xf39		+ koMAP		;Evoltage3 high
.equ	Evoltage3L			=	0xf3a		+ koMAP		;Evoltage3 low

.equ	Evoltage4H			=	0xf3b		+ koMAP		;Evoltage4 high
.equ	Evoltage4L			=	0xf3c		+ koMAP		;Evoltage4 low

.equ	Evoltage5H			=	0xf3d		+ koMAP		;Evoltage5 high
.equ	Evoltage5L			=	0xf3e		+ koMAP		;Evoltage5 low

.equ	Evoltage6H			=	0xf3f		+ koMAP		;Evoltage1 high
.equ	Evoltage6L			=	0xf40		+ koMAP		;Evoltage1 low

.equ	Evoltage7H			=	0xf41		+ koMAP		;Evoltage2 high
.equ	Evoltage7L			=	0xf42		+ koMAP		;Evoltage2 low

.equ	Evoltage8H			=	0xf43		+ koMAP		;Evoltage3 high
.equ	Evoltage8L			=	0xf44		+ koMAP		;Evoltage3 low

.equ	Evoltage9H			=	0xf45		+ koMAP		;Evoltage4 high
.equ	Evoltage9L			=	0xf46		+ koMAP		;Evoltage4 low

.equ	Evoltage10H			=	0xf47		+ koMAP		;Evoltage5 high
.equ	Evoltage10L			=	0xf48		+ koMAP		;Evoltage5 low



;....................................................................................

;G) 5xspeed (air/fluid/object)
.equ	ALLspeed1H			=	0xf49		+ koMAP		;ALLspeed1 high
.equ	ALLspeed1L			=	0xf4a		+ koMAP		;ALLspeed1 low

.equ	ALLspeed2H			=	0xf4b		+ koMAP		;ALLspeed2 high
.equ	ALLspeed2L			=	0xf4c		+ koMAP		;ALLspeed2 low

.equ	ALLspeed3H			=	0xf4d		+ koMAP		;ALLspeed3 high
.equ	ALLspeed3L			=	0xf4e		+ koMAP		;ALLspeed3 low

.equ	ALLspeed4H			=	0xf4f		+ koMAP		;ALLspeed4 high
.equ	ALLspeed4L			=	0xf50		+ koMAP		;ALLspeed4 low

.equ	ALLspeed5H			=	0xf51		+ koMAP		;ALLspeed5 high
.equ	ALLspeed5L			=	0xf52		+ koMAP		;ALLspeed5 low


;....................................................................................

;H) 5xbrightness (air)
.equ	ALLbright1H			=	0xf53		+ koMAP		;ALLbright1 high
.equ	ALLbright1L			=	0xf54		+ koMAP		;ALLbright1 low

.equ	ALLbright2H			=	0xf55		+ koMAP		;ALLbright2 high
.equ	ALLbright2L			=	0xf56		+ koMAP		;ALLbright2 low

.equ	ALLbright3H			=	0xf57		+ koMAP		;ALLbright3 high
.equ	ALLbright3L			=	0xf58		+ koMAP		;ALLbright3 low

.equ	ALLbright4H			=	0xf59		+ koMAP		;ALLbright4 high
.equ	ALLbright4L			=	0xf5a		+ koMAP		;ALLbright4 low

.equ	ALLbright5H			=	0xf5b		+ koMAP		;ALLbright5 high
.equ	ALLbright5L			=	0xf5c		+ koMAP		;ALLbright5 low



;....................................................................................

;I) noise
.equ	ALLnoise1H			=	0xf5d		+ koMAP		;ALLnoise1 high
.equ	ALLnoise1L			=	0xf5e		+ koMAP		;ALLnoise1 low

.equ	ALLnoise2H			=	0xf5f		+ koMAP		;ALLnoise2 high
.equ	ALLnoise2L			=	0xf60		+ koMAP		;ALLnoise2 low

.equ	ALLnoise3H			=	0xf61		+ koMAP		;ALLnoise3 high
.equ	ALLnoise3L			=	0xf62		+ koMAP		;ALLnoise3 low

.equ	ALLnoise4H			=	0xf63		+ koMAP		;ALLnoise4 high
.equ	ALLnoise4L			=	0xf64		+ koMAP		;ALLnoise4 low

.equ	ALLnoise5H			=	0xf65		+ koMAP		;ALLnoise5 high
.equ	ALLnoise5L			=	0xf66		+ koMAP		;ALLnoise5 low




;....................................................................................

;I) 5xtiming 
.equ	ALLtiming1H			=	0xf67		+ koMAP		;ALLtiming1 high
.equ	ALLtiming1L			=	0xf68		+ koMAP		;ALLtiming1 low

.equ	ALLtiming2H			=	0xf69		+ koMAP		;ALLtiming2 high
.equ	ALLtiming2L			=	0xf6a		+ koMAP		;ALLtiming2 low

.equ	ALLtiming3H			=	0xf6b		+ koMAP		;ALLtiming3 high
.equ	ALLtiming3L			=	0xf6c		+ koMAP		;ALLtiming3 low

.equ	ALLtiming4H			=	0xf6d		+ koMAP		;ALLtiming4 high
.equ	ALLtiming4L			=	0xf6e		+ koMAP		;ALLtiming4 low

.equ	ALLtiming5H			=	0xf6f		+ koMAP		;ALLtiming5 high
.equ	ALLtiming5L			=	0xf70		+ koMAP		;ALLtiming5 low



;....................................................................................

;I) 5xposition (object)
.equ	OBJposition1H		=	0xf71		+ koMAP		;OBJposition1 high
.equ	OBJposition1L		=	0xf72		+ koMAP		;OBJposition1 low

.equ	OBJposition2H		=	0xf73		+ koMAP		;OBJposition2 high
.equ	OBJposition2L		=	0xf74		+ koMAP		;OBJposition2 low

.equ	OBJposition3H		=	0xf75		+ koMAP		;OBJposition3 high
.equ	OBJposition3L		=	0xf76		+ koMAP		;OBJposition3 low

.equ	OBJposition4H		=	0xf77		+ koMAP		;OBJposition4 high
.equ	OBJposition4L		=	0xf78		+ koMAP		;OBJposition4 low

.equ	OBJposition5H		=	0xf79		+ koMAP		;OBJposition5 high
.equ	OBJposition5L		=	0xf7a		+ koMAP		;OBJposition5 low

					;..............................................................................
					.equ	para_hys_tbl	    =	(Atemp1L	- koMAP) - 0x784	;e2p hysterese baseadress
                    .equ    para_hys_tblRANGE   =   para_hys_tbl    +   0x15d
					;...............................................................................
					;..............................................................................
					.equ	hys_exe_tbl		=	para_hys_tbl	+ 0x8b			;e2p execution-condition baseadress
					;...............................................................................
;<program>
.equ	COMPEXpointP		=	0xf7b		+ koMAP		;parameter pointer
.equ	COMPEXtempEVE		=	0xf7c		+ koMAP		;temp.event
.equ	COMPEXtempHYSl		=	0xf7d		+ koMAP		;temp.hystereseLOW
.equ	COMPEXtempHYSh		=	0xf7e		+ koMAP		;temp.hystereseHIGH
.equ	COMPEXtempCON		=	0xf7f		+ koMAP		;temp.control var
.equ	COMPEXtempEXE		=	0xf80		+ koMAP		;temp.execution var
;<compex>
.equ	COMPEXcnt			=	0xf81		+ koMAP		;para counter
.equ	COMPEXstate			=	0xf82		+ koMAP		;compex state

;------------------------------------------------------------------------------------
.equ	COMexFLAG			=	0xf83		+ koMAP				;startadresse fr ex-flags
;----------------------- END 0xf8b --------------------------------------------------

;<curADC> local 16bit (10bit resolution) adc values

.equ	ADC16_1H		=	0xf8b		+ koMAP		;ADC16_1 high
.equ	ADC16_1L		=	0xf8c		+ koMAP		;ADC16_1 low

.equ	ADC16_2H		=	0xf8d		+ koMAP		;ADC16_2 high
.equ	ADC16_2L		=	0xf8e		+ koMAP		;ADC16_2 low

.equ	ADC16_3H		=	0xf8f		+ koMAP		;ADC16_3 high
.equ	ADC16_3L		=	0xf90		+ koMAP		;ADC16_3 low

.equ	ADC16_4H		=	0xf91		+ koMAP		;ADC16_4 high
.equ	ADC16_4L		=	0xf92		+ koMAP		;ADC16_4 low

;<curADC> local sensoric-para adresses - showa to the MSB of para

.equ	ADC16_SA1H		=	0xf93		+ koMAP		;ADC16_SA1 high
.equ	ADC16_SA1L		=	0xf94		+ koMAP		;ADC16_SA1 low

.equ	ADC16_SA2H		=	0xf95		+ koMAP		;ADC16_SA2 high
.equ	ADC16_SA2L		=	0xf96		+ koMAP		;ADC16_SA2 low

.equ	ADC16_SA3H		=	0xf97		+ koMAP		;ADC16_SA3 high
.equ	ADC16_SA3L		=	0xf98		+ koMAP		;ADC16_SA3 low

.equ	ADC16_SA4H		=	0xf99		+ koMAP		;ADC16_SA4 high
.equ	ADC16_SA4L		=	0xf9a		+ koMAP		;ADC16_SA4 low

					;.................................................................
					.equ	adcSENSE_paraTBL	    =	(ADC16_SA1H - koMAP) - 0x2ef	;e2p adress
                    .equ    adcSENSE_paraTBLRANGE   =   adcSENSE_paraTBL    +   0x7
					;.................................................................
;------------------------------------------------------------------------------------
;<savAREArx>
.equ	savAREArx		=	0xf9b		+ koMAP		;size 10bytes  
;-----------------------------END0xfa4-------------------------------------------------

;<TWI BUFFER>--------------------------------------------------------------------------------
.equ	TWIbuffer		=	0xfa5	+ koMAP		;twi-buffer real start adresse	max.100bytes
;-----------------------END 0x1009	+ koMAP	-------------------------------------------------

.equ    e2pDELvar       =   0x100a      + koMAP     ;delete var
.equ    e2DELpointL     =   0x100b      + koMAP     ;adresspointer L
.equ    e2DELpointH     =   0x100c      + koMAP     ;adresspointer H
.equ    e2DELrangeL     =   0x100d      + koMAP     ;rangeadress L
.equ    e2DELrangeH     =   0x100e      + koMAP     ;rangeadress H





;INFO: RAMEND(MEG128)= 4351(dec) / 0x10ff(hex)
