;----------------------------------------------------------------------------------------
;--------- profile tx-framer ------------------------------------------------------------
;----------------------------------------------------------------------------------------
;modify mega644
;sfr's - ok



;********************************************************************************************
;0xef = profile counter
;0xf0 = segmentartadresse H
;0xf1 = "             "   L
;0xf2 = temp.frame-size
;startadress profile memory space = 0x240
;********************************************************************************************
;--------------------------------------------------------------------------
;profilstruktur 
;--------------------------------------------------------------------------
;-> 20 profile definierbar
;-> profilgre a'22bytes

;profilformat bei:
;a) gezielter adressierung					  |<- ab hier max.
; ______________________________________________________|__________________________________
;|mi    |ho-tar |sub-tar|ho-sou |sub-sou|frame  |adress |sou-adr|tar-adr|weitere....|event |
;|byte  |adress |adress |adress |adress |size   |segment|pointer|pointer|sou/tar....|byte  |
;|      |       |       |       |       |       |,type' |       |       |pointer....|      |
;|______|_______|_______|_______|_______|_______|_______|_______|_______|___________|______|


;b) seuenzielle adressierung					  
; _____________________________________________________________________________
;|mi    |ho-tar |sub-tar|ho-sou |sub-sou|frame  |adress |sou-adr|tar-adr|event |
;|byte  |adress |adress |adress |adress |size   |segment|pointer|pointer|byte  |
;|      |       |       |       |       |       |,type' |       |       |      | 
;|______|_______|_______|_______|_______|_______|_______|_______|_______|______|



;z.teil aufwndige berechnungen -deshalb routine in 3 schritten 
;abarbeiten
;
;
_PROFframer:
	;wenn programmierung luft ist diese routine blockiert !!!

	;
	lds	r19,SEflagVARa		;serial flag variable A laden
	lds	r22,SEflagVARb		; "             "     B
	lds	r17,SEflagVARc
	;
	sbrc	r19,RXframe
	rjmp	_FAILframerBK		;buffer besetzt 

	sbrc	r19,TXframe
	rjmp	_FAILframerBK		; "             "            "         "

	sbrc	r19,SEbusy
	rjmp	_FAILframerBK		;aktiver bertragung
	;
	sbrc	r17,SERcomACT	;sercommodul belegt....
	rjmp	_FAILframerBK
	;
	;vorbereitung im sercom luft
	sbrc	r22,newTX
	rjmp	_FAILframerBK

	;vorbereitung im sercom luft
	sbrc	r22,reqTX
	rjmp	_FAILframerBK


   ;vielleicht noch einen
   ;twi-job zu erledigen, dann kein neues frame !
    lds     r20,TWIstatus
    sbrc    r20,doTWI 
    rjmp    _FAILframerBK

	sbrc	r19,SEenabled
	rjmp	_PROFICNTck
	rjmp	_FAILframerBK		;serielle module disabled
	;
_PROFICNTck:
	;auch hier in stcken abarbeiten !
	lds	r23,0x10f	;profiCNT....
	cpi	r23,0
	breq	_PROFILdec	;starte mit profiladressberechnung
	cpi	r23,1
	breq	_FRAMEbuilderXX ; weiter mit speicher kopieren
	cpi	r23,2
	breq	_profTRANSoutXX
	;alles nix...
	clr	r23
	sts	0x10f,r23
	jmp	_FAILframerBKy
	;jumper...
_FRAMEbuilderXX:
	jmp	_FRAMEbuilderX

_profTRANSoutXX:
	jmp	_profTRANSoutX


	;...profil kann nun decodiert werden
	;hierfr aus aktuellem profil adresse berechnen und 
	;eventbyte prfen..
	;
_PROFoutX:
	jmp	_PROFout
_PROFILdec:
	lds	r16,0xef	;profile counter laden
	cpi	r16,20
	brsh _PROFoutX	
	;bei aktivem masterremote
	;profile 0-14 sperren !!!
	lds	zl,remFLAG
	sbrc	zl,RTactivM		;active master remote
	rjmp	_PROFILcheckREM			;
	rjmp	_PROFILdecX
_PROFILcheckREM:
	cpi	r16,15
	brsh	_PROFILdecX		;zwischen 15-19
	ldi	r16,15
	sts	0xef,r16	;profilcounter sichern
_PROFILdecX:
	;
	;
	;nun kalkuliere profil-platz:  (profil-counter)*(22 == SWmultiplikation)+
	;                              (startadresse profiSTram/0x5d5 sram)= programmplatz
	;0-19
	ldi	r22,22			;22 (profil-memory-space-segment)
	mul	r22,r16
	mov	r21,r0
	mov	r17,r1
	;addiere (profil*22) +startadresse 0x5d5
	subi	r21, low(-profiSTram)	;Add low byte ( x -(-y)) = x + y
	sbci	r17, high(-profiSTram)	;Add high byte with carry

	
	;store segmentSTARTadresse... !!!

	sts	0xf0,r17		;store high-adress-nibble
	sts	0xf1,r21		; "    lower-adress-nibble

	;addiere eventbyte + (programmplatz*22)
	ldi	r18,21		;(L)... eventbyte ist das letzte im profilsegment !
	ldi	r20,0			;(H)
	add	r21,r18			;Add low bytes
	adc	r17,r20			;Add high bytes with carry
	;
	;
	;adressierung fertig / nun aktuelles eventbyte holen!
	call	_RDprofi
	;
	;***************************************************************		
	;***************************************************************
	;***************************************************************
	;    eventbyte
	;... enthlt die event-instruction lt. tabelle 
	;
	;0 = profile nicht belegt / aktiviert
	;1 = profile-timer1 (1-255 s) event
	;2 = profile-timer2 (1-255 s) event
	;3 = second-event
	;4 = minute-event
	;5 = hour-event
	;6 = day-event
	;7 = week-event
	;8 = year-event
	;9 = rail&portENABLE (H)/ 0xcc = ports aktiviert
	;10= rail&portDISABLE(L)/ 0xcc = ports deaktiviert
	;11= power-up (...system fhrt hoch !) 
	;12= HIF 1
	;13= HIF 2
	;14= HIF 3
	;15= HIF 4
	;16= HIF 5
	;17= HIF 6
	;18= 5 second-event
	;19= powerrail-shortcut 
	;20= softPOev0		(0xf9/ev3FLvar)
	;21= softPOev1		(0xf9/ev3FLvar)
	;22= softPOev2		(0xf9/ev3FLvar)
	;23= softPOev3		(0xf9/ev3FLvar)
	;24= softPOev4		(0xf9/ev3FLvar)
	;25= softPOev5		(0xfb/ev4FLvar)
	;26= softPOev6		(0xfb/ev4FLvar)
	;27= softPOev7		(0xfb/ev4FLvar)
	;28= softPOev8		(0xfb/ev4FLvar)
	;29= softPOev9		(0xfb/ev4FLvar)
	;30= sndREMon		(0x236/remote on-frame als master senden)
	;31= sndREMoff		(0x236/remote off-frame als slave senden)
	;32= sndREMactiv	(0x236/remote activ-frame als slave senden)
	;33= sndREMspicode	(0x236/spidaten als master senden)
	;34= sndREMdisplay	(0x236/spidaten als slave senden)
	;..............................................................
	;noch nicht aktiv
	;35= HIF 7			(0xfb)
	;36= HIF 8			"
	;37= HIF 9			"

	
	;->
	;weitere flagdefinitionen folgen





	;**************************************************************
	;jetzt eventbyte testen und decodieren
_prof0eventX:
	tst 	r19
	brne	_prof1eventX
	jmp	_NXTprofile
	;-------------------------------------------------
	;profil = 1 ?
_prof1eventX:
	;timer1 (1-255s) (nachfolgende timer und sekunden-flags werden im TIMESLOT-modul gesetzt)
	cpi	r19,1
	brne	_prof2eventX
	lds	r20,ev1FLvar ;event-flag-variable 1
	sbrc	r20,tim1ev
	rjmp	_tim1event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim1event:
	cbr	r20,1<<tim1ev
	sts	ev1FLvar,r20 ;event-flag-variable 1 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 2 ?
_prof2eventX:
	;timer2 (1-255s)
	cpi	r19,2
	brne	_prof3eventX
	lds	r20,ev1FLvar ;event-flag-variable 1
	sbrc	r20,tim2ev
	rjmp	_tim2event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim2event:
	cbr	r20,1<<tim2ev
	sts	ev1FLvar,r20 ;event-flag-variable 1 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 3 ?
_prof3eventX:
	;RTC sekunde
	cpi	r19,3
	brne	_prof4eventX
	lds	r20,ev1FLvar ;event-flag-variable 1
	sbrc	r20,RTCsecEV
	rjmp	_tim3event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim3event:
	cbr	r20,1<<RTCsecEV
	sts	ev1FLvar,r20 ;event-flag-variable 1 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 4 ?
_prof4eventX:
	;RTC minute	(nachfolgende zeitflags werden im RTC-modul gesetzt)
	cpi	r19,4
	brne	_prof5eventX
	lds	r20,ev1FLvar ;event-flag-variable 1
	sbrc	r20,RTCminEV
	rjmp	_tim4event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim4event:
	cbr	r20,1<<RTCminEV
	sts	ev1FLvar,r20 ;event-flag-variable 1 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 5 ?
_prof5eventX:
	;RTC stunde
	cpi	r19,5
	brne	_prof6eventX
	lds	r20,ev1FLvar ;event-flag-variable 1
	sbrc	r20,RTChouEV
	rjmp	_tim5event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim5event:
	cbr	r20,1<<RTChouEV
	sts	ev1FLvar,r20 ;event-flag-variable 1 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 6 ?
_prof6eventX:
	;RTC tag
	cpi	r19,6
	brne	_prof7eventX
	lds	r20,ev1FLvar ;event-flag-variable 1
	sbrc	r20,RTCdayEV
	rjmp	_tim6event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim6event:
	cbr	r20,1<<RTCdayEV
	sts	ev1FLvar,r20 ;event-flag-variable 1 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 7 ?
_prof7eventX:
	;RTC woche
	cpi	r19,7
	brne	_prof8eventX
	lds	r20,ev1FLvar ;event-flag-variable 1
	sbrc	r20,RTCmoEV
	rjmp	_tim7event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim7event:
	cbr	r20,1<<RTCmoEV
	sts	ev1FLvar,r20 ;event-flag-variable 1 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 8 ?
_prof8eventX:
	;RTC jahr
	cpi	r19,8
	brne	_prof9eventX
	lds	r20,ev1FLvar ;event-flag-variable 1
	sbrc	r20,RTCyeaEV
	rjmp	_tim8event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim8event:
	cbr	r20,1<<RTCyeaEV
	sts	ev1FLvar,r20 ;event-flag-variable 1 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 9 ?
_prof9eventX:
	;rail&portENABLED = ports aktiviert (wird im POWERRAIL modul gesetzt)
	cpi	r19,9
	brne	_prof10eventX
	lds	r20,ev2FLvar ;event-flag-variable 2
	sbrc	r20,RAILenab
	rjmp	_tim9event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim9event:
	cbr	r20,1<<RAILenab
	sts	ev2FLvar,r20 ;event-flag-variable 2 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 10 ?
_prof10eventX:
	;rail&portENABLED = ports aktiviert (wird im POWERRAIL-modul gesetzt)
	cpi	r19,10
	brne	_prof11eventX
	lds	r20,ev2FLvar ;event-flag-variable 2
	sbrc	r20,RAILdisa
	rjmp	_tim10event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim10event:
	cbr	r20,1<<RAILdisa
	sts	ev2FLvar,r20 ;event-flag-variable 2 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 11 ?
_prof11eventX:
	;powerUP (wird in ENTRY-modul gesetzt)
	cpi	r19,11
	brne	_prof12eventX
	lds	r20,ev2FLvar ;event-flag-variable 2
	sbrc	r20,PWRon
	rjmp	_tim11event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim11event:
	cbr	r20,1<<PWRon
	sts	ev2FLvar,r20 ;event-flag-variable 2 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 12 ?
_prof12eventX:
	;hif1
	cpi	r19,12
	brne	_prof13eventX
	lds	r20,ev2FLvar ;event-flag-variable 2
	sbrc	r20,HIF1
	rjmp	_tim12event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim12event:
	cbr	r20,1<<HIF1
	sts	ev2FLvar,r20 ;event-flag-variable 2 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 13 ?
_prof13eventX:
	;hif2
	cpi	r19,13
	brne	_prof14eventX
	lds	r20,ev2FLvar ;event-flag-variable 2
	sbrc	r20,HIF2
	rjmp	_tim13event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim13event:
	cbr	r20,1<<HIF2
	sts	ev2FLvar,r20 ;event-flag-variable 2 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 14 ?
_prof14eventX:
	;hif3
	cpi	r19,14
	brne	_prof15eventX
	lds	r20,ev2FLvar ;event-flag-variable 2
	sbrc	r20,HIF3
	rjmp	_tim14event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim14event:
	cbr	r20,1<<HIF3
	sts	ev2FLvar,r20 ;event-flag-variable 2 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 15 ?
_prof15eventX:
	;hif4
	cpi	r19,15
	brne	_prof16eventX
	lds	r20,ev2FLvar ;event-flag-variable 2
	sbrc	r20,HIF4
	rjmp	_tim15event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim15event:
	cbr	r20,1<<HIF4
	sts	ev2FLvar,r20 ;event-flag-variable 2 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 16 ?
_prof16eventX:
	;hif5
	cpi	r19,16
	brne	_prof17eventX
	lds	r20,ev2FLvar ;event-flag-variable 2
	sbrc	r20,HIF5
	rjmp	_tim16event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim16event:
	cbr	r20,1<<HIF5
	sts	ev2FLvar,r20 ;event-flag-variable 2 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 17 ?
_prof17eventX:
	;hif6
	cpi	r19,17
	brne	_prof18eventX
	lds	r20,ev3FLvar ;event-flag-variable 2
	sbrc	r20,HIF6
	rjmp	_tim17event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim17event:
	cbr	r20,1<<HIF6
	sts	ev3FLvar,r20 ;event-flag-variable 2 sichern
	jmp	_FRAMEbuilder	
	;------------------------------------------------
	;profil = 18 ?
_prof18eventX:
	;5Sec... (wird im timeslot-Modul generiert)
	cpi	r19,18
	brne	_prof19eventX
	lds	r20,ev3FLvar ;event-flag-variable 2
	sbrc	r20,ti5secEV
	rjmp	_tim18event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim18event:
	cbr	r20,1<<ti5secEV
	sts	ev3FLvar,r20 ;event-flag-variable 2 sichern
	jmp	_FRAMEbuilder
	
	;------------------------------------------------
	;profil = 19 ?
_prof19eventX:
	;Powerrail shortcut (wird im PWRrail-Modul generiert)
	cpi	r19,19
	brne	_prof20eventX
	lds	r20,ev3FLvar ;event-flag-variable 2
	sbrc	r20,CURshortEV
	rjmp	_tim19event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim19event:
	cbr	r20,1<<CURshortEV
	sts	ev3FLvar,r20 ;event-flag-variable 2 sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;softport-events'
	;profil = 20 ?
_prof20eventX:
	cpi	r19,20
	brne	_prof21eventX
	lds	r20,ev3FLvar ;event-flag-variable 
	sbrc	r20,softPOev0
	rjmp	_tim20event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim20event:
	cbr	r20,1<<softPOev0
	sts	ev3FLvar,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 21 ?
_prof21eventX:
	cpi	r19,21
	brne	_prof22eventX
	lds	r20,ev3FLvar ;event-flag-variable 
	sbrc	r20,softPOev1
	rjmp	_tim21event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim21event:
	cbr	r20,1<<softPOev1
	sts	ev3FLvar,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 22 ?
_prof22eventX:
	cpi	r19,22
	brne	_prof23eventX
	lds	r20,ev3FLvar ;event-flag-variable 
	sbrc	r20,softPOev2
	rjmp	_tim22event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim22event:
	cbr	r20,1<<softPOev2
	sts	ev3FLvar,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 23 ?
_prof23eventX:
	cpi	r19,23
	brne	_prof24eventX
	lds	r20,ev3FLvar ;event-flag-variable 
	sbrc	r20,softPOev3
	rjmp	_tim23event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim23event:
	cbr	r20,1<<softPOev3
	sts	ev3FLvar,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder	
	;------------------------------------------------
	;profil = 24 ?
_prof24eventX:
	cpi	r19,24
	brne	_prof25eventX
	lds	r20,ev3FLvar ;event-flag-variable 
	sbrc	r20,softPOev4
	rjmp	_tim24event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim24event:
	cbr	r20,1<<softPOev4
	sts	ev3FLvar,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 25 ?
_prof25eventX:
	cpi	r19,25
	brne	_prof26eventX
	lds	r20,ev4FLvar ;event-flag-variable 
	sbrc	r20,softPOev5
	rjmp	_tim25event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim25event:
	cbr	r20,1<<softPOev5
	sts	ev4FLvar,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 26 ?
_prof26eventX:
	cpi	r19,26
	brne	_prof27eventX
	lds	r20,ev4FLvar ;event-flag-variable 
	sbrc	r20,softPOev6
	rjmp	_tim26event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim26event:
	cbr	r20,1<<softPOev6
	sts	ev4FLvar,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 27 ?
_prof27eventX:
	cpi	r19,27
	brne	_prof28eventX
	lds	r20,ev4FLvar ;event-flag-variable 
	sbrc	r20,softPOev7
	rjmp	_tim27event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim27event:
	cbr	r20,1<<softPOev7
	sts	ev4FLvar,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 28 ?
_prof28eventX:
	cpi	r19,28
	brne	_prof29eventX
	lds	r20,ev4FLvar ;event-flag-variable 
	sbrc	r20,softPOev8
	rjmp	_tim28event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim28event:
	cbr	r20,1<<softPOev8
	sts	ev4FLvar,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 29 ?
_prof29eventX:
	cpi	r19,29
	brne	_prof30eventX
	lds	r20,ev4FLvar ;event-flag-variable 
	sbrc	r20,softPOev9
	rjmp	_tim29event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim29event:
	cbr	r20,1<<softPOev9
	sts	ev4FLvar,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 30 ?
_prof30eventX:
	cpi	r19,30
	brne	_prof31eventX
	lds	r20,remEVflag ;event-flag-variable 
	sbrc	r20,sndREMon
	rjmp	_tim30event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim30event:
	cbr	r20,1<<sndREMon
	sts	remEVflag,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 31 ?
_prof31eventX:
	cpi	r19,31
	brne	_prof32eventX
	lds	r20,remEVflag ;event-flag-variable 
	sbrc	r20,sndREMoff
	rjmp	_tim31event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim31event:
	cbr	r20,1<<sndREMoff
	sts	remEVflag,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 32 ?
_prof32eventX:
	cpi	r19,32
	brne	_prof33eventX
	lds	r20,remEVflag ;event-flag-variable 
	sbrc	r20,sndREMactiv
	rjmp	_tim32event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim32event:
	cbr	r20,1<<sndREMactiv
	sts	remEVflag,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 33 ?
_prof33eventX:
	cpi	r19,33
	brne	_prof34eventX
	lds	r20,remEVflag ;event-flag-variable 
	sbrc	r20,sndREMspicode
	rjmp	_tim33event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim33event:
	cbr	r20,1<<sndREMspicode
	sts	remEVflag,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder
	;------------------------------------------------
	;profil = 34 ?
_prof34eventX:
	cpi	r19,34
	brne	_prof35eventX
	lds	r20,remEVflag ;event-flag-variable 
	sbrc	r20,sndREMdisplay
	rjmp	_tim34event	 ;event eingetroffen !!!
	jmp	_NXTprofile	 ;event nicht eingetroffen !!!
_tim34event:
	cbr	r20,1<<sndREMdisplay
	sts	remEVflag,r20 ;event-flag-variable  sichern
	jmp	_FRAMEbuilder




	;	
	;<<<
	;<<
	;...weitere Abfragen hier einsetzen
_prof35eventX:
	jmp	_NXTprofile
	;<
	;<<
	;<<<
	;<<<<+++++++++++++++++++---------------------------------------------------------
	;<<<
	;<<
	;ACHTUNG: nun an profil-routine anpassen !!!
	;		
	;generiere header
	;in diesem fall als broadcast-message
	;d.h. keine adressprfung !!!
	;
	;segmentstartadresee aus 0xf0 (H)
	;				 0xf1 (L)
	;framesize nach          0xf2 
	;
	;
_FRAMEbuilder:
	;test ------ OK bis hierher alles stabil !!!

	;framebuilder startet...
	lds	r16,SEflagVARc
	sbr	r16,1<<FRbuild
	sts	SEflagVARc,r16
	;
	ldi	r23,1
	sts	0x10f,r23
	clr	r20
	sts	0x112,r20
	jmp	_FAILframerBK




	;--------------------------------------------------------
_FRAMEbuilderX:	
	lds	r20,0x112
	tst	r20
	breq	_FRAmy
	
;hier variablen zurckholen...
	lds	r21,0x110	;e2adrL
	lds	r17,0x111	;     H
	lds	r20,0x112	;framecounter
	lds	r18,0x113	;framesize
	lds	zl,0x114
	lds	zh,0x115		
	lds	r22,0x117
	jmp	_profTRANS
	;
	;
	;... das erste byte (mi) aus dem profilsegment
_FRAmy:			
	;lade zuerst mi
	;
	lds	r17,0xf0		;restore high-adress-nibble
	lds	r21,0xf1		; "      lower-adress-nibble
	call	_RDprofi
	sbrs	r19,adr_mod	;sequenz od. gezielt ?
	rjmp		_FRadr_direkt
	clr		r22
	sbr		r22,1<<0	;flag-sequenz
	jmp	    _FRAMsize_Y
_FRadr_direkt:
	clr		r22			;flag-direkt	
_FRAMsize_Y:	 
	;+5
	;framesize = 10(header)+2(type-adress)+2(checksumme)+x(daten)
	subi	r21, low(-kon5ST)	;Add low byte ( x -(-y)) = x + y
	sbci	r17, high(-kon5ST)	;Add high byte with carry
	clc
	nop
	call	_RDprofi 
	;ergebnis (framesize) store
	sts	0xf2,r19		
	;
	;lade profilsegment-startadresse 
	lds	r17,0xf0		;store high-adress-nibble
	lds	r21,0xf1		; "    lower-adress-nibble
	;
	;lade SRAM-buffer-startadresse
	ldi	zl, low(RXbufferST)	;
	ldi	zh, high(RXbufferST)	;
	;
		
	










_profTRANS:	
	;hole daten aus  sram
	call	_RDprofi	
_onlySRinc:
	;
	st	z+,r19	;daten aus sram -> rxbuffer
	sts	0x129,zl
	sts	0x12a,zh 
	;
	dec	r18			;frame-size...	
	tst	r18
	breq	_profTRANSout	;im nchsten durchgang
	;
	inc	r20
	;das sind die 3 leerbytes !!!
	cpi	r20,6
	breq	_onlySRinc
	cpi	r20,7
	breq	_onlySRinc
	cpi	r20,8
	breq	_onlySRinc
	;
	;ab byte#12 prfen ob sequenziell oder gezielt 
	;adressiert wird ???
	;
	cpi	r20,11
	breq	_FRAMEadressCK ;sequ == nur sou/tar adresspointer nach rxbuffer & fertig
	cpi	r20,12
	brsh    _FRAMEgezADR ;gez  == x-sou/tar-adresspointer nach rxbuffer & fertig 
	;nichts dabei...	
	jmp	_ramADRESSING
	;




	;alle werte >=12 bedeuten gezielte adressierung
_FRAMEgezADR:   			;help flag gelscht bedeutet:
					;das sram adresse +2 gesetzt wird
					;und frame-size zustzlich -2 subtrahiert wird

	sbrs	r22,1			
	rjmp	_FRAMEadd2ADR	;add rxbufffer-adress +2
	rjmp	_FRAMEadrGO		;belasse rxbuffer-adress

_FRAMEadd2ADR:
	;SRAMadresse +2
	lds	zl,0x129		;rxbuffer adresse L
	lds	zh,0x12a		;			H
	subi	zl, low(-kon2ST)	;Add low byte ( x -(-y)) = x + y
	sbci	zh, high(-kon2ST)	;Add high byte with carry
	;counter <3 ... dann bereits im checksummenbereich == also fertig
	cpi	r18,3
	brlo	_profTRANSout	
	;frame size -2
	subi	r18,2
	sbr	r22,1<<1		;beim nchsten mal nur adresse holen
	rjmp	_ramADRESSING	;nchste adresse laden

_FRAMEadrGO:
	;
	cbr	r22,1<<1
	;counter <3 ... dann bereits im checksummenbereich == also fertig
	cpi	r18,3
	brlo	_profTRANSout	
	rjmp	_ramADRESSING	;nchste adresse laden	
	;	
	;








_FRAMEadressCK:

	sbrs	r22,0
	rjmp	    _ramADRESSING
	;sequenz
	ldi	r18,1		;frame-size manipulieren
				;bedeutet da nur noch byte 10
				;type adress au sram kopiert wird
	;-----------------------------------------------------		
_ramADRESSING:		
	;ram-adresse +1
	subi	r21, low(-kon1ST)	;Add low byte ( x -(-y)) = x + y
	sbci	r17, high(-kon1ST)	;Add high byte with carry
	;
	;hier variablen sichern...
	sts	0x110,r21	;e2adrL
	sts	0x111,r17	;     H
	sts	0x112,r20	;framecounter
	sts	0x113,r18	;framesize
	sts	0x114,zl
	sts	0x115,zh	
	sts	0x117,r22	;helpflags
	jmp	_FAILframerBKy
	;
	;
	;
	;-------------------------------
_profTRANSout:
	
	ldi	r23,2		
	sts	0x10f,r23 ;statuscounter
	clr	r20
	sts	0x112,r20	;framecounter ==0
	jmp	_FAILframerBKy

_profTRANSoutX:
	;nun checksumme ber.
	call	_framer_CKsum
	jmp	_TXframerBK
	;


_FAILframerBKy:
	jmp	_FAILframerBK

	
;______________________________________________________________________________________________
;calculate checksumme (SUB)
;wird rein aus den sram gepufferten daten berechnet
;framesize 0xf2
;type
;______________________________________________________________________________________________
	;checksumme (16-bit)wird aus <type/8-bit>*<framesize/8-bit> berechnet !
	;framesize ist immer das 5te byte eines frames
	;type ist das 10te - byte eines frames
	;
_framer_CKsum:
	;zuerst den type nach r17 holen.....	
	clr	r31	
	ldi	r30,9			; type-byte		
	subi	r30,low(-RXbufferST)	;Add low byte ( x -(-y)) = x + y
	sbci	r31,high(-RXbufferST)	;Add high byte with carry
	ld	r17,z
	;dann die framesize nach r20 holen...
	lds	r20,0xf2
	mov	r19,r20
	;
	;jetzt type*framesize...	
	mul	r20,r17
	mov	r20,r0
	mov	r18,r1
	;nun mittels framesize 
	;die checksumme low speichern
	clr	r31
	subi	r19,2				;framesize -2
	mov	r30,r19			;empfangenes checksummen-byte		
	subi	r30,low(-RXbufferST)	;Add low byte ( x -(-y)) = x + y
	sbci	r31,high(-RXbufferST)	;Add high byte with carry
	st	z+,r20			;low-byte
	st	z,r18			;high-byte
	inc	r19			;framesize wieder herstellen
	inc	r19
	ret



;************* read sram sub ****************************************************************
_RDprofi:
	mov	yh,r17
	mov	yl,r21	
	ld	r19,y		; kopiere daten aus sram nach r19
	ret


;--------------------------------------------------------------------------------------------
;----------------- zurck .... --------------------------------------------------------------
;--------------------------------------------------------------------------------------------

_TXframerBK:
	clr	r23
	sts	0x10f,r23	;PROFIcounter reset
	;

	lds	r16,0xef
	inc	r16		;profile counter....
	lds	r22,SEflagVARb
	sbr	r22,1<<newTX
	sts	SEflagVARb,r22
	jmp	_PROFbk
	;
_NXTprofile:
	clr	r23
	sts	0x10f,r23	;PROFIcounter reset
	;
	lds	r16,0xef
	inc	r16		;profile counter....
	jmp	_PROFbk
_PROFout:
	clr	r16
_PROFbk:
	sts	0xef,r16	;store profile counter
_FAILframerBK:
	ret
	