;------------------------------------------------------------------------------------------------
;-------------------------- Static conceptXM1 Boot-Loader --------------------------------------
;------------------------------------------------------------------------------------------------
;
;1.) Der Bootloader startet:
;	 a) nach einem Hardware-Reset und scannt aktives UART nach gltigen Daten
;       Sind nach einer Wartezeit von 5 Sekunden keine ,Flash'-Daten eingetroffen startet 
;       automatisch der Applikationsbereich.
;	 b) nach einem Software-Reset. Ein Software-Reset wird durch entsprechende Typisierung
;       (Type= 252) und Adressierung eines DMA-Frames initiiert.
;
;2.) Das Beschreiben des Flash-Speichers erfolgt in ,Pages'. Eine Page umfasst 128 Words.
;    (16Bit) - Folglich also 256 Bytes. 
;
;3.) Die bertragung einer Page via UART erfolgt in 3 Teilen die nach berprfung deren 
;	 Checksummen zusammengefgt werden. Anschlieend werden die Daten in den Page-Buffer 
;    bertragen und letztlich nach einem Page-Erase in den Flash-Applikationsbereich
;    geschrieben.
;
;4.) Das bertragungsprotokoll entspricht im Grunde dem serCOM-Standard und wird als Braodcast
;    Message verschickt. Das Protokoll enthlt ausser den blichen physikalischen Transfer-
;	 befehlen, den Flash-Page Index, den Flash-Page-Part Index, sowie den eigentlichen
;    Transfercode. 
;
;4.1)Protokoll:
;(sercom-format)
; ______________________________________________________________________________________
;|mi    |ho-tar |sub-tar|ho-sou |sub-sou|frame  |type   |device |page   |page-pa|data   |
;|byte  |adress |adress |adress |adress |size=  |=252   |0=sys  |16bit  |8bit   |86bytes|
;|      |       |       |       |       |102    |       |1=hif  |msb/lsb|       |43word |
;|______|_______|_______|_______|_______|_______|_______|_______|_______|_______|_______|
;
;

_BOOT000entry:
	;disable interrupts
	cli
	;reset vector
	clr	zh
	clr	zl
	ijmp







;--------------------------------------------------------------------------------------------------------
_BOOTback:
	ret

