;.....................................................................
;APPLICATION: {OBJEKT_AP.ASM}
;.....................................................................
;- objektspeicher verwaltung inkl. garbage collector
;-> systemspezifischen eol-wert neuer objekte berechnen
;   ausnahme: eol = 0 bedeutet nur einmalige verarbeitung!
;-> neues objekt in freies segment legen
;	segmentnummer aus indextabelle entfernen =255
;-> zyklische berprfung aller objekte auf aktualitt (eol!)
;-> abgelaufene objekte durch <dataclass>=0 kennzeichnen
;   freie segmentnummer in indextabelle sichern
;-> zyklische bergabe der objektdaten an system gem filterdefinition
;	ausnahme: <Xdata to sys>-wert = 0 (keine automatische bergabe an das system
;.....................................................................
;<FREE_OBJ_INDEX>-table
;.equ	free_obj_index	=	0x7db	;startadresse indextabelle
;.equ	obj_index_limit	=	free_obj_index + 40		;max.40 objekt segmente...
;.equ	obj_table_limit	=	40
;.....................................................................
;.equ	SYSeolL			=	0x7b1	;system eol timer L
;.equ	SYSeolH			=	0x7b2	;   "     "     " H
;.equ	objectCNT		=	0x7b0	;objekt counter
;.equ	objectFLAG		=	0x7bc
;INFO: - SYSeol wird im 10ms takt hochgezhlt
;	   - SYSeol wird bei 65535 auf 0 gesetzt
;	   - Neuer EOL-Wert errechnet sich aus: EOL(empfangen)+SYSeol
;Bsp.: a) SYSeol(25525) + EOL(30000) = EOLneu(55525)
;      b) SYSeol(44000) + EOL(30000) = EOLneu(74000) FEHLER - max.65536!
;         -> 65536-SYSeol(44000)=DIFF(21536)
;		  -> EOL(30000)>DIFF(21536)? 
;         NEIN! EOLneu=SYSeol+EOL
;			JA! EOLneu=EOL-DIFF
;....................................................................	
;FREIGABE VERFALLENER OBJEKTE (EOL berschritten)
;Bsp.: - bis SYSeol(32767) alle Objekte <=SYSeol freigeben
;	   - ab SYSeol(32768) alle Objekte >=SYSeol-32768 freigeben
;.equ	SYSeolSUB	=	32768
;....................................................................

;
;
;............................................................................
;_obj001  BERPRFE AUF NEUES OBJEKT
;............................................................................
_obj001:
	lds	r16,objectFLAG
	sbrs	r16,newOB	;neues objekt im temporren segment
	rjmp	_obj010		;zum garbage collector....
	;.......................................................................		
			
	;objekt in freies speichersegment verlegen
	;system eol counter laden
	lds	zh,SYSeolH	
	lds	zl,SYSeolL
	;objekt-eol adressieren...		
	clr	yh	
	ldi	yl,2						
	subi	yl, low(-dyn_object_TE)	;Add low byte ( x -(-y)) = x + y
	sbci	yh, high(-dyn_object_TE)	;Add high byte with carry
	ld	r17,y+	;eol H
	ld	r16,y	;eol L
	;eol=0???
	;nicht verndern - wird nur einmal verwendet !
	tst	r17
	brne	_obj001go	;>0
	tst	r16
	brne	_obj001go	;>0
	jmp	_obj002
	;................................................................
	;berechne objekt-eol in relation z. system-eol
_obj001go:
	;65535
	ldi	yl,0xff
	ldi	yh,0xff
	;-SYSeol
	sub	yl,zl
	sbc	yh,zh
	;=DIFF(YH|YL)
	;-------------
	;EOL>DIFF?
	cp	r16,yl
	cpc	r17,yh
	brsh	eolMIdif
	;EOLneu=SYSeol+EOL
	add	zl,r16
	adc	zh,r17
	jmp	_obj002
	;EOLneu=eol-DIFF
eolMIdif:
	sub	r16,yl
	sbc	r17,yh
	mov	zl,r16
	mov	zh,r17
	;.................
	;EOLneu sichern
_obj002:
	clr	yh	
	ldi	yl,2						;eol adressieren...		
	subi	yl, low(-dyn_object_TE)	;Add low byte ( x -(-y)) = x + y
	sbci	yh, high(-dyn_object_TE)	;Add high byte with carry
	st	y+,zh	;eol H
	st	y,zl	;eol L
	;b)objekt index table laden
	ldi	zh,high(free_obj_index)
	ldi	zl,low(free_obj_index)
_obj002loop:
	ld	r16,z
	cpi	r16,0xff	;0xff=belegt
	brne	_obj003
	;teste limit
	adiw	zh:zl,1		
	cpi	zl,low(obj_index_limit)	;Compare low byte
	ldi	r17,high(obj_index_limit)	;
	cpc	zh,r17	;Compare high byte
	brsh	_obj002END	;limit errecht == kein freies segment verfgbar !
	jmp	_obj002LOOP	;loop...
	;
_obj002END:
	lds	r16,objectFLAG
	sbr	r16,1<<errOB	;fehler...
	jmp	_obj003ENDx

	;objekt in freies segment kopieren
_obj003:
	;+++++NEW++++++
	mov	r2,zl
	mov	r3,zh
	;index berechnen
	;b)objekt index table laden
	ldi	yh,high(free_obj_index)
	ldi	yl,low(free_obj_index)
	sub	zl,yl
	sbc	zh,yh
	;diff zl/zh
	mov	r16,zl
	mov	r13,zh
	;restore zl/zh
	mov	zl,r2
	mov	zh,r3
	;+++++NEW END ++++

	;freies segment adressieren
	ldi	yh,high(dyn_object_define)
	ldi	yl,low(dyn_object_define)
	;dyn_object_define+(r16*dyn_object_segment)
	ldi	r18,high(dyn_object_segment + 1)
	ldi	r17,low(dyn_object_segment + 1)
	;
	mul	r16, r17		; al * bl
	movw	r15:r14,r1:r0
	mul	r13, r17		; ah * bl
	add	r15, r0
	mul	r18, r16		; bh * al
	add	r15, r0
	;result r15:r14
	;adressiere segment...
	add	yl,r14
	adc	yh,r15
	;index als belegt kennzeichnen
	ldi	r16,0xff	;index belegen
	st	z,r16
	;kopiere objekt in segment...
	ldi	zl,low(dyn_object_TE)	
	ldi	zh,high(dyn_object_TE)
	ldi	r17,dyn_object_segment + 1
	;loop
_obj003LOOP:
	ld	r16,z+
	st	y+,r16
	;limit prfen
	dec	r17
	tst	r17
	breq	_obj003END	;limit errecht == done !
	jmp	_obj003LOOP
	;fertig...
_obj003END:	
	lds	r16,objectFLAG
	cbr	r16,1<<newOB	;bereit f.neues objekt
	cbr	r16,1<<errOB	;kein fehler
_obj003ENDx:
	sts	objectFLAG,r16
	jmp	_obj999			;exit
;
;
;
;
;
;.....................................................................
;garbage collector
;- speichersegmente auf aktualitt (eol) prfen
;- abgelaufene, freie segmente in ,free-table' listen
;.....................................................................
;<CLASS_FILTER_DEFINE>	-> 	beinhaltet:	<data_class>	0...255
;										<client_adr>	0...255
;										<Xdata to sys>  1..5(max.5*8Bit Data)/0=no data to system
;										<sysADR>,<sysADR>...
;......................................................................
;<dyn_object_TE>  	    -> beinhaltet: 	<data_class>	0...255
;										<client_adr>	0...255
;										<eol>			0...65535
;										<Xdata to sys>	1...5(max.5*8Bit Data)/0=no data to system
;										<data>,<data>...
;......................................................................
_obj010:
	;lade index table
	;b)objekt index table laden
	clr	yh	
	lds	yl,objectCNT				;index adressieren...	
	;++++NEW+++++++++
	mov	r2,yl	;save	
	;++++NEW END ++++
	;objekt limit prfen...
	cpi	yl,obj_table_limit
	brlo	_obj010a	;<limit...
	clr	yl
	sts	objectCNT,yl
	jmp	_obj999	;exit...
_obj010a:
	subi	yl,low(-free_obj_index)	;Add low byte ( x -(-y)) = x + y
	sbci	yh,high(-free_obj_index)	;Add high byte with carry
	ld	r16,y
	cpi	r16,0xff	;==belegt?
	breq	_obj011	;ja, also testen ob noch aktuell..
	;nein <=> weiter...
	lds	yl,objectCNT
	inc	yl
	sts	objectCNT,yl
	jmp	_obj999	;exit...
	;
	;eol im zielsegment prfen
_obj011:
	;++++NEW++++++++
	mov	r16,r2	;restore
	;++++NEW END ++++
	;belegtes segment adressieren
	ldi	zh,high(dyn_object_define)
	ldi	zl,low(dyn_object_define)
	;dyn_object_define+(r16*dyn_object_segment) (10bytes / segment)
	ldi	r18,high(dyn_object_segment + 1)
	ldi	r17,low(dyn_object_segment + 1)
	clr	r15
	;
	mul	r16, r17		; al * bl
	movw	r13:r12, r1:r0	;13/12
	mul	r15, r17		; ah * bl
	add	r13, r0
	mul	r18, r16		; bh * al
	add	r13, r0
	;result r13:r12
	;adressiere segment...
	add	zl,r12
	adc	zh,r13	
	;startadresse pushen
	mov		r3,zh
	mov		r2,zl
	;adressiere eol im segment
	adiw	zh:zl,2
	ld	r17,z+	;eol H
	ld	r16,z	;eol L
	;eol=0 <=> nur einmal verwenden, dann lschen!
	tst	r16
	brne	_obj011TEST
	tst	r17
	brne	_obj011TEST
	;eol <=> 0
	;eol = SYSeol ... segment freigeben
	mov		zh,r3
	mov		zl,r2
	jmp	_obj011CLEAR
	;...............................................................
	;
	;
_obj011TEST:
	mov		zh,r3
	mov		zl,r2
	;hole SYSeol...
	lds	r18,SYSeolL
	lds	r19,SYSeolH

;....................................................................	
;FREIGABE VERFALLENER OBJEKTE (EOL berschritten)
;Bsp.: - bis SYSeol(32767) alle Objekte <=SYSeol freigeben
;	   - ab SYSeol(32768) alle Objekte >=SYSeol-32768 freigeben
;.equ	SYSeolSUB	=	32768
;....................................................................
	cpi	r18,low(SYSeolSUB)	;Compare low byte
	ldi	r22,high(SYSeolSUB)	;
	cpc	r19,r22	;Compare high byte
	brsh	_obj011SUBI
	;- syseol < 32768
	;- vergleiche eol|SYSeol
	cp	r16,r18
	cpc	r17,r19
	brsh	_obj011OK	;objekt noch gltig == ausfhren
	jmp	_obj011CLEAR
	;
_obj011SUBI:
	subi	r18,low(SYSeolSUB)
	sbci	r19,high(SYSeolSUB)
	;- vergleiche eol|SYSeol
	cp	r16,r18
	cpc	r17,r19
	brlo	_obj011OK	;objekt noch gltig == ausfhren
;...................................................................
	;OBJEKT AUSFHREN & FREIGEBEN
_obj011CLEAR:
	;EX?
;	jmp	_obj011CLEAR


	push	zh	;segment-adresse (dataclass-adress)
	push	zl	;
	push	yh	;index-table adresse
	push	yl	; "
	call	_obj020SUB	;ausfhren !
	pop		yl
	pop		yh
	pop		zl
	pop		zh
	;korrigiere index-table
	clr	r16	;lds	r16,objectCNT
	st	y,r16	
	;lsche data-class im segment
	;== 0 setzen !
	ldi	r16,0
	st	z,r16
	jmp	_obj999
;..................................................................
	;OBJEKT AUSFHREN & NICHT FREIGEBEN
_obj011OK:
	call	_obj020SUB
	jmp	_obj999




;........................................................................
;SUB - objekt gem. definition(class_filter_define) ausfhren
;........................................................................
;<CLASS_FILTER_DEFINE>	-> 	beinhaltet:	<data_class>	0...255
;										<client_adr>	0...255
;										<Xdata to sys>  1..5(max.5*8Bit Data)/0=no data to system
;										<sysADR16bit>,<sysADR16bit>...
;
;<DYN_OBJECT_DEFINE>	->	beinhaltet:	<data_class>	0...255
;										<client_adr>	0...255
;										<eol16bit>		0...32768
;										<Xdata to sys>	1...5(max.5*8Bit Data)0=no data to system
;										<data>,<data>...
;
_obj020SUB:
	;passende dataclass im filter suchen...
	ldi	yh,high(class_filter_def)
	ldi	yl,low(class_filter_def)
	ld	r16,z	;dataclass aus adressiertem segment laden
_obj021SUB:
	ld	r17,y
	cp	r16,r17
	breq	_obj021SUBb	;dataclass identisch	
	adiw	yh:yl,class_filter_segment						
	jmp	_obj021SUB
_obj021SUBb:
	;automatisch ausfhren ?
	;<Xdata to sys>...
	adiw	yh:yl,2
	ld	r16,y+
	tst	r16				;Xdata to sys = 0
	breq	_obj030SUB	;KEINE automatische ausfhrung!
	;1...5
	;INFO:y-pointer auf systemadresse(MSB)
	;	  x-pointer dataclass im segment (daten)
	adiw	zh:zl,5	;data1  dyn_object_define
_obj021LOOP:
	ld		r17,z+
	mov		r3,zh
	mov		r2,zl
	ld	zh,y+	;msb
	ld	zl,y+	;lsb
	;----------------------------------------------
	;daten wurden netto (ohne komap) definiert
	;-> jetzt +koMAP
	subi	zl,low(-koMAP)
	sbci	zh,high(-koMAP)
	st	z,r17	;daten nach systemadresse...
	;----------------------------------------------
	mov		zh,r3
	mov		zl,r2
	;x-daten ?
	dec	r16
	tst	r16
	breq	_obj030SUB
	jmp	_obj021LOOP
	;....................................................................
	;return f. sub
_obj030SUB:
	ret



;........................................................................
;rcksprung aus modul
;........................................................................
_obj999:
	ret
