;**************************************************************
;REMOTE-modul (dynamisch)
;**************************************************************
;master<->slave remote control
;.............................................................
;variablen:
;remCNT			= ablaufcounter 
;remFLAG		= remote-status-flags 
;remMASTER		= masteradresse (LHA) 
;remSLAVE		= slaveadresse  (LHA) 
;------------------------------------------------------------------
;remote-flags(remFLAG	):
;RTmaster	    =	0	;versetzt modul in mastermode
;RTactivS	    =	1	;versetzt modul in slavemode
;RTon		    =	2	;remotemode (on/off)
;RTactivMstart	=	3	;master remote startet
;
;------------------------------------------------------------------


;START
_remoteENTRY:
	;zuerst entry conditions prfen...
	lds	r19,SEflagVARa		;serial flag variable A laden
	lds	r22,SEflagVARb		; "             "     B
	lds	r16,SEflagVARc		; "             "     C
	;WICHTIG !serielles if enabled ?
	sbrs	r19,SEenabled
	rjmp		_remoteBACKz		;serielle module disabled
	;WICHTIG ! frame aus buffer noch nicht verschickt
	sbrc	r19,TXframe
	rjmp	_remoteBACKz		; "             "            "         "
	;WICHTIG !serielles if noch busy
	sbrc	r19,SEbusy
	rjmp	_remoteBACKz		;aktiver bertragung

	;WICHTIG ! vorbereitung im sercom luft
	sbrc	r22,newTX
	rjmp	_remoteBACKz
	;requestanforderung im sercom luft noch...
	sbrc	r22,reqTX
	rjmp	_remoteBACKz
   	;noch ein twi-job zu erledigen, dann kein neues frame !
    lds     r22,TWIstatus
    sbrc    r22,doTWI 
    rjmp    _remoteBACKz
	;noch aktiv?
	lds	r22,comFLAGspi		;flagvariable laden
	sbrc	r22,spiWORKIN		
	rjmp	_remoteBACKz


;----------------------------------------------------------------------------------------------
	;hier remote conditions prfen
	lds	r16,remCNT
	lds	r17,remFLAG
	;off sequenz starten (aus slave)?
	sbrc	r17,RToff
	rjmp	_remoteOFF			;remote off
	sbrs	r17,RTon			;remote on
	rjmp	_remoteBACK
	;master / slave ?	
	sbrc	r17,RTmaster
	rjmp	_remoteMASTER		;send remote on & master
	jmp	_remoteBACK









;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;mastermode
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;master sendet remote 
;befehl zum slave
_remoteMASTER:
    sbrc    r17,RTactivMstart
    rjmp    _remoteMASTERsend
    jmp	_remoteBACK


_remoteMASTERsend:
    cbr     r17,1<<RTactivMstart
	;build master-remote instruction
    ;setup mode
    clr r22
    sbr r22,1<<RFsetup
	ldi	zl,low(TXbufferST)	
	ldi	zh,high(TXbufferST)	
    st  z+,r22
    ;store remote slave adress
    lds r22,REMslave
    st  z,r22
    ;frame size
    adiw    zh:zl,4
    ldi r22,7
    st  z+,r22
    ;type = master remote on
    ldi r22,10
    st  z,r22
    ;start tranmitting
    lds	r22,SEflagVARa		;serial flag variable A laden
    sbr r22,1<<TXframe
    sts SEflagVARa,r22
	jmp	_remoteBACK





;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~--------------------------------------------------------------------------------
;remote off 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~--------------------------------------------------------------------------------
_remoteOFF:
	cpi	r16,10
	brne	_remoteOFFtoIIMSRT
    ;slave sends remote off
	rjmp	_remoteOFFtoMSRT

_remoteOFFtoIIMSRT:
    cpi r16,20
    brne   _remoteOFFtoSYS
    rjmp   _remoteOFFtoMSRTIIgo 

_remoteOFFtoSYS:
	cpi	r16,200
	brne	_remoteBACK
    rjmp    _remoteOFFtoMSRTIIgo


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~--------------------------------------------------------------------------------
;remote off (durch slave) // nur bei RToff=1
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~--------------------------------------------------------------------------------


_remoteOFFtoMSRT:
    lds r22,remWTloop               ;delay... default=100
    dec r22
    tst r22
    breq  _remoteOFFtoMSRTgo        ;first level
    sts remWTloop,r22
    rjmp _remoteBACK



    ;.........................
    ;first level
    ;=> tx remote off to hif
    ;& further to master
    ;.........................
_remoteOFFtoMSRTgo:
    ldi r22,200
    sts  remWTloop,r22
    ;second level
    ldi r22,20
    sts remCNT,r22
	;build off-remote instruction
    ;setup mode
    clr r22
    sbr r22,1<<RFsetup
	ldi	zl,low(TXbufferST)	
	ldi	zh,high(TXbufferST)	
    st  z,r22
    ;store remote master adress
    adiw    zh:zl,3
    lds r22,REMmaster
    st  z,r22
    ;frame size
    adiw    zh:zl,2
    ldi r22,7
    st  z+,r22
    ;type = remote off
    ldi r22,11
    st  z,r22
    ;start tranmitting
    lds	r22,SEflagVARa		;serial flag variable A laden
    sbr r22,1<<TXframe
    sts SEflagVARa,r22
	;remote glob flags
	clr	r16
	sts	remTEfl,r16		;lokale remflags
	rjmp _remoteBACK


    ;.........................
    ;second level
    ;=> tx remote off to hif
    ;& further to master
    ;.........................
_remoteOFFtoMSRTIIgo:
  lds r22,remWTloop                         ;delay... default=100
    dec r22
    tst r22
    breq  _remoteOFFtoMSRTIIfinish          ;second level
    sts remWTloop,r22
    rjmp _remoteBACK


_remoteOFFtoMSRTIIfinish:
   	;prozPSC=1
	;progPSC=0
	ldi	r16,1	
	sts	prozPSC,r16
	clr	r16
	sts	progPSC,r16
	;ausfhren
	clr	r16
	sbr	r16,1<<exeSPIdata
	sbr	r16,1<<spiMready
	sts	comFLAGspi,r16
    ;off state=0
    clr r17
    sts remCNT,r17
    rjmp _remoteBACK



;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~-------------------------------------------------------------------------
;HOME
;----------------------------------------------------------------------------------------------------------------------
_remoteBACK:
	sts	remFLAG,r17
_remoteBACKz:
	ret



