;--------------------------------------------------------------------------------------------
;----------- adc-converter  -----------------------------------------------------------------
;--------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------
;folgende adc-kanle werden 
;adc3(pf3) == analogD 
;adc2(pf2) == analogC
;adc1(pf1) == analogB
;adc0(pf0) == analogA
;
;--------------------------------------------------------------------------------------------
_adcLOOP:
	;
	in		r16,adcsr
	sbrc	r16,adsc		;1==until conv is ready !
	rjmp	_adcBACK
	;
	;work with actually 8-bit data...(right adjusted !!!)
	in	r16,adcl		;adcl = lower nibble
	in	r18,adch		;mu gelesen werden !!!
	;bk 16bit full-size
	mov	zl,r16
	mov	zh,r18
	;/2 for 8bit work !
	lsr	r18
	ror	r16
	clc
	;nur mux 0...7 zeigen !
	in	r17,admux	;TEST lds	r17,cntLOOP		;adc-mux
	andi r17,0b00000111
	;
	;analogD(pf3)
	cpi	r17,3
	brne	_adcC
	ldi	r17,2
	sts	ADCpD,r16		;speichern und fertig !!!
	;--------------------
	;*5
	;val= ((Vin*1024)/Vref)*5
	clr	yh
	ldi	yl,5
	mul	zl, yl	
	movw	r7:r6, r1:r0
	mul	zh, yl		
	add	r7, r0
	mul	yh, zl	
	add	r7, r0
	;result r6/r7
	mov	zl,r6
	mov	zh,r7
	;store to 16bit var
	sts	ADC16_4H,zh
	sts	ADC16_4L,zl
	;--------------------
	jmp	_selCH
	;
	;analogC(pf2)
_adcC:
	cpi	r17,2
	brne	_adcB
	ldi	r17,1
	sts	ADCpC,r16		;speichern und fertig !!!
	;--------------------
	;*5
	;val= ((Vin*1024)/Vref)*5
	clr	yh
	ldi	yl,5
	mul	zl, yl	
	movw	r7:r6, r1:r0
	mul	zh, yl		
	add	r7, r0
	mul	yh, zl	
	add	r7, r0
	;result r6/r7
	mov	zl,r6
	mov	zh,r7
	;store to 16bit var
	sts	ADC16_3H,zh
	sts	ADC16_3L,zl
	;--------------------
	jmp	_selCH
	;
	;analogB(pf1)
_adcB:
	cpi	r17,1
	brne	_adcA
	sts	ADCpB,r16		;speichern und fertig !!!
	;--------------------
	;*5
	;val= ((Vin*1024)/Vref)*5
	clr	yh
	ldi	yl,5
	mul	zl, yl	
	movw	r7:r6, r1:r0
	mul	zh, yl		
	add	r7, r0
	mul	yh, zl	
	add	r7, r0
	;result r6/r7
	mov	zl,r6
	mov	zh,r7
	;store to 16bit var
	sts	ADC16_2H,zh
	sts	ADC16_2L,zl
	;--------------------
	ldi	r17,0
	jmp	_selCH
	;
	;analogA(pf0)
_adcA:
	tst	r17
	brne	_adcBACK
	sts	ADCpA,r16		;speichern und fertig !!!
	;--------------------
	;*5
	;val= ((Vin*1024)/Vref)*5
	clr	yh
	ldi	yl,5
	mul	zl, yl	
	movw	r7:r6, r1:r0
	mul	zh, yl		
	add	r7, r0
	mul	yh, zl	
	add	r7, r0
	;result r6/r7
	mov	zl,r6
	mov	zh,r7
	;store to 16bit var
	sts	ADC16_1H,zh
	sts	ADC16_1L,zl
	;--------------------
	ldi	r17,3
	jmp	_selCH

;----------------------------------------------------------------------------------------------
	;new mux-channel & start conversation
_selCH:
	;neuen mux wert setzen
	in	r18,admux
	andi	r18,0b11111000
	or	r18,r17
	out	admux,r18	
	nop
	in	r16,adcsr
	sbr	r16,1<<adsc		;start conversation	
	out	adcsr,r16
	jmp	_adcBACK
;----------------------------------------------------------------------------------------------
_adcBACK:
;	ret

	;-------------------------------------------------------------------
	;FOR THE FUTURE !
	;now store adc-values via crosstable (defined in prog16obSEC-modul)
	ldi	r18,4
	;start with HIGH adress nibble
	ldi	zl,low(ADC16_SA1H)
	ldi	zh,high(ADC16_SA1H)
	;start with HIGH adc para nibble
	ldi	yl,low(ADC16_1H)
	ldi	yh,high(ADC16_1H)
	;
_adcBACKa:
	tst	r18
	breq	_adcBACKgo
	ld	r17,z+	;MSB adress
	ld	r16,z+	;LSB adress
	ld	r19,y+	;para HIGH-nibble
	push	zl
	push	zh
	mov	zl,r16
	mov	zh,r17
	st	z+,r19	;store to sensoric section  MSB 
	ld	r19,y+	;para LOW-nibble
	st	z,r19	;store to sensorich section LSB
	pop	zh
	pop	zl
	dec	r18
	rjmp	_adcBACKa	
	;ready...
_adcBACKgo:
	ret
