;-----------------------------------------------------------------
;dcf77 decoder / call 222s
;-----------------------------------------------------------------

;variablen:
;.equ	time1msFL		=	0x224	;1ms timer-flags (im timeslot-modul gesetzt)
;.equ	dcf77_psc		=	0x225	;status-counter
;.equ	dcf77_status	=	0x226	;statusflags


;.equ	dcf77_levCTlow	=	0x227	;dcf77 level counter (16bit)100ms=low/200ms=high
;.equ	dcf77_levCThigh	=	0x228	;dcf77 level counter (16bit)100ms=low/200ms=high


;.equ	dcf77_sekunde	=	0x229	;dcf77 sekunde 0-59(60)
;.equ	dcf77_minunte	=	0x22a	;dcf77 minute 0-59
;.equ	dcf77_stunde	=	0x22b	;dcf77 stunde 0-23
;.equ	dcf77_tag		=	0x22c	;dcf77 kalendertag 1-31
;.equ	dcf77_Wtag		=	0x22d	;dcf77 wochentag 1-7
;.equ	dcf77_mon		=	0x22e	;dcf77 monat
;.equ	dcf77_jahr		=	0x22f	;dcf77 jahr



;flags:
;.equ	dcf77sync		=	0	;sync-flag - dieses flag sperrt die interne rtc !!!!!
;.equ	dcf77level		=	1	;last-level-flag
;.equ	dcf77high		=	3	;high-impuls
;.equ	dcf77sumST		=	5	;start-sommerzeit
;.equ	dcf77mesz		=	6	;sommerzeit mez+1
;.equ	dcf77schalt		=	7	;schaltsekunde
;
;input-pin pd7 (high.aktiv!)
;
;------------------------------------------------------------------

_dcfENTRY:
	;call-intervall 222s
	lds	r17,dcf77_status
	lds	r18,dcf77_psc
    ;check dcf enable
    sbrc    r17,dcf77ena 
    rjmp	_dcfBACK        ;don't use dcf77 !!!
	;prfe status
	tst	r18
	brne	_dcf001
	;status 0
	sbic	pind,pind7	;port-pin...
	rjmp	_dcfSIG
	;kein signal...
    ;sync sign - 
	ldi	r17,0x2d	;-
	sts	dcfASCII,r17
	clr	r17	;flags lschen
	clr	r18	;status counter =0
	rjmp	_dcfBACK

	;start-high-flanke erkannt
_dcfSIG:  
    ;try to sync sign ! 
	ldi	r18,0x21	;!
	sts	dcfASCII,r18
	;status 1
	ldi	r18,1
	;level-flag setzen
	sbr	r17,1<<dcf77level	;high-level
	;counter lschen
	clr	r20
	sts	dcf77_levCThigh,r20
	sts	dcf77_levCTlow,r20
	;
	rjmp	_dcfBACK






		;.............................................
				;signal check
	_dcf002X:
		rjmp	_dcf002
		
			_dcf001:
				cpi	r18,1
				brne	_dcf002X
				;
				sbic	pind,pind7
				rjmp	_dcf001HIGHcheck
				;prfe ob low-flanke erreicht
				sbrc	r17,dcf77level
				rjmp	_dcf001lowEDGE	;high->low flanke erkannt
				rjmp	_dcf001lowLEVEL	;low level stabil
				;high pegel
			_dcf001HIGHcheck:
				sbrc	r17,dcf77level
				rjmp	_dcf001highLEVEL	;high level stabil
				rjmp	_dcf001highEDGE	;low->high flanke erkannt
				;
				;
				;
				;
				;.............................................
				;
				;
				;
				;			    ___
				;bei high->low flanke    |____
				;a) counter prfen 100ms/200ms
		_dcf001lowEDGE:
				cbr	r17,1<<dcf77level	;nun level flag low
				;
				;counter laden
				lds	r19,dcf77_levCTlow	
				lds	r20,dcf77_levCThigh
				;prfe 200ms (high)
				mov	r21,r19
				mov	r22,r20
				cpi	r21,low(ko180dcf)	;Compare low byte
				ldi	r23,high(ko180dcf)	;
				cpc	r22,r23	;Compare high byte
				brlo	_dcf001dcfLOW
				;setze dcf77HIGH
				sbr	r17,1<<dcf77high
				rjmp	_ADDdcfCT	;nun counter +1
		_dcf001dcfLOW:
				;prfe 100ms (low)
				mov	r21,r19
				mov	r22,r20
				cpi	r21,low(ko80dcf)	;Compare low byte
				ldi	r23,high(ko80dcf)	;
				cpc	r22,r23	;Compare high byte
				brlo	_dcf001dcfERRORx
				;lsche dcf77HIGH == LOW
				cbr	r17,1<<dcf77high
				rjmp	_ADDdcfCT	;nun counter +1
_dcf001dcfERRORx:
	rjmp	_dcf001dcfERROR				;

				;
				;
				;
				;...........................................
				;
				;
				;
				;
				;bei stabilem low level  ______
				;a)counter prfen: 999ms & dcfSYNC = sekunde+1
				;b)counter+1
 				;
		_dcf001lowLEVEL:
				;counter laden
				lds	r19,dcf77_levCTlow	
				lds	r20,dcf77_levCThigh
				;prfe 999ms (low)
				mov	r21,r19
				mov	r22,r20
				cpi	r21,low(ko999dcf)	;Compare low byte
				ldi	r23,high(ko999dcf)	;
				cpc	r22,r23	;Compare high byte
				brne	_ADDdcfCTx	;nun counter +1
				;prfe dcfSYNC
				sbrs	r17,dcf77sync
				rjmp	_ADDdcfCTx	;nun counter +1
				;sekunde+1
				lds	r20,dcf77_sekunde
				inc	r20
				sts	dcf77_sekunde,r20
				sts	sekunS,r20	;rtc...
		;..........................................
		;events neu
		ldi	r23,3
		sts	eventTE,r23			;sekunden event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
				;hier sekunden rtc-flag setzen (wichtig fr rtc & timer steuerung)
				lds	r23,time1msFL
				sbr	r23,1<<dcf1_s
				sts	time1msFL,r23
				rjmp	_adddcfCTx	;nun counter +1
;far jmp
_ADDdcfCTx:
	rjmp	_ADDdcfCT
				;
				;
				;
				;
				;...................................
				;
				;
				;
				;                           ______
				;bei low->high flanke _____|
				;a) counter prfen: >=2000ms =dcfSYNC & sekunde =0
				;b)                 >=1000ms =sekunde+1 (nur wenn dcfSYNC)
				;c) anschlieend counter =0
				;
		_dcf001highEDGE:
				sbr	r17,1<<dcf77level	;nun level flag high
				;		
				;counter laden
				lds	r19,dcf77_levCTlow	
				lds	r20,dcf77_levCThigh
				;prfe 2000ms (sync)
				mov	r21,r19
				mov	r22,r20
				cpi	r21,low(ko2000dcf)	;Compare low byte
				ldi	r23,high(ko2000dcf)	;
				cpc	r22,r23	;Compare high byte
				brlo	_dcf001highNOsync	
				;sync flag setzen
				;sbr	r17,1<<dcf77sync ;weiter unten ausfhren...
				;sekunde =0
				clr	r20
				sts	dcf77_sekunde,r20
				sts	sekunS,r20	;rtc...	
		_dcfSYNCdis:
				rjmp	_cleardcfCTdecST	;counter lschen & decodieren
		_dcf001highNOsync:
				sbrc	r17,dcf77sync
				rjmp	_dcf001highsync
				rjmp	_cleardcfCT		;counter lschen
				;sekunde +1
		_dcf001highsync:
				lds	r20,dcf77_sekunde
				cpi	r20,60
				brsh	_dcf001freezeSEK
				inc	r20
		_dcf001stSEK:
				sts	dcf77_sekunde,r20
				sts	sekunS,r20		;rtc...
				rjmp	_cleardcfCTdec 	;counter lschen & decodieren
				;
 				;
		_dcf001freezeSEK:
				ldi	r20,59
				jmp	_dcf001stSEK
				;
				;
				;................................
				;
				;                       _______
				;bei stabilem high level 
				;a)counter timeout > 300ms = clear dcfSYNC
				;b)counter +1
		_dcf001highLEVEL:
				;counter laden
				lds	r19,dcf77_levCTlow	
				lds	r20,dcf77_levCThigh
				;prfe 300ms (timeout)
				mov	r21,r19
				mov	r22,r20
				cpi	r21,low(ko300dcf)	;Compare low byte
				ldi	r23,high(ko300dcf)	;
				cpc	r22,r23	;Compare high byte
				brsh	_dcf001highTI				
				rjmp	_adddcfCT		;counter +1
				;timeout
				;dcfSYNC clear
		_dcf001highTI:
				rjmp	_dcf001dcfERROR	
			




;......................................
;_dcf001dcfERROR / high impuls zu kurz
;......................................
_dcf001dcfERROR:
	sbrs	r17,dcf77sync
	rjmp	_adddcfCT
	;nicht mehr sync...
_dcfNOerrDIS:
	cbr	r17,1<<dcf77sync
	rjmp	_adddcfCT
	
;..............................
;_adddcfCT
;..............................
_adddcfCT:
	;counter laden
	lds	yl,dcf77_levCTlow	
	lds	yh,dcf77_levCThigh
	adiw	yh:yl,1
	;counter +1 sichern
	sts	dcf77_levCTlow,yl
	sts	dcf77_levCThigh,yh
	;und zurck...
	rjmp	_dcfBACK


;...................................
;_cleardcfCT  / counter =0 & zurck
;...................................
_cleardcfCT:
	clr	r19
	;counter =0 sichern
	sts	dcf77_levCTlow,r19
	sts	dcf77_levCThigh,r19
	;und zurck...
	rjmp	_dcfBACK

;..........................................
;_cleardcfCTdec  /  counter =0 & decodieren
;..........................................
_cleardcfCTdec:
	;counter =0 sichern
	clr	r19
	sts	dcf77_levCTlow,r19
	sts	dcf77_levCThigh,r19
	;und decodieren...
	;
		;..........................................
		;events neu
		ldi	r23,3
		sts	eventTE,r23			;sekunden event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	;hier sekunden rtc-flag setzen (wichtig fr rtc & timer steuerung)
	lds	r23,time1msFL
	sbr	r23,1<<dcf1_s
	sts	time1msFL,r23
	rjmp	_dcf003	;decodieren....


;......................................................
;_cleardcfCTdecST  /  counter =0 & parameter speichern
;                                & event-flags setzen
;......................................................
_cleardcfCTdecST:
	;counter =0 sichern
	clr	r19
	sts	dcf77_levCTlow,r19
	sts	dcf77_levCThigh,r19
	;
	;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	;+1x pro minute ->hier nun die entsprechenden event-flags setzen        +
	;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	;
	;hier sekunden&minuten-event-flag setzen	
		;..........................................
		;events neu
		ldi	r23,3
		sts	eventTE,r23			;sekunden event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
		;..........................................
		;events neu
		ldi	r23,4
		sts	eventTE,r23			;minute event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	;
	;hier sekunden rtc-flag setzen (wichtig fr rtc & timer steuerung)
	lds	r23,time1msFL
	sbr	r23,1<<dcf1_s
	sts	time1msFL,r23
	;
	;hier stunden-event-flag zur minute=0 setzen
	lds	r18,dcf77_minute	;dcf77 minute -> system minute
	tst	r18
	brne	_dcfNOevent
		;..........................................
		;events neu
		ldi	r23,5
		sts	eventTE,r23			;stunde event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	;hier tage-event-flag zur stunde=0 setzen
	lds	r18,dcf77_stunde
	tst	r18
	brne	_dcfNOevent
		;..........................................
		;events neu
		ldi	r23,6
		sts	eventTE,r23			;tag event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	;hier monat-event-flag zum tag=1 setzen
	lds	r18,dcf77_tag
	cpi	r18,1
	brne	_dcfNOevent
		;..........................................
		;events neu
		ldi	r23,7
		sts	eventTE,r23			;monat event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................	
	;hier jahres-event-flag zum monat=1 setzen
	lds	r18,dcf77_monat
	cpi	r18,1
	brne	_dcfNOevent
		;..........................................
		;events neu
		ldi	r23,8
		sts	eventTE,r23			;jahr event setzen
		call	_MAKEeventSUB	;submodul !
		;..........................................
	;
_dcfNOevent:
	sbrc	r17,dcf77sync
	rjmp	_dcfPARAstore
	sbr	r17,1<<dcf77sync
	rjmp	_dcfPARAback
_dcfPARAstore:
	;hier nun aktuelle dcf77-daten
	;an rtc bergeben !!!!
	lds	r18,dcf77_sekunde	;dcf77 sekunde -> system sekunde
	sts	sekunS,r18
	lds	r18,dcf77_minute	;dcf77 minute -> system minute
	sts	minutS,r18
	lds	r18,dcf77_stunde	;dcf77 stunde -> system stunde
	sts	stundS,r18
	lds	r18,dcf77_tag	;dcf77 tag -> system tag
	sts	tageS,r18
	lds	r18,dcf77_monat	;dcf77 monat -> system monat
	sts	monatS,r18
	lds	r18,dcf77_jahr	;dcf77 jahr -> system jahr
	sts	jahrS,r18
	;
	;starte kalender (lcd-darstellung !)
	lds	r18,dateVAR
	sbr	r18,1<<kalender
	sts	dateVAR,r18
    ;rtc updated...
    ;disable dcf...
    sbr    r17,1<<dcf77ena
    cbr	   r17,1<<dcf77sync
    ;sync sign +
	ldi	r18,0x2b
	sts	dcfASCII,r18	;+	
    ;state =0
    clr    r18
	rjmp	_dcfBACK




	;zurck
_dcfPARAback:
	ldi	r18,1
	rjmp	_dcfBACK







			;.................................................
			;pro sekunde in abhngigkeit des sync-zustandes
			;und der sekunde decodieren !
			;.................................................


_dcf003nodecX:
	rjmp	_dcf003nodec
_checkMONTHX:
	rjmp	_checkMONTH
_checkWdayX:	
	rjmp	_checkWday
_checkDAYX:
	rjmp	_checkDAY
_checkHOURX:
	rjmp	_checkHOUR
_checkMINX:
	rjmp	_checkMIN



			_dcf003:
				;luft synchron !!!
				;nun decodieren....
				lds	r20,dcf77_sekunde
				;wichtig !!!
				subi	r20,1	;bezieht sich auf die letzte sekunde !!!
				cpi	r20,15	;alles bis 14 nicht relevant !!!
				brlo	_dcf003nodecX
				breq	_reserveTX	;prfe reservesender in betrieb 
				cpi	r20,16
				breq	_summertime	;prfe ankndigung sommerzeit 
				cpi	r20,17
				breq	_timezoneA	;prfe zeitzone1
				cpi	r20,18
				breq	_timezoneB	;prfe zeitzone2
				cpi	r20,19
				breq	_schaltsec	;prfe schaltsekunde
				cpi	r20,50
				brsh	_checkYEAR	;prfe jahr
				cpi	r20,45
				brsh	_checkMONTHX;prfe monat
				cpi	r20,42
				brsh	_checkWdayX	;prfe wochentag
				cpi	r20,36
				brsh	_checkDAYX	;prfe tag
				cpi	r20,29	
				brsh	_checkHOURX	;prfe stunde
				cpi	r20,21
				brsh	_checkMINX	;prfe minute							
				rjmp	_dcf003nodec

;rervesender	
_reserveTX:	
	;z.zt keine auswertung
	rjmp	_dcf003nodec
	

			
		;start-sommerzeit
		_summertime:
			sbrc	r17,dcf77HIGH
			sbr	r17,1<<dcf77sumST
			rjmp	_dcf003nodec
	
	
			;sommerzeit mez+1 (mesz)
			_timezoneA:
				sbrc	r17,dcf77HIGH
				sbr	r17,1<<dcf77mesz	;sommerzeit
				rjmp	_dcf003nodec
				
						;winter(normal)zeit (mez)
						_timezoneB:
							sbrc	r17,dcf77HIGH
							cbr	r17,1<<dcf77mesz	;sommerzeit
							rjmp	_dcf003nodec
			
				

								;schaltsekunde sec+1
								_schaltsec:
									sbrc	r17,dcf77HIGH
									sbr	r17,1<<dcf77schalt	;schaltsekunde
									rjmp	_dcf003nodec



;.................................
;jahr
_checkYEAR:
	lds	r19,dcf77_jahr
	cpi	r20,50
	brne	_checkYEARa
	;jahr =0
	clr	r19
	sts	dcf77_jahr,r19
	;
_checkYEARa:
	cpi	r20,58
	brsh	_dcf003nodecX	;out of range...
	;
	sbrs	r17,dcf77HIGH
	rjmp	_dcf003nodec
	rcall	_addtable
	lds	r3,dcf77_jahr
	add	r3,r2
	sts	dcf77_jahr,r3
	rjmp	_dcf003nodec






;..................................
;monat

_checkMONTH:
	lds	r19,dcf77_monat
	cpi	r20,45
	brne	_checkMONTHa
	;monat =0
	clr	r19
	sts	dcf77_monat,r19
	;
_checkMONTHa:
	;
	sbrs	r17,dcf77HIGH
	rjmp	_dcf003nodec
	rcall	_addtable
	lds	r3,dcf77_monat
	add	r3,r2
	sts	dcf77_monat,r3
	rjmp	_dcf003nodec


;......................................
;wochentag


_checkWday:
	lds	r19,dcf77_Wtag
	cpi	r20,42
	brne	_checkWdaya
	;wochentag =0
	clr	r19
	sts	dcf77_Wtag,r19
	;
_checkWdaya:
	sbrs	r17,dcf77HIGH
	rjmp	_dcf003nodec
	rcall	_addtable
	lds	r3,dcf77_Wtag
	add	r3,r2
	sts	dcf77_Wtag,r3
	rjmp	_dcf003nodec


;...................................
;tag
_checkDAY:
	lds	r19,dcf77_tag
	cpi	r20,36
	brne	_checkDAYa
	;jahr =0
	clr	r19
	sts	dcf77_tag,r19
	;
_checkDAYa:
	sbrs	r17,dcf77HIGH
	rjmp	_dcf003nodec
	rcall	_addtable
	lds	r3,dcf77_tag
	add	r3,r2
	sts	dcf77_tag,r3
	rjmp	_dcf003nodec




;...........................................
;stunde

_checkHOUR:
	lds	r19,dcf77_stunde
	cpi	r20,29
	brne	_checkHOURa
	;stunde =0
	clr	r19
	sts	dcf77_stunde,r19
	;
_checkHOURa:
	sbrs	r17,dcf77HIGH
	rjmp	_dcf003nodec
	rcall	_addtable
	lds	r3,dcf77_stunde
	add	r3,r2
	sts	dcf77_stunde,r3
	rjmp	_dcf003nodec


;............................................
;minute

_checkMIN:
	lds	r19,dcf77_minute
	cpi	r20,21
	brne	_checkMINa
	;minute =0
	clr	r19
	sts	dcf77_minute,r19
	;
_checkMINa:
	sbrs	r17,dcf77HIGH
	rjmp	_dcf003nodec
	rcall	_addtable
	lds	r3,dcf77_minute
	add	r3,r2
	sts	dcf77_minute,r3
	rjmp	_dcf003nodec
			
	_dcf003nodec:
		rjmp	_dcfBACK

;..........................................................

_dcf002:
	;status =0
	clr	r18
	rjmp	_dcfBACK


;**************
;* sub's      *
;**************


;...................................................
;tabellenwert holen
;...................................................


	;+X
_addtable:
	clr	r3
	ldi	zh,high(_dcftable*2)
	ldi	zl,low(_dcftable*2)
	subi	r20,21	;tabellenkorrektur
	add	zl,r20
	adc	zh,r3
	lpm	
	mov	r2,r0
	ret
;.................................................................



;und tschss
_dcfBACK:
	sts	dcf77_status,r17
	sts	dcf77_psc,r18
	ret


