;--------------------------------------------------------------------------------------------
;device_driver_modul 
;--------------------------------------------------------------------------------------------
;----------Zyklische Abarbeitung durch 111s interrupt Aufruf -------------------------------
;--------------------------------------------------------------------------------------------
;ab MultiNET0_5 8*Devices/Kat
;intervall entfallen !
;.............................................................................................
;* ,aktivierung-byte'-Info-Tabelle :
; _______________________________________
;|    |    |    |    |    |    |    |    |
;|bit7|bit6|bit5|bit4|bit3|bit2|bit1|bit0|
;|____|____|____|____|____|____|____|____|
;|execute bit's |Dev-bit's     |category |
;|-> portx.0-7  |-> 0-7        |-> 0-3   |
;|______________|______________|_________|
;
;
;Definition ,execute-bit':  frei zuweisbare port-pin's (nicht mehrfach belegbar!)
;
;Definition ,device-bit':   auswahl einer innerhalb ,category' maximal 8 x vorhandenen funktionsart   
;
;Definition ,category-bit': auswahl einer funktionsart 
;
;
;* category/device-tabelle:
;
; category 0:  triggered signal (phasenschnitt..)        	device 0-7		(nur device 0-3 intern !)
;
; category 1:  delayed off				 					device 0-7  	
;
; category 2:  counter compared on/off (rolladen...)	 	device 0-7		(nur device 0-3 intern !)
; ACHTUNG: Funktion bentigt portA als hauptrelaistreiber (automatisch selbe portpinnummer wie standard !)
;
; category 3:  aktuator     on/off      	         		device 0-7		
								


;---------------------------------------------------------------------------------
;--- hauptloop -------------------------------------------------------------------
;---------------------------------------------------------------------------------

_pinDRV:
	;bevor's weitergeht power-on/off-conditions checken !
	lds	r17,PWRflag	;power-flag-register
	sbrs	r17,portON
	rjmp	_pinHOMEXX
	;a)blend posiitonen ins e2prom?
	lds	r20,SstateBLEND
	cpi	r20,0xff
	brne	_pinDRVgo
	;ja!
	call	_BLENDMIrrore2
_pinDRVgo:
	;B)nun category-counter laden...
	lds	r19,PdeviceCNT
	lds	r18,PcatCNT


	tst	r18			;category 0
	breq	_LIGHTz		;.... port-pin triggered signal (...phasenschnitt) WIRD IM HIGH SPEED TRIGGER MODIFIZIERT	

	cpi	r18,1		;category 1
	breq	_DELloopO		;.... delays start

	cpi	r18,2		;category 2 
	breq	_COMPloopO		;.... counter-compare an/aus (rollo...)


	cpi	r18,3		;category 3
	breq	_AKTAloopO		;.... aktuator A an/aus
	jmp	_devHOMEX
	;far jmp
_DELloopO:
	jmp	_DELloopx
_COMPloopO:
	jmp	_COMPloopx
_AKTAloopO:
	jmp	_AKTAloopx
_pinHOMEXX:
	jmp	_pinHOMEX			;zurck zur basis routine <=> timeslot_modul


;----------------------------------------------------------------------------------
;----- lights (pwm) cat0 ----------------------------------------------------------
;----------------------------------------------------------------------------------
_LIGHTz:


	;++++++++++++++TEST+++++++++++++++
;	jmp	_aktDECODE
	;++++++++++++++TEST ENDE++++++++++++++




	;vergleiche alten mit neuem pwm-summenwert
	;<> setzte event
	;== weiter zum pindriver !
	clr	yh
	clr	yl
	clr	r15
	ldi	zl,low(phase1)
	ldi	zh,high(phase1)
_LIGHTzLOOP:
	ld	r14,z+
	cpi		zl,low(phase1 +8)	;Compare low byte
	ldi		r17,high(phase1 +8)	;
	cpc		zh,r17	;Compare high byte
	brsh	_LIGHTzGO	;fertig!
	;add
	add		yl,r14
	adc		yh,r15
	rjmp	_LIGHTzLOOP	;loop !
	;goon
_LIGHTzGO:
	lds		zl,OUTpwmL
	lds		zh,OUTpwmH
	;<>
	cp		zl,r14
	cpc		zh,r15
	breq	_LIGHTzGOON	
	;store 
	sts		OUTpwmL,r14
	sts		OUTpwmH,r15
	;set event
	;----------------------------------------
	;<new-light-state> - event setzen
	ldi		r23,65
	sts		eventTE,r23			;
	call	_MAKEeventSUB		;submodul !
	;----------------------------------------
_LIGHTzGOON:
	jmp		_aktDECODE





;-----------------------------------------------------------------------------------	
;-----------------------------------------------------------------------------------
;---- delayed off (0-255 sek)- loop (basiert auf rtc-werten) -----------------------
;-----------------------------------------------------------------------------------
_DELloopx:			
	lds	r20,sekunS	;aktuelles 1s signal laden
	tst	r19
	breq	_delay0		;delay 0 <=> off
	cpi	r19,1
	breq	_delay1		;delay 1 <=> off
	cpi	r19,2
	breq	_delay2		;delay 2 <=> off
	cpi	r19,3
	breq	_delay3		;delay 3 <=> off
	cpi	r19,4
	breq	_delay4x	;delay 4 <=> off
	cpi	r19,5
	breq	_delay5x	;delay 5 <=> off
	cpi	r19,6
	breq	_delay6x	;delay 6 <=> off
	cpi	r19,7
	breq	_delay7x	;delay 7 <=> off
	jmp		_devHOMEX	;zurck in hauptschleife



_delay4x:
	jmp	_delay4
_delay5x:
	jmp	_delay5
_delay6x:
	jmp	_delay6
_delay7x:
	jmp	_delay7


_delay0:
	lds	r16,delay0		;delay soll 1
	lds	r22,dy0temp		;delay ist  1
	lds	r21,te0sBKup		;1s backup
	call	_DELAYx	
	sts	dy0temp,r22		;sichere istwert
	sts	te0sBKup,r21		;sichere 1s backup
	jmp	_devHOMEX		;return....

_delay1:
	lds	r16,delay1		;delay soll 2
	lds	r22,dy1temp		;delay ist  2
	lds	r21,te1sBKup		;1s backup
	call	_DELAYx
	sts	dy1temp,r22		;sichere istwert
	sts	te1sBKup,r21		;sichere 1s backup
	jmp	_devHOMEX		;return....

_delay2:
	lds	r16,delay2		;delay soll 3
	lds	r22,dy2temp		;delay ist  3
	lds	r21,te2sBKup		;1s backup
	call	_DELAYx	
	sts	dy2temp,r22		;sichere istwert
	sts	te2sBKup,r21		;sichere 1s backup
	jmp	_devHOMEX		;return....

_delay3:
	lds	r16,delay3		;delay soll 4
	lds	r22,dy3temp		;delay ist  4
	lds	r21,te3sBKup		;1s backup
	call	_DELAYx	
	sts	dy3temp,r22		;sichere istwert
	sts	te3sBKup,r21		;sichere 1s backup
	jmp	_devHOMEX		;return....

_delay4:
	lds	r16,delay4		;delay soll 4
	lds	r22,dy4temp		;delay ist  4
	lds	r21,te4sBKup		;1s backup
	call	_DELAYx	
	sts	dy4temp,r22		;sichere istwert
	sts	te4sBKup,r21		;sichere 1s backup
	jmp	_devHOMEX		;return....

_delay5:
	lds	r16,delay5		;delay soll 5
	lds	r22,dy5temp		;delay ist  5
	lds	r21,te5sBKup		;1s backup
	call	_DELAYx
	sts	dy5temp,r22		;sichere istwert
	sts	te5sBKup,r21		;sichere 1s backup
	jmp	_devHOMEX		;return....

_delay6:
	lds	r16,delay6		;delay soll 6
	lds	r22,dy6temp		;delay ist  6
	lds	r21,te6sBKup		;1s backup
	call	_DELAYx	
	sts	dy6temp,r22		;sichere istwert
	sts	te6sBKup,r21		;sichere 1s backup
	jmp	_devHOMEX		;return....

_delay7:
	lds	r16,delay7		;delay soll 7
	lds	r22,dy7temp		;delay ist  7
	lds	r21,te7sBKup		;1s backup
	call	_DELAYx	
	sts	dy7temp,r22		;sichere istwert
	sts	te7sBKup,r21		;sichere 1s backup
	jmp	_devHOMEX		;return....





;--------------------------------------------------------------------------------------------
_DELAYx:
;##aktueller 1s trigger ?	
	cp	r20,r21			;real-sekunden / sekunden bkUP
	brne	_DELopYY		;zhlerstnde nicht gleich .... aktualisieren !	
	cbr	tiFLAG,1<<s1s
	jmp	_DELopYX		;gleich <=> nix neues - zurck !
_DELopYY:
	mov	r21,r20			;1s backup aktualisieren
	sbr	tiFLAG,1<<s1s		;1s flag setzen
;##soll/ist vergleich
_DELopYX:
	cp	r22,r16			;ist/soll-vergleich
	brsh	_dOFFpinx		;== gleich 		
	sbrc	tiFLAG,s1s
	inc	r22			;alle 1s ist der zhler zu erhhen
	;lade OUTdelFL
	lds	zl,OUTdelFL
	call	_ONdevx		;set device flag
	;sichere OUTdelFL
	rjmp	_dDELback
	;
_dOFFpinx:
	mov	r22,r16			;ist=soll
	;lade OUTdelFL
	lds	zl,OUTdelFL
	call	_OFFdevx	;clear device flag
_dDELback:
	;sichere OUTdelFL
	sts	OUTdelFL,zl
	;vergleiche alten delay-status mit neuem status...
	;== zurck
	;<> setze new delay-event
	lds		zh,OUTdelFLold
	cp		zl,zh	;alt == neu?
	breq	_dDELbackZ
	;alt upgedated
	sts		OUTdelFLold,zl
	;----------------------------------------
	;<new-delay-state> - event setzen
	ldi		r23,80
	sts		eventTE,r23			;
	call	_MAKEeventSUB		;submodul !
	;----------------------------------------
_dDELbackZ:
	ret





;-----------------------------------------------------------------------------------
;--- aktuatoren  ansteuern ---------------------------------------------------------
;-----------------------------------------------------------------------------------

_AKTAloopx:
	lds	zl,OUTaktFL
	cpi	r19,0
	brne	_AKTAloopxA
	jmp		_akta0		;aktiv 0
_AKTAloopxA:
	cpi	r19,1
	brne	_AKTAloopxB	
	jmp		_akta1		;aktiv 1
_AKTAloopxB:
	cpi	r19,2
	brne	_AKTAloopxC
	jmp		_akta2		;aktiv 2
_AKTAloopxC:
	cpi	r19,3
	brne	_AKTAloopxD
	jmp		_akta3		;aktiv 3
_AKTAloopxD:
	cpi	r19,4
	brne	_AKTAloopxE	
	jmp		_akta4		;aktiv 4
_AKTAloopxE:
	cpi	r19,5
	brne	_AKTAloopxF
	jmp		_akta5		;aktiv 5
_AKTAloopxF:
	cpi	r19,6
	brne	_AKTAloopxG
	jmp		_akta6		;aktiv 6
_AKTAloopxG:
	cpi	r19,7
	brne	_AKTAloopxH
	jmp		_akta7		;aktiv 7
_AKTAloopxH:
	jmp	_devHOMEX		;zurck in hauptschleife

_akta0:
	lds	r18,Akdi0 	;variable laden
	cpi	r18,0
	breq	_aka0
	call	_ONdevx		;device 0 
	jmp	_aktax
_aka0:
	call   _OFFdevx
	jmp	_aktax	

_akta1:
	lds	r18,Akdi1 	;variable laden
	cpi	r18,0
	breq	_aka1
	call	_ONdevx		;device 1
	jmp	_aktax
_aka1:
	call   _OFFdevx
	jmp	_aktax

	
_akta2:
	lds	r18,Akdi2 	;variable laden
	cpi	r18,0
	breq	_aka2
	call	_ONdevx		;device 2 
	jmp	_aktax
_aka2:
	call   _OFFdevx
	jmp	_aktax

;	
_akta3:
	lds	r18,Akdi3 	;variable laden
	cpi	r18,0
	breq	_aka3
	call	_ONdevx		 ;device 3
	jmp	_aktax
_aka3:
	call   _OFFdevx
	jmp	_aktax


_akta4:
	lds	r18,Akdi4 	;variable laden
	cpi	r18,0
	breq	_aka4
	call	_ONdevx		;device 4 
	jmp	_aktax
_aka4:
	call   _OFFdevx
	jmp	_aktax
; 	

_akta5:
	lds	r18,Akdi5 	;variable laden
	cpi	r18,0
	breq	_aka5
	call	_ONdevx		;device 5
	jmp	_aktax
_aka5:
	call   _OFFdevx
	jmp	_aktax


_akta6:
	lds	r18,Akdi6 	;variable laden
	cpi	r18,0
	breq	_aka6
	call	_ONdevx		;device 6 
	jmp	_aktax
_aka6:
	call   _OFFdevx
	jmp	_aktax

;	
_akta7:
	lds	r18,Akdi7 	;variable laden
	cpi	r18,0
	breq	_aka7
	call	_ONdevx		 ;device 7
	jmp	_aktax
_aka7:
	call   _OFFdevx
	jmp	_aktax


_aktax:
	sts	OUTaktFL,zl

	;vergleiche alten delay-status mit neuem status...
	;== zurck
	;<> setze new delay-event
	lds		zh,OUTaktFLold
	cp		zl,zh	;alt == neu?
	breq	_dAKTbackZ
	;alt upgedated
	sts		OUTaktFLold,zl
	;----------------------------------------
	;<new-akt-state> - event setzen
	ldi		r23,134
	sts		eventTE,r23			;
	call	_MAKEeventSUB		;submodul !
	;----------------------------------------
_dAKTbackZ:
	jmp	_devHOMEX
	


	

	

;-----------------------------------------------------------------------------------
;--- zhlergesteuerte pinlevel  (soll/ist regelung) --------------------------------
;--- counter compare----------------------------------------------------------------
;-----------------------------------------------------------------------------------


_COMPloopx:				
	sts	tePORTvar,r19	;devicewert nach tePORTvar
	tst	r19
	breq	_COM1x		;compare 1
	cpi	r19,1
	breq	_COM2x		;compare 2
	cpi	r19,2
	breq	_COM3x		;compare 3
	cpi	r19,3
	breq	_COM4x		;compare 4
	cpi	r19,4
	breq	_COM5x		;compare 5
	cpi	r19,5
	breq	_COM6x		;compare 6
	cpi	r19,6
	breq	_COM7x		;compare 7
	cpi	r19,7
	breq	_COM8x		;compare 8

	jmp		_devHOMEX	;zurck in hauptschleife

;far jumps
_COM1x:
	jmp	_COM1
_COM2x:
	jmp	_COM2
_COM3x:
	jmp	_COM3
_COM4x:
	jmp	_COM4
_COM5x:
	jmp	_COM5
_COM6x:
	jmp	_COM6
_COM7x:
	jmp	_COM7
_COM8x:
	jmp	_COM8


	
	
;compare funktion 1 aktivieren
_COM1:
	;soll1
	lds	r16,CpareA			;compare soll 1
	;max
	lds	r22,CmaxA
	;ist
	lds	r18,CpareI1			;compare ist  1	
	;down-time (16bit)
	lds	zh,timeDWhigh		;time-base high SOLL
	lds	zl,timeDWlow		;time-base low  SOLL
	;up-time
	lds	r15,timeUP0high		;time-base high SOLL
	lds	r14,timeUP0low		;time-base low  SOLL
	;temporrer time counter
	lds	r21,TEcounter0H  	;temporrer counter high IST
	lds	r20,TEcounter0L		;temporrer counter low  IST
	;device u/d status-flags
	lds		yl,DEVUDstate
	andi	yl,0b00000001	;nur device0 sichtbar machen....
	;device on/off status-flags
	lds		yh,DEVONstate
	andi	yh,0b00000001	;nur device0 sichtbar machen....
	;protect delay 
	lds		r17,CprotectA
	;soll/ist...
	call	_COMx
	;protect delay sichern
	sts		CprotectA,r17
	;.......................................................
	;modifizierten device u/d-status sichern
	lds		zl,DEVUDstate
	andi	yl,0b00000001
	andi	zl,0b11111110
	or		zl,yl
	sts	DEVUDstate,zl
	;modifizierten device on/off-status sichern
	lds		zl,DEVONstate
	andi	yh,0b00000001
	andi	zl,0b11111110
	or		zl,yh
	sts	DEVONstate,zl
	;.......................................................
	;temporren counter sichern ...
	sts	TEcounter0H,r21	
	sts	TEcounter0L,r20
	;ist sichern....
	sts	CpareI1,r18
_COM1bk:
	jmp	_devHOMEX	;return....		



;compare funktion 2 aktivieren	
_COM2:
	;soll
	lds	r16,CpareB			;compare soll 1
	;max
	lds	r22,CmaxB			;compare max  1
	;ist
	lds	r18,CpareI2			;compare ist  1	
	;down-time (16bit)
	lds	zh,timeDWhigh		;time-base high SOLL
	lds	zl,timeDWlow		;time-base low  SOLL
	;up-time
	lds	r15,timeUP1high		;time-base high SOLL
	lds	r14,timeUP1low		;time-base low  SOLL
	;temporrer time counter
	lds	r21,TEcounter1H  	;temporrer counter high IST
	lds	r20,TEcounter1L		;temporrer counter low  IST
	;device u/d status-flags
	lds		yl,DEVUDstate
	andi	yl,0b00000010	;nur device1 sichtbar machen....
	;device on/off status-flags
	lds		yh,DEVONstate
	andi	yh,0b00000010	;nur device1 sichtbar machen....
	;protect delay 
	lds		r17,CprotectB
	;soll/ist...
	call	_COMx
	;protect delay sichern
	sts		CprotectB,r17
	;.......................................................
	;modifizierten device u/d-status sichern
	lds		zl,DEVUDstate
	andi	yl,0b00000010
	andi	zl,0b11111101
	or		zl,yl
	sts	DEVUDstate,zl
	;modifizierten device on/off-status sichern
	lds		zl,DEVONstate
	andi	yh,0b00000010
	andi	zl,0b11111101
	or		zl,yh
	sts	DEVONstate,zl
	;.......................................................
	;	;temporren counter sichern ...
	sts	TEcounter1H,r21	
	sts	TEcounter1L,r20
	;ist sichern....
	sts	CpareI2,r18
_COM2bk:
	jmp	_devHOMEX	;return....		




	
;compare funkiton 3 aktivieren	
_COM3:
	;soll
	lds	r16,CpareC			;compare soll 1
	;max
	lds	r22,CmaxC			;compare max  1
	;ist
	lds	r18,CpareI3			;compare ist  1	
	;down-time (16bit)
	lds	zh,timeDWhigh		;time-base high SOLL
	lds	zl,timeDWlow		;time-base low  SOLL
	;up-time
	lds	r15,timeUP2high		;time-base high SOLL
	lds	r14,timeUP2low		;time-base low  SOLL
	;temporrer time counter
	lds	r21,TEcounter2H  	;temporrer counter high IST
	lds	r20,TEcounter2L		;temporrer counter low  IST
	;device u/d status-flags
	lds		yl,DEVUDstate
	andi	yl,0b00000100	;nur device2 sichtbar machen....
	;device on/off status-flags
	lds		yh,DEVONstate
	andi	yh,0b00000100	;nur device2 sichtbar machen....
	;protect delay 
	lds		r17,CprotectC
	;soll/ist...
	call	_COMx
	;protect delay sichern
	sts		CprotectC,r17
	;.......................................................
	;modifizierten device u/d-status sichern
	lds		zl,DEVUDstate
	andi	yl,0b00000100
	andi	zl,0b11111011
	or		zl,yl
	sts	DEVUDstate,zl
	;modifizierten device on/off-status sichern
	lds		zl,DEVONstate
	andi	yh,0b00000100
	andi	zl,0b11111011
	or		zl,yh
	sts	DEVONstate,zl
	;.......................................................
	;temporren counter sichern ...
	sts	TEcounter2H,r21	
	sts	TEcounter2L,r20
	;ist sichern....
	sts	CpareI3,r18
_COM3bk:
	jmp	_devHOMEX	;return....		


	
;compare funktion 4 aktivieren	
_COM4:
	;soll
	lds	r16,CpareD			;compare soll 1
	;max
	lds	r22,CmaxD			;compare max  1
	;ist
	lds	r18,CpareI4			;compare ist  1	
	;down-time (16bit)
	lds	zh,timeDWhigh		;time-base high SOLL
	lds	zl,timeDWlow		;time-base low  SOLL
	;up-time
	lds	r15,timeUP3high		;time-base high SOLL
	lds	r14,timeUP3low		;time-base low  SOLL
	;temporrer time counter
	lds	r21,TEcounter3H  	;temporrer counter high IST
	lds	r20,TEcounter3L		;temporrer counter low  IST
	;device u/d status-flags
	lds		yl,DEVUDstate
	andi	yl,0b00001000	;nur device3 sichtbar machen....
	;device on/off status-flags
	lds		yh,DEVONstate
	andi	yh,0b00001000	;nur device3 sichtbar machen....
	;protect delay 
	lds		r17,CprotectD
	;soll/ist...
	call	_COMx
	;protect delay sichern
	sts		CprotectD,r17
	;.......................................................
	;modifizierten device u/d-status sichern
	lds		zl,DEVUDstate
	andi	yl,0b00001000
	andi	zl,0b11110111
	or		zl,yl
	sts	DEVUDstate,zl
	;modifizierten device on/off-status sichern
	lds		zl,DEVONstate
	andi	yh,0b00001000
	andi	zl,0b11110111
	or		zl,yh
	sts	DEVONstate,zl
	;.......................................................
	;temporren counter sichern ...
	sts	TEcounter3H,r21	
	sts	TEcounter3L,r20
	;ist sichern....
	sts	CpareI4,r18
_COM4bk:
	jmp	_devHOMEX	;return....		





;compare funktion 5 aktivieren
_COM5:
	;soll1
	lds	r16,CpareE			;compare soll 5
	;max
	lds	r22,CmaxE
	;ist
	lds	r18,CpareI5			;compare ist  5	
	;down-time (16bit)
	lds	zh,timeDWhigh		;time-base high SOLL
	lds	zl,timeDWlow		;time-base low  SOLL
	;up-time
	lds	r15,timeUP4high		;time-base high SOLL
	lds	r14,timeUP4low		;time-base low  SOLL
	;temporrer time counter
	lds	r21,TEcounter4H  	;temporrer counter high IST
	lds	r20,TEcounter4L		;temporrer counter low  IST
	;device u/d status-flags
	lds		yl,DEVUDstate
	andi	yl,0b00010000	;nur device4 sichtbar machen....
	;device on/off status-flags
	lds		yh,DEVONstate
	andi	yh,0b00010000	;nur device4 sichtbar machen....
	;protect delay 
	lds		r17,CprotectE
	;soll/ist...
	call	_COMx
	;protect delay sichern
	sts		CprotectE,r17
	;.......................................................
	;modifizierten device u/d-status sichern
	lds		zl,DEVUDstate
	andi	yl,0b00010000
	andi	zl,0b11101111
	or		zl,yl
	sts	DEVUDstate,zl
	;modifizierten device on/off-status sichern
	lds		zl,DEVONstate
	andi	yh,0b00010000
	andi	zl,0b11101111
	or		zl,yh
	sts	DEVONstate,zl
	;.......................................................
	;temporren counter sichern ...
	sts	TEcounter4H,r21	
	sts	TEcounter4L,r20
	;ist sichern....
	sts	CpareI5,r18
_COM5bk:
	jmp	_devHOMEX	;return....		



	
;compare funktion 6 aktivieren	
_COM6:
	;soll
	lds	r16,CpareF			;compare soll 6
	;max
	lds	r22,CmaxF			;compare max  6
	;ist
	lds	r18,CpareI6			;compare ist  6	
	;down-time (16bit)
	lds	zh,timeDWhigh		;time-base high SOLL
	lds	zl,timeDWlow		;time-base low  SOLL
	;up-time
	lds	r15,timeUP5high		;time-base high SOLL
	lds	r14,timeUP5low		;time-base low  SOLL
	;temporrer time counter
	lds	r21,TEcounter5H  	;temporrer counter high IST
	lds	r20,TEcounter5L		;temporrer counter low  IST
	;device u/d status-flags
	lds		yl,DEVUDstate
	andi	yl,0b00100000	;nur device5 sichtbar machen....
	;device on/off status-flags
	lds		yh,DEVONstate
	andi	yh,0b00100000	;nur device5 sichtbar machen....
	;protect delay 
	lds		r17,CprotectF
	;soll/ist...
	call	_COMx
	;protect delay sichern
	sts		CprotectF,r17
	;.......................................................
	;modifizierten device u/d-status sichern
	lds		zl,DEVUDstate
	andi	yl,0b00100000
	andi	zl,0b11011111
	or		zl,yl
	sts	DEVUDstate,zl
	;modifizierten device on/off-status sichern
	lds		zl,DEVONstate
	andi	yh,0b00100000
	andi	zl,0b11011111
	or		zl,yh
	sts	DEVONstate,zl
	;.......................................................
	;temporren counter sichern ...
	sts	TEcounter5H,r21	
	sts	TEcounter5L,r20
	;ist sichern....
	sts	CpareI6,r18
_COM6bk:
	jmp	_devHOMEX	;return....		


	
	
;compare funkiton 7 aktivieren	
_COM7:
	;soll
	lds	r16,CpareG			;compare soll 7
	;max
	lds	r22,CmaxG			;compare max  7
	;ist
	lds	r18,CpareI7			;compare ist  7	
	;down-time (16bit)
	lds	zh,timeDWhigh		;time-base high SOLL
	lds	zl,timeDWlow		;time-base low  SOLL
	;up-time
	lds	r15,timeUP6high		;time-base high SOLL
	lds	r14,timeUP6low		;time-base low  SOLL
	;temporrer time counter
	lds	r21,TEcounter6H  	;temporrer counter high IST
	lds	r20,TEcounter6L		;temporrer counter low  IST
	;device u/d status-flags
	lds		yl,DEVUDstate
	andi	yl,0b01000000	;nur device6 sichtbar machen....
	;device on/off status-flags
	lds		yh,DEVONstate
	andi	yh,0b01000000	;nur device6 sichtbar machen....
	;protect delay 
	lds		r17,CprotectG
	;soll/ist...
	call	_COMx
	;protect delay sichern
	sts		CprotectG,r17
	;.......................................................
	;modifizierten device u/d-status sichern
	lds		zl,DEVUDstate
	andi	yl,0b01000000
	andi	zl,0b10111111
	or		zl,yl
	sts	DEVUDstate,zl
	;modifizierten device on/off-status sichern
	lds		zl,DEVONstate
	andi	yh,0b01000000
	andi	zl,0b10111111
	or		zl,yh
	sts	DEVONstate,zl
	;.......................................................
	;temporren counter sichern ...
	sts	TEcounter6H,r21	
	sts	TEcounter6L,r20
	;ist sichern....
	sts	CpareI7,r18
_COM7bk:
	jmp	_devHOMEX	;return....		


	
;compare funktion 8 aktivieren	
_COM8:
	;soll
	lds	r16,CpareH			;compare soll 8
	;max
	lds	r22,CmaxH			;compare max  8
	;ist
	lds	r18,CpareI8			;compare ist  8	
	;down-time (16bit)
	lds	zh,timeDWhigh		;time-base high SOLL
	lds	zl,timeDWlow		;time-base low  SOLL
	;up-time
	lds	r15,timeUP7high		;time-base high SOLL
	lds	r14,timeUP7low		;time-base low  SOLL
	;temporrer time counter
	lds	r21,TEcounter7H  	;temporrer counter high IST
	lds	r20,TEcounter7L		;temporrer counter low  IST
	;device u/d status-flags
	lds		yl,DEVUDstate
	andi	yl,0b10000000	;nur device7 sichtbar machen....
	;device on/off status-flags
	lds		yh,DEVONstate
	andi	yh,0b10000000	;nur device7 sichtbar machen....
	;protect delay 
	lds		r17,CprotectH
	;soll/ist...
	call	_COMx
	;protect delay sichern
	sts		CprotectH,r17
	;.......................................................
	;modifizierten device u/d-status sichern
	lds		zl,DEVUDstate
	andi	yl,0b10000000
	andi	zl,0b01111111
	or		zl,yl
	sts	DEVUDstate,zl
	;modifizierten device on/off-status sichern
	lds		zl,DEVONstate
	andi	yh,0b10000000
	andi	zl,0b01111111
	or		zl,yh
	sts	DEVONstate,zl
	;.......................................................	
	;temporren counter sichern ...
	sts	TEcounter7H,r21	
	sts	TEcounter7L,r20
	;ist sichern....
	sts	CpareI8,r18
_COM8bk:
	jmp	_devHOMEX	;return....		



;-----------------------------------------------------------------------------------------
_COMx:
	;## soll/max safety-check (soll>max verhindern)
	cp	r16,r22		;soll >= max ? 
	brsh	_COMPloopMAX
	jmp	_COMPloopYXa
	;## sollwert = max
_COMPloopMAX:
	mov	r16,r22		;sollwert nimmt den maximalwert an !
	;## up/down oder stop checken
_COMPloopYXa:	
	;##jetzt der soll /ist - vergleich
	cp	r16,r18		;soll /ist - vergleich
	breq	_OFFpicoX	;soll/ist gleich == stop!
	brsh	_DWpico		;soll > ist == dw ---> pin low  (dw) & drive-pin low (motor) <=> antrieb   -dw-  aktivieren
	jmp	_UPpico		;soll < ist == up ---> pin high (up) & drive-pin low (motor) <=> antrieb   -up-  aktivieren

_OFFpicoX:
	jmp	_OFFpico	



	;##korrigiere ist zhlerstnde in abhngigkeit aktueller 10ms trigger
	;##anlaufverzgerung integrieren (lastSTATE)
	;----------------------------------------------------------------------	
	;UP
	;MOTORSCHUTZ:
	;ALTER ZUSTAND: a) OFF -> DEVUP -> WAIT -> DEVON
	;               b) DW  -> DEVOFF-> WAIT -> DEVUP -> WAIT -> DEVON
	;               c) UP  -
_UPpico:
	tst	yl
	breq	_UPpicoDW
	;devud=1 (up)...
	tst	yh
	brne	_UPpicoRUN  ;... devud=1 (up) & devon=1 ... up luft bereits / oder protect 2!
	;devud=1 (up) & devon=0 (aus) ... up protect aktiv !	
	tst	r17
	breq	_UPpicoUP
	dec	r17
	jmp	_COhome


	;protect 1 ready
_UPpicoUP:
	;lade OUTcompaFL
	lds	zl,OUTcompaFL
	call	_ONdevx	;up
	sts	OUTcompaFL,zl
	;devon flags =1
	ldi	yh,0xff
	;wait counter default
	ldi	r17,COpro	;base: modul-calltime=111s*40*wtcnt === 444ms
	jmp	_COhome


	;luft noch ein dw oder start aus off ?
_UPpicoDW:
	;devon?
	tst	yh
	breq 	_UPpicoOFF	
	;devud=0 (dw) & devon=1 (an) .... dw luft noch !
	;lade OUTcompbFL
	lds		zl,OUTcompbFL
	call	_OFFdevx	;gleiche pin#(device) auf portA steuern (motor)
	sts		OUTcompbFL,zl
	;devup flags =1
	ldi	yl,0xff
	;devon flags =0
	ldi	yh,0
	;wait counter default
	ldi	r17,COpro	;base: modul-calltime=111s*40*wtcnt === 444ms
	jmp	_COhome


	;last state off (devon=0 & devud=0) ... off !
	;kein protect 1 erforederlich !!!
_UPpicoOFF:	
	;devup flags =1
	ldi	yl,0xff
	jmp	_UPpicoUP


	;run oder protect 2
_UPpicoRUN:
	tst	r17
	breq	_UPpicoC	;run !!!
	dec	r17
	jmp	_COhome


	;c) aktiv UP
_UPpicoC:
	;>0
	;devon !!
	;hier up-timebase
	cp	r20,r14
	cpc	r21,r15
	brsh	_UPpicoD
	jmp	_COhome
_UPpicoD:
	;temporre counter =0 (ziel erreicht)
	clr	r20
	clr	r21
	;devon!
	;lade OUTcompbFL
	lds	zl,OUTcompbFL
	call	_ONdevx	;gleiche pin#(device) auf portA steuern (motor)
	sts	OUTcompbFL,zl
	;
	dec	r18		;ist-wert -1
	jmp	_COhome





	;----------------------------------------------------------------------
	;DOWN
	;MOTORSCHUTZ:
	;ALTER ZUSTAND: a) OFF -> DEVDW -> WAIT -> DEVON
	;               b) UP  -> DEVOFF-> WAIT -> DEVDW -> WAIT -> DEVON
	;               c) DW  -
_DWpico:
	tst	yl
	brne	_DWpicoUP
	;devud=1 (up)...
	tst	yh
	brne	_DWpicoRUN  ;... devud=1 (up) & devon=1 ... up luft bereits / oder protect 2!
	;devud=0 (up) & devon=0 (aus) ... up protect aktiv !	
	tst	r17
	breq	_DWpicoDW
	dec	r17
	jmp	_COhome


	;protect 1 ready
_DWpicoDW:
	;lade OUTcompaFL
	lds	zl,OUTcompaFL
	call	_OFFdevx	;dw
	sts	OUTcompaFL,zl
	;devon flags =1
	ldi	yh,0xff
	;wait counter default
	ldi	r17,COpro	;base: modul-calltime=111s*40*wtcnt === 444ms
	jmp	_COhome


	;luft noch ein up oder start aus off ?
_DWpicoUP:
	;devon?
	tst	yh
	breq 	_DWpicoOFF	
	;devud=0 (dw) & devon=1 (an) .... dw luft noch !
	;lade OUTcompbFL
	lds		zl,OUTcompbFL
	call	_OFFdevx	;gleiche pin#(device) auf portA steuern (motor)
	sts		OUTcompbFL,zl
	;devup flags =0
	ldi	yl,0
	;devon flags =0
	ldi	yh,0
	;wait counter default
	ldi	r17,COpro	;base: modul-calltime=111s*40*wtcnt === 444ms
	jmp	_COhome



	;last state off (devon=0 & devud=0) ... off !
	;kein protect 1 erforederlich !!!
_DWpicoOFF:	
	;devup flags =0
	ldi	yl,0
	jmp	_DWpicoDW

	;run oder protect 2
_DWpicoRUN:
	tst	r17
	breq	_DWpicoC	;run !!!
	dec	r17
	jmp	_COhome


	;activ down
_DWpicoC:
	;hier down-timebase
	cp	r20,zl
	cpc	r21,zh
	brsh	_DWpicoD
	jmp	_COhome
_DWpicoD:
	;temporre counter =0 (ziel erreicht)
	clr	r20
	clr	r21
	;devon!
	;lade OUTcompbFL
	lds	zl,OUTcompbFL
	call	_ONdevx	;gleiche pin#(device) auf portA steuern (motor)
	sts	OUTcompbFL,zl
	;
	inc	r18		;ist-wert +1
	jmp	_COhome



	;----------------------------------------------------------------------
	;OFF
	;MOTORSCHUTZ:
	;ALTER ZUSTAND: a) UP  -> DEVOFF -> WAIT -> DEVDW
	;               b) DW  -> DEVOFF
	;               c) OFF - 
_OFFpico:
	tst	yh
	brne	_OFFpicoB
	tst	r17
	breq	_OFFpicoC
	dec	r17
	jmp		_COhome
	;....................................
	;motor aus
_OFFpicoB:
	;lade OUTcompbFL
	lds	zl,OUTcompbFL
	call	_OFFdevx	;gleiche pin#(device) auf portA steuern (motor)
	sts	OUTcompbFL,zl
	;+++NEU++++++++++++++++++++++++++++++++++++++++
	;abschlieend positionen ins e2prom sichern !
	;<<saveE2PROM-flag setzen
	;+CmaxA...H +Cist1...8
	;blends /counter compare
	ldi	r21,high(CmaxA)
	ldi	r20,low(CmaxA) 			;mirror - sram start	
	sts	SblendL,r20
	sts	SblendH,r21
	;sichern
	ldi	r20,0xff
	sts	SstateBLEND,r20
	;
	;++++++++++++++++++++++++++++++++++++++++++++++
	;devon=0
	ldi	yh,0
	;delay default
	ldi	r17,COpro
	;temporre counter =0 (ziel erreicht)
	clr	r20
	clr	r21
	jmp	_COhome
	;..........................................
	;ud =0
_OFFpicoC:
	;devud=0
	ldi	yl,0
	;lade OUTcompaFL
	lds	zl,OUTcompaFL
	call	_OFFdevx	;down (oder stromlos!)
	sts	OUTcompaFL,zl
	jmp	_COhome






_COhome:
		;vergleiche alten delay-status mit neuem status...
	;== zurck
	;<> setze new compa-event
	lds		r14,OUTcompaFLold
	lds		r15,OUTcompaFL
	cp		r14,r15	;alt == neu?
	breq	_dCOMPbackZ
	;alt upgedated
	sts		OUTcompaFLold,r15
	;----------------------------------------
	;<new-u/d-state> - event setzen
	ldi		r23,108
	sts		eventTE,r23			;
	call	_MAKEeventSUB		;submodul !
	;----------------------------------------
_dCOMPbackZ:
	;<> setze new compb-event
	lds		r14,OUTcompbFLold
	lds		r15,OUTcompbFL
	cp		r14,r15	;alt == neu?
	breq	_dCOMPbackY
	;alt upgedated
	sts		OUTcompbFLold,r15
	;----------------------------------------
	;<new-on/off-state> - event setzen
	ldi		r23,109
	sts		eventTE,r23			;
	call	_MAKEeventSUB		;submodul !
	;----------------------------------------
_dCOMPbackY:	
	ret


;--------------------------------------------------------------------
;device flag lschen (parameter in zl / device in r19) // HIGH AKTIV
;--------------------------------------------------------------------
_OFFdevx:
	tst	r19
	breq	_OFFdev0		
	cpi	r19,1
	breq	_OFFdev1		
	cpi	r19,2
	breq	_OFFdev2		
	cpi	r19,3
	breq	_OFFdev3		
	cpi	r19,4
	breq	_OFFdev4		
	cpi	r19,5
	breq	_OFFdev5	
	cpi	r19,6
	breq	_OFFdev6	
	cpi	r19,7
	breq	_OFFdev7	
	
_OFFdev0:
	cbr	zl,1<<0	
	ret
_OFFdev1:
	cbr	zl,1<<1	;
	ret
_OFFdev2:
	cbr	zl,1<<2
	ret
_OFFdev3:
	cbr	zl,1<<3
	ret
_OFFdev4:
	cbr	zl,1<<4
	ret
_OFFdev5:
	cbr	zl,1<<5
	ret
_OFFdev6:
	cbr	zl,1<<6
	ret
_OFFdev7:
	cbr	zl,1<<7
	ret


;--------------------------------------------------------------------
;device flag setzen (parameter in zl / device in r19) // HIGH-AKTIV
;--------------------------------------------------------------------
_ONdevx:
	tst	r19
	breq	_ONdev0		
	cpi	r19,1
	breq	_ONdev1		
	cpi	r19,2
	breq	_ONdev2		
	cpi	r19,3
	breq	_ONdev3		
	cpi	r19,4
	breq	_ONdev4		
	cpi	r19,5
	breq	_ONdev5	
	cpi	r19,6
	breq	_ONdev6	
	cpi	r19,7
	breq	_ONdev7	
	
_ONdev0:
	sbr	zl,1<<0	
	ret
_ONdev1:
	sbr	zl,1<<1	;
	ret
_ONdev2:
	sbr	zl,1<<2
	ret
_ONdev3:
	sbr	zl,1<<3
	ret
_ONdev4:
	sbr	zl,1<<4
	ret
_ONdev5:
	sbr	zl,1<<5
	ret
_ONdev6:
	sbr	zl,1<<6
	ret
_ONdev7:
	sbr	zl,1<<7
	ret


	


;---------------------------------------------------------
;akt1...akt8 decodieren & devicestatus nach ports kopieren
;---------------------------------------------------------
_aktDECODE:
	;lokale registerdefinition
	lds	yl,PINcntL		;zwischengespeichertes aktivbyteadresse 
	lds	yh,PINcntH		;zwischengespeichertes aktivbyteadresse 
	cpi	yl,low(akt8 +1)	;Compare low byte
	ldi	r18,high(akt8 +1)	;
	cpc	yh,r18	;Compare high byte
	brne	_STinf
	;auf erstes aktivbyte setzen	
	ldi	yh,high(akt1)
	ldi	yl,low(akt1)
	sts		PINcntL,yl	;sichere aktuelle adresse 
	sts		PINcntH,yh	;sichere aktuelle adresse 
	;nchste category / device0 bearbeiten
	lds	r18,PcatCNT
	inc	r18
	sts	PcatCNT,r18
	;
	clr	r19
	sts	PdeviceCNT,r19
	jmp	_pinHOMEX
	;
_STinf:
	ld		r17,y		;info x
	adiw	yh:yl,1
	sts		PINcntL,yl	;sichere aktuelle adresse 
	sts		PINcntH,yh	;sichere aktuelle adresse 
	;cat decodieren...
	mov		r16,r17
	andi	r16,0b00000011	;zeige nur die 2 kategoriebits
	;dev decodieren...
	mov		r20,r17		;hole das ursprngliche info-byte
	lsr		r20		;
	lsr		r20		;r16/8 <=> 2xshift right (== kat ausblenden)
	andi	r20,0b00000111 	;zeige nur die device-bits
	;pin decodieren...
	mov		r19,r17		
	lsr		r19		;
	lsr		r19		;
	lsr		r19
	lsr		r19
	lsr		r19		;r16/32 <=> 5xshift right (== kat&device ausblenden)
	andi	r19,0b00000111 	;zeige nur die execute-bits	
	;
	;
	;----------------------------------------------------------------------
	;CATEGORY?
	;----------------------------------------------------------------------
	tst	r16		;category 0
	breq	_TRIGloopO		;.... port-pin triggered signal (...phasenschnitt)	
	cpi	r16,1		;category 1
	breq	_DELloopOpin		;.... delays start
	cpi	r16,2		;category 2 
	breq	_COMPloopOpin		;.... counter-compare an/aus (rollo...)
	cpi	r16,3		;category 4
	breq	_AKTloopOpin		;.... aktuator A an/aus
	
;1.0)pwm devices to pin
_TRIGloopO:
	cpi		r20,4
	brsh	_TRIGloop2O
	;device 0...3
	clr		zh
	mov		zl,r20
	subi	zl, low(-devAKT0)	;startadresse+devicewert = zieladresse !
	sbci	zh, high(-devAKT0)	;
	clr	r17
	call	_OFFpinxxY	;setzte jeweiligen pin (r17) high!
	st	z,r17			;aktuelle bit position der ziel device-adresse zugeordnet!
	jmp	_pinHOMEX	;zurck in hauptschleife
	;device 4...7
_TRIGloop2O:
	subi	r20,4
	mov		zl,r20
	clr		zh
	subi	zl, low(-devAKT4)	;startadresse+devicewert = zieladresse !
	sbci	zh, high(-devAKT4)	;
	clr	r17
	call	_OFFpinxxY	;setzte jeweiligen pin (r17) high!
	st	z,r17			;aktuelle bit position der ziel device-adresse zugeordnet!
	jmp	_pinHOMEX	;zurck in hauptschleife




;1.1)delay devices to pin
_DELloopOpin:
	;1.1.1) hole deviceflags
	lds		zl,OUTdelFL
	;1.1.2) decodiere und aktualisiere pinstatus
	call	_pinDECODE	;
	jmp		_pinHOMEX

;1.2)compare devices to pin
_COMPloopOpin:
	;1.2.1) hole deviceflagsA
	lds		zl,OUTcompaFL
	;1.2.2) decodiere und aktualisiere pinstatus
	call	_pinDECODE	;
	;1.2.3) hole deviceflagsB
	lds		zl,OUTcompbFL
	;1.2.4) decodiere und aktualisiere pinstatus
	call	_pinDECODEZ ;B
	jmp		_pinHOMEX

;1.3)akt devices to pin
_AKTloopOpin:
	;1.3.1) hole deviceflags
	lds		zl,OUTaktFL
	;1.3.2) decodiere und aktualisiere pinstatus
	call	_pinDECODE	;
	jmp		_pinHOMEX










;-----------------------------------------------------------------------------------
;----- sub's -> extraktion von execute,device & category-bits !  -------------------
;-----------------------------------------------------------------------------------
;r17=aktiv byte (unverndert)
;r19=pinX
;r20=devX
;r16=catX
;zl= devFLAGs (aktuell)


;....................................................................................
;OUTPUTS HIGH-ACTIV!
;....................................................................................
_pinDECODE:
	;1.0) device?
	tst		r20
	;->device0 definiert
	;->status in device-flag register?
	brne	_pinDECODEa
	sbrs	zl,0		;flag0 L/H?
	rjmp	_DEVLOW		;=0
	rjmp	_DEVHIGH	;=1
_pinDECODEa:
	cpi		r20,1
	;->device1 definiert
	;->status in device-flag register?
	brne	_pinDECODEb
	sbrs	zl,1		;flag0 L/H?
	rjmp	_DEVLOW		;=0
	rjmp	_DEVHIGH	;=1	
_pinDECODEb:
	cpi		r20,2
	;->device2 definiert
	;->status in device-flag register?
	brne	_pinDECODEc
	sbrs	zl,2		;flag0 L/H?
	rjmp	_DEVLOW		;=0
	rjmp	_DEVHIGH	;=1	
_pinDECODEc:
	cpi		r20,3
	;->device3 definiert
	;->status in device-flag register?
	brne	_pinDECODEd
	sbrs	zl,3		;flag0 L/H?
	rjmp	_DEVLOW		;=0
	rjmp	_DEVHIGH	;=1	
_pinDECODEd:
	cpi		r20,4
	;->device4 definiert
	;->status in device-flag register?
	brne	_pinDECODEe
	sbrs	zl,4		;flag0 L/H?
	rjmp	_DEVLOW		;=0
	rjmp	_DEVHIGH	;=1	
_pinDECODEe:
	cpi		r20,5
	;->device5 definiert
	;->status in device-flag register?
	brne	_pinDECODEf
	sbrs	zl,5		;flag0 L/H?
	rjmp	_DEVLOW		;=0
	rjmp	_DEVHIGH	;=1	
_pinDECODEf:
	cpi		r20,6
	;->device6 definiert
	;->status in device-flag register?
	brne	_pinDECODEg
	sbrs	zl,6		;flag0 L/H?
	rjmp	_DEVLOW		;=0
	rjmp	_DEVHIGH	;=1	
_pinDECODEg:
	cpi		r20,7
	;->device7 definiert
	;->status in device-flag register?
	brne	_pinDECODEh
	sbrs	zl,7		;flag0 L/H?
	rjmp	_DEVLOW		;=0
	rjmp	_DEVHIGH	;=1	
	;ungltig...
_pinDECODEh:
	ret
	;
	;
;pin clear
_DEVLOW:
	call	_OFFpinx
	ret
;pin set
_DEVHIGH:
	call	_ONpinx
	ret

;....................................................................................
;OUTPUTS HIGH-ACTIV!
;....................................................................................
_pinDECODEZ:
	;1.0) device?
	tst		r20
	;->device0 definiert
	;->status in device-flag register?
	brne	_pinDECODEZa
	sbrs	zl,0		;flag0 L/H?
	rjmp	_DEVLOWZ		;=0
	rjmp	_DEVHIGHZ	;=1
_pinDECODEZa:
	cpi		r20,1
	;->device1 definiert
	;->status in device-flag register?
	brne	_pinDECODEZb
	sbrs	zl,1		;flag0 L/H?
	rjmp	_DEVLOWZ		;=0
	rjmp	_DEVHIGHZ	;=1	
_pinDECODEZb:
	cpi		r20,2
	;->device2 definiert
	;->status in device-flag register?
	brne	_pinDECODEZc
	sbrs	zl,2		;flag0 L/H?
	rjmp	_DEVLOWZ		;=0
	rjmp	_DEVHIGHZ	;=1	
_pinDECODEZc:
	cpi		r20,3
	;->device3 definiert
	;->status in device-flag register?
	brne	_pinDECODEZd
	sbrs	zl,3		;flag0 L/H?
	rjmp	_DEVLOWZ		;=0
	rjmp	_DEVHIGHZ	;=1	
_pinDECODEZd:
	cpi		r20,4
	;->device4 definiert
	;->status in device-flag register?
	brne	_pinDECODEZe
	sbrs	zl,4		;flag0 L/H?
	rjmp	_DEVLOWZ		;=0
	rjmp	_DEVHIGHZ	;=1	
_pinDECODEZe:
	cpi		r20,5
	;->device5 definiert
	;->status in device-flag register?
	brne	_pinDECODEZf
	sbrs	zl,5		;flag0 L/H?
	rjmp	_DEVLOWZ		;=0
	rjmp	_DEVHIGHZ	;=1	
_pinDECODEZf:
	cpi		r20,6
	;->device6 definiert
	;->status in device-flag register?
	brne	_pinDECODEZg
	sbrs	zl,6		;flag0 L/H?
	rjmp	_DEVLOWZ		;=0
	rjmp	_DEVHIGHZ	;=1	
_pinDECODEZg:
	cpi		r20,7
	;->device7 definiert
	;->status in device-flag register?
	brne	_pinDECODEZh
	sbrs	zl,7		;flag0 L/H?
	rjmp	_DEVLOWZ		;=0
	rjmp	_DEVHIGHZ	;=1	
	;ungltig...
_pinDECODEZh:
	ret
	;
	;
;pin clear
_DEVLOWZ:
	call	_OFF2pinx
	ret
;pin set
_DEVHIGHZ:
	call	_ON2pinx
	ret

	
	
	
	
	

;-----------------------------------------------------------------------------------
;------  sub zur port-pin-definition -----------------------------------------------
;-----------------------------------------------------------------------------------

;sekundrer outport fr compare 
_ON2pinx:
	mov	r19,r20			;belege nur portA 0-7
	in	r17,porta
	call	_ONpinxx
	out	porta,r17
	ret


;primrer outport aktivieren
_ONpinx:
	in	r17,portc
	call	_ONpinxx
	out	portc,r17
	ret

_ONpinxx:
	tst	r19
	brne	_ONpin1
	sbr	r17,1<<0
	rjmp	_ONpinxxBK
_ONpin1:
	cpi	r19,1
	brne	_ONpin2	
	sbr	r17,1<<1	
	rjmp	_ONpinxxBK
_ONpin2:
	cpi	r19,2
	brne	_ONpin3	
	sbr	r17,1<<2	
	rjmp	_ONpinxxBK
_ONpin3:
	cpi	r19,3
	brne	_ONpin4	
	sbr	r17,1<<3	
	rjmp	_ONpinxxBK
_ONpin4:
	cpi	r19,4
	brne	_ONpin5	
	sbr	r17,1<<4	
	rjmp	_ONpinxxBK
_ONpin5:
	cpi	r19,5
	brne	_ONpin6	
	sbr	r17,1<<5	
	rjmp	_ONpinxxBK
_ONpin6:
	cpi	r19,6
	brne	_ONpin7	
	sbr	r17,1<<6	
	rjmp	_ONpinxxBK
_ONpin7:
	cpi	r19,7
	brne	_ONpinxxBK	
	sbr	r17,1<<7	
_ONpinxxBK:
	ret
	


;----------------------------------------------------------





;sekundrer outport fr compare 
_OFF2pinx:
	mov	r19,r20			;belege nur portA 0-7
	in	r17,porta
	call	_OFFpinxx
	out	porta,r17
	ret


;primrer outport aktivieren
_OFFpinx:
	in	r17,portc
	call	_OFFpinxx
	out	portc,r17
	ret

_OFFpinxx:
	tst	r19
	brne	_OFFpin1
	cbr	r17,1<<0
	rjmp	_OFFpinxxBK
_OFFpin1:
	cpi	r19,1
	brne	_OFFpin2	
	cbr	r17,1<<1	
	rjmp	_OFFpinxxBK
_OFFpin2:
	cpi	r19,2
	brne	_OFFpin3	
	cbr	r17,1<<2	
	rjmp	_OFFpinxxBK
_OFFpin3:
	cpi	r19,3
	brne	_OFFpin4	
	cbr	r17,1<<3	
	rjmp	_OFFpinxxBK
_OFFpin4:
	cpi	r19,4
	brne	_OFFpin5	
	cbr	r17,1<<4	
	rjmp	_OFFpinxxBK
_OFFpin5:
	cpi	r19,5
	brne	_OFFpin6	
	cbr	r17,1<<5	
	rjmp	_OFFpinxxBK
_OFFpin6:
	cpi	r19,6
	brne	_OFFpin7	
	cbr	r17,1<<6	
	rjmp	_OFFpinxxBK
_OFFpin7:
	cpi	r19,7
	brne	_OFFpinxxBK	
	cbr	r17,1<<7	
_OFFpinxxBK:
	ret
	











;------------------------------------------------------------------------

	;nur f. trigger
	;------------------
_OFFpinxxY:
	tst	r19
	breq	_OFFpin0Y		;lege device x -> auf pin0
	cpi	r19,1
	breq	_OFFpin1Y		;lege device x -> auf pin1
	cpi	r19,2
	breq	_OFFpin2Y		;lege device x -> auf pin2
	cpi	r19,3
	breq	_OFFpin3Y		;lege device x -> auf pin3
	cpi	r19,4
	breq	_OFFpin4Y		;lege device x -> auf pin4
	cpi	r19,5
	breq	_OFFpin5Y		;lege device x -> auf pin5
	cpi	r19,6
	breq	_OFFpin6Y		;lege device x -> auf pin6
	cpi	r19,7
	breq	_OFFpin7Y		;lege device x -> auf pin7
	
_OFFpin0Y:
	sbr	r17,1<<0	;low-aktiv konfiguriert... also low=an
	ret
_OFFpin1Y:
	sbr	r17,1<<1	;
	ret
_OFFpin2Y:
	sbr	r17,1<<2	;
	ret
_OFFpin3Y:
	sbr	r17,1<<3
	ret
_OFFpin4Y:
	sbr	r17,1<<4
	ret
_OFFpin5Y:
	sbr	r17,1<<5
	ret
_OFFpin6Y:
	sbr	r17,1<<6
	ret
_OFFpin7Y:
	sbr	r17,1<<7	
	ret


;--------------------------------------------------------
;set next device / cat
_devHOMEX:
	;alle devices definierter kategorien abklappern...
	;A)device-counter laden...
	lds	r19,PdeviceCNT
	lds	r18,PcatCNT
	inc	r19
	cpi	r19,8
	brsh	_devCATnxt		;nchste kategorie laden
	jmp	_devHOMEZ
_devCATnxt:
	clr	r19
	inc	r18
	cpi	r18,4
	brsh	_cat0nxt
	jmp	_devHOMEZ
_cat0nxt:
	clr	r18
_devHOMEZ:
	sts	PdeviceCNT,r19
	sts	PcatCNT,r18
	jmp	_pinHOMEX
;home
_pinHOMEX:
	ret



;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++ SAVE BLEND IST/MAX ++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++ NACH E2PROM STORAGE +++++++++++++++++++++++++++++++++++++++++++++++
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++







_BLENDMIrrore2:
	sbic	eecr,eewe		; eepe nicht gelscht ?
	rjmp	_BLENDMIrrore3	; vielleicht beim nchsten mal !?
	;
	;a) lade aktuelle sram-adresse
	lds	zl,SblendL
	lds	zh,SblendH
	;b) lade variable aus sram (z-pointer)
	ld	r2,z
	;c) berechne e2adresse
	subi	zl,low(CmaxE2sub)
	sbci	zh,high(CmaxE2sub)		;mirror - e2prom start
	;d) sichere ins e2prom
	out	eearh,zh
	out	eearl,zl		; adressierung e2prom
	out	eedr,r2          ; kopiere ins'e2prom-datenregister
	sbi	eecr,eemwe	
	sbi	eecr,eewe		;set EEPROM Write
	;e) sram adresse +1
	lds	zl,SblendL
	lds	zh,SblendH
	adiw 	zh:zl,1		
	sts	SblendL,zl
	sts	SblendH,zh
	;f) range
	ldi	yl,low(CpareI8 +1)
	ldi	yh,high(CpareI8 +1)
	;max?
	cp		zl,yl
	cpc		zh,yh			;nur bis ..mirror range
	brlo	_BLENDMIrrore3  ;noch nicht fertig !
	;g) ready!
	clr	r20
	sts	SstateBLEND,r20
_BLENDMIrrore3:
	ret


