;-----------------------------------------------------------------------------
;---- high speed - triggered signal/dimmer loop (basis _PHbase) --------------
;-----------------------------------------------------------------------------
;100hz trigger section dem timebase modul entnommen
;-----------------------------------------------------------------------------
	;- Synchronisation basis phasenschnittzhler (pind.6)
	;- device bez. aktiv variablen 
	;- linearisierung via tabelle !
;-----------------------------------------------------------------------------
	;
_SPEEDloop:
	;bevor's wietergeht power-on/off-conditions checken !
	lds	r17,PWRflag	;power-flag-register
	sbrs	r17,portON
	rjmp	_SPEEDhome
	;
	lds	r22,_PHbase
	inc	r22		;synchronisation-istwert
	sbic	pind,pind6	;portD pin 6 - trigger base
	rjmp	_SPEEDload	;kein zero..
	;hier phasen max-wert speichern
	;....
	;fr die startphase
	cpi	r22,15
	brlo _PHASEshort
	sts	PHASEbkup,r22	;phasen-ist maximalwert
_PHASEshort:
	clr	r22		;bei 100Hzsync wird der zhler bei 180 gelscht !
_SPEEDload:
	sts	_PHbase,r22	;phasen-istwert sichern...
		
	;lade phasenschnittwerte aus sram 
_goSPEEDa:
	;pwm1	
	lds	r21,devAKT0
	tst	r21
	breq	_goSPEEDb
	lds	r16,phase1		;ab phase1 phasenschnittwerte laden !
	rcall	_CONVsub
	rcall	_TRspeedA	
	;pwm2
_goSPEEDb:
	lds	r21,devAKT1
	tst	r21
	breq	_goSPEEDc
	lds	r16,phase2		
	rcall	_CONVsub
	rcall	_TRspeedA

	;pwm3	
_goSPEEDc:
	lds	r21,devAKT2
	tst	r21
	breq	_goSPEEDd
	lds	r16,phase3		
	rcall	_CONVsub
	rcall	_TRspeedA
	;pwm4
_goSPEEDd:
	lds	r21,devAKT3
	tst	r21
	breq	_goSPEEDe
	lds	r16,phase4		
	rcall	_CONVsub
	rcall	_TRspeedA
	;pwm5
_goSPEEDe:
	lds	r21,devAKT4
	tst	r21
	breq	_goSPEEDf
	lds	r16,phase5		
	rcall	_CONVsub
	rcall	_TRspeedA
	;pwm6
_goSPEEDf:
	lds	r21,devAKT5
	tst	r21
	breq	_goSPEEDg
	lds	r16,phase6		
	rcall	_CONVsub
	rcall	_TRspeedA
	;pwm7
_goSPEEDg:
	lds	r21,devAKT6
	tst	r21
	breq	_goSPEEDh
	lds	r16,phase7		
	rcall	_CONVsub
	rcall	_TRspeedA
	;pwm8
_goSPEEDh:
	lds	r21,devAKT7
	tst	r21
	breq	_goSPEEDi
	lds	r16,phase8		
	rcall	_CONVsub
	rcall	_TRspeedA
_goSPEEDi:
	ret				;fertig........

;*****************************
;start neue speed sub-routine

_TRspeedA:
	in	r17,portc	;prim. portc nach r17						
	or	r17,r21		;r17 wird ergnzt -> r21 enthlt den device bezogenen aktivierungspin!

	;hier noch phase max & phase soll vergleichen
	;phase soll darf nie grer als phase max-5 sein !!!
	lds	r19,PHASEbkup	;phasen maximalwert holen
	subi	r19,5
	cp	r16,r19
	brsh	_TRphaseKORR	;soll >= max-wert ...(soll auf max-5 setzen) 
	jmp	_TRphaseIO
_TRphaseKORR:
	mov	 r16,r19	
		;phase ist <=5 dann aus...	
_TRphaseIO:	
	cpi	r22,5
	brsh _TRphasePERF
	jmp	_OFFspeedX	;aus
	;
_TRphasePERF:
	cp	r22,r16		;r22==phase ist  /  r16==phase soll vergleich
	brsh	_ONspeedX_pulse	;...
	brlo	_OFFspeedX	;aus
	;
	;differenz >5?
	;bewirkt einen pulse von 5*timeslotcyclen (5*55,5s)
_ONspeedX_pulse:
	mov	r19,r22
	subi	r19,5
	cp	r19,r16
	brlo	_ONspeedX
	jmp		_OFFspeedX
	;
	;
	;
	;ausgangslogik...
_OFFspeedX:
	com	r21		;komplement r21 == device bez. aktiv-pin	
	and	r17,r21	;pin wird low == off
	out	portc,r17	;und power!
	sts	portCte,r17
	rjmp	_SPEEDhome


_ONspeedX:
	out	portc,r17	;und power !
	sts	portCte,r17
	;
_SPEEDhome:
	ret




;****************************
_CONVsub:
clr		zh
mov		zl,r16	;r16 aktueller phasecut-wert
subi 	zl,low(-_CONVtrig*2)
sbci	zh,high(-_CONVtrig*2)
lpm		r16,z
ret



