;-------------------------------------------------------------------------------------
;Neue Combi-Version
;Knftig zwischen HIF-Daten oder NET-Daten differenzieren
;Hierfr Status _ifSEL(PB4) prfen:
;0= NET-Daten
;1= HIF-Daten
;interrupt routine;format:<CURindex>,<paraFUNC>,<paraPOS>,<PARAx>,<paraMINx>,<paraMAXx>
;-------------------------------------------------------------------------------------
;ingration fully remote == als aktiver master nur passiv !
;-> 
SPI_SLAVE:
    push    r0
 	push	r15	;r15 on stack
    push    r16
    push    r17
    push    yl
    push    yh
    push    zl
    push    zh
	in	r15,sreg

    ;.................
    ;reset counter
    clr yl
    sts spiDEMcnt,yl
    ;.................



;----------------------------------------------------------
;receive HIF-data NEW
;-> check at start if HIF or NET-data will be received
;----------------------------------------------------------
    ;--------------------
    ;load data from spi 
    in  yl,spdr
	;--------------------
    lds	r17,comFLAGspi
	;jetzt byte counter laden
	lds	r16,spiDATctIST	
	tst	r16	;identifier byte empfangen ?
	brne	_RECspi02CHK
    ;-------------------
    ;check start-byte
    ;a) HIF-Data 0x2d
    ;b) NET-Data 0xd4
    ;-------------------
    cpi yl,0x2d
    breq   _RECspiHIFstart
    cpi yl,0xd4
    breq    _RECspiNETstart  
    ;invalid data
    lds     r17,ifSELstate
    sbr     r17,1<<SPIrecERR
    sts     ifSELstate,r17
    rjmp    _SPbkX         ;no further action

;------------------------
;start HIF-data receiving
;------------------------
_RECspiHIFstart:
	;SPIstring startadresse
	ldi	zh,high(SPIstring)
	ldi	zl,low(SPIstring)
	;SPIstring sichern
	sts	spiBUFadrH,zh
	sts	spiBUFadrL,zl
	;range prfen
	;&jetzt busy setzen
	sbr	r17,1<<spiBUSY	;busy...
	sbr	r17,1<<spiWORKIN
    sts comFLAGspi,r17
    ;hif receive activ
    lds     r17,ifSELstate
    sbr     r17,1<<SPIrecHIF
    sts     ifSELstate,r17
    ;--------------------
    ;<spiDATctIST> +1
    ;--------------------
    lds	r16,spiDATctIST		
    inc r16
    sts spiDATctIST,r16
    cbi ddrb,_ifSEL
    cbi portb,_ifSEL
    nop
    sbi ddrb,_ifSEL
    cbi portb,_ifSEL
 
    ;
    rjmp    _SPbkX         ;no further action


















;------------------------
;start NET-data receiving
;------------------------
_RECspiNETstart:
	;&jetzt busy setzen
    lds r17,ifSELstate
	sbr	r17,1<<SPIrecNET
    cbr	r17,1<<SPIrecERR 	    ;no error	
   	sts	ifSELstate,r17
    ;--------------------
    ;<spiDATctIST> +1
    ;--------------------
    lds	r16,spiDATctIST		
    inc r16
    sts spiDATctIST,r16
    ;preset 
    ldi r16,0xff
    sts spiDATctSOLL,r16
    ;
   ;block bus
    cbi ddrb,_ifSEL
    cbi portb,_ifSEL
    nop
    sbi ddrb,_ifSEL
    cbi portb,_ifSEL
 
 
    rjmp    _SPbkX         ;no further action
 

;-------------------------
;HIF/NET-DATA ?
;-------------------------
_RECspi02CHK:
   lds     r17,ifSELstate
    sbrc    r17,SPIrecERR 
    rjmp    _SPbkX         ;no further action
    ;check if it's hif-data
    sbrc    r17,SPIrecHIF 
    rjmp    _RECspi03HIF        ;goon with hif-data
    ;check if it's hif-data
    sbrc    r17,SPIrecNET
    rjmp    _RECspi03NET        ;goon with hif-data
    ;invalid state
    ;-> error    
	sbr	r17,1<<SPIrecERR	    ;no error
   	sts	ifSELstate,r17
    clr r16
    sts spiDATctIST,r16
    rjmp    _SPbkX         ;no further action

 




;------------------------------------------------------------------------------------
;NET-DATA RECEIVING FROM ConcetMX1.xx
;------------------------------------------------------------------------------------
_RECspi03NET:

	;request waiting..
	lds	r16,SEflagVARb	
	sbrc	r16,reqTX		;request vorbereitung luft im sercom !!!
	rjmp	_SPbkX		;keine rx-daten beachten ==taub
    lds     r16,fifoVAR
	sbr		r16,1<<fifoNEW
	sts		fifoVAR,r16
	lds		zl,fifoIN
	mov		r16,zl
	clr		zh			
	subi		zl,low(-fifoSEG)
	sbci		zh,high(-fifoSEG)
	st		z,yl		;store received data to fifo
	inc		r16
	sts		fifoIN,r16	;store new counter value <=> points
						;to the next empty memory-space


	    lds	r16,spiDATctIST	
        cpi r16,6               ;the sixth byte contains the frame-size
        brne  _RECspi03NETgo
        ;calculate range
        sts spiDATctSOLL,yl     ;the frame size !
        
;---------------------------
;check range
;---------------------------
_RECspi03NETgo:
	    lds	r17,spiDATctSOLL
        cp  r16,r17
        brlo     _RECspiBACK
        ;frame complete
       	;data counter = 0
    	clr	r16
	    sts	spiDATctIST,r16
       	;&jetzt busy setzen
        lds r17,ifSELstate
	    cbr	r17,1<<SPIrecNET
        cbr	r17,1<<SPIrecERR 	    ;no error	
   	    sts	ifSELstate,r17
        ;free bus
       
        cbi ddrb,_ifSEL
        sbi portb,_ifSEL
        rjmp	_SPbkX		;...& back



;----------------------------
;now update storage pointer
;----------------------------      
_RECspiBACK:
        ;byte counter +1
        inc r16
        sts	spiDATctIST,r16     
        rjmp	_SPbkX		;...& back

	








;------------------------------------------------------------------------------------
;HIF-DATA RECEIVING FROM H_IF
;------------------------------------------------------------------------------------

;-------------------------
;HIF-DATA
;<spiDATctIST> =1 ? 
;-------------------------
_RECspi03HIF:
    ;---------------------
    ;save data to buffer
    ;---------------------
	lds	zh,spiBUFadrH
	lds	zl,spiBUFadrL
	st	z+,yl           ;spi data to buffer
	;SPIstring sichern
	sts	spiBUFadrH,zh
	sts	spiBUFadrL,zl
    ;---------------------
    ;check IST counter
    ;---------------------
    cpi r16,1
    brne   _RECspi03range ;check range
    ;calculate size
	ldi	r17,6		    ;nein == 6 bytes
	sts	spiDATctSOLL,r17
;-------------------------
;check end of frame !
;-------------------------
_RECspi03range:
	lds	r17,spiDATctSOLL
	;range?
	cp	r16,r17		;ist<soll ?
	brlo	_SPI05sub	
	;>= fertig
  	;&jetzt busy setzen
    lds r16,comFLAGspi
	sbr	r16,1<<spiBUSY	;busy...
	sbr	r16,1<<newSPIdata
	sts	comFLAGspi,r16
    ;hif receive stop
    lds     r17,ifSELstate
    cbr     r17,1<<SPIrecHIF
    sts     ifSELstate,r17
	;data counter = 0
	clr	r16
	sts	spiDATctIST,r16
    ;free bus
   
    cbi ddrb,_ifSEL
    sbi portb,_ifSEL

    rjmp    _SPbkX         ;no further action
	;not reached the end
_SPI05sub:
	inc	r16
	sts	spiDATctIST,r16
    rjmp    _SPbkX         ;no further action





;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_SPbkX:
 	out	sreg,r15
    pop zh
    pop zl
    pop yh
    pop yl
    pop r17
    pop r16
    pop r15
    pop r0
    reti

